<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : administracao/admin.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : administracao/admin.inc
  ========================================================== */

/* **********************************************************************
   PreparaCabecalho - Monta o Cabecalho padro da pgina da administracao
   Entrada: Nenhuma
   Saida: Monta o cabealho no HTML
*/
function PreparaCabecalhoAdmin($lista_frases)
{
  echo("<html><head>\n");

  /* 1- Administrao */
  echo("<title>TelEduc - ".RetornaFraseDaLista($lista_frases,1)."</title>\n");
  echo("</head>\n");
  echo("<body text=#000000 bgcolor=#FFFFFF link=#0000FF vlink=#0000FF ALINK=#0000FF>\n");
  echo("<table width=100% cols=2>\n");
  echo("  <tr valign=bottom>\n");
  echo("    <td><img SRC=../figuras/teleduc.gif border=0 height=79 width=172></td>\n");
  echo("    <td align=right>\n");

  /* 2- Pgina da Administrao */
  echo("      <font face=Verdana,Arial,Helvetica color=#990000 size=+1>".RetornaFraseDaLista($lista_frases,2)."</font>\n");
  echo("    </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("<hr><p>\n");
}

/* **********************************************************************
   PreparaCabecalhoOpcao - Prepara o cabecalho da opo da administrao
   Entrada: Nenhuma
   Saida: Monta o cabealho no HTML
*/
function PreparaCabecalhoOpcao($texto)
{
  echo("<b><font face=Verdana,Arial,Helvetica color=#990000 SIZE=3>".$texto."</FONT></B><br><br>\n");
}

/* **********************************************************************
   PreparaBoldLink - Monta um link na pgina (completa com RetornaSessionID()
   Entrada: $nome - nome do link
            $endereco - Endereco a ser chamado
            $parametros - parametros a serem passados
   Saida: Monta o a href
*/
function PreparaBoldLink($nome,$endereco,$parametros)
{
  echo("<B><font face=Verdana,Arial,Helvetica color=#990000 SIZE=2><a href=".$endereco."?".RetornaSessionID()."&".$parametros." target=_top>".$nome."</a></FONT></B><br><br>\n");
}

/* **********************************************************************
   RetornaSenhaAtual - Retorna a senha atual criptografada da administracao
   Entrada: Nenhum
   Saida: senha criptografada
*/
function RetornaSenhaAtual()
{
  $sock=Conectar("");
  $query="select valor from Config where item='admtele'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  Desconectar($sock);
  return $linha[0];
}

/* **********************************************************************
   AlteraSenhaAdministracao - Altera a senha atual da administracao
   Entrada: $senha_antiga - Senha antiga no criptografada
            $senha - Senha nova J criptografada
   Saida: nenhum
*/
function AlteraSenhaAdministracao($senha_antiga,$senha)
{
  $senha_antiga=crypt($senha_antiga,"AA");
  if ($senha_antiga==RetornaSenhaAtual())
  {
    $sock=Conectar("");
    $query="update Config set valor='".$senha."' where item='admtele'";
    Enviar($sock,$query);
    Desconectar($sock);
  }
}

/* **********************************************************************
   RetornaDadosInstituicao - Retorna os dados da instituio
   Entrada: nenhuma
   Saida: array com ['nome'],['informacoes'],['link']
*/
function RetornaDadosIntituicao()
{
  $sock=Conectar("");
  $query="select * from Instituicao";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  Desconectar($sock);
  return ($linha);
}

/* **********************************************************************
   AtualizaDadosInstituicao - Atualiza os dados da instituio
   Entrada: $nome - nome da instituicao
            $informacoes - Informacoes
            $link - Pagina WEB da instituicao
   Saida: nenhum
*/
function AtualizaDadosIntituicao($nome,$informacoes,$link)
{
  $nome=ConverteAspas2Html($nome);
  $informacoes=Enter2Br(ConverteAspas2Html($informacoes));
  $link=ConverteAspas2Html($link);
  $sock=Conectar("");
  $query="select count(*) from Instituicao";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  if ($linha[0]>0)
  {
    $query="update Instituicao set nome='".$nome."',informacoes='".$informacoes."',link='".$link."'";
  }
  else
  {
    $query="insert into Instituicao values ('".$nome."','".$informacoes."','".link."')";
  }
  Enviar($sock,$query);
  Desconectar($sock);
}

/* **********************************************************************
   RetornaContatos - Retorna os dados dos contatos
   Entrada: nenhuma
   Saida: array com []['nome'],[]['email'],[]['status'] (C-Criar Curso, " "-caso contrario)
*/
function RetornaContatos()
{
  $sock=Conectar("");
  $query="select * from Contatos order by nome";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  Desconectar($sock);
  return ($lista);
}

/* **********************************************************************
   InsereContato - Insere contato
   Entrada: $nome - nome do contato
            $email - email do contato
            $status - [C] Lista de Criar Curso [ ] s em contatos
   Saida: nenhuma
*/
function InsereContato($nome,$email,$status)
{
  $nome=ConverteAspas2Html($nome);
  $sock=Conectar("");
  $query="insert into Contatos values ('".$nome."','".$email."','".$status."')";
  Enviar($sock,$query);
  Desconectar($sock);
  return ($lista);
}

/* **********************************************************************
   RemoveContato- remove contato
   Entrada: $nome - nome do contato
   Saida: nenhuma
*/
function RemoveContato($nome)
{
  $nome=ConverteAspas2Html($nome);
  $sock=Conectar("");
  $query="delete from Contatos where nome='".$nome."'";
  Enviar($sock,$query);
  Desconectar($sock);
}

/* **********************************************************************
   EnviarTodasBasesCursos - Envia para todas as bases de curso do ambiente.
   Entrada: $query - nome do contato
   Saida: array[]['NomeBase'] - Nome da Base
          array[]['Res'] - Resultado da consulta na base
*/
function EnviarTodasBasesCursos($query)
{
  global $dbnamecurso;
        $sock=Conectar("");
  $lista_bases=RetornaListaBases($sock);
  Desconectar($sock);
  $i=0;
  unset($saida);
  if (count($lista_bases)>0)
  {
    foreach($lista_bases as $cod => $linha)
    {
      if (eregi("^".$dbnamecurso,$linha))
      {
        $saida[$i]['NomeBase']=$linha;
        $sock=ConectarDB($linha);
        if ($i==0)
          $res=Enviar($sock,$query);
        if (($res=EnviarNC($sock,$query)))
        {
          $saida[$i]['Campos']=RetornaCampos($res);
          $saida[$i]['Res']=RetornaArrayLinhas($res);
        }
        Desconectar($sock);
        $i++;
      }
    }
  }
  return ($saida);
}

/* **********************************************************************
   RetornaListaCursosAtivos - Retorna a lista de cursos no encerrados
   Entrada: nenhuma
   Saida: array [$cod_curso] - Nome do curso
*/
function RetornaListaCursosAtivos()
{
  $ontem=time() - 24*60*60;
        $sock=Conectar("");
  $query="select cod_curso,nome_curso from Cursos where curso_fim>".$ontem." order by nome_curso";
  $res=Enviar($sock,$query);
  Desconectar($sock);
  while (($linha=RetornaLinha($res)))
    $saida[$linha['cod_curso']]=$linha['nome_curso'];
  return $saida;
}

/* **********************************************************************
   EnviarMensagem - Envia a mensagem para os destinatarios.
   Entrada: $cod_curso - codigo do curso a receber a mensagem.
            $coordenadores - 1 se for para enviar para coordenadores
            $formadores - 1 se for para enviar para formadores
            $alunos - 1 se for para enviar para alunos
            $assunto - assunto da mensagem
            $mensagem - mensagem a ser enviada
            $destinos - lista de emails que j receberam o e-mail.
   Saida: string com lista de emails que receberam e-mail.
*/
function EnviarMensagem($cod_curso,$coordenadores,$formadores,$alunos,$assunto,$mensagem,$destinos)
{
  $sock=Conectar($cod_curso);
  if ($formadores==1)
  {
    $query="select email from Usuario where tipo_usuario='F'";
    $res=Enviar($sock,$query);
    $cont=0;
    while($linha=RetornaLinha($res))
    {
      if ($linha['email']<>"")
      {
        $lista_formadores[$cont]=$linha['email'];
        $cont ++;
      }
    }
  }
  else if ($coordenadores==1)
  {
    $query="select U.email as 'email' from Usuario U, Cursos C where C.cod_coordenador=U.cod_usuario and C.cod_curso=".$cod_curso;
    $res=Enviar($sock,$query);
    $cont=0;
    while($linha=RetornaLinha($res))
    {
      if ($linha['email']<>"")
      {
        $lista_formadores[$cont]=$linha['email'];
        $cont ++;
      }
    }
  }

  if ($alunos==1)
  {
    $query="select email from Usuario where tipo_usuario='A'";
    $res=Enviar($sock,$query);
    $cont=0;
    while($linha=RetornaLinha($res))
    {
      if ($linha['email']<>"")
      {
        $lista_alunos[$cont]=$linha['email'];
        $cont ++;
      }
    }
  }
  Desconectar($sock);

  if (count($lista_formadores)>0 && count($lista_alunos)>0)
    $lista_destino=implode(",",$lista_formadores).",".implode(",",$lista_alunos);
  else if (count($lista_formadores)>0)
    $lista_destino=implode(",",$lista_formadores);
  else
    $lista_destino=implode(",",$lista_alunos);

  /* enviar e-mail */

  $sock=Conectar("");
  $remetente=DadosAdministracaoParaEmail($sock);
  Desconectar($sock);


  MandaMsg($remetente,$lista_destino,$assunto,$mensagem);

  $destinos.=",".$lista_destino;

  return $destinos;
}

/* **********************************************************************
   RetornaListaLogins - Retorna a lista de logins dos usurios do curso
   Entrada: $cod_curso - codigo do curso
   Saida: array [$cod_usuario]=login do usuario
*/
function RetornaListaLogins($cod_curso)
{
        $sock=Conectar($cod_curso);
  $query="select cod_usuario,login from Usuario";
  $res=Enviar($sock,$query);
  Desconectar($sock);
  while (($linha=RetornaLinha($res)))
    $saida[$linha['cod_usuario']]=$linha['login'];
  return $saida;

}

/* **********************************************************************
   AlterarLoginUsuario - Altera o login do usuario
   Entrada: $cod_curso - codigo do curso
            $cod_usuario - codigo do usurio
            $login - novo login a ser colocado
   Saida: true se a alterao foi concluda, false se o login for repetido
*/
function AlterarLoginUsuario($cod_curso,$cod_usuario,$login)
{
  $sock=Conectar($cod_curso);
  $query="select login from Usuario where cod_usuario<>".$cod_usuario." and login='".$login."'";
  $res=Enviar($sock,$query);
  if (RetornaNumLinhas($res)==0)
  {
    $query="update Usuario set login='".$login."' where cod_usuario=".$cod_usuario;
    Enviar($sock,$query);
    return true;
  }
  else
    return false;
}

/* *******************************************************************************
  DadosUsuario - Retorna array com dados basicos do usuario
  Entradas: $sock - sock de conexao,
            $cod_curso - codigo do curso,
            $cod_usuario - codigo do usuario
  Saida:    Array com ['nome'] - nome do Usuario
                      ['email'] - endereco email do usuario
                      ['tipo_usuario'] - (char) tipo de usuario - (A)luno,(F)ormador,(C)oordenador
*/
function DadosUsuario($sock,$cod_curso,$cod_usuario)
{
  $query="select nome,email,tipo_usuario from Usuario where cod_usuario=".$cod_usuario;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);

  if(ECoordenador($sock,$cod_curso,$cod_usuario)==1)
  {
    $linha['tipo_usuario']="C";
  }

  return($linha);
}

/* **********************************************************************
   RetornaFerramentasOrdemMenu - Retorna o codigo e nome das ferramentas
                                 na ordem do menu
   Entrada: nenhuma
   Saida: array[$cod_ferramenta]=nome
*/
function RetornaFerramentasOrdemMenu()
{
  global $cod_lingua_s;
  $sock=Conectar("");
  $query ="select F.cod_ferramenta 'cod_ferramenta', L.texto 'texto', M.posicao 'posicao'";
  $query.=" from Ferramentas F, Menu M, Lingua_textos L where L.cod_lingua=".$cod_lingua_s;
  $query.=" and L.cod_ferramenta=-4 and L.cod_texto=F.cod_texto_nome and F.cod_ferramenta=M.cod_ferramenta";
  $query.=" order by M.posicao";
  $res=Enviar($sock,$query);
  unset ($saida);
  while ($linha=RetornaLinha($res))
    $saida[$linha['cod_ferramenta']]=$linha['texto'];
  Desconectar($sock);
  return $saida;
}

/* **********************************************************************
   ListaFrasesDecrescente - Retorna a lista de frases em ordem decrescente
   Entrada: $cod_lingua - codigo da lingua a ser lida
            $cod_ferramenta - codigo da ferramenta a ser lida
   Saida: array [cod_ferramenta][cod_texto]=texto na lingua pedida
*/
function ListaFrasesDecrescente($cod_lingua,$cod_ferramenta)
{
  $sock=Conectar("");
  $query="select * from Lingua_textos where cod_lingua=".$cod_lingua." and cod_ferramenta=".$cod_ferramenta." order by cod_texto desc";
  $res=Enviar($sock,$query);
  Desconectar($sock);
  while ($linha=RetornaLinha($res))
    $saida[$linha['cod_ferramenta']][$linha['cod_texto']]=$linha['texto'];
  return $saida;
}

/* **********************************************************************
   ListaFrasesNaoPreenchidas - Retorna as frases no preenchidas na outra lingua
   Entrada: $cod_lingua - codigo da lingua a ser lida
   Saida: array [cod_ferramenta][cod_texto]=texto na lingua base
*/
function ListaFrasesNaoPreenchidas($cod_lingua)
{
  $sock=Conectar("");
  /* Buscar elementos no comuns a segunda lingua */
  $query="select * from Lingua_textos where cod_lingua=1 order by cod_ferramenta,cod_texto";
  $res=Enviar($sock,$query);
  while ($linha=RetornaLinha($res))
    $lista_base[$linha['cod_ferramenta']][$linha['cod_texto']]=$linha['texto'];

  $query="select * from Lingua_textos where cod_lingua=".$cod_lingua." order by cod_ferramenta,cod_texto";
  $res=Enviar($sock,$query);
  while ($linha=RetornaLinha($res))
    $lista_comp[$linha['cod_ferramenta']][$linha['cod_texto']]=$linha['texto'];

  Desconectar($sock);
  /* Ler os elementos no preenchidos */
  unset ($saida);

  foreach($lista_base as $cod_ferramenta => $linha)
    foreach($linha as $cod_texto => $texto)
      if (!isset($lista_comp[$cod_ferramenta][$cod_texto]) || $lista_comp[$cod_ferramenta][$cod_texto]=="")
        $saida[$cod_ferramenta][$cod_texto]=$texto;

  return $saida;
}

/* **********************************************************************
   InsereTexto - Insere o texto na ferramenta passada
   Entrada: $cod_lingua - codigo da lingua a ser lida
            $cod_ferramenta - codigo da ferramenta
            $texto - Texto a ser colocado
   Saida: Retorna o cdigo do texto em que foi inserido
*/
function InsereTexto($cod_lingua,$cod_ferramenta,$texto)
{
  $sock=Conectar("");
  $query="select cod_texto from Lingua_textos where cod_lingua=1 and cod_ferramenta=".$cod_ferramenta." order by cod_texto desc limit 1";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $cod_texto=((int)$linha[0])+1;
  $texto=ConverteAspas2Html($texto);
  $query="insert into Lingua_textos values (".$cod_texto.",".$cod_lingua.",".$cod_ferramenta.",'".$texto."')";
  echo($query);
  Enviar($sock,$query);
  Desconectar($sock);
  return $cod_texto;
}

/* **********************************************************************
   AlteraTexto - altera o texto na ferramenta passada
   Entrada: $cod_lingua - codigo da lingua
            $cod_ferramenta - codigo da ferramenta
            $cod_texto - codigo do texto a ser alterado
            $texto - Texto a ser alterado
   Saida: codigo do texto alterado
*/
function AlteraTexto($cod_lingua,$cod_ferramenta,$cod_texto,$texto)
{
  $sock=Conectar("");
  $texto=ConverteAspas2Html($texto);
  $query="update Lingua_textos set texto='".$texto."' where cod_lingua=".$cod_lingua." and cod_ferramenta=".$cod_ferramenta." and cod_texto=".$cod_texto;
  Enviar($sock,$query);
  Desconectar($sock);
  return $cod_texto;
}

/* **********************************************************************
   ApagaTexto - Apaga o texto na ferramenta passada
   Entrada: $cod_ferramenta - codigo da ferramenta
            $cod_texto - codigo do texto a ser alterado
            $texto - Texto a ser alterado
   Saida: nenhuma
   OBS.: Apagar as frases equivalentes em todas as linguas... use com cuidado.
*/
function ApagaTexto($cod_ferramenta,$cod_texto)
{
  $sock=Conectar("");
  $texto=ConverteAspas2Html($texto);
  $query="delete from Lingua_textos where cod_ferramenta=".$cod_ferramenta." and cod_texto=".$cod_texto;
  Enviar($sock,$query);
  Desconectar($sock);
  return $cod_texto;
}

/* **********************************************************************
   ExisteTexto - Retorna true se existe o registro
   Entrada: $cod_lingua - codigo da lingua
            $cod_ferramenta - codigo da ferramenta
            $cod_texto - codigo do texto a ser alterado
   Saida: true se existir
*/
function ExisteTexto($cod_lingua,$cod_ferramenta,$cod_texto)
{
  $sock=Conectar("");
  $query="select * from Lingua_textos where cod_lingua=".$cod_lingua." and cod_ferramenta=".$cod_ferramenta." and cod_texto=".$cod_texto;
  $res=Enviar($sock,$query);
  Desconectar($sock);
  if (RetornaNumLinhas($res)>0)
    return true;
  return false;
}

/* **********************************************************************
   InsereTextoComCodigo - Insere o texto na ferramenta passada
   Entrada: $cod_lingua - codigo da lingua a ser lida
            $cod_ferramenta - codigo da ferramenta
            $cod_texto - codigo do texto
            $texto - Texto a ser colocado
   Saida: Retorna o cdigo do texto em que foi inserido
*/
function InsereTextoComCodigo($cod_lingua,$cod_ferramenta,$cod_texto,$texto)
{
  $sock=Conectar("");
  $texto=ConverteAspas2Html($texto);
  $query="insert into Lingua_textos values (".$cod_texto.",".$cod_lingua.",".$cod_ferramenta.",'".$texto."')";
  Enviar($sock,$query);
  Desconectar($sock);
  return $cod_texto;
}

/* **********************************************************************
   CriarBaseDoCurso - Obtem o cdigo do proximo curso, e prepara a criao das tabelas
                      a partir do arquivo "base_curso/Base_Vazia.table".
   Entrada: $nome_curso - nome do curso
            $num_alunos - numero de alunos previstos
            $cod_pasta - Codigo da pasta a qual pertence o curso.
   Saida: Retorna o cdigo do curso
*/
function CriarBaseDoCurso($nome_curso,$num_alunos,$cod_pasta,$nome_coordenador,$email,$login,$senha)
{
  global $dbnamecurso;
  global $cod_lingua_s;
  $sock=Conectar("");
  $query="select max(cod_curso) from Cursos";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $cod_curso=$linha[0] + 1;

  $nome_base=$dbnamecurso.$cod_curso;
  $query="drop database if exists ".$nome_base;
  Enviar($sock,$query);

  $query="create database ".$nome_base;
  Enviar($sock,$query);

  Desconectar($sock);

  $sock=Conectar($cod_curso);

  if ($fh=fopen("base_curso/Base_Vazia.table","r"))
  {
    $comando="";
    while (!feof($fh))
    {
      $linha=fgets($fh,1024);
      if ($linha[0]!="#")
      {
        $linha=eregi_replace("\n"," ",$linha);
        $linha=trim($linha);
        $comando .= $linha;

        if (eregi(";",$linha))
        {
          $comando=eregi_replace(";"," ",$comando);
          $comando=trim($comando);
          Enviar($sock,$comando);
          $comando ="";
        }
      }
    }
  }

  fclose($fh);

  $senha_crypt=crypt($senha,"AA");
  $cod_usuario=RetornaProximoCodigo($sock,"Usuario");
  $query="insert into Usuario (cod_usuario,nome,email,login,senha,tipo_usuario,data_inscricao, cod_lingua) values (".$cod_usuario.",'".$nome_coordenador."','".$email."','".$login."','".$senha_crypt."','F',".time().", ".$cod_lingua_s.")";
  Enviar($sock,$query);

  $query="insert into Cursos (cod_curso,nome_curso,num_alunos,cod_coordenador,cod_pasta,cod_lingua,acesso_visitante) values (".$cod_curso.",'".$nome_curso."',$num_alunos,".$cod_usuario.",".$cod_pasta.",".$cod_lingua_s.",'N')";

  Enviar($sock,$query);

  Desconectar($sock);
  $sock=Conectar("");
  Enviar($sock,$query);

  Desconectar($sock);

  return $cod_curso;
}

/* **********************************************************************
   RetornaDiretorio - Retorna o Diretorio pedido
   Entrada: $item - item da tabela de diretorios a ser retornado
   Saida: Retorna o diretorio
*/
function RetornaDiretorio($item)
{
  $sock=Conectar("");
  $query="select diretorio from Diretorio where item='".$item."'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  Desconectar($sock);
  return $linha['diretorio'];
}

/* **********************************************************************
   RetornaConfig - Retorna dado da tabela Config
   Entrada: $item - item da tabela de diretorios a ser retornado
   Saida: Retorna o diretorio
*/
function RetornaConfig($item)
{
  $sock=Conectar("");
  $query="select valor from Config where item='".$item."'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  Desconectar($sock);
  return $linha['valor'];
}

/* **********************************************************************
   RetornaCursosExtraiveis - Retorna lista de cursos que podem ser extraidos (terminados)
   Entrada: nenhuma
   Saida: Retorna array com [$cod_curso]=nome_curso
*/
function RetornaCursosExtraiveis()
{
  $sock=Conectar("");
  $query="select cod_curso,nome_curso from Cursos where curso_fim<".(time()+86399)." order by nome_curso";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  Desconectar($sock);
  if (count($lista)>0)
    foreach($lista as $cod => $linha)
      $saida[$linha['cod_curso']]=$linha['nome_curso'];
  return $saida;
}


/* ************************************************************************
   RetornaSubDiretorios - Retorna um array com os subdiretorios (do primeiro
                          nivel de profundidade, apenas) do diretorio informado

   Entrada: $diretorio - diretorio a ser varrido.
   Saida: Array multidimensional com:
          $lista[<num>]['Caminho'] - caminho completo.
          $lista[<num>]['Diretorio'] - Diretorio do arquivo
          $lista[<num>]['Arquivo'] - Nome do arquivo
          $lista[<num>]['Status'] - Condio especial (true ou false);
          $lista[<num>]['Tamanho'] - tamanho do arquivo
          $lista[<num>]['Data'] - data da ltima modificao
*/
function RetornaSubDiretorios($diretorio)
{
  /* Coloca a barra no final, se no tiver */
  $diretorio .="/";
  $diretorio = implode("/",explode("//",$diretorio));

  /* Prepara lista de arquivos */
  clearstatcache();
  unset ($lista);
  $fp=popen("find ".$diretorio." -type d -maxdepth 1","r");

  $cont=0;
  while($s = fgets($fp, 1024))
  {
    /* cortando carro de linha */

    $enter=explode("\n",$s);
    $s=$enter[0];

    $s = ereg_replace($diretorio,"", $s);
    $s = ereg_replace("/","", $s);
    $s = ereg_replace("\.","", $s);

    if ($s != '')
      $lista[$cont]=$s;

    $cont++;
  }
  if (count($lista)>0)
    sort ($lista);

  return ($lista);
}


/* **********************************************************************
   RetornaCursosInseriveis - Retorna lista de cursos que podem ser inseridos
   Entrada: nenhuma
   Saida: Retorna array com [$cod_curso]=nome_curso
*/
function RetornaCursosInseriveis()
{
  $diretorio_extracao = RetornaDiretorio('Extracao');
  $lista_diretorios = RetornaSubDiretorios($diretorio_extracao);
  if (count($lista_diretorios) > 0)
    foreach ($lista_diretorios as $diretorio)
    {
       $arquivo = $diretorio_extracao.'/'.$diretorio.'/TelEduc.table';

       $fd = fopen ($arquivo, "r");
       $texto_procurado = 'INSERT INTO Cursos VALUES ('.$diretorio.',';
       $achou_nome = 0;
       while ((!feof($fd)) && (!$achou_nome))
       {
           $buffer = fgets($fd, 4096);

           if (strstr($buffer, $texto_procurado))
           {
             $partes = explode("'", $buffer);
             $nome_do_curso = $partes[1];
             $achou_nome = 1;
           }
       }
       fclose ($fd);

      $saida[$diretorio]=$nome_do_curso;
    }
  return $saida;
}


/* **********************************************************************
   RetornaCategorias - Retorna as categorias que um curso pode pertencer
   Entrada: nenhum
   Saida: array com [$cod_pasta]='nome da pasta'
*/
function RetornaCategorias()
{
  $sock=Conectar("");
  $query="select * from Cursos_pastas order by pasta";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  Desconectar($sock);
  if (count($lista)>0)
    foreach($lista as $cod => $linha)
      $saida[$linha['cod_pasta']]=$linha['pasta'];
  return $saida;
}

/* **********************************************************************
   InserirCategoria - Insere a categoria e retorna o cdigo da mesma
   Entrada: $nome_pasta
   Saida: codigo da categoria
*/
function InserirCategoria($nome_pasta)
{
  $sock=Conectar("");
  $query="select * from Cursos_pastas where pasta like '".$nome_pasta."'";
  $res=Enviar($sock,$query);
  if (RetornaNumLinhas($res)>0)
  {
    $linha=RetornaLinha($res);
    return $linha['cod_pasta'];
  }
  else
  {
    $query="insert into Cursos_pastas (pasta) values ('".$nome_pasta."')";
    Enviar($sock,$query);
    $query="select * from Cursos_pastas where pasta like '".$nome_pasta."'";
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);
    return $linha['cod_pasta'];
  }
}


/* **********************************************************************
   ApagarCategoria - Apaga a categoria passada
   Entrada: $cod_pasta
   Saida: nenhuma
*/
function ApagarCategoria($cod_pasta)
{
  $sock=Conectar("");
  $query="delete from Cursos_pastas where cod_pasta=".$cod_pasta;
  Enviar($sock,$query);
  $query="update Cursos set cod_pasta=NULL where cod_pasta=".$cod_pasta;
  Enviar($sock,$query);
  Desconectar($sock);

}

/* **********************************************************************
   RenomearCategoria - Renomeia a categoria
   Entrada: $cod_pasta
            $nome
   Saida: nenhuma
*/
function RenomearCategoria($cod_pasta,$nome)
{
  $sock=Conectar("");
  $query="update Cursos_pastas set pasta='".$nome."' where cod_pasta=".$cod_pasta;
  Enviar($sock,$query);
  Desconectar($sock);
}

/* **********************************************************************
   RetornaCursos - Retorna lista de cursos
   Entrada: nenhuma
   Saida: Retorna array com [$cod_curso]=nome_curso
*/
function RetornaCursos()
{
  $sock=Conectar("");
  $query="select * from Cursos order by cod_pasta, nome_curso";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  Desconectar($sock);
  if (count($lista)>0)
    foreach($lista as $cod => $linha)
      $saida[$linha['cod_curso']]=$linha;
  return $saida;
}

/* **********************************************************************
   AtualizaPastaCursos - atualiza a pasta (categoria) a que pertence o curso
   Entrada: $cod_curso, $cod_pasta
   Saida: nenhum
*/
function AtualizaPastaCursos($cod_curso, $cod_pasta)
{
  $query="update Cursos set cod_pasta=".$cod_pasta." where cod_curso=".$cod_curso;
  $sock=Conectar("");
  Enviar($sock,$query);
  Desconectar($sock);
  $sock=Conectar($cod_curso);
  Enviar($sock,$query);
  Desconectar($sock);
}

?>
