<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : administracao/ajuda/ajuda.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : administracao/ajuda/ajuda.inc
  ========================================================== */

/* **********************************************************************
   PreparaCabecalhoAjuda - Monta o Cabecalho padro da pgina da administracao/ajuda
   Entrada: Nenhuma
   Saida: Monta o cabealho no HTML
*/
function PreparaCabecalhoAjuda($lista_frases)
{
  echo("<html><head>\n");

  /* 1- Administrao */
  echo("<title>TelEduc - ".RetornaFraseDaLista($lista_frases,1)."</title>\n");
  echo("</head>\n");
  echo("<body text=#000000 bgcolor=#FFFFFF link=#0000FF vlink=#0000FF ALINK=#0000FF>\n");
  echo("<table width=100% cols=2>\n");
  echo("  <tr valign=bottom>\n");
  echo("    <td><img SRC=../../figuras/teleduc.gif border=0 height=79 width=172></td>\n");
  echo("    <td align=right>\n");

  /* 2- Pgina da Administrao */
  echo("      <font face=Verdana,Arial,Helvetica color=#990000 size=+1>".RetornaFraseDaLista($lista_frases,2)."</font>\n");
  echo("    </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("<hr><p>\n");
}

/* **********************************************************************
   RetornaTextoDaAjuda - Retorna o texto referente aos parmetros passados na Entrada.
   Entrada: $sock = Socket da conexo atual
            $cod_ferramenta = Cdigo da ferramenta da qual se quer o texto da Ajuda
            $cod_lingua =  Cdigo da lngua na qual se quer o texto da Ajuda
            $cod_pagina =  Cdigo da pgina da ferramenta da qual se quer o texto da Ajuda
            $tipo_usuario = Para saber se o texto ser o exibido na viso do aluno ou formador.
   Saida: $array['texto'] = O referido texto
*/
function RetornaTextoDaAjuda($sock,$cod_ferramenta,$cod_pagina,$cod_lingua,$tipo_usuario)
{
  $query="select texto from Ajuda where cod_ferramenta=".$cod_ferramenta." and cod_pagina=".$cod_pagina." and cod_lingua=".$cod_lingua." and tipo_usuario='".$tipo_usuario."'\n";
  $res=Enviar($sock,$query);
  $array=RetornaLinha($res);
  return($array['texto']);
}

/* **********************************************************************
   CriaCampoTexto - Cria na tabela Ajuda uma nova linha para insero do texto da Ajuda
   Entrada: $sock = Socket da conexo atual
            $cod_ferramenta = Cdigo da ferramenta da qual se quer o texto da Ajuda
            $cod_pagina = Cdigo da pgina da Ajuda
            $cod_lingua =  Cdigo da lngua na qual se quer o texto da Ajuda
            $nome_pagina =  Nome da pgina da ferramenta da qual se quer o texto da Ajuda
            $tipo_usuario = Para saber se o texto ser o exibido na viso do aluno ou formador.
   Saida: Cria a linha especificada
*/
function CriaCampoTexto($sock,$cod_ferramenta,$cod_pagina,$nome_pagina,$cod_lingua,$tipo_usuario)
{

  $query="insert INTO Ajuda (cod_ferramenta,cod_pagina,cod_lingua,tipo_usuario,texto,nome_pagina) VALUES(".$cod_ferramenta.",".$cod_pagina.",".$cod_lingua.",'".$tipo_usuario."','','".$nome_pagina."')\n";
  Enviar($sock,$query);
}

/* **********************************************************************
   AtualizaTexto - Atualiza o texto da Ajuda
   Entrada: $sock = Socket da conexo atual
            $cod_ferramenta = Cdigo da ferramenta da qual se quer atualizar o texto da Ajuda
            $cod_pagina = Cdigo da pgina da qual se quer atualizar o texto da Ajuda
            $cod_lingua =  Cdigo da lngua na qual se quer o texto da Ajuda
            $tipo_usuario = Para saber se o texto ser o exibido na viso do aluno ou formador
            $texto = Texto novo
   Saida: Atualiza texto da Ajuda
*/
function AtualizaTexto($sock,$cod_ferramenta,$cod_pagina,$cod_lingua,$tipo_usuario,$texto)
{
  $query="update Ajuda SET texto='".$texto."' where cod_ferramenta=".$cod_ferramenta." and cod_pagina=".$cod_pagina." and cod_lingua=".$cod_lingua." and tipo_usuario='".$tipo_usuario."'\n";
  Enviar($sock,$query);
}

/* **********************************************************************
   AtualizaNomePagina - Atualiza o nome da pgina da Ajuda
   Entrada: $sock = Socket da conexo atual
            $cod_pagina = Cdigo da pgina que se quer atualizar o nome
            $nome_pagina = Novo nome da pgina
            $cod_ferramenta = Cdigo da ferramenta da qual se quer atualizar o nome da pgina
            $cod_lingua =  Cdigo da lngua na qual se quer atualizar o nome da pgina
            $tipo_usuario = Tipo do usurio que se quer atualizar o nome da pgina
   Saida: Atualiza nome da pgina da Ajuda
*/
function AtualizaNomePagina($sock,$cod_pagina,$nome_pagina,$cod_ferramenta,$cod_lingua,$tipo_usuario)
{
  $query="update Ajuda SET nome_pagina='".$nome_pagina."' where cod_pagina=".$cod_pagina." and cod_ferramenta=".$cod_ferramenta." and cod_lingua=".$cod_lingua." and tipo_usuario='".$tipo_usuario."'\n";
  Enviar($sock,$query);
}

/* **********************************************************************
   RetornaCodPagina - Retorna o cdigo da pgina da Ajuda
   Entrada: $sock = Socket da conexo atual
            $nome_pagina = Nome da pgina que se quer o cdigo
            $cod_ferramenta = Cdigo da ferramenta cuja pgina se quer o cdigo
            $cod_lingua =  Cdigo da lngua cuja pgina se quer o cdigo
            $tipo_usuario = Tipo do usurio que se quer o cdigo da pgina
   Saida: $resultado['cod_pagina'] = cdigo da pgina de nome $nome_pagina
*/
function RetornaCodPagina($sock,$nome_pagina,$cod_ferramenta,$cod_lingua,$tipo_usuario)
{
  $query="select cod_pagina from Ajuda where nome_pagina='".$nome_pagina."' and cod_ferramenta=".$cod_ferramenta." and cod_lingua=".$cod_lingua." and tipo_usuario='".$tipo_usuario."'\n";
  $res=Enviar($sock,$query);
  $resultado=RetornaLinha($res);
  $cod_pagina=$resultado['cod_pagina'];
  if ($cod_pagina=='')
    return (-1);
  else
    return($cod_pagina);
}

/* **********************************************************************
   RetornaNomePagina - Retorna o nome da pgina da Ajuda
   Entrada: $sock = Socket da conexo atual
            $cod_pagina = Nome da pgina que se quer o cdigo
            $cod_ferramenta = Cdigo da ferramenta cuja pgina se quer o cdigo
            $cod_lingua =  Cdigo da lngua cuja pgina se quer o cdigo
            $tipo_usuario = Tipo do usurio que se quer o cdigo da pgina
   Saida: $resultado['nome_pagina'] = nome da pgina de nome $nome_pagina
*/
function RetornaNomePagina($sock,$cod_pagina,$cod_ferramenta,$cod_lingua,$tipo_usuario)
{
  $query="select nome_pagina from Ajuda where cod_pagina=".$cod_pagina." and cod_ferramenta=".$cod_ferramenta." and cod_lingua=".$cod_lingua." and tipo_usuario='".$tipo_usuario."'\n";
  $res=Enviar($sock,$query);
  $resultado=RetornaLinha($res);
  $nome_pagina=$resultado['nome_pagina'];
  return($nome_pagina);
}

/* **********************************************************************
   RetornaPaginasdaFerramenta - Retorna as pginas de uma determinada ferramenta
   Entrada: $sock = Socket da conexo atual
            $cod_ferramenta = Cdigo da ferramenta da qual se quer as pginas
            $cod_lingua =  Cdigo da lngua na qual se quer as pginas
            $tipo_usuario = Tipo do usurio do qual se quer as pginas
   Saida: $lista = Lista com nomes das pginas
*/
function RetornaPaginasdaFerramenta($sock,$cod_ferramenta,$cod_lingua,$tipo_usuario)
{
  $query="select nome_pagina,cod_pagina from Ajuda where cod_ferramenta=".$cod_ferramenta." and cod_lingua=".$cod_lingua." and tipo_usuario='".$tipo_usuario."' order by cod_pagina\n";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* **********************************************************************
   MaxCodPagina - Retorna o prximo cdigo de pgina que vir a ser criado
   Entrada: $sock = Socket da conexo atual
            $cod_ferramenta = Cdigo da ferramenta da qual se quer o cdigo
            $cod_lingua =  Cdigo da lngua na qual se quer o cdigo
            $tipo_usuario = Tipo do usurio do qual se quer o cdigo
   Saida: $cod_pagina = O maior cdigo de pgina existente + 1
*/
function MaxCodPagina ($sock,$cod_ferramenta,$cod_lingua,$tipo_usuario)
{
  $query="select max(cod_pagina) from Ajuda where cod_ferramenta=".$cod_ferramenta." and cod_lingua=".$cod_lingua." and tipo_usuario='".$tipo_usuario."'\n";
  $res=Enviar($sock,$query);
  $resultado=RetornaLinha($res);
  $cod_pagina=$resultado['max(cod_pagina)'] + 1;
  return($cod_pagina);
}

/* **********************************************************************
   AtualizaCodPagina - Atualiza o cdigo da pgina especificada
   Entrada: $sock = Socket da conexo atual
            $cod_ferramenta = Cdigo da ferramenta da qual se quer atualizar o cdigo de pgina
            $cod_pagina_atual =  Cdigo atual da pgina
            $cod_pagina_novo =  Cdigo novo da pgina
            $tipo_usuario = Tipo do usurio do qual se quer atualizar o cdigo
   Saida: Atualiza o cdigo de pgina especificado
*/
function AtualizaCodPagina($sock,$cod_ferramenta,$cod_pagina_atual,$cod_pagina_novo,$tipo_usuario)
{
  $query="update Ajuda set cod_pagina=".$cod_pagina_novo." where cod_ferramenta=".$cod_ferramenta." and cod_pagina=".$cod_pagina_atual." and tipo_usuario='".$tipo_usuario."'\n";
  Enviar($sock,$query);
}
?>