<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : administracao/estatistica/estat.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : administracao/estatistica/estat.inc
  ========================================================== */

/* **********************************************************************
   PreparaCabecalhoEstat - Monta o Cabecalho padro da pgina da administracao/estatistica
   Entrada: Nenhuma
   Saida: Monta o cabealho no HTML
*/
function PreparaCabecalhoEstat($lista_frases)
{
  echo("<html><head>\n");

  /* 1- Administrao */
  echo("<title>TelEduc - ".RetornaFraseDaLista($lista_frases,1)."</title>\n");
  echo("</head>\n");
  echo("<body text=#000000 bgcolor=#FFFFFF link=#0000FF vlink=#0000FF ALINK=#0000FF>\n");
  echo("<table width=100% cols=2>\n");
  echo("  <tr valign=bottom>\n");
  echo("    <td><img SRC=../../figuras/teleduc.gif border=0 height=79 width=172></td>\n");
  echo("    <td align=right>\n");

  /* 2- Pgina da Administrao */
  echo("      <font face=Verdana,Arial,Helvetica color=#990000 size=+1>".RetornaFraseDaLista($lista_frases,2)."</font>\n");
  echo("    </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("<hr><p>\n");
}

/* **********************************************************************
   RetornaNumeroDeCursos - Retorna um array com nmero de cursos ativos, encerrados e latentes, respectivamente
   Entrada: $sock - Socket de conexo
   Saida: array($ativos, $encerrados, $latentes)
*/
function RetornaNumeroDeCursos($sock)
{
  /* Nmero total de cursos */
  $query = "select * from Cursos";
  $res = Enviar($sock,$query);
  $num_cursos = RetornaNumLinhas($res);

  /*Cursos com datas de nicio e fim definidas*/
  $query = "select curso_inicio,curso_fim from Cursos where curso_inicio is not NULL";
  $res = Enviar($sock,$query);
  $nao_latentes = RetornaNumLinhas($res);
  $array = RetornaArrayLinhas($res);

  $horatual = time();

  $ativos = 0; $encerrados = 0;
  for ($i = 0; $i < $nao_latentes; $i++)
  {
   if ($horatual > $array[$i]['curso_fim'])
     $encerrados++;
   else if ($horatual < $array[$i]['curso_fim'] && $horatual > $array[$i]['curso_inicio'])
     $ativos++;
  }
  $latentes = $num_cursos - $encerrados - $ativos;

  return array($ativos, $encerrados, $latentes);
}

/* **********************************************************************
   ImprimeTamanhoDosCursos - Imprime os nomes dos cursos e seus respectivos tamanhos (em Kbytes) como parte
                             de uma tabela
   Entrada: $sock - Socket de conexo
            $diretorio - Diretorio com os arquivos dos cursos
   Saida: Monta parte da tabela do tamanho dos cursos no HTML
*/
function ImprimeTamanhoDosCursos($sock, $diretorio)
{
  global $lista_frases;
 
  $query="select cod_curso,nome_curso from Cursos";
  $res = Enviar($sock,$query);

  $array = RetornaArrayLinhas($res);
  $tam_array = RetornaNumLinhas($res);

  if ($tam_array>0)
  {
    echo("<table border=2><tr>\n");
    /*Cabealho da tabela*/

    // 157 - Curso 
    echo("<td bgcolor=#990000><font color=white><b>".RetornaFraseDaLista($lista_frases,157)."</b></font></td>\n");

    // 158 - Tamanho (Kbytes)
    echo("<td bgcolor=#990000><font color=white><b>".RetornaFraseDaLista($lista_frases,158)."</b></font></td>\n");
    echo("</tr>\n");

    for ($i = 0; $i < $tam_array; $i++)
    {
      $valor=shell_exec("du -ks ".$diretorio."/".$array[$i]['cod_curso']."");
      $tam=explode('/', $valor);
      echo("<tr><td>".$array[$i]['nome_curso']."</td><td>".$tam[0]."</td></tr>\n");
    }
    echo("</table>\n");
  }
  else
    /* 159 - No h nenhum curso. */
    echo("".RetornaFraseDaLista($lista_frases,159)."");
}

/* **********************************************************************
   ImprimeNumeroDeAlunos - Imprime os nomes dos cursos e seus respectivos tamanhos (em Kbytes) como parte
                             de uma tabela
   Entrada: $sock - Socket de conexo
            $lista - Lista com todos os usurios (e seus respectivos tipos) de todos os cursos
   Saida: Monta a tabela do nmero de alunos por curso no HTML
*/
function ImprimeNumeroDeAlunos($sock,$lista)
{
  global $lista_frases;
  $query="select nome_curso from Cursos";
  $res=Enviar($sock,$query);

  if (count($lista)>0)
  {
    $TotalInsc=0; $TotalAc=0; $TotalForm=0;
    echo("<table border=2><tr>\n");
    /*Cabealho da tabela*/
    // 157 - Curso 
    echo("<td bgcolor=#990000><font color=white><b>".RetornaFraseDaLista($lista_frases,157)."</b></font></td>\n");
    // 160 - Alunos Inscritos
    echo("<td bgcolor=#990000><font color=white><b>".RetornaFraseDaLista($lista_frases,160)."</b></font></td>\n");
    // 161 - Alunos Aceitos
    echo("<td bgcolor=#990000><font color=white><b>".RetornaFraseDaLista($lista_frases,161)."</b></font></td>\n");
    // 162 - Formadores
    echo("<td bgcolor=#990000><font color=white><b>".RetornaFraseDaLista($lista_frases,162)."</b></font></td>\n");

    $nomes = RetornaArrayLinhas($res);
    $i = 0;
    foreach($lista as $cod => $linha)
    {
      if (count($linha['Res'])>0)
      {                                ;
        $AInscritos=0; $AAceitos=0; $Formadores=0;
        foreach($linha['Res'] as $cod1 => $linha1)
        {
          foreach($linha['Campos'] as $cod2 => $linha2)
          {
            if ($linha1[$linha2]=='r' || $linha1[$linha2]=='a') $AInscritos++;
            else if ($linha1[$linha2]=='A') $AAceitos++;
            else if ($linha1[$linha2]=='F') $Formadores++;
          }
        }
        $AInscritos += $AAceitos;
        echo("<tr><td>".$nomes[$i]["nome_curso"]."</td><td>$AInscritos</td><td>$AAceitos</td><td>$Formadores</td></tr>\n");
        $i++;
        $TotalInsc += $AInscritos;
        $TotalAc += $AAceitos;
        $TotalForm += $Formadores;
      }
    }
    echo("<tr><td><b>Todos</b></td><td>$TotalInsc</td><td>$TotalAc</td><td>$TotalForm</td></tr>\n");
    echo("</table>\n");
  }
  else
    /* 159 - No h nenhum curso. */
    echo("".RetornaFraseDaLista($lista_frases,159)."");
}
?>
