<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : cursos/aplic/administracao/administracao.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/* ==========================================================
   ARQUIVO : cursos/aplic/administracao/administracao.inc
   ========================================================== */


/* *********************************************************************
   HouveAlteracoes - Verifica se houve alteraes nas bases de dados
                     utilizada pela administrao.
   Entrada: $sock - BASE DO CURSO ou BASE EXTERNA
            $cod_curso= codigo do curso,
   Saida:   array ['cod_curso'] = codigo do curso
                  ['nome_curso'] = nome do curso
                  ['inscricao_inicio'] = timestamp do dia de inicio da inscricao
                  ['inscricao_fim'] = timestamp do dia de fim da inscricao
                  ['curso_inicio'] = timestamp do dia de inicio do curso
                  ['curso_fim'] = timestamp do dia de fim do curso
                  ['informacoes'] = informacoes sobre o curso
                  ['publico_alvo'] = Publico esperado
                  ['tipo_inscricao'] = tipo de inscricao
                  ['acesso_visitante'] = 'A' - Permite acesso de visitante
                                         'N' - No permite
*/

function HouveAlteracoes($sock, $cod_usuario)
{
  /* Cria um array com 4 elementos com valores iniciais iguais a zero. */
  /* O valor de cada elemento ser utilizado para adicionar a tag bold */
  /* nas ferramentas onde houve modificaes.                          */

  $alt = array(0,  /* Modificaes no cronograma do curso.         */
               0,  /* Modificaes na escolha de ferramentas.      */
               0,  /* Modificaes no destaque de ferramentas.     */
               0); /* Nova requisio de inscrio.                */

  /* Obtm o horrio do penltimo acesso do usurio e compara-o com */
  /* as datas das tabelas.                                          */
  $penultac = PenultimoAcesso($sock, $cod_usuario, "");

  /* Verifica se houve modificao no cronograma do curso.          */
  $query = "select _timestamp from Cursos";
  $res = Enviar($sock, $query);
  $tupla = RetornaLinha($res);
  if ($tupla['data'] > $penultac)
    $alt[0] = 1;

  /* Verifica se houve modificao na escolha das ferramentas.      */
  unset($tupla);
  $query = "select max(_timestamp) 'data' from Curso_ferramentas";
  $res = Enviar($sock, $query);
  $tupla = RetornaLinha($res);
  if ($tupla['data'] > $penultac)
    $alt[1] = 1;

  /* Verifica se houve modificao no destaque das ferramentas.     */
  unset($tupla);
  $query = "select max(data) 'data' from Ferramentas_destaque";
  $res = Enviar($sock, $query);
  $tupla = RetornaLinha($res);
  if ($tupla['data'] > $penultac)
    $alt[2] = 1;

  /* Verifica se h uma nova requisio de inscrio.               */
  unset($tupla);
  $query = "select max(data_inscricao) 'data' from Usuario where tipo_usuario = 'a'";
  $res = Enviar($sock, $query);
  $tupla = RetornaLinha($res);
  if ($tupla['data'] > $penultac)
    $alt[3] = 1;

  /* Se alguma das alteraes for verdadeira sinaliza o menu das    */
  /* ferramentas.                                                   */
  if ($alt[0] or $alt[1] or $alt[2] or $alt[3])


  return($alt);
}

/* *********************************************************************
   RetornaDadosCurso - Atualiza o cronograma do curso
   Entrada: $sock - BASE DO CURSO ou BASE EXTERNA
            $cod_curso= codigo do curso,
   Saida:   array ['cod_curso'] = codigo do curso
                  ['nome_curso'] = nome do curso
                  ['inscricao_inicio'] = timestamp do dia de inicio da inscricao
                  ['inscricao_fim'] = timestamp do dia de fim da inscricao
                  ['curso_inicio'] = timestamp do dia de inicio do curso
                  ['curso_fim'] = timestamp do dia de fim do curso
                  ['informacoes'] = informacoes sobre o curso
                  ['publico_alvo'] = Publico esperado
                  ['tipo_inscricao'] = tipo de inscricao
                  ['acesso_visitante'] = 'A' - Permite acesso de visitante
                                         'N' - No permite
                  ['cod_lingua'] = codigo da lingua padro do curso (atual)
*/
function RetornaDadosCurso($sock,$cod_curso)
{
  $query ="select * from Cursos where cod_curso=".$cod_curso;
  $res=Enviar($sock,$query);
  return (RetornaLinha($res));
}

/* *********************************************************************
   CadastraDadosCurso - Atualiza o cronograma do curso 
   Entrada: $sock - BASE DO CURSO ou BASE EXTERNA
            $cod_curso= codigo do curso,
            $nome_curso = nome do curso
            $inscricao_inicio = timestamp do dia de inicio da inscricao
            $inscricao_fim = timestamp do dia de fim da inscricao
            $curso_inicio = timestamp do dia de inicio do curso
            $curso_fim = timestamp do dia de fim do curso
            $informacoes = informacoes sobre o curso
            $publico_alvo = Publico esperado
            $tipo_inscricao = tipo de inscricao
            $acesso_visitante = 'A' - Permite acesso de visitante
                                'N' - No permite
            $cod_lingua - Codigo da lingua padro a ser utilizada no curso
   Saida: true se tudo ok.
*/
function CadastraDadosCurso($sock,$cod_curso,$nome_curso,$inscricao_inicio,$inscricao_fim,$curso_inicio,$curso_fim,$informacoes,$publico_alvo,$tipo_inscricao,$acesso_visitante,$cod_lingua)
{
  if ($acesso_visitante!='A')
    $acesso_visitante='N';

  $nome_curso=EliminaScript($nome_curso);
  $informacoes=EliminaScript($informacoes);
  $publico_alvo=EliminaScript($publico_alvo);
  $tipo_inscricao=EliminaScript($tipo_inscricao);

  $query ="update Cursos set nome_curso='".$nome_curso."',";
  $query.=" inscricao_inicio=".Data2Unixtime($inscricao_inicio).",";
  $query.=" inscricao_fim=".Data2Unixtime($inscricao_fim).",";
  $query.=" curso_inicio=".Data2Unixtime($curso_inicio).",";
  $query.=" curso_fim=".Data2Unixtime($curso_fim).",";
  $query.=" informacoes='".$informacoes."',";
  $query.=" publico_alvo='".$publico_alvo."',";
  $query.=" tipo_inscricao='".$tipo_inscricao."',";
  $query.=" cod_lingua=".$cod_lingua.",";
  $query.=" acesso_visitante='".$acesso_visitante."'";
  $query.=" where cod_curso=".$cod_curso;

  $res=Enviar($sock,$query);
  return $res;
}

/* *********************************************************************
   CadastraCronograma - Atualiza o cronograma do curso
   Entrada: $sock - BASE DO CURSO ou BASE EXTERNA
            $cod_curso= codigo do curso,
            $inscricao_inicio = timestamp do dia de inicio da inscricao
            $inscricao_fim = timestamp do dia de fim da inscricao
            $curso_inicio = timestamp do dia de inicio do curso
            $curso_fim = timestamp do dia de fim do curso
   Saida: true se tudo ok.
*/
function CadastraCronograma($sock,$cod_curso,$inscricao_inicio,$inscricao_fim,$curso_inicio,$curso_fim)
{

  $query ="update Cursos set ";
  $query.=" inscricao_inicio=".Data2Unixtime($inscricao_inicio).",";
  $query.=" inscricao_fim=".Data2Unixtime($inscricao_fim).",";
  $query.=" curso_inicio=".Data2Unixtime($curso_inicio).",";
  $query.=" curso_fim=".Data2Unixtime($curso_fim);
  $query.=" where cod_curso=".$cod_curso;

  $res=Enviar($sock,$query);
  return $res;
}

/* *********************************************************************
   RetornaListaFerramentas - Retorna a lista de ferramentas
   Entrada: $sock - BASE EXTERNA
   Saida: array [$cod_ferramenta]['cod_texto_nome']
                [$cod_ferramenta]['cod_texto_descricao']
                [$cod_ferramenta]['diretorio']
*/
function RetornaListaFerramentas($sock)
{
  $query ="select * from Ferramentas order by cod_ferramenta";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  unset($lista1);
  foreach($lista as $cod=>$linha)
  {
    $lista1[$linha['cod_ferramenta']]['cod_texto_nome']=$linha['cod_texto_nome'];
    $lista1[$linha['cod_ferramenta']]['cod_texto_descricao']=$linha['cod_texto_descricao'];
    $lista1[$linha['cod_ferramenta']]['diretorio']=$linha['diretorio'];
  }
  return ($lista1);
}

/* *********************************************************************
   RetornaOrdemFerramentas - Retorna a ordem das ferramentas no menu
   Entrada: $sock - BASE EXTERNA
   Saida: array []['cod_ferramenta']= codigo da ferramenta
                []['posicao'] = posicao da ferramenta. -1 se barra
*/
function RetornaOrdemFerramentas($sock)
{
  $query ="select * from Menu order by posicao";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  return ($lista);
}

/* *********************************************************************
   RetornaFerramentasCurso - Retorna a lista de ferramentas com status e
                             acessibilidade
   Entrada: $sock - BASE DO CURSO
   Saida: array [$cod_ferramenta]['status']
                [$cod_ferramenta]['acesso_visitante']
*/
function RetornaFerramentasCurso($sock)
{
  $query ="select * from Curso_ferramentas order by cod_ferramenta";
  $res=Enviar($sock,$query);
  unset($lista1);
  if (RetornaNumLinhas($res)>0)
  {
    $lista=RetornaArrayLinhas($res);
    foreach($lista as $cod=>$linha)
    {
      $lista1[$linha['cod_ferramenta']]['status']=$linha['status'];
      $lista1[$linha['cod_ferramenta']]['acesso_visitante']=$linha['acesso_visitante'];
    }
  }
  return ($lista1);
}

/* *********************************************************************
   CompletaFerramentasCurso - Retorna a lista de ferramentas com status e
                             acessibilidade
   Entrada: $sock - BASE DO CURSO
            $lista_ferramentas - Lista de Ferramentas do Ambiente (RetornaListaFerramentas)
            $ferramentas_curso - Lista de Ferrametnas do Curso (RetornaFerramentasCurso)
   Saida: $ferramentas_curso modificada.
*/
function CompletaFerramentasCurso($sock,$lista_ferramentas,$ferramentas_curso)
{
  $lista1=$lista_ferramentas;
  $lista2=$ferramentas_curso;
  foreach($lista1 as $cod_ferramenta => $linha)
  {
    if (!isset($lista2[$cod_ferramenta]['status']))
    {
      if ($cod_ferramenta==1 || $cod_ferramenta==16 || $cod_ferramenta==17)
         $lista2[$cod_ferramenta]['status']='A';
      else
         $lista2[$cod_ferramenta]['status']='D';
      $lista2[$cod_ferramenta]['acesso_visitante']='N';
      $query="insert into Curso_ferramentas values (".$cod_ferramenta.",'".$lista2[$cod_ferramenta]['status']."','N')";
      $res=Enviar($sock,$query);
    }
  }
  return ($lista2);
}


/* *********************************************************************
   RetornaFerramentasMarcadas - Retorna a lista com os cdigos das ferramentas
     marcadas.

   Entrada: $sock - BASE DO CURSO
   Saida: array contendo $cod_ferramenta
*/

function RetornaFerramentasMarcadas($sock)
{
  $query = "select max(data) 'data' from Ferramentas_destaque";

  $res = Enviar($sock, $query);
  $linha = RetornaLinha($res);

  $maxdata = $linha['data'];
  if ($maxdata != NULL)
  {
    $query = "select cod_ferramenta from Ferramentas_destaque where data = ".$maxdata;
    $res = Enviar($sock, $query);

    $ferramentas_marcadas = RetornaArrayLinhas($res);
  }

  return($ferramentas_marcadas);
}

/* *********************************************************************
   MarcaFerramentas - Marca as ferramentas especificadas pelo array
     $lista_ferramentas. Se no houver ferramentas a serem marcadas
     insere na base com o cod_ferramenta -1 (invlido).

   Entrada: $sock - BASE DO CURSO,
            $lista_ferramentas - array com cod_ferramenta.
   Saida: true se bem-sucedido, false do contrrio
*/

function MarcaFerramentas($sock, $lista_ferramentas)
{
  /* Obtm a hora atual */
  $time = time();
  $res = true;

  /* Se no houver ferramentas marcadas, insira -1 como cdigo da ferramenta na base. */
  if (($total = count($lista_ferramentas)) == 0)
  {
    $query = "insert into Ferramentas_destaque values (-1, ".$time.")";
    $res = Enviar($sock, $query);
  }
  else
  {
    for ($i = 0; (($i < $total) && ($res == true)); $i++)
    {
      $query = "insert into Ferramentas_destaque values (".$lista_ferramentas[$i].", ".$time.")";
      $res = Enviar($sock, $query);
    }
  }
  AtualizaFerramentasNova($sock,0,'F');
  return($res);
}


/* *********************************************************************
   RetornaListaLogins - Retorna lista de logins existentes para conferncia
   Entrada: $sock - BASE DO CURSO
   Saida: array com [$login]==1 se login existe
*/
function RetornaListaLogins($sock)
{
  $query="select login from Usuario";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  foreach ($lista as $cod => $linha)
  {
    $saida[$linha['login']]=1;
  }
  return $saida;
}

/* *********************************************************************
   CadastrarUsuario - Cadastra o usurio com os dados passados. Envia
                      e-mail avisando login e senha.
   Entrada: $sock - BASE DO CURSO
            $cod_curso - Codigo do curso
            $dados - array com ['nome']
                               ['login']
                               ['email']
                               ['tipo_usuario']
                               ['senha']
   Saida: $sock com a base do curso  (necessrio por causa do e-mail)
*/
function CadastrarUsuario($sock,$cod_curso,$dados)
{
  global $lista_frases,$cod_lingua_s;
  $query="insert into Usuario (cod_usuario,nome,login,email,tipo_usuario,senha,data_inscricao,cod_lingua) values (".RetornaProximoCodigo($sock,"Usuario").",'".$dados['nome']."','".$dados['login']."','".$dados['email']."','".$dados['tipo_usuario']."','".crypt($dados['senha'],"AA")."',".time().",".$cod_lingua_s.")";
  Enviar($sock,$query);

  $dados_curso=DadosCursoParaEmail($sock);
  $remetente=$dados_curso['email'];
  $destino=$dados['email'];

  Desconectar($sock);
  $sock=Conectar("");

  $query="select valor from Config where item='host'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $host=$linha['valor'];

  $query="select diretorio from Diretorio where item='raiz_www'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $raiz_www=$linha['diretorio'];

  /* 63 - TelEduc: Inscrio */
  $assunto=RetornaFraseDaLista($lista_frases,63);

  if ($dados['tipo_usuario']=="A")
  {
    /* 64 - Voc foi inscrito como aluno para o curso */
    $mensagem =RetornaFraseDaLista($lista_frases,64)." '".$dados_curso['nome_curso']."'.\n\n";
  }
  else
  {
    /* 72 - Voc foi inscrito como formador para o curso */
    $mensagem =RetornaFraseDaLista($lista_frases,72)." '".$dados_curso['nome_curso']."'.\n\n";
  }

  /* 65 - Visite a pgina do curso para obter informaes sobre o seu incio. */
  $mensagem.=RetornaFraseDaLista($lista_frases,65).".\n\n";

  /* 66 - Anteciosamente, Coordenao do curso */
  $mensagem.=RetornaFraseDaLista($lista_frases,66).".\n\n";

  $mensagem.="-----------------------------------------------------\n\n";

  /* 67 - Seu login  */
  $mensagem.=RetornaFraseDaLista($lista_frases,67)." ".$dados['login']." ";

  /* 68 - e sua senha  */
  $mensagem.=RetornaFraseDaLista($lista_frases,68)." ".$dados['senha'].".\n\n";

  /* 69 - Estes dados serao pedidos a voce cada vez que entrar no curso. Para faze-lo, basta ir ao endereco */
  $mensagem.=RetornaFraseDaLista($lista_frases,69).":\n";

  $mensagem.="http://".$host.$raiz_www."/cursos/aplic/index.php?cod_curso=".$cod_curso."\n\n";

  /* 71 - Na primeira vez que entrar no curso, ser exibido um cadastro para que preencha seus dados pessoais. */
  $mensagem.=RetornaFraseDaLista($lista_frases,71).".\n";

  /* 70 - Para alterar a senha, entre na ferramenta Perfil, e selecione seu nome, e depois Alterar Senha. */
  $mensagem.=RetornaFraseDaLista($lista_frases,70).".\n";

  MandaMsg($remetente,$destino,$assunto,$mensagem);

  Desconectar($sock);
  $sock=Conectar($cod_curso);

  return ($sock);
}

/* *********************************************************************
   RetornaListaUsuariosDoGerenciamento - Retorna a lista de usuarios p/
                                         a tela gerenciamento.php
   Entrada: $sock - BASE DO CURSO
            $tipo_usuario - Tipo do usurio a ser retorna (a,r,A,F)
            $ordem - "nome" ou "data"
   Saida: array com [$cod_usuario]['nome']
                    [$cod_usuario]['data_inscricao']

*/
function RetornaListaUsuariosDoGerenciamento($sock,$tipo_usuario,$ordem)
{
  if ($ordem=="data")
    $ordem="data_inscricao";
  $query="select cod_usuario,nome,data_inscricao from Usuario where binary tipo_usuario='".$tipo_usuario."' and cod_usuario>=0 order by ".$ordem;
  $res=Enviar($sock,$query);
  while ($linha=RetornaLinha($res))
  {
    $saida[$linha['cod_usuario']]['nome']=$linha['nome'];
    $saida[$linha['cod_usuario']]['data_inscricao']=$linha['data_inscricao'];
  }
  return $saida;
}

/* *********************************************************************
   RetornaListaUsuariosDoGerenciamento - Retorna a lista de usuarios p/
                                         a tela gerenciamento.php
   Entrada: $sock - BASE DO CURSO
            $cod_curso - Codigo do curso
            $cod_usu - Array com codigo dos usuarios
            $tipo_usuario - Tipo do usurio a ser definidio (r,A)
            $assunto - Assunto da mensagem
            $mensagem - Mensagem em si (Em caso de A, ser anexado instrues de acesso).
   Saida: $sock da base do curso

*/
function MudarTipoUsuarioComMensagem($sock,$cod_curso,$cod_usu,$tipo_usuario,$assunto,$mensagem)
{
  global $lista_frases;

  Desconectar($sock);
  $sock=Conectar("");

  $query="select valor from Config where item='host'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $host=$linha['valor'];

  $query="select diretorio from Diretorio where item='raiz_www'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $raiz_www=$linha['diretorio'];

  Desconectar($sock);
  $sock=Conectar($cod_curso);

  if (count($cod_usu)>0)
  {
    $mensagem_temp=$mensagem;
    foreach($cod_usu as $cod => $cod_usuario)
    {
      $query="update Usuario set tipo_usuario='".$tipo_usuario."' where cod_usuario=".$cod_usuario;
      $res=Enviar($sock,$query);
      $dados_curso=DadosCursoParaEmail($sock);
      $query="select nome,email,login from Usuario where cod_usuario=".$cod_usuario;
      $res=Enviar($sock,$query);
      $dados=RetornaLinha($res);

      if ($tipo_usuario=="A")
      {
        $senha=GeraSenha();
        $senha_cript=crypt($senha,"AA");
        $query="update Usuario set senha='".$senha_cript."' where cod_usuario=".$cod_usuario;
        $res=Enviar($sock,$query);

        $mensagem =$mensagem_temp;
        $mensagem.="-----------------------------------------------------\n\n";

        /* 67 - Seu login  */
        $mensagem.=RetornaFraseDaLista($lista_frases,67)." ".$dados['login']." ";

        /* 68 - e sua senha  */
        $mensagem.=RetornaFraseDaLista($lista_frases,68)." ".$senha."\n\n";

        /* 69 - Estes dados serao pedidos a voce cada vez que entrar no curso. Para faze-lo, basta ir ao endereco */
        $mensagem.=RetornaFraseDaLista($lista_frases,69).":\n";

        $mensagem.="http://".$host.$raiz_www."/cursos/aplic/index.php?cod_curso=".$cod_curso."\n\n";

        /* 70 - Para alterar a senha, entre na ferramenta Perfil, e selecione seu nome, e depois Alterar Senha. */
        $mensagem.=RetornaFraseDaLista($lista_frases,70).".\n";
      }
      MandaMsg($dados_curso['email'],$dados['email'],$assunto,$mensagem);
    }
  }
  return $sock;
}

/* *********************************************************************
   MudaTipoUsuario - Muda o tipo do usurio.
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - codigo do usuario
            $tipo_usuario - Tipo do usurio a ser definidio
   Saida: nenhuma
*/
function MudaTipoUsuario($sock,$cod_usuario,$tipo_usuario)
{
  $query="update Usuario set tipo_usuario='".$tipo_usuario."' where cod_usuario=".$cod_usuario;
  $res=Enviar($sock,$query);
}

/* *********************************************************************
   RetornaDadosUsuario - Retorna dados do usuario da tabela Usuario
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - codigo do usuario
   Saida: nenhuma
*/
function RetornaDadosUsuario($sock,$cod_usuario)
{
  $query="select * from Usuario where cod_usuario=".$cod_usuario;
  $res=Enviar($sock,$query);
  return RetornaLinha($res);
}

/* *****************************************************************************
  RetornaListaEscolaridade - Verifica se existe a orientacao na tabela Perfil_Orientacao
  Entrada: $sock - sock de conexao EXTERNA
  Saida:   array com
            []['cod_escolaridade']
            []['cod_texto_escolaridade']
*/
function RetornaListaEscolaridade($sock)
{
  $query="select * from Escolaridade order by cod_escolaridade";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* *********************************************************************
   RetornaListaUsuariosDoGerenciamento - Retorna a lista de usuarios p/
                                         a tela gerenciamento.php
   Entrada: $sock - BASE DO CURSO
   Saida: array com [$cod_usuario]['nome']
                    [$cod_usuario]['login']

*/
function RetornaListaUsuariosSenha($sock)
{
  $query="select cod_usuario,nome,login,email from Usuario where cod_usuario>=0 and (binary tipo_usuario='A' or binary tipo_usuario='F') order by nome";
  $res=Enviar($sock,$query);
  while ($linha=RetornaLinha($res))
  {
    $saida[$linha['cod_usuario']]['nome']=$linha['nome'];
    $saida[$linha['cod_usuario']]['login']=$linha['login'];
    $saida[$linha['cod_usuario']]['email']=$linha['email'];
  }
  return $saida;
}

/* *********************************************************************
   AtualizaSenhaUsuario - Atualiza a senha do Usurio.
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - Codigo do Usuario
            $senha_crypt - Senha j criptografada
   Saida: nenhuma
*/
function AtualizaSenhaUsuario($sock,$cod_usuario,$senha)
{
  $query="update Usuario set senha='".$senha."' where cod_usuario=".$cod_usuario;
  $res=Enviar($sock,$query);
}

/* *********************************************************************
   AtualizaEmailusuario - Atualiza o e-mail do Usurio.
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - Codigo do Usuario
            $email - $email do usuario
   Saida: nenhuma
*/
function AtualizaEmailUsuario($sock,$cod_usuario,$email)
{
  $query="update Usuario set email='".$email."' where cod_usuario=".$cod_usuario;
  return(Enviar($sock,$query));
}

?>
