<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : bibliotecas/acesso_php.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : bibliotecas/acesso_php.inc
  ========================================================== */
/*
   Verificao de validao...
   IMPORTANTE : Tem que ser o primeiro comando do arquivo, e nada pode ter
   sido enviando para HTML...
   - Retorna o cod_usuario do usuario logado
*/


/* *********************************************************************
   AcessoNegado - Exibe a mensagem padro para entrada em rea restrita.
   Sem entrada ou saida. Interrompe o cdigo
*/
function AcessoNegado()
{
  $sock=Conectar($sock);
  /* 1 - Erro de Acesso */
  /* 2 - Sinto muito, mas voc no tem acesso a esta rea. */
  echo("<HTML><BODY BGCOLOR=white><H1>TelEduc</H1><h2>".RetornaFrase($sock,1,-2)."</h2>".RetornaFrase($sock,2,-2));
  Desconectar($sock);
  die("");
}

/* *********************************************************************
   VerificaAutenticacao - Verifica se o usurio tem autorizao no curso
   Entrada: $cod_curso - Codigo do curso
   Saida: Codigo do Usuario logado
*/
function VerificaAutenticacao($cod_curso)
{
  /* Informaes sobre alunos. cod_usuario>0 aluno normal.
     cod_usuario = -1 Administrador (Formador).
     cod_usuario = -2 visitante. (Acesso Passivo).
  */

  /* Adquire as variaveis de verificao */
  global $PHP_AUTH_USER,$PHP_AUTH_PW,$visitante_s,$cod_curso_s,$cod_lingua_s,$logout_flag_s;

  /* Obtm a raiz_www */
  $sock = Conectar("");
  $query = "select diretorio from Diretorio where item = 'raiz_www'";
  $res = Enviar($sock,$query);
  $linha = RetornaLinha($res);
  $raiz_www = $linha[0];
  Desconectar($sock);

  $caminho = $raiz_www."/cursos/aplic";
 
  if ($visitante_s=="sim")
  {
    $sock=Conectar("");
    $query="select acesso_visitante from Cursos where cod_curso=".$cod_curso;
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);
    if ($linha[0]!="A")
    {
      /* 12 - Este curso no permite a entrada de visitantes. */
      /* 23 - Voltar. */
      echo RetornaFrase($sock,12,-2).' <a href=# onclick=history.go(-1);>'.RetornaFrase($sock,23,-1).'</a>';
      Desconectar($sock);
      exit;
    }
    Desconectar($sock);
    return (-2);
  }
  else
  {
    if (!isset($PHP_AUTH_USER))
    {
      $sock=Conectar("");
      /* 3- Ambiente de Administrao do TelEduc */
      header('WWW-Authenticate: Basic realm="'.RetornaFrase($sock,10,-2).'"');
      header('HTTP/1.0 401 Unauthorized');
      /* 4 - Autorizao necessria para entrar no Ambiente de Administrao do TelEduc. */
      /* 23 - Voltar */
      echo RetornaFrase($sock,11,-2).' <a href=# onclick=history.go(-1);>'.RetornaFrase($sock,23,-1).'</a><p>';
      /* 24 - Caso tenha esquecido sua senha siga o link: */
      /* 23 - Esqueci minha senha!                        */
      echo(RetornaFrase($sock, 24, -2)." <a href='".$caminho."/esqueci_senha.php?cod_curso=".$cod_curso."'>".RetornaFrase($sock, 23, -2)."</a>");
      Desconectar($sock);
      exit;
    }
    else
    {
      $senha=crypt($PHP_AUTH_PW,"AA");
      if ($PHP_AUTH_USER=="admtele")
      {
        $sock=Conectar("");
        $query="select valor from Config where item='admtele'";
        $res=Enviar($sock,$query);
        $num=RetornaNumLinhas($res);
        $linha=RetornaLinha($res);
        if ($num<1 || $linha[0]!=$senha)
        {
          /* 10- Ambiente de Curso do TelEduc */
          header('WWW-Authenticate: Basic realm="'.RetornaFrase($sock,10,-2).'"');
          header('HTTP/1.0 401 Unauthorized');
          /* 11 - Autorizao necessria para entrar no Ambiente de Curso do TelEduc. */
          /* 23 - Voltar */
          echo RetornaFrase($sock,11,-2).' <a href=# onclick=history.go(-1);>'.RetornaFrase($sock,23,-1).'</a>';
          Desconectar($sock);
          exit;
        }
        else
        {
          Desconectar($sock);
          $cod_curso_s=$cod_curso;
          return (-1);
        }
      }
      else
      {
        $sock=Conectar($cod_curso);
        $query="select senha,cod_usuario from Usuario where login='".$PHP_AUTH_USER."'";
        $res=Enviar($sock,$query);
        $num=RetornaNumLinhas($res);
        $linha=RetornaLinha($res);

        if ($num<1 || $linha[0]!=$senha)
        {
          Desconectar($sock);
          $sock=Conectar("");
          /* 10 - Ambiente de Curso do TelEduc */
          header('WWW-Authenticate: Basic realm="'.RetornaFrase($sock,10,-2).'"');
          header('HTTP/1.0 401 Unauthorized');
          /* 11 - Autorizao necessria para entrar no Ambiente de Curso do TelEduc. */
          /* 23 - Voltar */
          echo RetornaFrase($sock,11,-2).' <a href=# onclick=history.go(-1);>'.RetornaFrase($sock,23,-1).'</a><p>';
          /* 24 - Caso tenha esquecido sua senha siga o link: */
          /* 23 - Esqueci minha senha!                        */
          echo(RetornaFrase($sock, 24, -2)." <a href='".$caminho."/esqueci_senha.php?cod_curso=".$cod_curso."'>".RetornaFrase($sock, 23, -2)."</a>");
          Desconectar($sock);
          exit;
        }
        else
        {
          /* Se o usurio efetuou o logout, requisita novamente as informaes para acesso. */
          if ($logout_flag_s == 1)
          {
            $GLOBALS['_SERVER']['PHP_AUTH_USER']='';
            $GLOBALS['_SERVER']['PHP_AUTH_PW']='';

            $logout_flag_s = 0;

            Desconectar($sock);
            $sock=Conectar("");
            /* 10 - Ambiente de Curso do TelEduc */
            header('WWW-Authenticate: Basic realm="'.RetornaFrase($sock,10,-2).'"');
            header('HTTP/1.0 401 Unauthorized');
            /* 11 - Autorizao necessria para entrar no Ambiente de Curso do TelEduc. */
            /* 23 - Voltar */
            echo RetornaFrase($sock,11,-2).' <a href=# onclick=history.go(-1);>'.RetornaFrase($sock,23,-1).'</a><p>';
            /* 24 - Caso tenha esquecido sua senha siga o link: */
            /* 23 - Esqueci minha senha!                        */
            echo(RetornaFrase($sock, 24, -2)." <a href='".$caminho."/esqueci_senha.php?cod_curso=".$cod_curso."'>".RetornaFrase($sock, 23, -2)."</a>");
            Desconectar($sock);
            exit;
          }
          else
          {
            Desconectar($sock);
            $cod_curso_s=$cod_curso;
            $sock=Conectar($cod_curso);
            $cod_lin=RetornaLinguaUsuario($sock,$linha[1]);  

            Desconectar($sock);
            if ($cod_lin!=$cod_lingua_s)
            {
              $sock=Conectar("");
              MudancaDeLingua($sock, $cod_lin); 
              Desconectar($sock);
            }
            return ($linha[1]);
          }
        }
      }
    }
  }
  echo("Se voc est vendo essa mensagem, ocorreu um erro na codificao dos IFs");
  exit;
}

/* *********************************************************************
   VerificaAutenticacaoAdministracao - Verifica se o usurio
                                       tem autorizao a administracao
   Sem entradas.
   Saida: Codigo do Usuario logado
*/
function VerificaAutenticacaoAdministracao()
{
  global $PHP_AUTH_USER,$PHP_AUTH_PW;
  $sock=Conectar("");

  if (!isset($PHP_AUTH_USER))
  {
    /* 3- Ambiente de Administrao do TelEduc */
    header('WWW-Authenticate: Basic realm="'.RetornaFrase($sock,3,-2).'"');
    header('HTTP/1.0 401 Unauthorized');
    /* 4 - Autorizao necessria para entrar no Ambiente de Administrao do TelEduc. */
    /* 23 - Voltar */
    echo RetornaFrase($sock,4,-2).' <a href=# onclick=history.go(-1);>'.RetornaFrase($sock,23,-1).'</a>';
    Desconectar($sock);
    exit;
  }
  else
  {
    $senha=crypt($PHP_AUTH_PW,"AA");
    $query="select valor from Config where item='admtele'";
    $res=Enviar($sock,$query);
    $num=RetornaNumLinhas($res);
    $linha=RetornaLinha($res);
    if ($num<1 || $linha[0]!=$senha || $PHP_AUTH_USER!="admtele")
    {
      /* 3- Ambiente de Administrao do TelEduc */
      header('WWW-Authenticate: Basic realm="'.RetornaFrase($sock,3,-2).'"');
      header('HTTP/1.0 401 Unauthorized');
      /* 4 - Autorizao necessria para entrar no Ambiente de Administrao do TelEduc. */
      /* 23 - Voltar */
      echo RetornaFrase($sock,4,-2).' <a href=# onclick=history.go(-1);>'.RetornaFrase($sock,23,-1).'</a>';
      Desconectar($sock);
      exit;
    }
  }
  Desconectar($sock);
}

/* *********************************************************************
   GeraSenha - Gera uma senha aleatria para o usurio
   Entrada: nenhuma
   Saida: senha gerada de 8 caracteres
*/
function GeraSenha()
{
  $caracteres="ABCDEFGHJLKMNPQRSTUVWXYZabcdefghjmnpqrstuvwxyz23456789";
  list($usec, $sec) = explode(' ', microtime());
  mt_srand((float) $sec + ((float) $usec * 100000));

  $senha="";

  for ($i=0;$i<8;$i++)
  {
    $senha.=$caracteres[mt_rand(0,53)];
  }
  return $senha;
}

?>
