<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : bibliotecas/acesso_sql.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : bibliotecas/acesso_sql.inc
  ========================================================== */

/* ************************************************************************
   InterrompeAcessoBase - Para todo o processamento da pgina e exibe
   mensagem de erro correpondente (s aplicvel a base de dados)
   Entrada: $erro - mensagem de erro a ser exibida.
   Obs.: Uso somente pela biblioteca acesso_sql.inc
*/  
function InterrompeAcessoBase($erro)
{
  echo("</script></table></div></table></div></table></div>\n");
  die($erro);
}

/* ************************************************************************
   LeConfig - Le arquivo de configurao a partir do arquivo teleduc.conf
              Todo diretorio deve conter o arquivo ".auth", com o caminho
              para teleduc.con
   Sem entrada ou saida. Afeta globais de uso de acesso_sql.inc
*/
function LeConfig()
{
  global $dbuser,$dbpassword,$dbnamebase,$dbnamecurso;
  $fp = fopen (".auth", "r");
  if (!$fp)
    InterrompeAcessoBase("Erro : LeConfig = Diretrio sem arquivo de autorizao.");
  $cam=fgets($fp,256);
  $cam1=explode("\n",$cam);
  $caminho=$cam1[0];
  fclose($fp);

  $fp=fopen($caminho."teleduc.conf","r"); 
  if (!$fp)
    InterrompeAcessoBase("Erro : LeConfig = Arquivo de configurao do TelEduc no encontrado.");
  while (!feof($fp))
  {
    $linha=fgets($fp,256);
    $parte=explode("=",$linha);
    $conteudo=explode("\n",$parte[1]);
    if ($parte[0]=="dbuser")
      $dbuser=$conteudo[0];
    if ($parte[0]=="dbpassword")
      $dbpassword=$conteudo[0];
    if ($parte[0]=="dbnamebase")
      $dbnamebase=$conteudo[0];
    if ($parte[0]=="dbnamecurso")
      $dbnamecurso=$conteudo[0];
  }
  fclose($fp);
}


/* *******************************************
   ConectarDB - Conecta a base de dados pedida
   Entrada: $base - nome da base de dados
   Saida: socket do servidor de base de dados, se ok.
          interrompe o cdigo e envia alerta caso contrario
*/
function ConectarDB($base)
{
  /* $UltimaConexaoBase_g est sendo usada provisriamente para resolver um
     problema com o sistema de linguas. At que achemos uma soluo, essa 
     variavel  acessada pelo arquivo linguas.inc */
  global $dbuser,$dbpassword,$UltimaConexaoBase_g;
  if (!isset($dbuser))
    LeConfig();

  $UltimaConexaoBase_g=$base;

  if (! $sock = mysql_connect('localhost',$dbuser,$dbpassword))
    InterrompeAcessoBase("ERRO : mysql_connect = ".mysql_error()."<BR>\n");
  else
  {
    if (! mysql_select_db($base, $sock))
      InterrompeAcessoBase("ERRO : mysql_select_db = ".mysql_error()."<BR>\n");
    else
      return($sock);
  }
}

/* *******************************************
   MudarDB - Muda a base de dados acessada
   Entrada: $base - nome da base de dados
   Saida: socket do servidor de base de dados, se ok.
          interrompe o cdigo e envia alerta caso contrario
*/
function MudarDB($sock,$cod_curso="")
{
  global $dbnamebase,$dbnamecurso;
  if ($cod_curso!="")
    $base=$dbnamecurso.$cod_curso;
  else
    $base=$dbnamebase;
  if (! mysql_select_db($base, $sock))
    InterrompeAcessoBase("ERRO : mysql_select_db = ".mysql_error()."<BR>\n");
  else
    return($sock);
}


/* *****************************************************
   Conectar - Funo de conexo as bases de uso continuo
   Entradas: $cod_curso - para acessar a base do curso correspondente
                        - "" para base geral
   Saida: socket do servidor de base de dados, se ok.
          interrompe o cdigo e envia alerta caso contrario
*/  
function Conectar($cod_curso)
{
  global $dbnamebase,$dbnamecurso;  
  if (!isset($dbnamebase))
    LeConfig();
  if (!isset($cod_curso) | $cod_curso=="")
    $base=$dbnamebase;
  else
    $base=$dbnamecurso.$cod_curso;
  return(ConectarDB($base));
}

/* **************************************************
   Desconectar - Funo de desconexo as bases em uso
   Entradas: $sock - Sock da base a ser liberado
*/  
function Desconectar($sock)
{
  if (! mysql_close($sock))
    die("ERRO : mysql_close = ".mysql_error()."<BR>\n");
}

/* **********************************************
   Enviar - Funo de execuo da query requerida
   Entradas: $sock - Sock da base a ser consultada
             $query - consulta a ser realizada
   Saida: apontador de resultado da consulta
*/  
function Enviar($sock, $query)
{
  if (!($ms = mysql_query($query, $sock)))
  {
    $enter = "%OD%0A";

    if (eregi("^SELECT",$query))
      $palavra = "pesquisa";
    else
      $palavra = "atualiza&ccedil;&atilde;o";

    $ERRMSG = ereg_replace("\"", "", $ERRMSG = mysql_error());
    $ERRMSG = ereg_replace("'", "", $ERRMSG);

    $msgerro = "<h3>Ocorreu um erro na ".$palavra." solicitada\n<br>\n";
    $msgerro .= "Por favor tente novamente.</h3>";
    $msgerro .= "<b>Erro na consulta : </b>".$ERRMSG."\n<br>";
    $msgerro .= "<b>Consulta enviada : </b>\n".$query."\n<br>";
    $msgerro .= "<a href=# onclick='history.go(-1);return(false);'>Voltar</a>\n<br>";
    InterrompeAcessoBase($msgerro);
  }
  else
    return($ms);
}

/* **********************************************************
   RetornaNumLinhas - Retorna o nmero de linhas do resultado
   Entrada: $id - apontador de resultado da consulta
   Saida: nmero de linhas          
*/
function RetornaNumLinhas($id)
{
  return(mysql_num_rows($id));
}

/* **********************************************************
   RetornaLinha - Retorna a linha corrente do resultado
   Entrada: $id - apontador de resultado da consulta
   Saida: array com todos os campos da linha
*/
function RetornaLinha($id)
{
  return(mysql_fetch_array($id));
}

/* **********************************************************
   RetornaArrayLinhas - Retorna um array com todas as linhas
   Entrada: $id - apontador de resultado da consulta
   Saida: array das linhas 
*/
function RetornaArrayLinhas($id)
{
  unset($ar);
  $num=RetornaNumLinhas($id);
  $cont=0;
  while ($num>0)
  {
    $num--;
    $ar[$cont]=mysql_fetch_array($id); 
    $cont++;
  }
  return($ar);
}

/* **********************************************************
   RetornaNumCampos- Retorna nmero de campos do resultado da consulta
   Entrada: $id - apontador de resultado da consulta
   Saida: nmero de campos
*/
function RetornaNumCampos($id)
{
  $num=mysql_num_fields($id);
  return ($num);
}

/* **********************************************************
   RetornaCampos- Retorna array com os campos resultados da pesquisa
   Entrada: $id - apontador de resultado da consulta
   Saida: array com os campos
*/
function RetornaCampos($id)
{
  unset($linha);
  $num=mysql_num_fields($id);
  $c=0;
  while ($c<$num)
  {
    $field=mysql_fetch_field($id);
    $linha[$c]=$field->name;
    $c++;    
  }  
  return ($linha);
}

/* **********************************************************
   RetornaListaBases- Retorna nmero de campos do resultado da consulta
   Entrada: $sock - sock da base em uso
   Saida: array com o nome das bases da tabela
*/
function RetornaListaBases($sock)
{
  unset($lista);
  $db_list = mysql_list_dbs($sock);
  $c=0;
  while ($row = mysql_fetch_object($db_list)) 
  {
    $lista[$c]=$row->Database;
    $c++;
  }
  return ($lista);
}

/* *********************************************************************
   RetornaProximoCodigo- Retorna o prximo nmero a ser usado nessa base
   Entrada: $sock - sock da base em uso
            $tabela - nome da tabela a ser retirada a sequencia
   Saida: prximo numero da sequencia
*/
function RetornaProximoCodigo($sock,$tabela)
{
  global $cod_usuario;
  $cod_usuario_tmp=$cod_usuario;
  if ($cod_usuario_tmp=="")
    $cod_usuario_tmp=0;
    
  $data=time();
  $query="insert into ".$tabela."_sequencia (cod_usuario,data) values (".$cod_usuario_tmp.",".$data.")";
  if (!($res=mysql_query($query, $sock)))
  {
    /* Criar tabela e repetir */
    $query = "CREATE TABLE ".$tabela."_sequencia (cod int PRIMARY KEY AUTO_INCREMENT,cod_usuario INT,data INT)";
    $res=Enviar($sock,$query);
    $query="insert into ".$tabela."_sequencia (cod_usuario,data) values (".$cod_usuario_tmp.",".$data.")";
    $res=Enviar($sock,$query);
    $query="select cod from ".$tabela."_sequencia where cod_usuario=".$cod_usuario_tmp." and data=".$data;
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);
    $query="delete from ".$tabela."_sequencia where cod_usuario=".$cod_usuario_tmp." and data=".$data;
    $res=Enviar($sock,$query);
    return ($linha[0]);
  }
  else
  {
    $query="select cod from ".$tabela."_sequencia where cod_usuario=".$cod_usuario_tmp." and data=".$data;
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);
    $query="delete from ".$tabela."_sequencia where cod_usuario=".$cod_usuario_tmp." and data=".$data;
    $res=Enviar($sock,$query);
    return ($linha[0]);     
  }
}

/* *********************************************************************
   PegaSemaforo- Pega semaforo para ferramenta
   Entrada: $sock - sock da base em uso
            $ferramenta - nome da Ferramenta
   Sada: Somente quando consegue o semaforo, ou exibe mensagem de erro
*/
function PegaSemaforo($sock,$ferramenta)
{
  $cont=0;
  $query="CREATE TABLE Semaforo_".$ferramenta." (cod int)";
  while (!mysql_query($query, $sock))
  {
    if ($cont>10)
      die("</script></div></table></table></table>Erro interno! <a href=# onclick=history.go(-1);>Volte e tente novamente</a><br>Se o erro persistir, avise o suporte");
    $cont++;
    sleep(1);
  }
}

/* *********************************************************************
   LiberaSemaforo- Pega semaforo para ferramenta
   Entrada: $sock - sock da base em uso
            $ferramenta - nome da Ferramenta
   Sada: Nenhuma.
*/
function LiberaSemaforo($sock,$ferramenta)
{
  $query="DROP TABLE Semaforo_".$ferramenta;
  mysql_query($query,$sock);
}

/* *********************************************************************
   LiberaTodosSemaforos- Pega semaforo para ferramenta
   Entrada: $sock - sock da base em uso
   Sada: Nenhuma
*/
function LiberaTodosSemaforos($sock)
{
  $query="Show tables";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  foreach($lista as $cod => $linha)
  {
    if (eregi("^Semaforo",$linha[0]))
    {
      $query="DROP TABLE ".$linha[0];
      msql_query($query,$sock);
    }
  }
}

/* **********************************************
   EnviarNC - Funo de execuo da query requerida (no check)
   Entradas: $sock - Sock da base a ser consultada
             $query - consulta a ser realizada
   Saida: apontador de resultado da consulta
*/  
function EnviarNC($sock, $query)
{
  $ms = mysql_query($query, $sock);
  return($ms);
}


?>
