<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : bibliotecas/cursos.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : bibliotecas/cursos.inc
  ========================================================== */

/* *********************************************************************
   NomeCurso - Retorna o nome do curso
   Entrada: $sock - SOCK Externo
   Saida: string contendo o nome do curso
*/
function NomeCurso($sock, $cod_curso)
{
  $query="select nome_curso from Cursos where cod_curso = ".$cod_curso;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return $linha['nome_curso'];
}


/* *********************************************************************
   RetornaCursoConfig - retorna o valor associado a uma informao
                        especificada por item.
   Entrada: $sock - Base de dados do curso,
            $item - informao cujo valor  requisitado

   Saida:   string contendo o valor solicitado.
*/

function RetornaCursoConfig($sock, $item)
{
  $query = "select valor from Config where item = '".$item."'";
  $res = Enviar($sock, $query);
  $linha = RetornaLinha($res);
  return($linha['valor']);
}

/* *********************************************************************
   AlteraCursoConfig - altera o valor associado a uma informao
                       especificada por item.
   Entrada: $sock - Base de dados do curso,
            $item - informao cujo valor ser alterado,
            $valor - novo valor.

   Saida:   true se bem sucedido, do contrrio false.
*/

function AlteraCursoConfig($sock, $item, $valor)
{
  $query = "update Config set valor = '".$valor."' where item = '".$item."'";
  $res = Enviar($sock, $query);
  return($res);
}

/* *********************************************************************
   DadosCursoParaEmail - Retorna os dados do Curso para usar para enviar
                         e-mail
   Entrada: $sock - Base de dados do curso
   Saida: array com ['nome_curso'] - nome do curso
                    ['nome_coordenador'] - nome do coordenador
                    ['email'] - email do coordenador
*/
function DadosCursoParaEmail($sock)
{
  $query="select C.nome_curso 'nome_curso',U.nome 'nome_coordenador',U.email 'email' from Cursos C, Usuario U where C.cod_coordenador=U.cod_usuario";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return $linha;
}

/* *********************************************************************
   DadosAdministracaoParaEmail - Retorna os dados da administracao para
                                 Enviar e-mail
   Entrada: $sock - SOCK Externo
   Saida: e-mail do coordenador
*/

function DadosAdministracaoParaEmail($sock)
{
  $query="select * from Config where item='adm_email'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return ($linha[1]);
}

/* *********************************************************************
   RetornaStatusCurso - Retorna se o curso j est em andamento, ou se j
                        se encerrou
   Entradas: $sock - Socket da base de dados (retorno do Conectar)
             BASE DO CURSO
             $cod_curso - Curso em que ele est
   Saida: N - No comeou ainda
          A - Em Andamento
          E - Encerrado
          I - Invalido
*/
function RetornaStatusCurso($sock,$cod_curso)
{
  $query="select curso_inicio,curso_fim from Cursos where cod_curso=".$cod_curso;
  $res=Enviar($sock,$query);
  if (RetornaNumLinhas($res)>0)
  {
    $linha=RetornaLinha($res);
                $hoje=time();
                $ontem=$hoje - 86400;
    if ($linha[0]>$hoje)
      return ("N");
    else if ($linha[1]>=$ontem)
      return ("A");
    else
      return ("E");
    return ($linha[0]);
  }
  else
  {
    return ("I");
  }
}

/* *********************************************************************
   PreparaCabecalhoNomeCurso - Prepara o cabecalho com o nome do curso
   Entradas: $cod_curso
   Saida: String com a parte cabecalho do nome do curso
*/
function PreparaCabecalhoNomeCurso($cod_curso)
{
  global $sock;
  $query="select nome_curso from Cursos where cod_curso=".$cod_curso;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $saida ="<table cellpadding=0 cellspacing=0 border=0 width=100%><tr><td><font face=Arial,Verdana size=+1><b><nobr>".$linha['nome_curso']."</nobr></b></font></td></tr><tr><td bgcolor=#000000><img src=../figuras/invisivel.gif width=1 height=1 border=0></td></tr></table>";
  return $saida;
}


/* *********************************************************************
   PreparaCabecalho - Prepara o cabecalho das pginas
   Entradas: $cod_curso
             $cabecalho - Premontagem do cabecalho
             $cod_ferramenta - ferramenta atual
   Saida: string com o cabecalho
*/
function PreparaCabecalho($cod_curso,$cabecalho,$cod_ferramenta,$cod_pagina=null)
{
  global $cod_lingua_s,$sock,$cod_usuario,$bibliotecas;
 
  $ajuda_nao_encontrada=true;

  $cod_pagina=null;

  if (isset($cod_pagina))
  {
    $eformador=EFormador($sock,$cod_curso,$cod_usuario);
    MudarDB($sock,""); 
    $query="select nome_pagina,texto from Ajuda where cod_ferramenta=".$cod_ferramenta." and cod_pagina=".$cod_pagina." and cod_lingua=".$cod_lingua_s." and tipo_usuario='".($eformador ? 'F' : 'A' )."'";
    $res=Enviar($sock,$query);
    if (RetornaNumLinhas($res)>0)
    {
      $ajuda_nao_encontrada=false;
      $ajuda_link=$bibliotecas."../ajuda/ajuda.php?cod_ferramenta=".$cod_ferramenta."&cod_pagina=".$cod_pagina."&tipo_usuario=".($eformador ? 'F' : 'A' );
      $html_link="<td class=menu>&nbsp;<a class=menu href=".$ajuda_link." onClick=\"window.open('".$ajuda_link."','AjudaDisplay','width=600,height=400,top=100,left=100,scrollbars=yes,status=yes,toolbar=no,menubar=no,resizable=yes');return false;\" target=blank>Ajuda</a>&nbsp;</td>";
    }
    MudarDB($sock,$cod_curso);
  }

  // Esse ficar provisriamente, at que todas as pginas estiverem listadas
  if ($ajuda_nao_encontrada)
  {
    // Pegando o subtitulo da ferramenta para usar para linkar a ajuda
    $tmp=explode("> - ",$cabecalho);
    $tmp1=explode("</b>",$tmp[1]);
    $aname=RetiraEspacoEAcentos($tmp1[0]);

    // Checando se existe o diretrio com a Ajuda da ferramenta
    if (EFormador($sock,$cod_curso,$cod_usuario))
      $arquivo=$cod_lingua_s."_".$cod_ferramenta."_f.html";
    else
      $arquivo=$cod_lingua_s."_".$cod_ferramenta."_a.html";  

    if (file_exists($bibliotecas."../ajuda/".$arquivo))
    {
      $ajuda_link=$bibliotecas."../ajuda/".$arquivo."#".$aname;
      // ?? - Ajuda
      $html_link="<td class=menu>&nbsp;<a class=menu href=".$ajuda_link." onClick=\"window.open('".$ajuda_link."','PerfilDisplay','width=600,height=400,top=100,left=100,scrollbars=yes,status=yes,toolbar=no,menubar=no,resizable=yes');return false;\" target=blank>Ajuda</a>&nbsp;</td>";
    }
  }

  $saida=PreparaCabecalhoNomeCurso($cod_curso);
  $saida.="<table width=100% cellpadding=0 cellspacing=0 border=0>\n";
  $saida.="  <tr><td>".$cabecalho."</td>\n";
  $saida.="  <td width=1%>\n";
  $saida.="    <table border=0><tr>\n";
//  $saida.="      <tr><td class=menu>&nbsp;Busca&nbsp;</td><td class=menu>&nbsp;Ajuda&nbsp;</td><tr>\n";
//  $saida.="      <tr><td>".$ajuda_link."</td><tr>\n";
  $saida.=$html_link;
  $saida.="    </tr></table>\n";
  $saida.="  </td></tr>\n";
  $saida.="</table>\n";
  return $saida;
}

/* *********************************************************************
   CompletarDadosCurso - Retorna True se faltam dados do curso para completar
   Entradas: $sock - Socket da base de dados (retorno do Conectar)
             $cod_curso - Curso em que ele est
   Saida: true se precisa completar dados
*/
function CompletarDadosCurso($sock,$cod_curso)
{
  $query="select inscricao_inicio,inscricao_fim,curso_inicio,curso_fim,informacoes,publico_alvo,tipo_inscricao from Cursos where cod_curso=".$cod_curso;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  if ($linha['inscricao_inicio']=="" || $linha['inscricao_fim']=="" || $linha['curso_inicio']=="" || $linha['curso_fim']=="" || $linha['informacoes']=="" || $linha['publico_alvo']=="" || $linha['tipo_inscricao']=="")
    return true;
  return false;
}


?>
