<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : bibliotecas/linguas.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : bibliotecas/linguas.inc
  ========================================================== */

/* ************************************************************************
   RetornaFrase - Retorna a frase pedida da lingua atual
   Entrada: $sock - Sock da base geral aberta
            $cod_texto - cod_texto a ser empregado.
            $cod_ferramenta - cod_ferramenta a ser empregada  
   Saida: Texto na lingua pedida
*/
function RetornaFrase($sock, $cod_texto, $cod_ferramenta)
{
  Global $cod_lingua_s,$lista_frases_s;
  $cod_lingua=$cod_lingua_s;

  if (!isset($lista_frases_s[$cod_ferramenta]))
  {
    $query = "SELECT texto FROM Lingua_textos WHERE ";
    $query .= "cod_texto=".$cod_texto." AND ";
    $query .= "cod_lingua=".$cod_lingua." AND ";
    $query .= "cod_ferramenta=".$cod_ferramenta;

    if($id_query = Enviar($sock, $query))
    {
      $linha = RetornaLinha($id_query);
      $texto = $linha[0];
      if (! isset($texto))
        $texto = "(ERRO : Texto correspondente a essa lngua no cadastrado: ".$cod_texto.")";
    }
    else
    {
      // Erro na execuo da clusula : terminar o programa
      $msg = "</script></table></div></table></div></table></div><H3>ERRO : No foi possvel executar a clusula SQL<H3>";
      $msg .= "<BR><B>SQL : </B><BR>".$query;
      $msg .= "<BR><B>Mensagem de erro do Msql : </B><BR>".msql_error();
      $msg .= "<BR><a href=# onclick=history.go(-1);>Voltar</a>";
      die($msg);
    }
  }
  else
  {
    $texto=$lista_frases_s[$cod_ferramenta][$cod_texto];
  }

  return(ConverteAspas2Html($texto));
}

/* ************************************************************************
   RetornaListaDeFrases - Retorna uma lista com todas as frases da 
                          ferramenta escolhida. usada em conjunto com
                          RetornaFraseDaLista
   Entrada: $sock - Sock da base geral aberta
            $cod_ferramenta - cod_ferramenta a ser empregada  
   Saida: Array com a lista de frases
*/
function RetornaListaDeFrases($sock, $cod_ferramenta)
{
  Global $cod_lingua_s,$lista_frases_s;

  $cod_lingua=$cod_lingua_s;

  /* Se j estiver em memoria, vai direto... */
  if (isset($lista_frases_s[$cod_ferramenta]) && count($lista_frases_s[$cod_ferramenta])>0)
    return ($lista_frases_s[$cod_ferramenta]); 

  $query = "SELECT cod_texto, texto FROM Lingua_textos WHERE ";
  $query .= "cod_lingua=".$cod_lingua." AND ";
  $query .= "cod_ferramenta=".$cod_ferramenta." ";
  $query .= "ORDER BY cod_texto";

  if ($id_query = Enviar($sock, $query))
  {
    unset($textos);

    if (RetornaNumLinhas($id_query) > 0)
      while($linha = RetornaLinha($id_query))
        $textos[$linha["cod_texto"]] = $linha["texto"];
  }
  else
  {
    // Erro na execuo da clusula : terminar o programa
    $msg = "<H3>ERRO : No foi possvel executar a clusula SQL<H3>";
    $msg .= "<BR><B>SQL : </B><BR>".$query;
    $msg .= "<BR><B>Mensagem de erro do Msql : </B><BR>".msql_error();
    $msg .= "<BR><a href=# onclick=history.go(-1);>Voltar</a>";
    die($msg);
  }
  $lista_frases_s[$cod_ferramenta]=$textos;

  return($textos);
}

/* ************************************************************************
   RetornaFraseDaLista - Retorna a frase pedida da lingua atual
   Entrada: $textos - Array com lista de frases (RetornaListaDeFrases)
            $cod_texto - cod_texto a ser empregado.
   Saida: Texto na lingua pedida
*/
function RetornaFraseDaLista($textos, $cod_texto)
{
  return(ConverteAspas2Html($textos[$cod_texto]));
}

/* ************************************************************************
   ListaDeFrasesEmMemoria - Retorna true se j estiver me memria
   Entrada: $cod_ferramenta - cod_ferramenta a ser empregada  
   Saida: True se j estiver
*/
function ListaDeFrasesEmMemoria($cod_ferramenta)
{
  global $lista_frases_s;
  return (isset($lista_frases_s[$cod_ferramenta]));
}

/* ************************************************************************
   ListaLinguas - Retorna a lista de linguas cadastradas
   Entrada: $sock - BASE Externa
   Saida: array [$cod_lingua]=nome
*/
function ListaLinguas($sock)
{
  Global $cod_lingua_s;
  $query="select cod_texto 'cod_lingua',texto 'lingua' from Lingua_textos where cod_ferramenta=-6 and cod_lingua=".$cod_lingua_s." order by cod_texto";
  $res=Enviar($sock,$query);
  unset ($saida);
  while ($linha=RetornaLinha($res))
    $saida[$linha['cod_lingua']]=$linha['lingua'];
  return $saida;
}

/* ************************************************************************
   MemorizaListaDeFrases - Memoriza uma lista com todas as frases da
                          ferramenta escolhida. A partir desse momento, menos 
                          selects necessitarao ser feitos a base
   Entrada: $sock - Sock da base geral aberta
            $cod_ferramenta - cod_ferramenta a ser empregada
   Saida: nenhuma 
*/
function MemorizaListaDeFrases($sock, $cod_ferramenta)
{
  Global $cod_lingua_s,$lista_frases_s;

  $cod_lingua=$cod_lingua_s;

  $query = "SELECT cod_texto, texto FROM Lingua_textos WHERE ";
  $query .= "cod_lingua=".$cod_lingua." AND ";
  $query .= "cod_ferramenta=".$cod_ferramenta." ";
  $query .= "ORDER BY cod_texto";

  if ($id_query = Enviar($sock, $query))
  {
    unset($textos);

  if (RetornaNumLinhas($id_query) > 0)
      while($linha = RetornaLinha($id_query))
        $textos[$linha["cod_texto"]] = $linha["texto"];
  }
  else
  {
    // Erro na execuo da clusula : terminar o programa
    $msg = "<H3>ERRO : No foi possvel executar a clusula SQL<H3>";
    $msg .= "<BR><B>SQL : </B><BR>".$query;
    $msg .= "<br><b>Arquivo: </b><br>lingua.inc";
    $msg .= "<BR><B>Mensagem de erro do Msql : </B><BR>".msql_error();
    $msg .= "<BR><a href=# onclick=history.go(-1);>Voltar</a>";
    die($msg);
  }
  $lista_frases_s[$cod_ferramenta]=$textos;
}

/* ************************************************************************
   MudancaDeLingua - Atualiza todas as frases em memoria para a nova lingua selecionada 
   Entrada: $sock - Base Externa 
            $cod_lingua - codigo da lingua a ser atualizada
   Saida: nenhuma
*/
function MudancaDeLingua($sock, $cod_lingua)
{
  Global $cod_lingua_s,$lista_frases_s;
 
  if ($cod_lingua_s != $cod_lingua)
  {
    $cod_lingua_s=$cod_lingua;
    foreach($lista_frases_s as $cod_fer => $lista)
    {
      MemorizaListaDeFrases($sock,$cod_fer);
    }
  }

}

  if (!ListaDeFrasesEmMemoria(-4) || !ListaDeFrasesEmMemoria(-3) || !ListaDeFrasesEmMemoria(-2) || !ListaDeFrasesEmMemoria(-1)
 || !ListaDeFrasesEmMemoria(0))
  {
    $sock=Conectar("");

    if (!ListaDeFrasesEmMemoria(-4))
      MemorizaListaDeFrases($sock,-4);
    if (!ListaDeFrasesEmMemoria(-3))
      MemorizaListaDeFrases($sock,-3);
    if (!ListaDeFrasesEmMemoria(-2))
      MemorizaListaDeFrases($sock,-2);
    if (!ListaDeFrasesEmMemoria(-1))
      MemorizaListaDeFrases($sock,-1);
    if (!ListaDeFrasesEmMemoria(0))
      MemorizaListaDeFrases($sock,0);

    Desconectar($sock);
  }


?>
