<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : cursos/aplic/correio/correio.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
*/
/*==========================================================
  ARQUIVO : cursos/aplic/correio/correio.inc
  ========================================================== */

/*
Biblioteca de funcoes correio.inc
Para uso com a Ferramenta correio no Programa Teleduc
Autor: Leonel Aguilar Gayard
*/

/* ind_a
Funes nesta biblioteca:

RetornaListaMensagensNovas
RetornaListaMensagensRecebidas
RetornaListaMensagensEnviadas
RetornaListaMensagensLixeira
ComparaAutorCres
ComparaAutorDesc
ComparaAutorDesc
ComparaDestDescLixeira
RetornaNumMensagens
RetornaInfosMensagem
RetornaCodigoGruposDoCurso
RetornaNomeUsuarioDeCodigo
RetornaNumArquivosDaMensagem
RetornaCodigoFormadoresDoCurso
RetornaEstadoDaMensagemPorExtenso
RetornaCodigoAlunosDoCurso
RetornaGrupoComCodigo
InsereMsgCM
InsereMsgCLDCD
InsereMsgCD
PrimeiroDestinatarioDaMensagem
ListaCompletaDestinatarios
ApagaMsgCD
ApagaMsgCM
ApagaDefCM
ApagaDefCD
RetornaEstadoAbrev
AtualizaEstadoMsgCD
RetornaNumDestinatariosMsg
RetornaCategDestinoCodUsuarioMsg
EndentarMensagem
UsuarioEhDestinatarioDaMensagem
UsuarioEhDestinatarioDaMensagemApagada
RecuperaCM
RecuperaCD

ind_b
*/

/* *******************************************************************
  RetornaListaMensagensNovas - retorna lista com somente as mensagens novas
                               para o usuario
  Entrada: $sock - sock de conexao
           $cod_usuario - codigo do usuario
           $ordem - parametro de ordenacao
  Saida:   array bidimensional, sendo o segundo array com:
           ['cod_msg'] - codigo da mensagem
           ['assunto'] - assunto da mensagem
           ['cod_usuario_autor'] - codigo do usuario autor da mensagem
           ['data'] - data da mensagem em UnixTime
           ['nome'] - nome do autor da mensagem
*/
function RetornaListaMensagensNovas($sock,$cod_usuario,$ordem)
{
  $query="select cod_msg from Correio_destinos where cod_usuario=".$cod_usuario." and estado='N'";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);

  $where_clause="CM.cod_msg=";
  if (count($lista)>0)
    foreach($lista as $cod=>$linha)
      $where_clause.=$linha['cod_msg']." or CM.cod_msg=";
  $where_clause.="-1"; /* S para simplificar o cdigo, evitando fazer teste para caso vazio */

  $array_ordem="DataDesc,DataCres,AssuntoDesc,AssuntoCres,RemetenteDesc,RemetenteCres";
  $tmp_ordem=explode(",",$array_ordem);
  $array_base="CM.data DESC,CM.data,CM.assunto DESC,CM.assunto,U.nome DESC,U.nome";
  $tmp_base=explode(",",$array_base);

  $num=0;
  while($ordem != $tmp_ordem[$num] && $num < count($tmp_ordem))
    $num++;
  /* aqui, eh uma pesquisa nos arrays auxiliares para encontrar o correspondente MySQL para
     o parametro $ordem passado */

  $ordem_base=$tmp_base[$num];

  $query="select CM.cod_msg as cod_msg,CM.assunto as assunto,CM.cod_usuario as cod_usuario_autor,CM.data as data,U.nome as nome from Correio_mensagens as CM,Usuario as U where (".$where_clause.") and U.cod_usuario=CM.cod_usuario order by ".$ordem_base;

  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  return $lista;
}

/* *******************************************************************
  RetornaListaMensagensRecebidas - retorna lista de mensagens novas e recebidas
                                        do usuario
  Entrada: $sock - sock de conexao
           $cod_usuario - codigo do usuario
           $ordem - parametro de ordenacao
  Saida:   array bidimensional, o segundo array com:
           ['cod_msg'] - codigo da mensagem
           ['assunto'] - assunto da mensagem
           ['cod_usuario_autor'] - codigo do usuario autor da mensagem
           ['data'] - data da mensagem em UnixTime
           ['nome'] - nome do usuario autor da mensagem
*/
function RetornaListaMensagensRecebidas($sock,$cod_usuario,$ordem)
{
  $query="select cod_msg from Correio_destinos where cod_usuario=".$cod_usuario." and (estado='N' or estado='L' or estado='R' or estado='U')";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);

  $array_ordem="DataDesc,DataCres,AssuntoDesc,AssuntoCres,RemetenteDesc,RemetenteCres";
  $tmp_ordem=explode(",",$array_ordem);
  $array_base="CM.data DESC,CM.data,CM.assunto DESC,CM.assunto,U.nome DESC,U.nome";
  $tmp_base=explode(",",$array_base);

  $num=0;
  while($ordem != $tmp_ordem[$num] && $num < count($tmp_ordem))
    $num++;
  /* aqui, eh uma pesquisa nos arrays auxiliares para encontrar o correspondente MySQL para
     o parametro $ordem passado */

  $ordem_base=$tmp_base[$num];

  $where_clause="cod_msg=";
  foreach($lista as $cod=>$linha)
    $where_clause.=$linha[0]." or cod_msg=";
  $where_clause.="-1"; /* S para simplificar o cdigo, evitando fazer teste para caso vazio */

  /* codigo do usuario autor da mensagem */
  $query="select CM.cod_msg as cod_msg,CM.assunto as assunto,CM.cod_usuario as cod_usuario_autor,CM.data as data,U.nome as nome from Correio_mensagens as CM,Usuario as U where (".$where_clause.") and U.cod_usuario=CM.cod_usuario order by ".$ordem_base;

  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  return $lista;
}

/* *******************************************************************
  RetornaListaMensagensEnviadas - retorna lista de mensagens enviadas pelo usuario
  Entrada: $sock - sock de conexao
           $cod_usuario - codigo do usuario
           $ordem - parametro de ordenacao
  Saida:   array bidimensional, o segundo array com:
           []['cod_msg'] - codigo da mensagem
           []['assunto'] - assunto da mensagem
           []['data'] - data da mensagem em UnixTime
           []['destinatario'] - destinatario da mensagem. Se for mais de um, retorna o
                                primeiro seguido de " ..."
*/
function RetornaListaMensagensEnviadas($sock,$cod_usuario,$ordem)
{
  $array_ordem="DataDesc,DataCres,AssuntoDesc,AssuntoCres,DestinatarioDesc,DestinatarioCres";
  $tmp_ordem=explode(",",$array_ordem);
  $array_base="data DESC,data,assunto DESC,assunto,---,---";
  $tmp_base=explode(",",$array_base);

  /* aqui, eh uma pesquisa nos arrays auxiliares para encontrar o correspondente MySQL para
     o parametro $ordem passado */
  $num=0;
  while($ordem != $tmp_ordem[$num] && $num < count($tmp_ordem))
    $num++;

  if ($ordem != "DestinatarioDesc" && $ordem != "DestinatarioCres")
  {
    /* $ordem nao eh DestinatarioDesc nem DestinatarioCres */
    $ordem_base="order by ".$tmp_base[$num];
  }
  else
    /* ordenacao por destinatario */
    unset($ordem_base);

  $query="select cod_msg, assunto, data from Correio_mensagens where (cod_usuario=".$cod_usuario.") and (estado = 'E' or estado = 'R') ".$ordem_base;
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);

  if (count($lista)>0)
  {
    $cont=0;
    while ($cont<count($lista))
    {
      $lista[$cont]['destinatario']=PrimeiroDestinatarioDaMensagem($sock,$lista[$cont]['cod_msg']);
      $cont++;
    }
    if ($ordem == "DestinatarioDesc")
      uasort($lista,ComparaDestinatarioDescrescente);
    else if ($ordem == "DestinatarioCres")
      uasort($lista,ComparaDestinatarioCrescente);
  }
  return $lista;
}

/* *******************************************************************
  ComparaDestinatarioDescrescente - usado internamente com o uasort.
                                    compara o conteudo de uma sequencia
*/
function ComparaDestinatarioDescrescente($ar1, $ar2)
{
  if ($ar1['destinatario']>$ar2['destinatario'])
    return -1;
  else if ($ar1['destinatario']<$ar2['destinatario'])
    return 1;
  return 0;
}

/* *******************************************************************
  ComparaDestinatarioCrescente - usado internamente com o uasort.
                                 compara o conteudo de uma sequencia
*/
function ComparaDestinatarioCrescente($ar1, $ar2)
{
  if ($ar1['destinatario']>$ar2['destinatario'])
    return 1;
  else if ($ar1['destinatario']<$ar2['destinatario'])
    return -1;
  return 0;
}

/* *******************************************************************
  RetornaListaMensagensLixeira - Retorna Lista de mensagens da lixeira
  Entrada: $sock - sock de conexao
           $cod_usuario - codigo do usuario
           $ordem - parametro de ordenacao
  Saida:   array bidimensional, o segundo array com:
           []['cod_msg'] - codigo da mensagem
           []['assunto'] - assunto da mensagem
           []['cod_usuario'] - codigo do usuario autor da mensagem
           []['nome_autor'] - nome do autor da mensagem
           []['destinos'] - nome dos destinatarios da mensagem
           []['data'] - data da mensagem, em UnixTime

*/
function RetornaListaMensagensLixeira($sock,$cod_usuario,$ordem)
{
  /* Mensagens que foram recebidas e apagadas */
  $query="select cod_msg from Correio_destinos where estado='A' and cod_usuario=".$cod_usuario;
  $res=Enviar($sock,$query);
  /* montando array com cod_msgs retornados */
  $num=RetornaNumLinhas($res);
  unset($linha);
  unset($lista_recebidas);
  for ($i=0;$i<$num;$i++)
  {
    $linha=RetornaLinha($res);
    $lista_recebidas[$i]=$linha['cod_msg'];
  }

  /* Mensagens que foram enviadas e apagadas */
  $query="select cod_msg from Correio_mensagens where estado='A' and cod_usuario=".$cod_usuario;
  $res=Enviar($sock,$query);
  /* montando array com cod_msgs retornados */
  $num=RetornaNumLinhas($res);
  unset($linha);
  unset($lista_enviadas);
  for ($i=0;$i<$num;$i++)
  {
    $linha=RetornaLinha($res);
    $lista_enviadas[$i]=$linha['cod_msg'];
  }

  /* merge dos dois arrays */
  $lista_query=array_unique(array_merge($lista_recebidas,$lista_enviadas));

  $array_ordem="DataDesc,DataCres,AssuntoDesc,AssuntoCres,DestinatarioDesc,DestinatarioCres,RemetenteDesc,RemetenteCres";
  $tmp_ordem=explode(",",$array_ordem);
  $array_base="data DESC,data,assunto DESC,assunto,---,---,---,---";
  $tmp_base=explode(",",$array_base);

  /* busca no array para identificar parametro de ordenacao */
  $num=0;
  while($ordem != $tmp_ordem[$num] && $num < count($tmp_ordem))
    $num++;

  /* 0 - DataDesc     4 - DestinatarioDesc
     1 - DataCres     5 - DestinatarioCres
     2 - AssuntoDesc  6 - RemetenteDesc
     3 - Assunto Cres 7 - RemetenteCres
  */

  /* se ordenacao vai ser feita pela base de dados ou pela funcao uasort */
  if ($num != 4 && $num != 5 && $num != 6 & $num != 7)
  {
    $ordenar_base=true;   /* ordenar pela base */
    $param_ordenacao="order by ".$tmp_base[$num];
  }
  else
  {
    $ordenar_base=false;
  }

  if (count($lista_query) > 0)
  {
    $where_clause="cod_msg=";
    foreach($lista_query as $cod => $linha)
      $where_clause.=$linha." or cod_msg=";
    $where_clause.="-1";

    $query="select cod_msg, assunto, cod_usuario, data from Correio_mensagens where (".$where_clause.") ".$param_ordenacao;
    $res=Enviar($sock,$query);
    $lista_retorno=RetornaArrayLinhas($res);

    /* adicionando remetente e destinatarios da msg ao array de retorno*/
    $c=0;
    while ($c<count($lista_retorno))
    {
      $lista_retorno[$c]['nome_autor']=RetornaNomeUsuarioDeCodigo($sock,$lista_retorno[$c]['cod_usuario']);
      $lista_retorno[$c]['destinos']=PrimeiroDestinatarioDaMensagem($sock,$lista_retorno[$c]['cod_msg']);
      $c++;
    }

    if (!$ordenar_base) /* ordenar pela funcao uasort */
    {
      if ($ordem == "DestinatarioDesc")
        uasort($lista_retorno,ComparaDestDescLixeira);
      else if($ordem == "DestinatarioCres")
        uasort($lista_retorno,ComparaDestCresLixeira);
      else if($ordem == "RemetenteDesc")
        uasort($lista_retorno,ComparaAutorDesc);
      else if($ordem == "RemetenteCres")
        uasort($lista_retorno,ComparaAutorCres);
    }

    return($lista_retorno);
  }
  else
  {
    unset($lista_retorno);
    return($lista_retorno);
  }
}

/* *******************************************************************
  ComparaAutorCres - usado internamento com o uasort. (ordem crescente)
                     compara os destinatarios das mensagens na lixeira
*/
function ComparaAutorCres($ar1,$ar2)
{
  if ($ar1['nome_autor']>$ar2['nome_autor'])
    return 1;
  else if ($ar1['nome_autor']<$ar2['nome_autor'])
    return -1;
  return 0;
}

/* *******************************************************************
  ComparaAutorDesc - usado internamento com o uasort. (ordem decrescente)
                     compara os autores das mensagens na lixeira
*/
function ComparaAutorDesc($ar1,$ar2)
{
  if ($ar1['nome_autor']>$ar2['nome_autor'])
    return -1;
  else if ($ar1['nome_autor']<$ar2['nome_autor'])
    return 1;
  return 0;
}

/* *******************************************************************
  ComparaDestCresLixeira - usado internamento com o uasort. (ordem crescente)
                           compara os destinatarios das mensagens na lixeira
*/
function ComparaDestCresLixeira($ar1,$ar2)
{
  if ($ar1['destinos']>$ar2['destinos'])
    return 1;
  else if ($ar1['destinos']<$ar2['destinos'])
    return -1;
  return 0;
}

/* *******************************************************************
  ComparaDestDescLixeira - usado internamento com o uasort. (ordem decrescente)
                           compara os destinatarios das mensagens na lixeira
*/
function ComparaDestDescLixeira($ar1,$ar2)
{
  if ($ar1['destinos']>$ar2['destinos'])
    return -1;
  else if ($ar1['destinos']<$ar2['destinos'])
    return 1;
  return 0;
}

/* **********************************************************************
  RetornaNumMensagens - Retorna numero de mensagens na base de dados
                             dentro daquele item de mensagem
  Entrada: $sock - sock de conexao
           $letra_item - letra do item para a mensagem
                         Pode ser: 'N'ova,'E'nviadas,'R'ecebidas,'L'ixeira
           $cod_usuario - codigo do usuario
  Saida  : numero de mensagens naquele item
*/
function RetornaNumMensagens($sock,$letra_item,$cod_usuario)
{
  if ($letra_item == 'N')
  {
    /* 'N' - novas */
    $query="select count(*) from Correio_destinos where estado='N' and cod_usuario=".$cod_usuario;
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);
    return $linha[0];
  }
  else if ($letra_item == 'R')
  {
    /* 'R' - respondidas, 'N' - novas, 'L' - lidas, 'U' - recuperadas */
    $query="select count(*) from Correio_destinos where (estado='R' or estado='N' or estado='L' or estado='U') and cod_usuario=".$cod_usuario;
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);
    return $linha[0];
  }
  else if ($letra_item == 'E')
  {
    /* 'E' para Enviadas e 'R' para recuperada */
    $query="select count(*) from Correio_mensagens where (estado='E' or estado='R') and cod_usuario=".$cod_usuario;
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);

    return $linha[0];
  }
  else if ($letra_item == 'L')
  {
    /* busca pelas mensagens enviadas e apagadas */
    $query="select cod_msg from Correio_mensagens where cod_usuario=".$cod_usuario." and estado='A'";
    $res=Enviar($sock,$query);
    /* montando array com cod_msgs de retorno */
    unset($lista1);
    $num1=RetornaNumLinhas($res);
    for ($c=0;$c<$num1;$c++)
    {
      $linha=RetornaLinha($res);
      $lista1[$c]=$linha['cod_msg'];
    }

    /* busca pelas mensagens recebidas e apagadas */
    $query="select cod_msg from Correio_destinos where cod_usuario=".$cod_usuario." and estado='A'";
    $res=Enviar($sock,$query);
    /* montando array com cod_msgs de retorno */
    unset($lista2);
    $num2=RetornaNumLinhas($res);
    for ($c=0;$c<$num2;$c++)
    {
      $linha=RetornaLinha($res);
      $lista2[$c]=$linha['cod_msg'];
    }

    /* faz o merge dos dois arrays */
    $lista_retorno=array_unique(array_merge($lista1, $lista2));

    /* retorna a contagem de elementos */
    $num=count($lista_retorno);
    return($num);
  }
}

/* *************************************************************************
  RetornaInfosMensagem - retorna codigo do autor, assunto, data e conteudo da msg
  Entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
  Saida:   array com
         ['cod_usuario'] - codigo do autor da mensagem
         ['assunto'] - assunto da mensagem
         ['data'] - data da mensagem em UnixTime
         ['mensagem'] - conteudo da mensagem
*/
function RetornaInfosMensagem($sock,$cod_msg)
{
  $Query="select cod_usuario,assunto,data,mensagem from Correio_mensagens where cod_msg=".$cod_msg;
  $res=Enviar($sock,$Query);
  $linha=RetornaLinha($res);
  return $linha;
}

/* *************************************************************************
  RetornaCodigoGruposDoCurso - retorna array com os cod_grupo dos grupos do curso
  Entrada: $sock - sock de conexao
  Saida:   array com os cod_grupo dos grupos do curso
*/
function RetornaCodigoGruposDoCurso($sock)
{
  $query="select cod_grupo from Grupos where status != 'X' order by nome";
  $res=Enviar($sock,$query);
  $linha=RetornaArrayLinhas($res);
  return $linha;
}

/* *************************************************************************
  RetornaNomeUsuarioDeCodigo - retorna nome do usuario cujo codigo eh igual a entrada
  Entrada: $sock - sock de conexao
           $cod_usuario - codigo do usuario do qual procurar o nome
  Saida:   nome do usuario com codigo == $cod_usuario
*/
function RetornaNomeUsuarioDeCodigo($sock,$cod_usuario)
{
  $query="select nome from Usuario where cod_usuario=".$cod_usuario;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return $linha['nome'];
}

/* *************************************************************************
  RetornaNumArquivosDaMensagem - retorna numero de arquivos anexos  mensagem
  Entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
  Saida:   numero de arquivos na mensagem
*/
function RetornaNumArquivosDaMensagem($sock,$cod_msg)
{
  $query="select count(arquivo) from Correio_anexos where cod_msg=".$cod_msg;
  $res=Enviar($sock,$query);
  $num=RetornaLinha($res);
  return $num;
}

/* *************************************************************************
  RetornaCodigoFormadoresDoCurso - retorna array com os cod_usuario dos formadores do curso
  Entrada: $sock - sock de conexao
  Saida:   array com os cod_usuario dos formadores do curso
*/
function RetornaCodigoFormadoresDoCurso($sock)
{
  $query="select cod_usuario from Usuario where binary tipo_usuario='F' order by nome";
  $res=Enviar($sock,$query);
  $linha=RetornaArrayLinhas($res);
  return $linha;
}

/* **********************************************************************
  RetornaEstadoDaMensagemPorExtenso - Percorre as tabela CD ou CM, para encontrar o estado
                                           da msg para o usuario
  Entrada: $sock - sock de conexao
           $letra_item - letra do item de mensagens
           $cod_msg - codigo da mensagem
           $cod_usuario - codigo do usuario
  Saida:   se $letra_item == 'R' e $abrev == 'N'=> "nova"
           se $letra_item == 'R' e $abrev == 'A'=> "apagada"
           se $letra_item == 'R' e $abrev == 'R'=> "respondida"
           se $letra_item == 'R' e $abrev == 'L'=> "lida"
           se $letra_item == 'R' e $abrev == 'U'=> "recuperada"
           se $letra_item == 'E' e $abrev == 'E' => "enviada"
           se $letra_item == 'E' e $abrev == 'A' => "apagada"
           se $letra_item == 'E' e $abrev == 'R' => "recuperada"
*/
function RetornaEstadoDaMensagemPorExtenso($sock,$letra_item,$cod_msg,$cod_usuario)
{
  global $lista_frases;

  if ($letra_item == 'R') /* usuario eh destinatario da msg: buscar estado em CD */
  {
    $query="select estado from Correio_destinos where cod_msg=".$cod_msg." and cod_usuario=".$cod_usuario;
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);
    $abrev=$linha['estado'];

    /* 49 - Nova */
    $tabela['N']=RetornaFraseDaLista($lista_frases,49);
    /* 50 - Apagada*/
    $tabela['A']=RetornaFraseDaLista($lista_frases,50);
    /* 51 - Respondida*/
    $tabela['R']=RetornaFraseDaLista($lista_frases,51);
    /* 52 - Lida*/
    $tabela['L']=RetornaFraseDaLista($lista_frases,52);
    /* 53 - Recuperada */
    $tabela['U']=RetornaFraseDaLista($lista_frases,53);

    return $tabela[$abrev];
  }
  else if ($letra_item == 'E') /* usuario eh emissor da msg: buscar estado em CM */
  {
    $query="select estado from Correio_mensagens where cod_msg=".$cod_msg;
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);
    $abrev=$linha['estado'];

    /* 54 - Enviada */
    $tabela['E']=RetornaFraseDaLista($lista_frases,54);
    /* 50 - Apagada */
    $tabela['A']=RetornaFraseDaLista($lista_frases,50);
    /* 53 - Recuperada */
    $tabela['R']=RetornaFraseDaLista($lista_frases,53);

    return $tabela[$abrev];
  }
}

/* *************************************************************************
  RetornaCodigoAlunosDoCurso - retorna array com os cod_usuario dos alunos do curso
  Entrada: $sock - sock de conexao
  Saida:   array com os cod_usuario dos alunos do curso
*/
function RetornaCodigoAlunosDoCurso($sock)
{
  $query="select cod_usuario from Usuario where binary tipo_usuario='A' order by nome";
  $res=Enviar($sock,$query);
  $linha=RetornaArrayLinhas($res);
  return $linha;
}

/* *************************************************************************
  RetornaGrupoComCodigo - retorna nome do grupo do codigo dado
  Entrada: $sock - sock de conexao
           $cod_grupo - codigo do grupo
  Saida: nome do grupo de codigo igual a $cod_grupo
*/
function RetornaGrupoComCodigo($sock,$cod_grupo)
{
  $query="select nome from Grupos where cod_grupo=".$cod_grupo;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return $linha['nome'];
}

/* *************************************************************************
  InsereMsgCM - insere mensagem e parametros em Correio_mensagens
  Entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
           $cod_autor - codigo do usuario autor da mensagem
           $assunto - assunto da mensagem
           $data - data da mensagem em UnixTime
           $mensagem - conteudo da mensagem
           $cod_msg_ant - codigo da mensagem anterior, caso esta aqui seja reply
  Saida:   nenhuma
*/
function InsereMsgCM($sock,$cod_msg,$cod_autor,$assunto,$data,$mensagem,$cod_msg_ant)
{
  $mensagem_limpa=LimpaConteudo($mensagem);
  $mensagem_limpa=EliminaScript($mensagem_limpa);
  $mensagem_limpa=Br2Enter($mensagem_limpa);

  $query="insert into Correio_mensagens values (".$cod_msg.",".$cod_autor.",'".LimpaTitulo($assunto)."',".$data.",'".$mensagem_limpa."','E',".$cod_msg_ant.")";
  $res=Enviar($sock,$query);
  if ($cod_msg_ant!="" && $cod_msg_ant!="NULL")
  {
    $query="update Correio_destinos set estado='R' where cod_msg=".$cod_msg_ant." and cod_usuario=".$cod_autor;
    Enviar($sock,$query);
  }

}

/* *************************************************************************
  InsereMsgCLDCD - insere parametros da mensagem em Correio_lista_destinos e chama InsereMsgCD
  Entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
           $cod_autor - codigo do usuario autor da mensagem
           $categ - parametro de categoria dos destinatarios
                  'TT' - todos
                  'TG' - todos os grupos
                  'TA' - todos os alunos
                  'TF' - todos os formadores
                  'G' - grupo individual
                  'U' - usuario individual
           $cod_categ - codigo da categoria destinataria da mensagem.
                  -1 se $categ for 'TT,'TG','TA' ou 'TF'
           $array_enviadas - array contendo os cod_usuario dos usuarios que ja receberam esta msg,
                           para que nao a recebam 2 vezes
  Saida:   $array_enviadas - mesmo array de entrada, aumentado com os usuarios que receberam a msg
                           ao final da funcao
                           Caso a msg seja enviada para todos (TT), retorna array vazio
*/
function InsereMsgCLDCD($sock,$cod_msg,$cod_autor,$categ,$cod_categ,$array_enviadas)
{

  if ($categ == "G")
  {
    $query="insert into Correio_lista_destinos values (".$cod_msg.",".$cod_autor.",".$cod_categ.",'G')";
    $res=Enviar($sock,$query);

    $query="select distinct cod_usuario from Grupos_usuario where cod_grupo=".$cod_categ;
    $res=Enviar($sock,$query);
    $lista=RetornaArrayLinhas($res);

    foreach ($lista as $cod=>$linha)
      if (!in_array($linha['cod_usuario'],$array_enviadas))
      {
        InsereMsgCD($sock,$cod_msg,$linha['cod_usuario'],$cod_autor);
        array_push($array_enviadas,$linha['cod_usuario']);
      }
    return ($array_enviadas);
  }
  else if ($categ == "U")
  {
    if (!in_array($cod_categ,$array_enviadas))
    {
      $query="insert into Correio_lista_destinos values (".$cod_msg.",".$cod_autor.",".$cod_categ.",'U')";
      $res=Enviar($sock,$query);

      InsereMsgCD($sock,$cod_msg,$cod_categ,$cod_autor);
      array_push($array_enviadas,$cod_categ);
    }
    return ($array_enviadas);
  }
  else if ($categ == "TG")
  {
    /* select dos grupos que esto com status != apagado */
    $query="select cod_grupo from Grupos where status != 'X'";
    $res=Enviar($sock,$query);
    $lista=RetornaArrayLinhas($res);

    foreach ($lista as $cod=>$linha)
      $array_enviadas=InsereMsgCLDCD($sock,$cod_msg,$cod_autor,G,$linha['cod_grupo'],$array_enviadas);
    return ($array_enviadas);
  }
  else if ($categ == "TA")
  {
     /* msg enviada para todos os alunos, por isso, $cod_categ = -1 */
    $query="insert into Correio_lista_destinos values (".$cod_msg.",".$cod_autor.",-1,'A')";
    $res=Enviar($sock,$query);

    $query="select cod_usuario from Usuario where binary tipo_usuario='A'";
    $res=Enviar($sock,$query);
    $lista=RetornaArrayLinhas($res);

    foreach ($lista as $cod=>$linha)
      if (!in_array($linha['cod_usuario'],$array_enviadas))
      {
        InsereMsgCD($sock,$cod_msg,$linha['cod_usuario'],$cod_autor);
        array_push($array_enviadas,$linha['cod_usuario']);
      }
    return ($array_enviadas);
  }
  else if ($categ == "TF")
  {
    /* msg enviada para todos os formadores, por isso, $cod_categ = -1 */
    $query="insert into Correio_lista_destinos values (".$cod_msg.",".$cod_autor.",-1,'F')";
    $res=Enviar($sock,$query);

    $query="select cod_usuario from Usuario where binary tipo_usuario='F'";
    $res=Enviar($sock,$query);
    $lista=RetornaArrayLinhas($res);

    foreach ($lista as $cod=>$linha)
      if (!in_array($linha['cod_usuario'],$array_enviadas))
      {
        InsereMsgCD($sock,$cod_msg,$linha['cod_usuario'],$cod_autor);
        array_push($array_enviadas,$linha['cod_usuario']);
      }
    return ($array_enviadas);
  }
  else if ($categ == "TT")
  {
    $query="insert into Correio_lista_destinos values (".$cod_msg.",".$cod_autor.",-1,'T')";
    $res=Enviar($sock,$query);

    $query="select cod_usuario from Usuario where binary tipo_usuario='F' OR binary tipo_usuario='A'";
    $res=Enviar($sock,$query);
    $lista=RetornaArrayLinhas($res);

    foreach ($lista as $cod=>$linha)
      InsereMsgCD($sock,$cod_msg,$linha['cod_usuario'],$cod_autor);

    $array_retorno = array();
    return ($array_retorno);
  }
}

/* *************************************************************************
  InsereMsgCD - Insere parametros da msg em Correio_destinos e em Correio_intermap
  Entrada: $sock - sock de conexao
           $cod_msg - codigo da msg
           $cod_usuario_receptor - codigo do usuario destinatario da mensagem
           $cod_usuario_emissor - codigo do usuario emissor da mensagem
  Saida:   nenhuma
*/
function InsereMsgCD($sock,$cod_msg,$cod_usuario_receptor,$cod_usuario_emissor)
{
  $query="insert into Correio_destinos values (".$cod_msg.",".$cod_usuario_receptor.",'N')";
  $res=Enviar($sock,$query);

  $query="insert into Correio_intermap values (".$cod_msg.",".$cod_usuario_emissor.",".$cod_usuario_receptor.",".time().")";
  $res=Enviar($sock,$query);
}

/* *******************************************************************
  PrimeiroDestinatarioDaMensagem - Retorna primeiro usuario ou categoria destinatario da mensagem

  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
  saida:   se categoria destinaria - Todos, Todos os alunos, Todos os formadores ou Todos os grupos
           se usuario ou grupo destinatario - Nome do usuario ou grupo
           se a saida for mais de uma string, retorna-se o primeiro nome seguido de "..."
*/
function PrimeiroDestinatarioDaMensagem($sock,$cod_msg)
{
  global $lista_frases;

  $query="select cod_destino,categ_destino from Correio_lista_destinos where cod_msg=".$cod_msg." order by categ_destino limit 2";
  $res=Enviar($sock,$query);
  $num=RetornaNumLinhas($res);
  $lista=RetornaArrayLinhas($res);

  if ($lista[0]['categ_destino'] == 'T')
    /* 29 - Todos */
    $retorno=RetornaFraseDaLista($lista_frases,29);
  else if ($lista[0]['categ_destino'] == 'A')
    /* 31 - Todos os alunos */
    $retorno=RetornaFraseDaLista($lista_frases,31);
  else if ($lista[0]['categ_destino'] == 'F')
    /* 30 - Todos os formadores */
    $retorno=RetornaFraseDaLista($lista_frases,30);
  else if ($lista[0]['categ_destino'] == 'G')
  {
    $query="select nome from Grupos where cod_grupo=".$lista[0]['cod_destino'];
    $linha=RetornaLinha($res);
    $res=Enviar($sock,$query);
    $retorno=$linha['nome'];
  }
  else if ($lista[0]['categ_destino'] == 'U')
  {
    $query="select nome from Usuario where cod_usuario=".$lista[0]['cod_destino'];
    $res=Enviar($sock,$query);
    $linha=RetornaLinha($res);
    $retorno=$linha['nome'];
  }

  if($num>1)
    $retorno.=" ...";

  return $retorno;
}

/* *******************************************************************
  ListaCompletaDestinatarios - Lista nome e cod_usuario de todos os destinatarios ou -1
                               se destinatario nao for usuario.
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
  saida:   array bidimensional com
           []['nome'] - nome do destinatario
           []['codigo'] - se o destinatario for um usuario, aqui vai seu cod_usuario
                          senao, este valor eh -1
*/
function ListaCompletaDestinatarios($sock,$cod_msg)
{
  global $lista_frases;

  $query="select categ_destino,cod_destino from Correio_lista_destinos where cod_msg=".$cod_msg." order by categ_destino";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);

  if (count($lista)>0)
  {
    unset ($retorno);
    $i=0;
    foreach ($lista as $cod => $linha)
    {
      if ($lista[$i]['categ_destino'] == 'T')
      {
        /* 29 - Todos */
        $retorno[$i]['nome']=RetornaFraseDaLista($lista_frases,29);
        $retorno[$i]['codigo']=-1;
      }
      else if ($lista[$i]['categ_destino'] == 'A')
      {
        /* 31 - Todos os alunos */
        $retorno[$i]['nome']=RetornaFraseDaLista($lista_frases,31);
        $retorno[$i]['codigo']=-1;
      }
      else if ($lista[$i]['categ_destino'] == 'F')
      {
        /* 30 - Todos os formadores */
        $retorno[$i]['nome']=RetornaFraseDaLista($lista_frases,30);
        $retorno[$i]['codigo']=-1;
      }
      else if ($lista[$i]['categ_destino'] == 'G')
      {
        /* nome daquele grupo */
        $retorno[$i]['nome']=RetornaGrupoComCodigo($sock,$linha['cod_destino']);
        $retorno[$i]['codigo']=-1;
      }
      else if ($lista[$i]['categ_destino'] == 'U')
      {
        /* nome daquele usuario */
        $retorno[$i]['nome']=RetornaNomeUsuarioDeCodigo($sock,$linha['cod_destino']);
        $retorno[$i]['codigo']=$linha['cod_destino'];
      }
      $i++;
    }
    return $retorno;
  }
}

/* *******************************************************************
  ApagaMsgCM - altera para 'A' o estado de uma msg na tabela Correio_mensagens
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem da qual alterar o estado
  saida:  nenhuma
*/
function ApagaMsgCM($sock,$cod_msg)
{
  $query="update Correio_mensagens set estado='A' where cod_msg=".$cod_msg;
  $res=Enviar($sock,$query);
}

/* *******************************************************************
  ApagaMsgCD - altera para 'A' o estado de uma msg na tabela Correio_destinos
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem da qual alterar o estado
           $cod_usuario - codigo do usuario destinatario da mensagem a apagar
  saida:   nenhuma
*/
function ApagaMsgCD($sock,$cod_msg,$cod_usuario)
{
  $query="update Correio_destinos set estado='A' where cod_msg=".$cod_msg." and cod_usuario=".$cod_usuario;
  $res=Enviar($sock,$query);
}

/* *******************************************************************
  ApagaDefCM - altera para 'X' o estado de uma msg na tabela Correio_mensagens
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem da qual alterar o estado
  saida:   nenhuma
*/
function ApagaDefCM($sock,$cod_msg)
{
  $query="update Correio_mensagens set estado='X' where cod_msg=".$cod_msg." and estado='A'";
  $res=Enviar($sock,$query);
}

/* *******************************************************************
  ApagaDefCD - altera para 'X' o estado de uma msg na tabela Correio_destinos
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem da qual alterar o estado
           $cod_usuario - codigo do usuario destinatario da mensagem
  saida:   nenhuma
*/
function ApagaDefCD($sock,$cod_msg,$cod_usuario)
{
  $query="update Correio_destinos set estado='X' where cod_msg=".$cod_msg." and cod_usuario=".$cod_usuario." and estado='A'";
  $res=Enviar($sock,$query);
}

/* *******************************************************************
  RetornaEstadoAbrev - retorna letra do estado para o destinatario
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
           $cod_usuario - codigo do usuario destinatario
  saida:   letra de estado da mensagem para o destinatario
*/
function RetornaEstadoAbrev($sock,$cod_msg,$cod_usuario)
{
  $query="select estado from Correio_destinos where cod_msg=".$cod_msg." and cod_usuario=".$cod_usuario;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return $linha;
}

/* *******************************************************************
  AtualizaEstadoMsgCD - Atualiza o estado da msg na base Correio_destinos
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
           $cod_usuario - codigo do usuario destinatario da mensagem
           $novo_estado - novo estado da mensagem
  saida:   nenhuma
*/
function AtualizaEstadoMsgCD($sock,$cod_msg,$cod_usuario,$novo_estado)
{
  $query="update Correio_destinos set estado='".$novo_estado."' where cod_msg=".$cod_msg." and cod_usuario = ".$cod_usuario;
  $res=Enviar($sock,$query);
}

/* *******************************************************************
  RetornaNumDestinatariosMsg - retorna o numero de destinatarios da msg dada
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
  saida:   numero de destinatarios daquela msg
*/
function RetornaNumDestinatariosMsg($sock,$cod_msg)
{
  $query="select count(*) from Correio_lista_destinos where cod_msg=".$cod_msg;
  $res=Enviar($sock,$query);
  $num=RetornaLinha($res);
  return $num;
}

/* *******************************************************************
  RetornaCategDestinoCodUsuarioMsg - Consulta Correio_lista_destinos e retorna lista com
                                     categorias destinatarias da mensagem e seus codigos
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
  saida: array bidimensional com
         []['categ_destino'] - categoria destinaria da mensagem
         []['cod_destino'] - codigo da categoria destinataria
*/
function RetornaCategDestinoCodUsuarioMsg($sock,$cod_msg)
{
  $query="select categ_destino,cod_destino from Correio_lista_destinos where cod_msg=".$cod_msg;
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  return $lista;
}

/* **********************************************************************
  EndentarMensagem - Faz a identao de mensagens redirecionadas ou respondidas.
                     Retorna uma string com a mensagem passada identada e com cabealho
                     contendo autor e data
  entrada: $mensagem - mensagem a formatar
           $data - data no formato extenso (string)
           $nome_autor - nome do autor da mensagem
  saida:?  nenhuma
*/
function EndentarMensagem($mensagem,$data,$nome_autor)
{
  $traco="_________________________________________________________\n";
  $mensagem="\n".$traco."\nEm ".$data.", ".$nome_autor." havia escrito:\n\n$mensagem\n\n".$traco;
  $mensagem="\n\n".str_replace("\n","\n> ",$mensagem);
  return($mensagem);
}

/* **********************************************************************
  UsuarioEhDestinatarioDaMensagem - identifica se usuario eh destinatario da mensagem
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem a identificar
           $cod_usuario - codigo do usuario
  saida: true - usuario eh destinatario da mensagem
         false - usuario nao eh destinatario da mensagem
*/
function UsuarioEhDestinatarioDaMensagem($sock,$cod_msg,$cod_usuario)
{
  $query="select cod_usuario from Correio_destinos where cod_msg=".$cod_msg." and cod_usuario=".$cod_usuario." and estado != 'X'";
  $res=Enviar($sock,$query);
  $num=RetornaNumLinhas($res);

  if ($num > 0)
    return true;
  else
    return false;
}

/* **********************************************************************
  UsuarioEhDestinatarioDaMensagemApagada - identifica se usuario eh destinatario de mensagem apagada
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem a identificar
           $cod_usuario - codigo do usuario
  saida: true - usuario eh destinatario da mensagem apagada
         false - caso contrario
*/
function UsuarioEhDestinatarioDaMensagemApagada($sock,$cod_msg,$cod_usuario)
{
  $query="select cod_usuario from Correio_destinos where cod_msg=".$cod_msg." and cod_usuario=".$cod_usuario." and estado = 'A'";
  $res=Enviar($sock,$query);
  $num=RetornaNumLinhas($res);

  if ($num > 0)
    return true;
  else
    return false;
}

/* **********************************************************************
  RecuperaCM - recupera mensagem na tabela Correio_mensagens
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem a recuperar
  saida: nenhuma
*/
function RecuperaCM($sock,$cod_msg)
{
  $query="update Correio_mensagens set estado='R' where cod_msg=".$cod_msg." and estado='A'";
  $res=Enviar($sock,$query);
}

/* **********************************************************************
  RecuperaCD - recupera mensagem na tabela Correio_destinos
  entrada: $sock - sock de conexao
           $cod_msg - codigo da mensagem
           $cod_usuario - codigo do usuario
  saida: nenhuma
*/
function RecuperaCD($sock,$cod_msg,$cod_usuario)
{
  $query="update Correio_destinos set estado='U' where cod_msg=".$cod_msg." and cod_usuario=".$cod_usuario." and estado='A'";
  $res=Enviar($sock,$query);
}


/* ***********************************************************************************
  RetornaDiretorio - Retorna Diretorio (path) do item pedido
  Entrada: $sock - sock de conexao (BASE EXTERNA)
           $item - arquivo do qual se quer descobrir o diretorio
  Saida:   path do item
*/
function RetornaDiretorio($sock,$item)
{
  $query="select diretorio from Diretorio where item='".$item."'";
  $res=Enviar($sock,$query); // Base externa!!!!
  $linha=RetornaLinha($res);
  return ($linha[0]);
}

?>
