<?

/*
<!--
-------------------------------------------------------------------------------

    Arquivo : cursos/aplic/diario/diario.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : cursos/aplic/diario/diario.inc
  ========================================================== */

/* ******************************************************
  EliminaEspacos - Elimina espacos no comeo e no
    final da frase.
  Retorna a frase sem os espacos no comeo e no final dela.
  Entradas: $frase - frase
  Saida:   frase sem os espacos no comeo e no final dela.

*/

function EliminaEspacos($frase)
{
  return(trim($frase));
}

/* ******************************************************
  Compara - Compara os os elementos do array multidimensional
    pelo nome por ordem natural e sem sensibilidade  caixa
    das letras.
    Esta funo  utilizada pela funo usort de
    RetornaDiarios como critrio de ordenao.

  Entradas: $ar1 - elemento ,
            $ar2 - outro elemento do array.

  Saida:    < 0 se $ar1 for MENOR que $ar2,
            > 0 se $ar1 for MAIOR que $ar2,
            = 0 se $ar1 for IGUAL a $ar2.

*/

function Compara($ar1, $ar2)
{
  return (strnatcasecmp($ar1['nome'], $ar2['nome']));
}

/* ***********************************************************************
   RetornaDiarios - retorna links para os diarios
   entrada: $sock - sock de conexao
            $cod_curso - codigo do curso
            $cod_usuario - codigo do usuario logado
   saida:   array [ $cod_usuario ]['nome'] - 'diario de fulano de tal'
                                  ['data'] - data
                                  ['num_itens'] - numero de itens no diario
                                  ['num_itens_nao_comentados'] - numero de itens nao comentados
                                  ['novidade'] - booleano que indica se houve novidade no portfolio
*/
function RetornaDiarios ($sock, $cod_curso, $cod_usuario)
{
  global $lista_frases;

  // este eh o array de retorno
  unset ($lista_diarios);

  // lista dos usuarios
  $query = "select cod_usuario, nome from Usuario";
  $res   = Enviar ($sock, $query);
  $lista = RetornaArrayLinhas ($res);
  if (is_array ($lista))
    foreach ($lista as $c => $linha)
      $lista_usr [ $linha ['cod_usuario'] ] = $linha ['nome'];


  // garantindo que o usuario logado vai ter seu diario aparecendo, mesmo que este esteja vazio
  // se houver algo no diario, esta informacao vai ser sobreescrita no loop mais embaixo
  // 56 - Diario de
  $lista_diarios [ $cod_usuario ]['nome'] = RetornaFraseDaLista ($lista_frases, 56)." ".$lista_usr[ $cod_usuario ];
  $lista_diarios [ $cod_usuario ]['data'] = 0;
  $lista_diarios [ $cod_usuario ]['num_itens'] = 0;
  $lista_diarios [ $cod_usuario ]['num_itens_nao_comentados'] = 0;

  if ( EFormadorComVisaoDeAluno ($sock, $cod_curso, $cod_usuario))
  {
    $regra_comp = "tipo_compartilhamento = 'T'";
  }
  else if (! EFormador ($sock, $cod_curso, $cod_usuario))
  {
    $regra_comp = "(tipo_compartilhamento = 'T' or cod_usuario=".$cod_usuario.")";
  }
  else
  {
    $regra_comp = "(tipo_compartilhamento = 'T' or tipo_compartilhamento = 'F' or cod_usuario=".$cod_usuario.")";
  }

  // lista dos diarios a retornar
  $query = "select cod_usuario, cod_item, data from Diario_itens where ".$regra_comp." order by cod_usuario";
  $res   = Enviar ($sock, $query);
  $lista1= RetornaArrayLinhas ($res);

  if (is_array ($lista1))
  {
    // lista com diarios e numero de itens comentados em cada diario e maior data de comentario
    $query = "select cod_item, count(cod_comentario) 'num_comentarios', max(data) 'data' from Diario_comentarios group by cod_item";
    $res   = Enviar ($sock, $query);
    $lista2= RetornaArrayLinhas ($res);
    
    if (is_array ($lista2))
    {
      foreach ($lista2 as $linha2)
      {
        $cod_item = $linha2 ['cod_item'];
        $lista_comentarios [ $cod_item ]['num_comentarios'] = $linha2 ['num_comentarios'];
        $lista_comentarios [ $cod_item ]['data']            = $linha2 ['data'];
      }
    }

    $penultimo_acesso = PenultimoAcesso($sock, $cod_usuario, "");
    
    foreach ($lista1 as $linha1)
    {
      $cod_usr         = $linha1 ['cod_usuario'];
      $cod_item        = $linha1 ['cod_item'];
      $data_item       = $linha1 ['data'];
      $data_comentario = $lista_comentarios [$cod_item]['data'];

      // 56 - Diario de
      $lista_diarios [ $cod_usr ]['nome'] = RetornaFraseDaLista ($lista_frases, 56)." ".$lista_usr [ $cod_usr ];

      // retornar data do item mais novo (item mais novo = maior data) dentro do diario ou do comentarios mais novo
      if (!isset ($lista_diarios [ $cod_usr ]['data']) || $lista_diarios [ $cod_usr ]['data'] < $data_item)
        $lista_diarios [ $cod_usr ]['data'] = $data_item;
      if ($lista_diarios [ $cod_usr ]['data'] < $data_comentario)
        $lista_diarios [ $cod_usr ]['data'] = $data_comentario;

      // numero de itens no diario
      $lista_diarios [ $cod_usr ]['num_itens'] ++;

      // verifica se o item estah comentado. Se nao estiver, aumenta o numero de itens nao comentados no diario
      if (! isset ($lista_comentarios [ $cod_item ]))
        $lista_diarios [ $cod_usr ]['num_itens_nao_comentados'] ++;
      else
        $lista_diarios [ $cod_usr ]['num_itens_nao_comentados'] += 0;

      // ocorre novidade se houver um item novo ou um comentario novo
      $lista_diarios [ $cod_usr ]['novidade'] |= ($data_item > $penultimo_acesso || $data_comentario > $penultimo_acesso);
    }
  }

  uasort ($lista_diarios, Compara);

  return $lista_diarios;
}

/* ******************************************************
  RetornaItem - Retorna informaes detalhadas sobre o item.

  Entradas: $sock - sock de conexo,
            $cod_item - cdigo do item.

  Saida:    $cod_usuario - cdigo do usurio,
            $titulo - titulo do item,
            $texto - texto do item,
            $tipo_compartilhamento - tipo de compartilhamento do item 
            $data - data do item.

*/

function RetornaItem($sock, $cod_item)
{
  /* Status do item que ser selecionado.           */
  $status = 'A';

  $query = "select cod_usuario, titulo, texto, data, tipo_compartilhamento from Diario_itens where cod_item = ";
  $query .= $cod_item." and status = '".$status."'";

  $res = Enviar($sock, $query);
  $resultado = RetornaLinha($res);

  return($resultado);
}

/* ******************************************************
  RetornaItens - Retorna os itens do dirio do usurio.

  Entradas: $sock - sock de conexo,
            $cod_curso - codigo do curso
            $cod_usuario - codigo do usuario logado
            $cod_usuario_diario - cdigo do usurio dono do diario.

  Saida:    $cod_item - cdigo do item,
            $titulo - titulo do item,
            $data - data do item.

*/

function RetornaItens ($sock, $cod_curso, $cod_usuario, $cod_usuario_diario)
{
  // selecionando quais itens do diario retornar
  $where = "cod_usuario=".$cod_usuario_diario;

  if (EFormadorComVisaoDeAluno ($sock, $cod_curso, $cod_usuario))
  {
    $where.= " and tipo_compartilhamento = 'T'";
  }
  else if ($cod_usuario != $cod_usuario_diario)
  {
    if ( EFormador ($sock, $cod_curso, $cod_usuario) )
    {
      $where .= " and (tipo_compartilhamento = 'T' or tipo_compartilhamento = 'F')";
    }
    else
    {
      $where .= " and tipo_compartilhamento = 'T'";
    }
  }

  // selecionando diarios
  $query = "select cod_item, titulo, data, tipo_compartilhamento from Diario_itens where ".$where;
  $res   = Enviar ($sock, $query);
  $lista = RetornaArrayLinhas ($res);
  
  return $lista;
}

/* ******************************************************
  ApagaItem - Apaga o item especificado e seus comentrios.

  Entradas: $sock - sock de conexo,
            $cod_item - cdigo do item.

  Saida:    true se bem-sucedido, false do contrrio.

*/

function ApagaItem($sock, $cod_item)
{
  /* Status do item e comentrio que sero          */
  /* selecionados.                                  */
  $status_ativo = 'A';
  /* Status para o qual o item ou comentrio ser   */
  /* alterado.                                      */
  $status_apagado = 'D';

  /* "Apaga" os comentrios.                        */
  $query = "update Diario_comentarios set status = '".$status_apagado."' where cod_item = ";
  $query .= $cod_item." and status = '".$status_ativo."'";

  $res1 = Enviar($sock, $query);

  /* "Apaga" o item.                                */
  $query = "update Diario_itens set status = '".$status_apagado."' where cod_item = ";
  $query .= $cod_item." and status = '".$status_ativo."'";

  $res2 = Enviar($sock, $query);

  return($res1 && $res2);
}


/* ******************************************************
  EditaItem - Edita o ttulo e o texto, e atualiza a data
    do item especificado.

  Entradas: $sock - sock de conexo,
            $cod_item - cdigo do item,
            $titulo - ttulo do item,
            $texto - texto do item.
            $tipo_compartilhamento - tipo de compartilhamento do item

  Saida:    true se bem-sucedido, false do contrrio.

*/

function EditaItem($sock, $cod_item, $titulo, $texto, $tipo_compartilhamento)
{
  /* Status do item que ser selecionado.           */
  $status = 'A';

  $titulo = EliminaScript($titulo);
  $titulo = LimpaTitulo($titulo);
  $titulo = EliminaEspacos($titulo);

  $texto = EliminaScript($texto);
  $texto = LimpaConteudo($texto);

  $query = "update Diario_itens set titulo = '".$titulo."', texto = '";
  $query .= $texto."', data = ".time().", tipo_compartilhamento = '".$tipo_compartilhamento."' where cod_item = ".$cod_item;
  $query .= " and status = '".$status."'";

  $res = Enviar($sock, $query);

  return($res);
}


/* ******************************************************
  RenomeiaItem - Renomeia o item especificado.

  Entradas: $sock - sock de conexo,
            $cod_item - cdigo do item,
            $titulo - ttulo do item.

  Saida:    true se bem-sucedido, false do contrrio.

*/

function RenomeiaItem($sock, $cod_item, $titulo)
{
  /* Status do item que ser selecionado.           */
  $status = 'A';

  $titulo = EliminaScript($titulo);
  $titulo = LimpaTitulo($titulo);
  $titulo = EliminaEspacos($titulo);

  $query = "update Diario_itens set titulo = '".$titulo."', data = ".time();
  $query .= " where cod_item = ".$cod_item." and status = '".$status."'";

  $res = Enviar($sock, $query);

  return($res);
}


/* ******************************************************
  SalvaItem - Salva o item especificado.

  Entradas: $sock                  - sock de conexo,
            $titulo                - ttulo do item,
            $texto                 - texto do item,
            $cod_usuario           - cdigo do usurio.
            $tipo_compartilhamento - tipo de compartilhamento do item

  Saida:    true se bem-sucedido, false do contrrio.

*/

function SalvaItem($sock, $titulo, $texto, $cod_usuario, $tipo_compartilhamento)
{
  /* Status que ser salvo com o item.              */
  $status = 'A';

  $titulo = EliminaScript($titulo);
  $titulo = LimpaTitulo($titulo);
  $titulo = EliminaEspacos($titulo);

  $texto = EliminaScript($texto);
  $texto = LimpaConteudo($texto);

  $query = "insert into Diario_itens (cod_usuario, titulo, texto, data, status, tipo_compartilhamento) values";
  $query .= " (".$cod_usuario.", '".$titulo."', '".$texto."', ".time().", '".$status."', '".$tipo_compartilhamento."')";

  $res = Enviar($sock, $query);

  return($res);
}


/* ******************************************************
  ComentaItem - Comenta o item especificado.

  Entradas: $sock - sock de conexo,
            $cod_item - cdigo do item,
            $comentario - comentrio do item,
            $cod_usuario - cdigo do usurio.

  Saida:    true se bem-sucedido, false do contrrio.

*/

function ComentaItem($sock, $cod_item, $comentario, $cod_usuario)
{
  /* Status do comentrio que ser salvo.           */
  $status = 'A';

  $comentario = EliminaScript($comentario);
  $comentario = LimpaConteudo($comentario);

  $query = "insert into Diario_comentarios (cod_item, comentario,";
  $query .= " cod_comentarist, data, status) values (".$cod_item;
  $query .= ", '".$comentario."', ".$cod_usuario.", ".time();
  $query .= ", '".$status."')";

  $res = Enviar($sock, $query);

  return($res);
}


/* ******************************************************
  ApagaComent - Apaga o comentrio especificado.

  Entradas: $sock - sock de conexo,
            $cod_comentario - cdigo do comentrio.

  Saida:    true se bem-sucedido, false do contrrio.

*/

function ApagaComent($sock, $cod_comentario)
{
  /* Status do comentrio que ser selecionado.     */
  $status_ativo = 'A';
  /* Status para o qual o comentrio ser alterado. */
  $status_apagado = 'D';

  $query = "update Diario_comentarios set status = '".$status_apagado."'";
  $query .= " where cod_comentario = ".$cod_comentario." and status = '";
  $query .= $status_ativo."'";

  return(Enviar($sock, $query));
}


/* ******************************************************
  RetornaComentario - Obtm informaes detalhadas sobre
    o comentrio especificado.

  Entradas: $sock - sock de conexo,
            $cod_comentario - cdigo do comentrio.

  Saida:    $titulo - ttulo do item,
            $cod_comentarist - cdigo do usurio que fez
              o comentrio,
            $comentario - comentrio do item,
            $data - data do comentrio.

*/

function RetornaComentario($sock, $cod_comentario)
{
  /* Status do comentrio que ser selecionado.     */
  $status = 'A';

  $query = "select DI.titulo, DC.cod_comentarist, DC.comentario, DC.data";
  $query .=  " from Diario_itens as DI, Diario_comentarios as DC";
  $query .= " where DC.cod_comentario = ".$cod_comentario." and DC.status = '";
  $query .= $status."' and DI.cod_item = DC.cod_item";

  $res = Enviar($sock, $query);

  return(RetornaLinha($res));
}


/* ******************************************************
  TemComentario - Obtm o cod_usuario dos usurios que
    fizeram comentrios e a data do comentrio mais
    recente. Esta funo  utilizada para sinalizar ao
    usurio se h comentrios, se ele ou outros usurios
    foram os autores e se o comentrio  novo.

  Entradas: $sock - sock de conexo,
            $cod_item - cdigo do item.

  Saida:    $titulo - ttulo do item,
            $cod_comentarist - cdigo do usurio que fez
              o comentrio,
            $comentario - comentrio do item,
            $data - data do comentrio.

*/

function TemComentarios($sock, $cod_item)
{
  /* Status do item que ser selecionado.           */
  $status = 'A';

  $query = "select cod_comentarist from Diario_comentarios where cod_item = ";
  $query .= $cod_item." and status = '".$status."' group by cod_comentarist order";
  $query .= " by data desc";

  $res = Enviar($sock, $query);
  $tuplas = RetornaArrayLinhas($res);

  $query = "select data from Diario_comentarios where cod_item = ";
  $query .= $cod_item." and status = '".$status."' order by data desc limit 1";
  $res = Enviar($sock, $query);
  $tupla = RetornaLinha($res);

  $data = $tupla['data'];

  return array($tuplas, $data);
}

/* ****************************************************************************************************
   RetornaListaComentarios - retorna lista de comentarios indicando se para cada item houve comentarios de
                             formador, ou do dono do item
   entrada: $sock - sock de conexao
            $cod_usuario - codigo do usuario logado
            $cod_usuario_diario - codigo do usuario dono do diario

   saida: array [ $cod_item ]['comentario_aluno'] - booleano. indica se ha comentarios de aluno no item
                [ $cod_item ]['comentario_formador'] - booleano. indica se ha comentarios de formador no item
                [ $cod_item ]['comentario_dono'] - booleano. indica se ha comentarios do dono do item no item
                [ $cod_item ]['novidade'] - booleano. indica se ha novos comentarios desde o ultimo acesso do usuario
*/

function RetornaListaComentarios ($sock, $cod_usuario, $cod_usuario_diario)
{
  unset ($lista_retorno);
  
  $query = "select cod_usuario, tipo_usuario from Usuario";
  $res   = Enviar ($sock, $query);
  $lista = RetornaArrayLinhas ($res);
  if (is_array ($lista))
    foreach ($lista as $linha)
      $lista_usr [ $linha['cod_usuario'] ] = $linha ['tipo_usuario'];
  
  // se usuario que estah navegando for dono do diario, a regra eh apenas esta, sem compartilhamentos
  $regra = "where cod_usuario=".$cod_usuario_diario;

  if ($cod_usuario != $cod_usuario_diario)
  {
    if ( EFormador ($sock, $cod_curso, $cod_usuario))
    {
      // usuario que estah navegando nao eh dono, mas eh formador
      $regra.= " and (tipo_compartilhamento = 'T' or tipo_compartilhamento = 'F')";
    }
    else
    {
      // usuario que estah navegando nao eh dono do diario nem eh formador
      $regra.= " and tipo_compartilhamento = 'T'";
    }
  }

  $query = "select cod_item from Diario_itens ".$regra;
  $res   = Enviar ($sock, $query);
  $lista1= RetornaArrayLinhas ($res);

  if (is_array ($lista1))
  {
    foreach ($lista1 as $linha)
      $lista_itens [ $linha ['cod_item'] ] = true;
  
    $query = "select cod_item, cod_comentarist, data from Diario_comentarios order by cod_item";
    $res   = Enviar ($sock, $query);
    $lista2= RetornaArrayLinhas ($res);
    
    $penultimo_acesso = PenultimoAcesso($sock, $cod_usuario, "");
    
    if (is_array ($lista2))
    {
      foreach ($lista2 as $linha)
      {
        if ( $lista_itens [ $cod_item = $linha ['cod_item'] ] )
        {
          $cod_comentarista = $linha ['cod_comentarist'];
          $data_comentario  = $linha ['data'];

          $lista_retorno [ $cod_item ]['novidade']              |=  ( $data_comentario > $penultimo_acesso );

          if ( $cod_comentarista == $cod_usuario )
          {
            $lista_retorno [ $cod_item ]['comentario_dono'] = true;
          }
          else
          {
            $lista_retorno [ $cod_item ]['comentario_aluno']    |=  ( $lista_usr [ $cod_comentarista ] == 'A' );
            $lista_retorno [ $cod_item ]['comentario_formador'] |=  ( $lista_usr [ $cod_comentarista ] == 'F' );
          }
        }
      }
    }
  }
  return $lista_retorno;
}

/* ******************************************************
   AlteraTipoCompartilhamento - Altera o tipo de compartilhamento de um item
   entrada: $sock - sock de conexao
            $cod_item - codigo do item
            $tipo_comp - novo modo de compartilhamento do item
                  'T' - totalmente compartilhado
                  'F' - compartilhado com formadores
                  'P' - No compartilhado
*/
function AlteraTipoCompartilhamento ($sock, $cod_item, $tipo_comp)
{
  $query = "update Diario_itens set tipo_compartilhamento='".$tipo_comp."' where cod_item=".$cod_item;
  $res   = Enviar ($sock, $query);
}

/* ******************************************************
   VerificaDonoDiario - verifica se o usuario eh dono do diario ou do item visualizado
   entrada: $sock - sock de conexao
            $cod_curso - codigo do curso
            $cod_usuario - codigo do usuario logado
            $cod_propriet - codigo do usuario dono do diario
   saida: true - eh realmente o dono do diario
          false - nao eh o dono, ou estah na visao de aluno
*/
function VerificaDonoDiario ($sock, $cod_curso, $cod_usuario, $cod_propriet)
{
  return ( ($cod_usuario == $cod_propriet) && (! EFormadorComVisaoDeAluno ($sock, $cod_curso, $cod_usuario)) && (RetornaStatusCurso != 'E') );
}

/* ******************************************************
  RetornaComentariosItem - Obtm o cod_comentario, a data e o
    cod_comentarist dos comentrios do item especificado.
    Lista os comentrios e seus respectivos autores.

  Entradas: $sock - sock de conexo,
            $cod_item - cdigo do item.

  Saida:    $cod_comentario - cdigo do comentrio,
            $cod_comentarist - cdigo do usurio que fez
              o comentrio,
            $data - data do comentrio.

*/
function RetornaComentariosItem($sock, $cod_item)
{
  /* Status do item que ser selecionado.           */
  $status = 'A';

  $query = "select cod_comentario, cod_comentarist, data from Diario_comentarios";
  $query .= " where cod_item = ".$cod_item." and status = '";
  $query .= $status."' order by data desc";

  $res = Enviar($sock, $query);

  return(RetornaArrayLinhas($res));

}

/* *********************************************************************
   print_array - funcao para debugar, imprime o array
   entrada: $array - array do qual imprimir conteudo
            $level - nivel de aninhamento de array dentro de array. 
                     Primeira chamada sempre 0 (zero);
   saida:   nenhuma
*/
function print_array($array)
{
  return print_array_aux($array,0);
}

function print_array_aux($array,$level)
{
  if (!is_array($array))
    return 0;

  reset($array);
  $retorno = "";
  while ( list($key, $value) = each($array) ) 
  { 
    for ($i = 0; $i < $level; ++$i)
    {
      $retorno .= "&nbsp;&nbsp;&nbsp;";
    }
    $retorno .= "['".$key."'] ".$value."<br>";
    if (is_array($value))
      $retorno .= print_array_aux($value,$level+1);
  }
}

?>
