<?

/*
<!--
-------------------------------------------------------------------------------

    Arquivo : cursos/aplic/forum/forum.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : cursos/aplic/forum/forum.inc
  ========================================================== */

/* ******************************************************
  EliminaEspacos - Elimina espacos no comeo e no
    final da frase.
  Retorna a frase sem os espacos no comeo e no final dela.
  Entradas: $frase - frase
  Saida:   frase sem os espacos no comeo e no final dela.
*/
function EliminaEspacos($frase)
{
  return(trim($frase));
}


/* ******************************************************
  ForumExiste - Verifica a existncia do frum.

  Entradas: $sock - sock de conexo,
            $cod_forum - cdigo do frum.
  Saida:    true se existir, do contrrio, false.
*/
function ForumExiste($sock, $cod_forum)
{
  $query = "select nome from Forum where cod_forum = ".$cod_forum;

  $res = Enviar($sock, $query);

  if (RetornaNumLinhas($res) > 0)
    return(true);
  else
    return(false);
}

/* ******************************************************
  RetornaForuns - lista os fruns no apagados.

  Entradas: $sock - sock de conexao,
            $ordem - "N" - Nome, "D" - data

  Saida:    Array com: ['nome'] - nome do frum,
                       ['cod_forum'] - cdigo do frum,
                       ['status'] - status do forum: A - Ativo (escrita e leitura)
                                                     L - somente leitura
                                                     D - deletado (encontra-se na lixeira)
                                                     X - excludo
                       ['data'] - data de criao do Frum
            total de foruns encontrados.
*/
function RetornaForuns($sock,$ordem)
{
  $query = "select nome, cod_forum, status,data from Forum where ";
  $query .= "status = 'A' or status = 'L' order by status, ";
  if ($ordem=="N")
    $query .="nome";
  else
    $query .="data desc";

  $res = Enviar($sock, $query);
  $total = RetornaNumLinhas($res);
  $tuplas = RetornaArrayLinhas($res);

  $nMsgs = array();

  for ($i = 0; $i < $total; $i++)
  {
    /* Seleciona as mensagens ativas e obtm o total de mensagens pertencentes  cada frum. */
    $query = "select count(*),max(data) 'data' from Forum_mensagens where cod_forum = ".$tuplas[$i]['cod_forum'];
    $query .= " and status = 'A'";

    $res = Enviar($sock, $query);
    $valor = RetornaLinha($res);
    /* Insere no array os totais de mensagens de cada frum.                                 */
    array_push($nMsgs, $valor[0]);
    if ($valor['data']>0)
      $tuplas[$i]['data']=$valor['data'];
  }

  return array ($tuplas, $nMsgs, $total);
}


/* ******************************************************
  RetornaForunsDeletados - lista os fruns deletados.

  Entradas: $sock - sock de conexao,
            $ordem - "N" - nome, "D" - Data

  Saida:    Array com: ['nome'] - nome do frum,
                       ['cod_forum'] - cdigo do frum,
                       ['status'] - status do forum: A - Ativo (escrita e leitura)
                                                     L - somente leitura
                                                     D - deletado (encontra-se na lixeira)
                                                     X - excludo
                       ['data'] - data de criao do frum
            total de foruns encontrados.
*/
function RetornaForunsDeletados($sock,$ordem)
{
  $query = "select nome, cod_forum, status, data from Forum where ";
  $query .= "status = 'D' order by ";

  if ($ordem=="N")
    $query .="nome";
  else
    $query .="data desc";

  $res = Enviar($sock, $query);
  $total = RetornaNumLinhas($res);
  $tuplas = RetornaArrayLinhas($res);

  /* Inicializa o array. */
  $nMsgs = array();

  for ($i = 0; $i < $total; $i++)
  {
    /* Seleciona as mensagens deletadas e obtm o total de mensagens pertencentes  cada frum. */
    $query = "select count(*) from Forum_mensagens where cod_forum = ".$tuplas[$i]['cod_forum'];
    $query .= " and status = 'A'";

    $res = Enviar($sock, $query);
    $valor = RetornaLinha($res);

    /* Insere no array os totais de mensagens de cada frum.             */
    array_push($nMsgs, $valor[0]);
  }

  return array ($tuplas, $nMsgs, $total);
}


/* ******************************************************
  RetornaForum - lista os fruns no apagados.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum.

  Saida:    Array com: ['nome'] - nome do frum,
                       ['status'] - status do forum: A - Ativo (escrita e leitura)
                                                     L - somente leitura
                                                     D - deletado (encontra-se na lixeira)
                                                     X - excludo
*/
function RetornaForum($sock, $cod_forum)
{
  $query = "select nome, status from Forum where cod_forum = ".$cod_forum;

  $res = Enviar($sock, $query);
  $tupla = RetornaLinha($res);

  return($tupla);
}


/* ******************************************************
  ConfiguraForum - Altera o status do frum entre somente
    leitura e ativado.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum,
            $status - status do frum:  A - Ativo (escrita e leitura)
                                        L - somente leitura
                                        D - deletado (encontra-se na lixeira)
                                        X - excludo
  Saida:    true se bem-sucedido, do contrrio, false.

*/
function ConfiguraForum($sock, $cod_forum, $status)
{
  $query = "update Forum set status='".$status."' where cod_forum = ".$cod_forum;

  $res = Enviar($sock, $query);

  return($res);
}


/* ******************************************************
  DeletaForum - Deleta o frum movendo para a Lixeira.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum.
  Saida:    true se bem-sucedido, do contrrio, false.

*/
function DeletaForum($sock, $cod_forum)
{
//  $query = "update Forum_mensagens set status = 'D' where cod_forum = ";
//  $query .= $cod_forum." and status = 'A'";

// $res1 = Enviar($sock, $query);

  $query = "update Forum set status = 'D' where cod_forum = ".$cod_forum;
  $query .= " and (status = 'A' or status = 'L')";

  $res2 = Enviar($sock, $query);

  return($res2);
}


/* ******************************************************
  ExcluiForum - Muda o status das mensagens e do frum
    para 'X', impedindo que sejam visualizadas.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum.
  Saida:    true se bem-sucedido, do contrrio, false.

*/
function ExcluiForum($sock, $cod_forum)
{
//  $query = "update Forum_mensagens set status = 'X' where cod_forum = ";
//  $query .= $cod_forum." and status = 'D'";

//  $res1 = Enviar($sock, $query);

  $query = "update Forum set status = 'X' where cod_forum = ".$cod_forum;
  $query .= " and status = 'D'";

  $res2 = Enviar($sock, $query);

  return($res2);
}


/* ******************************************************
  RenomeiaForum - Renomeia o frum especificado.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum,
            $nome - nome do frum.
  Saida:    true se bem-sucedido, do contrrio, false.

*/
function RenomeiaForum($sock, $cod_forum, $nome)
{
  $nome = EliminaScript($nome);
  $nome = LimpaTitulo($nome);
  $nome = EliminaEspacos($nome);

  $query = "update Forum set nome = '".$nome."' where cod_forum = ".$cod_forum;

  $res = Enviar($sock, $query);

  return($res);
}


/* ******************************************************
  SalvaForum - Salva o frum na base de dados.

  Entradas: $sock - sock de conexao,
            $nome - nome do frum.
  Saida:    true se bem-sucedido, do contrrio, false.

*/
function SalvaForum($sock, $nome)
{
  $nome = EliminaScript($nome);
  $nome = LimpaTitulo($nome);
  $nome = EliminaEspacos($nome);

  $query = "insert into Forum (nome, status, data)";
  $query .= " values ('".$nome."', 'A', ".time().")";

  return(Enviar($sock, $query));
}


/* ******************************************************
  MensagemAlteradas - Verifica se alguma mensagem foi
    inserida/alterada. Se retornar true ento deve-se
    consultar a tabela de mensagens e listar todas as
    mensagens. Do contrrio usa-se apenas as mensagens
    guardadas em um array na memria.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum,
            $ultima_data_alteracao - data anterior 
              consulta  tabela de mensagens.
  Saida:    true se alterada/inserida, do contrrio,
              false.
*/
function MensagensAlteradas($sock, $cod_forum, $ultima_data_alteracao)
{
  $query = "select * from Forum_mensagens where cod_forum = ".$cod_forum;
  $query .= " and data > ".$ultima_data_alteracao;
  $res = Enviar($sock, $query);

  $numreg = RetornaNumLinhas($res);

  if ($numreg > 0)
    return(true);
  else
    return(false);
}


/* ******************************************************
  RetornaListagemCompletaRec - Recursivamente, cria uma
    lista com todas as mensagens, guardando em uma
    varivel, e em outra varivel cria os links das
    mensagens.

  Entradas: $sock - sock de conexao,
            $cod_msg_pai = cdigo da mensagem-pai,
            $cod_forum - cdigo do frum,
            $status - A - Ativo,
                      D - Deletado,
                      X - Excludo.
            $nivel - nvel das mensagens na rvore,
            &$msg - varivel que guarda os links das
              mensagens,
            &$NumMsg - nmero de mensagens.

  Saida:    Modifica as variveis:
              &$msg - array com a estrura:
                     ['cod_msg']['nivel'] - nvel da mensagem na rvore,
                     ['cod_msg']['cod_usuario'] - cdigo usurio que postou,
                         a mensagem,
                     ['cod_msg']['titulo'] - ttulo da mensagem,
                     ['cod_msg']['mensagem'] - texto da mensagem,
                     ['cod_msg']['data'] - data da mensagem.
              &$NumMsg - nmero de mensagens,

*/
function RetornaListagemCompletaRec($sock, $cod_msg_pai, $cod_forum, $status,
  $nivel, &$msg, &$NumMsg)
{
  $query = "select cod_msg, cod_usuario, titulo, mensagem, data from ";
  $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and ";
  $query .= "status = 'A' and cod_msg_pai = ".$cod_msg_pai." order by data";

  $res = Enviar($sock, $query);
  $total = RetornaNumLinhas($res);
  $tuplas = RetornaArrayLinhas($res);

  for ($i = 0; $i < $total; $i++)
  {
    $msg[$tuplas[$i]['cod_msg']]['nivel'] = $nivel;
    $msg[$tuplas[$i]['cod_msg']]['cod_usuario'] = $tuplas[$i]['cod_usuario'];
    $msg[$tuplas[$i]['cod_msg']]['titulo'] = $tuplas[$i]['titulo'];
    $msg[$tuplas[$i]['cod_msg']]['mensagem'] = $tuplas[$i]['mensagem'];
    $msg[$tuplas[$i]['cod_msg']]['data'] = $tuplas[$i]['data'];

    /* Incrementa o contador de mensagens.                        */
    $NumMsg++;

    /* Imprime as respostas recursivamente */
    RetornaListagemCompletaRec($sock, $tuplas[$i]['cod_msg'], $cod_forum, $status,
      $nivel + 1, $msg, $NumMsg);
  }
}

// function RetornaListagemCompletaRec($sock, $cod_msg_pai, $cod_forum, $status,
//   $recuo, &$msg, &$lista, &$NumMsg, $MAXSTRING, $penult_acesso, $lista_frases)
// {
//   Global $SalvarEmArquivo; /* Usada para determinar se tem que criar o link para o perfil */
//   # Gera a identao das mensagens
//   $espacos = "";
//   for ($j = 0; $j < $recuo; $j++)
//     $espacos .= "&nbsp;&nbsp;&nbsp;";
//
//   $query = "select cod_msg, cod_usuario, titulo, mensagem, data from ";
//   $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and ";
//   $query .= "status = 'A' and cod_msg_pai = ".$cod_msg_pai." order by data";
//
//   $res = Enviar($sock, $query);
//   $total = RetornaNumLinhas($res);
//   $tuplas = RetornaArrayLinhas($res);
//
//   for ($i = 0; $i < $total; $i++)
//   {
//     # Lista - INICIO
//
//     /* adiciona um separador. */
//     $lista .= "<tr>\n";
//     $lista .= "  <td colspan=3><hr></td>\n";
//     $lista .= "</tr>\n";
//
//     /* Cria uma ncora para o link da mensagem. */
//     $lista .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $lista .= "  <td><a name=".$tuplas[$i]['cod_msg']."></a>";
//     $lista .= "<font class=text>".($NumMsg + 1).".</font></td>\n";
//
//     /* Exibe o ttulo da mensagem.                */
//     $lista .= "  <td width=70%>\n";
//     $lista .= "    <font class=text><b>".$tuplas[$i]['titulo']."</b></font>\n";
//     $lista .= "  </td>\n";
//
//     /* Exibe a data de postagem da mensagem.    */
//     $lista .= "  <td width=30% align=right>\n";
//     $lista .= "    <font class=text>".NomeDiaSemana(UnixTime2DiaSemana($tuplas[$i]['data'])).", ";
//     $lista .= UnixTime2Data($tuplas[$i]['data']).", ".UnixTime2Hora($tuplas[$i]['data'])."</font>\n";
//     $lista .= "  </td>\n";
//     $lista .= "</tr>\n";
//
//     /* Exibe o nome do emissor.                 */
//     $lista .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $lista .= "  <td colspan=3 align=right>\n";
//     $lista .= "    <font class=text>".NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</font>\n";
//     $lista .= "  </td>\n";
//     $lista .= "</tr>\n";
//
//     /* Exibe o contedo da mensagem.            */
//     $lista .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $lista .= "  <td colspan=2 width=70%>\n";
//     $lista .= "    <font class=text>".Enter2BR(LimpaConteudo($tuplas[$i]['mensagem']));
//     $lista .= "</font>\n";
//     $lista .= "  </td>\n";
//
//     /* 79 - Voltar ao topo */
//     $lista .= "  <td width=30% align=right>\n";
//     $lista .= "    <a href=# class=text>".RetornaFraseDaLista($lista_frases, 79)."</a>\n";
//     $lista .= "  </td>\n";
//     $lista .= "</tr>\n";
//     # Lista - FIM
//
//     $msg .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $msg .= "  <td><font class=text>".($NumMsg + 1).".</font></td>\n";
//
//     $msg .= "  <td>";
//     /* Recua o texto para respostas (no  utilizado nas mensagens-raiz). */
//     $msg .= $espacos;
//     $msg .= "<a href=#".$tuplas[$i]['cod_msg']." class=text>";
//
//     /* Se a mensagem for nova para o usuario exibe-a em negrito. */
//     if ($tuplas[$i]['data'] > $penult_acesso)
//     {
//       $msg .= "<b>".TruncaString($tuplas[$i]['titulo'], $MAXSTRING)."</b></a></td>\n";
//
//       $msg .= "  <td class=text>";
//       if (!isset($SalvarEmArquivo))
//       {
//         $msg .= "<a class=text href=# onClick=";
//         $msg .= "'return(OpenWindowPerfil(".$tuplas[$i]['cod_usuario']."))'>";
//       }
//       $msg .= "<b>".NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</b></a></td>\n";
//
//       $msg .= "  <td><font class=text><b>".UnixTime2Data($tuplas[$i]['data'])."</b></font></td>\n";
//     }
//     else
//     {
//       $msg .= TruncaString($tuplas[$i]['titulo'], $MAXSTRING)."</a></td>\n";
//
//       $msg .= "  <td class=text>";
//       if (!isset($SalvarEmArquivo))
//       {
//         $msg .= "<a class=text href=# onClick=";
//         $msg .= "'return(OpenWindowPerfil(".$tuplas[$i]['cod_usuario']."))'>";
//       }
//       $msg .= NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</a></td>\n";
//
//       $msg .= "  <td><font class=text>".UnixTime2Data($tuplas[$i]['data'])."</font></td>\n";
//     }
//
//     $msg .= "</tr>\n";
//
//     /* Incrementa o contador de mensagens.                       */
//     $NumMsg++;
//
//     ## Imprime as respostas recursivamente
//     RetornaListagemCompletaRec($sock, $tuplas[$i]['cod_msg'], $cod_forum, $status,
//       $recuo + 1, $msg, $lista, $NumMsg, $MAXSTRING, $penult_acesso, $lista_frases);
//     ##
//   }
// }

/* ******************************************************
  RetornaListagemCompleta - Cria uma lista com todas as
    mensagens-raiz, guardando em uma varivel, e em outra
    varivel cria os links das mensagens-raiz. Chama a
    funo RetornaListagemCompletaRec que faz o mesmo
    nos subnveis.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum,
            $status - A - Ativo,
                      D - Deletado,
                      X - Excludo.
            $cod_usuario - cdigo do usurio.

  Saida:    array contendo:
              $NumMsg - total de mensagens,
              $msg - array com a estrura:
                     ['cod_msg']['nivel'] - nvel da mensagem na rvore,
                     ['cod_msg']['cod_usuario'] - cdigo usurio que postou,
                         a mensagem,
                     ['cod_msg']['titulo'] - ttulo da mensagem,
                     ['cod_msg']['mensagem'] - texto da mensagem,
                     ['cod_msg']['data'] - data da mensagem.
*/
function RetornaListagemCompleta($sock, $cod_forum, $status, $cod_usuario)
{
  /* Nmero de mensagens */
  $NumMsg = 0;
  /* Nivel das mensagens na rvore. Utilizado para identao. */
  $nivel = 0;

  $query = "select cod_msg, cod_usuario, titulo, mensagem, data from ";
  $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and ";
  $query .= "status = 'A' and cod_msg_pai is NULL order by data";

  $res = Enviar($sock, $query);
  $total = RetornaNumLinhas($res);
  $tuplas = RetornaArrayLinhas($res);

  for ($i = 0; $i < $total; $i++)
  {
    $msg[$tuplas[$i]['cod_msg']]['nivel'] = $nivel;
    $msg[$tuplas[$i]['cod_msg']]['cod_usuario'] = $tuplas[$i]['cod_usuario'];
    $msg[$tuplas[$i]['cod_msg']]['titulo'] = $tuplas[$i]['titulo'];
    $msg[$tuplas[$i]['cod_msg']]['mensagem'] = $tuplas[$i]['mensagem'];
    $msg[$tuplas[$i]['cod_msg']]['data'] = $tuplas[$i]['data'];

    /* Incrementa o contador de mensagens.                        */
    $NumMsg++;

    /* Imprime as respostas recursivamente */
    RetornaListagemCompletaRec($sock, $tuplas[$i]['cod_msg'], $cod_forum, $status,
      $nivel + 1, $msg, $NumMsg);
  }
  return array($NumMsg, $msg);
}

// function RetornaListagemCompleta($sock, $cod_forum, $status, $cod_usuario, $lista_frases)
// {
//   Global $SalvarEmArquivo; /* Usada para determinar se tem que criar o link para o perfil */
//
//   $MAXSTRING = 25;
//
//   $NumMsg = 0; # Nmero de mensagens
//   $recuo = 0; # Recuo para hierarquizao das mensagens
//   /* penltima data de acesso                                */
//   $penult_acesso = PenultimoAcesso($sock, $cod_usuario, "");
//
//   $query = "select cod_msg, cod_usuario, titulo, mensagem, data from ";
//   $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and ";
//   $query .= "status = 'A' and cod_msg_pai is NULL order by data";
//
//   $res = Enviar($sock, $query);
//   $total = RetornaNumLinhas($res);
//   $tuplas = RetornaArrayLinhas($res);
//
//   for ($i = 0; $i < $total; $i++)
//   {
//     # Lista - INICIO
//     /* adiciona um separador. */
//     $lista .= "<tr>\n";
//     $lista .= "  <td colspan=3><hr></td>\n";
//     $lista .= "</tr>\n";
//
//     /* Cria uma ncora para o link da mensagem. */
//     $lista .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $lista .= "  <td><a name=".$tuplas[$i]['cod_msg']."></a>";
//     $lista .= "<font class=text>".($NumMsg + 1).".</font></td>\n";
//
//     /* Exibe o ttulo da mensagem.                */
//     $lista .= "  <td width=70%>\n";
//     $lista .= "    <font class=text><b>".$tuplas[$i]['titulo']."</b></font>\n";
//     $lista .= "  </td>\n";
//
//     /* Exibe a data de postagem da mensagem.    */
//     $lista .= "  <td width=30% align=right>\n";
//     $lista .= "    <font class=text>".NomeDiaSemana(UnixTime2DiaSemana($tuplas[$i]['data'])).", ";
//     $lista .= UnixTime2Data($tuplas[$i]['data']).", ".UnixTime2Hora($tuplas[$i]['data'])."</font>\n";
//     $lista .= "  </td>\n";
//     $lista .= "</tr>\n";
//
//     /* Exibe o nome do emissor.                 */
//     $lista .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $lista .= "  <td colspan=3 align=right>\n";
//     $lista .= "    <font class=text>".NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</font>\n";
//     $lista .= "  </td>\n";
//     $lista .= "</tr>\n";
//
//     /* Exibe o contedo da mensagem.            */
//     $lista .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $lista .= "  <td colspan=2 widht=70%>\n";
//     $lista .= "    <font class=text>".Enter2BR(LimpaConteudo($tuplas[$i]['mensagem']));
//     $lista .= "</font>\n";
//     $lista .= "  </td>\n";
//
//     /* 79 - Voltar ao topo */
//     $lista .= "  <td width=30% align=right>\n";
//     $lista .= "    <a href=# class=text>".RetornaFraseDaLista($lista_frases, 79)."</a><a name=";
//     $lista .= $tuplas[$i]['cod_msg']."></a>\n";
//     $lista .= "  </td>\n";
//
//     $lista .= "</tr>\n";
//     # Lista - FIM
//
//     $msg .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $msg .= "  <td><font class=text>".($NumMsg + 1).".</font></td>\n";
//
//     $msg .= "  <td>";
//     /* Recua o texto para respostas (no  utilizado nas mensagens-raiz). */
//     # $msg .= $espacos;
//     $msg .= "<a href=#".$tuplas[$i]['cod_msg']." class=text>";
//
//     /* Se a mensagem for nova para o usuario exibe-a em negrito. */
//     if ($tuplas[$i]['data'] > $penult_acesso)
//     {
//       $msg .= "<b>".TruncaString($tuplas[$i]['titulo'], $MAXSTRING)."</b></a></td>\n";
//
//       $msg .= "  <td class=text>";
//       if (!isset($SalvarEmArquivo))
//       {
//         $msg .= "<a class=text href=# onClick=";
//         $msg .= "'return(OpenWindowPerfil(".$tuplas[$i]['cod_usuario']."))'>";
//       }
//       $msg .= "<b>".NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</b></a></td>\n";
//
//       $msg .= "  <td><font class=text><b>".UnixTime2Data($tuplas[$i]['data'])."</b></font></td>\n";
//     }
//     else
//     {
//       $msg .= TruncaString($tuplas[$i]['titulo'], $MAXSTRING)."</a></td>\n";
//
//       $msg .= "  <td class=text>";
//       if (!isset($SalvarEmArquivo))
//       {
//         $msg .= "<a class=text href=# onClick=";
//         $msg .= "'return(OpenWindowPerfil(".$tuplas[$i]['cod_usuario']."))'>";
//       }
//       $msg .= NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</a></td>\n";
//
//       $msg .= "  <td><font class=text>".UnixTime2Data($tuplas[$i]['data'])."</font></td>\n";
//     }
//
//     $msg .= "</tr>\n";
//
//     /* Incrementa o contador de mensagens.                        */
//     $NumMsg++;
//
//     ## Imprime as respostas recursivamente
//     RetornaListagemCompletaRec($sock, $tuplas[$i]['cod_msg'], $cod_forum, $status,
//       $recuo + 1, $msg, $lista, $NumMsg, $MAXSTRING, $penult_acesso, $lista_frases);
//     ##
//   }
//   return array($NumMsg, $msg, $lista);
// }

/* ******************************************************
  RetornaMensagensRec - Funo recursiva chamada pela
    funo RetornaMensagens. Aprofunda procurando
    mensagens-filhas (reply's) e altera o array, no qual
    so armazenadas, passado por referncia.

  Entradas: $sock - sock de conexao,
            $cod_msg_pai - cdigo da mensagem-pai,
            $cod_forum - cdigo do frum,
            $status - A - Ativo
                      D - Deletado,
                      X - Excludo.
            $msgperpag - nmero de mensagens por pgina,
            $MAXSTRING - tamanho mximo de caracteres para
              truncar o ttulo das mensagens,
            $nivel - nvel da mensagem na rvore (utilizado
              para identar as mensagens),
            &$pag - nmero da pgina atual,
            &$cont_msg - contador de mensagens por pgina,
            &$NumMsg - nmero de mensagens,
            &$arraymsg - array que guarda as mensagens,
            $sinpag - array que sinaliza quais as pginas
              possuem mensagens novas,
            $penult_acesso - data do penltimo acesso.

  Saida:    Modifica as variveis:
              &$arraymsg - array que guarda as mensagens,
              &$pag - nmero da pgina atual,
              &$NumMsg - nmero de mensagens,
              &$cont_msg - contador de mensagens por pgina.
*/

function RetornaMensagensRec($sock, $cod_msg_pai, $cod_forum, $status, $msgperpag, $MAXSTRING,
  $nivel, &$pag, &$cont_msg, &$NumMsg, &$arraymsg, &$sinpag, $penult_acesso)
{

  $query = "select cod_msg, cod_usuario, titulo, data from ";
  $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and ";
  $query .= "status = 'A' and cod_msg_pai = ".$cod_msg_pai." order by data";

  $res = Enviar($sock, $query);
  $total = RetornaNumLinhas($res);
  $tuplas = RetornaArrayLinhas($res);

  for ($i = 0; $i < $total; $i++)
  {
    if ($tuplas[$i]['data'] > $penult_acesso)
      $sinpag[$pag] = true;

    $arraymsg[$pag][$tuplas[$i]['cod_msg']]['nivel'] = $nivel;
    $arraymsg[$pag][$tuplas[$i]['cod_msg']]['cod_usuario'] = $tuplas[$i]['cod_usuario'];
    $arraymsg[$pag][$tuplas[$i]['cod_msg']]['data'] = $tuplas[$i]['data'];
    $arraymsg[$pag][$tuplas[$i]['cod_msg']]['titulo'] = TruncaString($tuplas[$i]['titulo'], $MAXSTRING);

    $NumMsg++;
    $cont_msg++;

    /* Se for excedido o nmero de mensagens por pgina, ento  */
    /* incrementa o nmero de pginas.                          */
    if ($cont_msg >= $msgperpag)
    {
      $pag++;
      $sinpag[$pag] = false;
      $cont_msg = 0;
    }

    /* Obtm as respostas recursivamente */
    RetornaMensagensRec($sock, $tuplas[$i]['cod_msg'], $cod_forum, $status, $msgperpag, $MAXSTRING,
      $nivel + 1, $pag, $cont_msg, $NumMsg, $arraymsg, $sinpag, $penult_acesso);
  }
}

// function RetornaMensagensRec($sock, $cod_msg_pai, $cod_forum, $status,
//  $recuo, &$arraymsg, &$pag, &$NumMsg, $numpag, &$cont_msg, $MAXSTRING, $penult_acesso)
// {
//   // Gera a identao das mensagens
//   $espacos = "";
//   for ($j = 0; $j < $recuo; $j++)
//     $espacos .= "&nbsp;&nbsp;&nbsp;";
//
//   $query = "select cod_msg, cod_usuario, titulo, data from ";
//   $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and ";
//   $query .= "status = 'A' and cod_msg_pai = ".$cod_msg_pai." order by data";
//
//   $res = Enviar($sock, $query);
//   $total = RetornaNumLinhas($res);
//   $tuplas = RetornaArrayLinhas($res);
//
//   for ($i = 0; $i < $total; $i++)
//   {
//     $arraymsg[$pag] .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $arraymsg[$pag] .= "  <td><font class=text>".($NumMsg + 1).".</font></td>\n";
//
//     $arraymsg[$pag] .= "  <td>";
//     /* Recua o texto para respostas (no  utilizado nas mensagens-raiz). */
//     $arraymsg[$pag] .= $espacos;
//     $arraymsg[$pag] .= "<a href=// class=text onClick='ExibirMensagem(".$tuplas[$i]['cod_msg'].");";
//     $arraymsg[$pag] .= "return(false);'>";
//
//     /* Se a mensagem for nova para o usuario exibe-a em negrito. */
//     if ($tuplas[$i]['data'] > $penult_acesso)
//     {
//       $arraymsg[$pag] .= "<b>".TruncaString($tuplas[$i]['titulo'], $MAXSTRING)."</b></a></td>\n";
//
//       $arraymsg[$pag] .= "  <td><a class=text href=// onClick=";
//       $arraymsg[$pag] .= "'return(OpenWindowPerfil(".$tuplas[$i]['cod_usuario']."))'>";
//       $arraymsg[$pag] .= "<b>".NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</b></a></td>\n";
//
//       $arraymsg[$pag] .= "  <td><font class=text><b>".UnixTime2Data($tuplas[$i]['data'])."</b></font></td>\n";
//     }
//     else
//     {
//       $arraymsg[$pag] .= TruncaString($tuplas[$i]['titulo'], $MAXSTRING)."</a></td>\n";
//
//       $arraymsg[$pag] .= "  <td><a class=text href=// onClick=";
//       $arraymsg[$pag] .= "'return(OpenWindowPerfil(".$tuplas[$i]['cod_usuario']."))'>";
//       $arraymsg[$pag] .= NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</a></td>\n";
//
//       $arraymsg[$pag] .= "  <td><font class=text>".UnixTime2Data($tuplas[$i]['data'])."</font></td>\n";
//     }
//
//     $arraymsg[$pag] .= "</tr>\n";
//
//     $NumMsg++;
//     $cont_msg++;
//
//     /* Se for excedido o nmero de mensagens por pgina, ento  */
//     /* incrementa o nmero de pginas.                          */
//     if ($cont_msg >= $numpag)
//     {
//       $pag++;
//       $cont_msg = 0;
//     }
//
//     /* Imprime as respostas recursivamente */
//     RetornaMensagensRec($sock, $tuplas[$i]['cod_msg'], $cod_forum, $status,
//       $recuo + 1, $arraymsg, $pag, $NumMsg, $numpag, $cont_msg, $MAXSTRING, $penult_acesso);
//
//   }
// }


/* ******************************************************
  RetornaMensagens - Retorna as mensagens-raiz, guard-as
    em um array e chama a funo recursiva
    RetornaMensagensRec.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum,
            $status - A - Ativo
                      D - Deletado,
                      X - Excludo.
            $msgperpag - nmero de mensagens por pgina,
            $cod_usuario - cdigo do usurio,
            $penult_acesso - data do penltimo acesso do
              usurio.

  Saida:    array contendo:
              $NumMsg - total de mensagens,
              $msg - array com as mensagens, onde cada
                ndice deste  uma pgina que
                contm $numpag mensagens,
              $sinpag - array sinalizando se a pgina contm
                mensagens.
*/

function RetornaMensagens($sock, $cod_forum, $status, $msgperpag, $cod_usuario, $penult_acesso)
{
  $MAXSTRING = 25;
  $msg = array();

  /* Array sinalizando se a pgina possui mensagens novas */
  $sinpag = array();

  /* Nvel das mensagens na rvore. */
  $nivel = 0;
  /* Contador de pginas */
  $pag = 1;
  /* Nmero de mensagens */
  $NumMsg = 0;
  /* Contador de mensagens da pgina atual */
  $cont_msg = 0;

  $query = "select cod_msg, cod_usuario, titulo, data from ";
  $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and ";
  $query .= "status = 'A' and cod_msg_pai is NULL order by data";

  $res = Enviar($sock, $query);
  $total = RetornaNumLinhas($res);
  $tuplas = RetornaArrayLinhas($res);

  /* Atribui falso ao primeiro elemento do array de sinalizao de mensagens novas */
  /* (primeira pgina).                                                            */
  $sinpag[$pag] = false;

  for ($i = 0; $i < $total; $i++)
  {
    /* Se a mensagem foi postada depois da penltima data de acesso ento sinaliza */
    /* que esta pgina possui mensagens novas.                                     */
    if ($tuplas[$i]['data'] > $penult_acesso)
      $sinpag[$pag] = true;

    $msg[$pag][$tuplas[$i]['cod_msg']]['nivel'] = $nivel;
    $msg[$pag][$tuplas[$i]['cod_msg']]['cod_usuario'] = $tuplas[$i]['cod_usuario'];
    $msg[$pag][$tuplas[$i]['cod_msg']]['data'] = $tuplas[$i]['data'];
    $msg[$pag][$tuplas[$i]['cod_msg']]['titulo'] = TruncaString($tuplas[$i]['titulo'], $MAXSTRING);

    $NumMsg++;
    $cont_msg++;

    /* Se for excedido o nmero de mensagens por pgina, ento  */
    /* incrementa o nmero de pginas.                          */
    if ($cont_msg >= $msgperpag)
    {
      $pag++;
      $sinpag[$pag] = false;
      $cont_msg = 0;
    }

    /* Obtm as respostas recursivamente */
    RetornaMensagensRec($sock, $tuplas[$i]['cod_msg'], $cod_forum, $status, $msgperpag, $MAXSTRING,
      $nivel + 1, $pag, $cont_msg, $NumMsg, $msg, $sinpag, $penult_acesso);
  }
  return array($NumMsg, $msg, $sinpag);
}

// function RetornaMensagens($sock, $cod_forum, $status, $numpag, $cod_usuario)
// {
//   $MAXSTRING = 25;
//
//   $msg = array();
//
//   $pag = 1; // Nmero de pginas contendo numpag mensagens
//   $NumMsg = 0; // Nmero de mensagens
//   $recuo = 0; // Recuo para hierarquizao das mensagens
//   $cont_msg = 0; // contador de mensagens na pgina atual
//   /* penltima data de acesso                                */
//   $penult_acesso = PenultimoAcesso($sock, $cod_usuario, "");
//
//
//   // Gera a identao das mensagens
//   // NO Utilizado para as mensagens-raiz
//   /*
//   $espacos = "";
//   for ($j = 0; $j < $recuo; $j++)
//     $espacos .= "&nbsp;&nbsp;&nbsp;";
//   */
//
//   $query = "select cod_msg, cod_usuario, titulo, data from ";
//   $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and ";
//   $query .= "status = 'A' and cod_msg_pai is NULL order by data";
//
//   $res = Enviar($sock, $query);
//   $total = RetornaNumLinhas($res);
//   $tuplas = RetornaArrayLinhas($res);
//
//   for ($i = 0; $i < $total; $i++)
//   {
//     $msg[$pag] .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $msg[$pag] .= "  <td><font class=text>".($NumMsg + 1).".</font></td>\n";
//
//     $msg[$pag] .= "  <td>";
//     /* Recua o texto para respostas (no  utilizado nas mensagens-raiz). */
//     // $msg[$pag] .= $espacos;
//     $msg[$pag] .= "<a href=// class=text onClick='ExibirMensagem(".$tuplas[$i]['cod_msg'].");";
//     $msg[$pag] .= "return(false);'>";
//
//     /* Se a mensagem for nova para o usuario exibe-a em negrito. */
//     if ($tuplas[$i]['data'] > $penult_acesso)
//     {
//       $msg[$pag] .= "<b>".TruncaString($tuplas[$i]['titulo'], $MAXSTRING)."</b></a></td>\n";
//
//       $msg[$pag] .= "  <td><a class=text href=// onClick=";
//       $msg[$pag] .= "'return(OpenWindowPerfil(".$tuplas[$i]['cod_usuario']."))'>";
//       $msg[$pag] .= "<b>".NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</b></a></td>\n";
//
//       $msg[$pag] .= "  <td><font class=text><b>".UnixTime2Data($tuplas[$i]['data'])."</b></font></td>\n";
//     }
//     else
//     {
//       $msg[$pag] .= TruncaString($tuplas[$i]['titulo'], $MAXSTRING)."</a></td>\n";
//
//       $msg[$pag] .= "  <td><a class=text href=// onClick=";
//       $msg[$pag] .= "'return(OpenWindowPerfil(".$tuplas[$i]['cod_usuario']."))'>";
//       $msg[$pag] .= NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</a></td>\n";
//
//       $msg[$pag] .= "  <td><font class=text>".UnixTime2Data($tuplas[$i]['data'])."</font></td>\n";
//     }
//
//     $msg[$pag] .= "</tr>\n";
//
//     $NumMsg++;
//     $cont_msg++;
//
//     /* Se for excedido o nmero de mensagens por pgina, ento  */
//     /* incrementa o nmero de pginas.                          */
//     if ($cont_msg >= $numpag)
//     {
//       $pag++;
//       $cont_msg = 0;
//     }
//     /* Imprime as respostas recursivamente */
//     RetornaMensagensRec($sock, $tuplas[$i]['cod_msg'], $cod_forum, $status,
//       $recuo + 1, $msg, $pag, $NumMsg, $numpag, $cont_msg, $MAXSTRING, $penult_acesso);
//
//   }
//   return array($NumMsg, $msg);
// }


/* ******************************************************
  RetornaListagemCompletaOrdenada - Cria um lista contendo
    todas as mensagens ordenadas e uma lista com links para
    essas mensagens.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum,
            $status - A - Ativo
                      D - Deletado
                      X - Excludo.
            $cod_usuario - cdigo do usurio.
            $ordem - data,
                     emissor,
                     titulo.

  Saida:    array contendo:
              $Nummsg - nmero total de mensagens,
              $msg - array com a estrura:
                     ['cod_msg']['nivel'] - nvel da mensagem na rvore,
                     ['cod_msg']['cod_usuario'] - cdigo usurio que postou,
                         a mensagem,
                     ['cod_msg']['titulo'] - ttulo da mensagem,
                     ['cod_msg']['mensagem'] - texto da mensagem,
                     ['cod_msg']['data'] - data da mensagem.

*/

function RetornaListagemCompletaOrdenada($sock, $cod_forum, $status, $cod_usuario, $ordem)
{
  /* Nmero de mensagens */
  $NumMsg = 0;

  if ($ordem == 'emissor')
  {
    $query = "select FM.cod_msg, FM.cod_usuario, FM.titulo, FM.mensagem, FM.data from ";
    $query .= "Forum_mensagens as FM, Usuario as U where FM.cod_forum = ".$cod_forum;
    $query .= " and FM.status = 'A' and FM.cod_usuario = U.cod_usuario";
    $query .= " order by U.nome, FM.data";
  }
  else
  {
    $query = "select cod_msg, cod_usuario, titulo, mensagem, data from ";
    $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and";
    $query .= " status = 'A' order by ".$ordem.", data";
  }
  $res = Enviar($sock, $query);
  $total = RetornaNumLinhas($res);
  $tuplas = RetornaArrayLinhas($res);

  for ($i = 0; $i < $total; $i++)
  {
    $msg[$tuplas[$i]['cod_msg']]['nivel'] = $nivel;
    $msg[$tuplas[$i]['cod_msg']]['cod_usuario'] = $tuplas[$i]['cod_usuario'];
    $msg[$tuplas[$i]['cod_msg']]['titulo'] = $tuplas[$i]['titulo'];
    $msg[$tuplas[$i]['cod_msg']]['mensagem'] = $tuplas[$i]['mensagem'];
    $msg[$tuplas[$i]['cod_msg']]['data'] = $tuplas[$i]['data'];

    $NumMsg++;
  }

  return array($NumMsg, $msg);
}

// function RetornaListagemCompletaOrdenada(
//   $sock, $cod_forum, $status, $cod_usuario, $ordem, $lista_frases)
// {
//   Global $SalvarEmArquivo; /* Usada para determinar se tem que criar o link para o perfil */
//
//   $MAXSTRING = 25;
//
//   /* Nmero de mensagens */
//   $NumMsg = 0;
//   /* penltima data de acesso                                */
//   $penult_acesso = PenultimoAcesso($sock, $cod_usuario, "");
//
//   if ($ordem == 'emissor')
//   {
//     $query = "select FM.cod_msg, FM.cod_usuario, FM.titulo, FM.mensagem, FM.data from ";
//     $query .= "Forum_mensagens as FM, Usuario as U where FM.cod_forum = ".$cod_forum;
//     $query .= " and FM.status = 'A' and FM.cod_usuario = U.cod_usuario";
//     $query .= " order by U.nome, FM.data";
//   }
//   else
//   {
//     $query = "select cod_msg, cod_usuario, titulo, mensagem, data from ";
//     $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and";
//     $query .= " status = 'A' order by ".$ordem.", data";
//   }
//   $res = Enviar($sock, $query);
//   $total = RetornaNumLinhas($res);
//   $tuplas = RetornaArrayLinhas($res);
//
//   for ($i = 0; $i < $total; $i++)
//   {
//     # Lista - INICIO
//
//     /* adiciona um separador. */
//     $lista .= "<tr>\n";
//     $lista .= "  <td colspan=3><hr></td>\n";
//     $lista .= "</tr>\n";
//
//     /* Cria uma ncora para o link da mensagem. */
//     $lista .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $lista .= "  <td><a name=".$tuplas[$i]['cod_msg']."></a>";
//     $lista .= "<font class=text>".($NumMsg + 1).".</font></td>\n";
//
//     /* Exibe o ttulo da mensagem.                */
//     $lista .= "  <td width=70%>\n";
//     $lista .= "    <font class=text><b>".$tuplas[$i]['titulo']."</b></font>\n";
//     $lista .= "  </td>\n";
//
//     /* Exibe a data de postagem da mensagem.    */
//     $lista .= "  <td width=30% align=right>\n";
//     $lista .= "    <font class=text>".NomeDiaSemana(UnixTime2DiaSemana($tuplas[$i]['data'])).", ";
//     $lista .= UnixTime2Data($tuplas[$i]['data']).", ".UnixTime2Hora($tuplas[$i]['data'])."</font>\n";
//     $lista .= "  </td>\n";
//     $lista .= "</tr>\n";
//
//     /* Exibe o nome do emissor.                 */
//     $lista .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $lista .= "  <td colspan=3 align=right>\n";
//     $lista .= "    <font class=text>".NomeUsuario($sock, $tuplas[$i]['cod_usuario'])."</font>\n";
//     $lista .= "  </td>\n";
//     $lista .= "</tr>\n";
//
//     /* Exibe o contedo da mensagem.            */
//     $lista .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $lista .= "  <td colspan=2 widht=70%>\n";
//     $lista .= "    <font class=text>".Enter2BR(LimpaConteudo($tuplas[$i]['mensagem']));
//     $lista .= "</font>\n";
//     $lista .= "  </td>\n";
//
//     /* 79 - Voltar ao topo */
//     $lista .= "  <td width=30% align=right>\n";
//     $lista .= "    <a href=# class=text>".RetornaFraseDaLista($lista_frases, 79)."</a><a name=";
//     $lista .= $tuplas[$i]['cod_msg']."></a>\n";
//     $lista .= "  </td>\n";
//     $lista .= "</tr>\n";
//     # Lista - FIM
//
//     $msg .= "<tr class=g".(($NumMsg % 2) + 1)."field>\n";
//     $msg .= "  <td><font class=text>".($NumMsg + 1).".</font></td>\n";
//
//     $msg .= "  <td>";
//     $msg .= "    <a href=#".$tuplas[$i]['cod_msg']." class=text>";
//
//     /* Se a mensagem for nova para o usuario exibe-a em negrito. */
//     if ($tuplas[$i]['data'] > $penult_acesso)
//     {
//       $btagOpen = "<b>";
//       $btagClose = "</b>";
//     }
//     else
//     {
//       $btagOpen = "";
//       $btagClose = "";
//     }
//
//     $msg .= $btagOpen.TruncaString($tuplas[$i]['titulo'], $MAXSTRING).$btagClose."</a></td>\n";
//     $msg .= "  <td class=text>";
//
//     if (!isset($SalvarEmArquivo))
//     {
//       $msg .= "<a class=text href=# onClick=";
//       $msg .= "'return(OpenWindowPerfil(".$tuplas[$i]['cod_usuario']."))'>";
//     }
//     $msg .= $btagOpen.NomeUsuario($sock, $tuplas[$i]['cod_usuario']).$btagClose."</a></td>\n";
//
//     $msg .= "  <td><font class=text>".$btagOpen.UnixTime2Data($tuplas[$i]['data']).$btagClose."</font></td>\n";
//
//     $msg .= "</tr>\n";
//
//     $NumMsg++;
//   }
//
//   return array($NumMsg, $msg, $lista);
// }


/* ******************************************************
  RetornaMensagensOrdenadas - Obtm os dados da mensagem.

  Entradas: $sock - sock de conexao,
            $cod_forum - cdigo do frum,
            $status - A - Ativo
                      D - Deletado
                      X - Excludo.
            $numpag - nmero de mensagens por pgina,
            $cod_usuario - cdigo do usurio.
            $ordem - data,
                     cod_usuario,
                     titulo.
            $penult_acesso - data do penltimo acesso
              do usurio.

  Saida:    array contendo:
              $Nummsg - nmero total de mensagens,
              $msg - array com os dados da mensagem,
              $sinpag - array sinalizando se a pgina contm
                mensagens.

*/

function RetornaMensagensOrdenadas($sock, $cod_forum, $status, $numpag, $cod_usuario, $ordem, $penult_acesso)
{
  $MAXSTRING = 25;

  $msg = array();

  /* Nmero de pginas contendo numpag mensagens */
  $pag = 1;
  /* Nmero de mensagens */
  $NumMsg = 0;
  /* contador de mensagens na pgina atual  */
  $cont_msg = 0;

  /* Array sinalizando se a pgina possui mensagens novas */
  $sinpag = array();

  if ($ordem == 'emissor')
  {
    $query = "select FM.cod_msg, FM.cod_usuario, FM.titulo, FM.data from ";
    $query .= "Forum_mensagens as FM, Usuario as U where FM.cod_forum = ".$cod_forum;
    $query .= " and FM.status = 'A' and FM.cod_usuario = U.cod_usuario";
    $query .= " order by U.nome, FM.data";
  }
  else
  {
    $query = "select cod_msg, cod_usuario, titulo, data from ";
    $query .= "Forum_mensagens where cod_forum = ".$cod_forum." and";
    $query .= " status = 'A' order by ".$ordem.", data";
  }
  $res = Enviar($sock, $query);
  $total = RetornaNumLinhas($res);
  $tuplas = RetornaArrayLinhas($res);

  /* Atribui falso ao primeiro elemento do array de sinalizao de mensagens novas */
  /* (primeira pgina).                                                            */
  $sinpag[$pag] = false;

  for ($i = 0; $i < $total; $i++)
  {
    /* Se a mensagem foi postada depois da penltima data de acesso ento sinaliza */
    /* que esta pgina possui mensagens novas.                                     */
    if ($tuplas[$i]['data'] > $penult_acesso)
      $sinpag[$pag] = true;

    $msg[$pag][$tuplas[$i]['cod_msg']]['cod_usuario'] = $tuplas[$i]['cod_usuario'];
    $msg[$pag][$tuplas[$i]['cod_msg']]['data'] = $tuplas[$i]['data'];
    $msg[$pag][$tuplas[$i]['cod_msg']]['titulo'] = TruncaString($tuplas[$i]['titulo'], $MAXSTRING);

    $NumMsg++;
    $cont_msg++;

    /* Se for excedido o nmero de mensagens por pgina, ento  */
    /* incrementa o nmero de pginas.                          */
    if ($cont_msg >= $numpag)
    {
      $pag++;
      $sinpag[$pag] = false;
      $cont_msg = 0;
    }
  }

  return array($NumMsg, $msg, $sinpag);
}


/* ******************************************************
  RetornaMensagem - Obtm os dados da mensagem.

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $cod_forum - cdigo do frum,
            $status - A - Ativo
                      D - Deletado
                      X - Excludo.

  Saida:    array contendo:
              $total - nmero total de mensagens,
              $tupla - array com os dados da mensagem: cod_usuario,
                                                       titulo,
                                                       mensagem,
                                                       data.
*/
function RetornaMensagem($sock, $cod_msg, $cod_forum, $status)
{
  $query = "select cod_usuario, titulo, mensagem, data from Forum_mensagens";
  $query .= " where cod_msg = ".$cod_msg." and cod_forum = ".$cod_forum;
  $query .= " and status = 'A'\n";

  $res = Enviar($sock, $query);
  $total = RetornaNumLinhas($res);
  $tupla = RetornaLinha($res);

  return array($total, $tupla);
}


/* ******************************************************
  ObtemMensagemAnteriorOrdenada - Obtm a mensagem anterior
    sob uma ordenao especfica.

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $cod_forum - cdigo do frum,
            $status - A - Ativo,
                      D - Deletado,
                      X - Excludo,
            $ordem - data,
                     cod_usuario,
                     titulo.

  Saida:    cdigo da mensagem anterior se esta existir, do
              contrrio -1.
*/
function ObtemMensagemAnteriorOrdenada($sock, $cod_msg, $cod_forum, $status, $ordem)
{
  $query = "select U.nome, FM.data, FM.titulo from Forum_mensagens as FM,";
  $query .= " Usuario as U where FM.cod_msg = ".$cod_msg." and FM.cod_forum = ";
  $query .= $cod_forum." and FM.status = 'A' and FM.cod_usuario = ";
  $query .= " U.cod_usuario";

  $res = Enviar($sock, $query);
  $resultado = RetornaLinha($res);

  $rnome = $resultado['nome'];
  $rdata = $resultado['data'];
  $rtitulo = $resultado['titulo'];

  switch($ordem)
  {
    case 'data':
      $query = "select cod_msg from Forum_mensagens where data < ".$rdata;
      $query .= " and cod_forum = ".$cod_forum." and status = 'A";
      $query .= "' order by data desc limit 1";
      break;
    case 'emissor':
      $query = "select FM.cod_msg from Forum_mensagens as FM, Usuario as U where";
      $query .= " FM.cod_usuario = U.cod_usuario and ((U.nome = '".$rnome."' and";
      $query .= " FM.data < ".$rdata.") or (U.nome < '".$rnome."'))";
      $query .= " and FM.cod_forum = ".$cod_forum." and FM.status = 'A";
      $query .= "' order by U.nome desc, FM.data desc limit 1";
      break;
    case 'titulo':
      $query = "select cod_msg from Forum_mensagens where ((titulo = '";
      $query .= $rtitulo."' and data < ".$rdata.") or (titulo < '";
      $query .= $rtitulo."')) and cod_forum = ".$cod_forum." and status = '";
      $query .= "A' order by titulo desc limit 1";
      break;
  }

  $res = Enviar($sock, $query);
  $resultado = RetornaLinha($res);

  if ($resultado['cod_msg'] > 0)
    return($resultado['cod_msg']);
  else
    return(-1);
}


/* ******************************************************
  ObtemMensagemSeguinteOrdenada - Obtm a mensagem seguinte
    sob uma ordenao especfica.

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $cod_forum - cdigo do frum,
            $status - A - Ativo,
                      D - Deletado,
                      X - Excludo,
            $ordem - data,
                     cod_usuario,
                     titulo.

  Saida:    cdigo da mensagem seguinte se esta existir, do
              contrrio -1.
*/
function ObtemMensagemSeguinteOrdenada($sock, $cod_msg, $cod_forum, $status, $ordem)
{
  $query = "select U.nome, FM.data, FM.titulo from Forum_mensagens as FM,";
  $query .= " Usuario as U where FM.cod_msg = ".$cod_msg." and FM.cod_forum = ";
  $query .= $cod_forum." and FM.status = 'A' and FM.cod_usuario = ";
  $query .= " U.cod_usuario";

  $res = Enviar($sock, $query);
  $resultado = RetornaLinha($res);

  $rnome = $resultado['nome'];
  $rdata = $resultado['data'];
  $rtitulo = $resultado['titulo'];

  switch($ordem)
  {
    case 'data':
      $query = "select cod_msg from Forum_mensagens where data > ".$rdata;
      $query .= " and cod_forum = ".$cod_forum." and status = 'A";
      $query .= "' order by data limit 1";
      break;
    case 'emissor':
      $query = "select FM.cod_msg from Forum_mensagens as FM, Usuario as U where";
      $query .= " FM.cod_usuario = U.cod_usuario and ((U.nome = '".$rnome."' and";
      $query .= " FM.data > ".$rdata.") or (U.nome > '".$rnome."'))";
      $query .= " and FM.cod_forum = ".$cod_forum." and FM.status = 'A";
      $query .= "' order by U.nome, FM.data limit 1";
      break;
    case 'titulo':
      $query = "select cod_msg from Forum_mensagens where ((titulo = '";
      $query .= $rtitulo."' and data > ".$rdata.") or (titulo > '";
      $query .= $rtitulo."')) and cod_forum = ".$cod_forum." and status = '";
      $query .= "A' order by titulo limit 1";
      break;
  }
  $res = Enviar($sock, $query);
  $resultado = RetornaLinha($res);

  if ($resultado['cod_msg'] > 0)
    return($resultado['cod_msg']);
  else
    return(-1);
}


/* ******************************************************
  ObtemMensagemAnteriorRecur - Obtm o cdigo da
    mensagem-filha mais velha de uma mensagem sob
    ordenao por rvore.

  Entradas: $sock - sock de conexao,
            $cod_msg_pai - cdigo da mensagem-pai,
            $cod_forum - cdigo do frum,
            $status - A - Ativo,
                      D - Deletado,
                      X - Excludo.

  Saida:    cdigo da mensagem-filha mais velha se esta
              existir, do contrrio cod_msg_pai.
*/
function ObtemMensagemAnteriorRecur($sock, $cod_msg_pai, $cod_forum, $status)
{
  $codigo = -1;

  $query = "select cod_msg from Forum_mensagens where cod_msg_pai = ".$cod_msg_pai;
  $query .= " and cod_forum = ".$cod_forum." and status = 'A";
  $query .= "' order by data desc limit 1";

  $res = Enviar($sock, $query);
  $num = RetornaNumLinhas($res);
  $tupla = RetornaLinha($res);

  if ($num > 0)
    $codigo = ObtemMensagemAnteriorRecur($sock, $tupla['cod_msg'], $cod_forum, $status);

  if ($codigo > 0)
    return($codigo);
  else
    return($cod_msg_pai);
}


/* ******************************************************
  ObtemMensagemAnterior - Obtm o cdigo da mensagem
    anterior sob ordenao por rvore.

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $cod_forum - cdigo do frum,
            $status - A - Ativo,
                      D - Deletado,
                      X - Excludo.

  Saida:    cdigo da mensagem anterior se esta existir, do
              contrrio -1.
*/
function ObtemMensagemAnterior($sock, $cod_msg, $cod_forum, $status)
{
  /* Obtm o cod_msg_pai e a data da mensagem.                              */
  $query = "select cod_msg_pai, data from Forum_mensagens where cod_msg = ";
  $query .= $cod_msg." and cod_forum = ".$cod_forum." and status = 'A'";

  $res = Enviar($sock, $query);
  $resultado = RetornaLinha($res);
  /* Extrai o cod_msg_pai e a data da mensagem.                             */
  $cod_msg_pai = $resultado['cod_msg_pai'];
  $data_mensagem = $resultado['data'];

  /* Seleciona a mensagem-irm cuja data  menor que a data da mensagem     */
  /* atual e maior que as das demais irms.                                 */
  if ($cod_msg_pai == "")
  {
    $query = "select cod_msg from Forum_mensagens where data < ".$data_mensagem;
    $query .= " and cod_msg_pai is NULL and cod_forum = ".$cod_forum;
    $query .= " and status = 'A' order by data desc limit 1";
  }
  else
  {
    $query = "select cod_msg from Forum_mensagens where data < ".$data_mensagem;
    $query .= " and cod_msg_pai = ".$cod_msg_pai." and cod_forum = ".$cod_forum;
    $query .= " and status = 'A' order by data desc limit 1";
  }

  $res = Enviar($sock, $query);
  $achou_irmao_anterior = RetornaNumLinhas($res);

  $irmao_anterior = RetornaLinha($res);

  /* Se existir uma mensagem-irm mais antiga, ento procura sua mensagem-filha */
  /* mais velha.                                                                */
  if ($achou_irmao_anterior > 0)
  {
    # Localiza o filho mais velho
    $anterior = ObtemMensagemAnteriorRecur($sock, $irmao_anterior['cod_msg'],
      $cod_forum, $status);
  }
  else
  /* Se no existir uma mensagem-irm mais antiga, ento verifica se h uma     */
  /* mensagem-pai. Se existir ser a mensagem anterior, do contrrio no h uma */
  /* mensagem anterior.                                                         */
  {
    /* Se no houver mensagem-pai, ento no h mensagem anterior.            */
    if ($cod_msg_pai == "")
      $anterior = -1; # No h antecessor.
    else
      $anterior = $cod_msg_pai; # A mensagem anterior  a mensagem-pai.
  }
  return($anterior);
}


/* ******************************************************
  RetornaMensagemSeguinteRecur - Obtm recusivamente o
    cod_msg da prxima mensagem em ordenao por rvore.

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $cod_forum - cdigo do frum,
            $status - A - Ativo
                      D - Deletado
                      X - Excludo.

  Saida:    cdigo da mensagem seguinte.

*/
function RetornaMensagemSeguinteRecur($sock, $cod_msg, $cod_forum, $status)
{
  # /: Obtm o cod_msg_pai e a data da mensagem.
  $query = "select cod_msg_pai, data from Forum_mensagens where cod_msg = ";
  $query .= $cod_msg." and cod_forum = ".$cod_forum." and status = 'A'";
  $res = Enviar($sock, $query);
  $resultado = RetornaLinha($res);

  $cod_msg_pai = $resultado['cod_msg_pai'];
  $data_mensagem = $resultado['data'];
  # :/

  /* Procura uma mensagem irm cuja data  maior que a da mensagem atual. */

  /* Se o cod_msg_pai for nulo ento a mensagem est na raiz.             */
  if ($cod_msg_pai == "")
  {
    $query = "select cod_msg from Forum_mensagens where data > ".$data_mensagem;
    $query .= " and cod_msg_pai is NULL and cod_forum = ".$cod_forum;
    $query .= " and status = 'A' order by data limit 1";
  }
  else
  /* Se o cod_msg_pai NO for nulo ento a mensagem  uma resposta.       */
  {
    $query = "select cod_msg from Forum_mensagens where data > ".$data_mensagem;
    $query .= " and cod_msg_pai = ".$cod_msg_pai." and cod_forum = ".$cod_forum;
    $query .= " and status = 'A' order by data limit 1";
  }

  $res = Enviar($sock, $query);
  $achou_proximo = RetornaNumLinhas($res);
  $proximo_irmao = RetornaLinha($res);

  # Se possuir irm ento esta  a mensagem seguinte
  if ($achou_proximo)
  {
    # A prxima mensagem  a mensagem-irm.
    $proximo = $proximo_irmao['cod_msg'];
  }
  else
  /* Se no houver irmos, ento verifica se h uma mensagem-pai */
  /* Se no houver ento no h mensagem seguinte.               */
  {
    if ($cod_msg_pai == "")
      $proximo = -1; # No h sucessor.
    else
    /* Se h uma mensagem pai ento deve-se procurar nela uma    */
    /* mensagem-irm.                                            */
      $proximo = RetornaMensagemSeguinteRecur($sock, $cod_msg_pai,
        $cod_forum, $status);
  }

  return($proximo);
}


/* ******************************************************
  ObtemMensagemSeguinte - Obtm o cod_msg da prxima
    mensagem em ordenao por rvore.

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $cod_forum - cdigo do frum,
            $status - A - Ativo
                      D - Deletado
                      X - Excludo.

  Saida:    cdigo da mensagem seguinte.

*/
function ObtemMensagemSeguinte($sock, $cod_msg, $cod_forum, $status)
{
  # /: Obtm o cod_msg_pai e a data da mensagem.
  $query = "select cod_msg_pai, data from Forum_mensagens where cod_msg = ";
  $query .= $cod_msg." and cod_forum = ".$cod_forum." and status = 'A'";
  $res = Enviar($sock, $query);
  $resultado = RetornaLinha($res);

  $cod_msg_pai = $resultado['cod_msg_pai'];
  $data_mensagem = $resultado['data'];
  # :/

  # /: Obtm o cod_msg do filho mais "novo", se aquele existir.
  $query = "select cod_msg from Forum_mensagens where cod_msg_pai = ";
  $query .= $cod_msg." and cod_forum = ".$cod_forum." and status = '";
  $query .= "A' order by data limit 1";

  $res = Enviar($sock, $query);
  $numfilho = RetornaNumLinhas($res);
  $filho_mais_novo = RetornaLinha($res);
  # :/

  /* Se existir um filho ento a mensagem seguinte ser ele. */
  if ($numfilho > 0)
  {
    $proximo = $filho_mais_novo['cod_msg'];
  }
  else
  /* Se no houver filhos ento deve-se procurar uma mensagem irm */
  /* cuja data  maior que a da mensagem atual.                    */
  {
    if ($cod_msg_pai == "")
    /* Se o cod_msg_pai for nulo ento a mensagem est na raiz. */
    {
      $query = "select cod_msg from Forum_mensagens where data > ".$data_mensagem;
      $query .= " and cod_msg_pai is NULL and cod_forum = ".$cod_forum;
      $query .= " and status = 'A' order by data limit 1";
    }
    else
    /* Se o cod_msg_pai NO for nulo, ento a mensagem  uma resposta. */
    {
      $query = "select cod_msg from Forum_mensagens where data > ".$data_mensagem;
      $query .= " and cod_msg_pai = ".$cod_msg_pai." and cod_forum = ".$cod_forum;
      $query .= " and status = 'A' order by data limit 1";
    }

    $res = Enviar($sock, $query);
    $achou_irmao_posterior = RetornaNumLinhas($res);
    $irmao_posterior = RetornaLinha($res);

    /* Se houver uma irm ento a mensagem seguinte  ela. */
    if ($achou_irmao_posterior > 0)
    {
      # A prxima mensagem  a mensagem-irm.
      $proximo = $irmao_posterior['cod_msg'];
    }
    else
    /* Se no houver irmos, ento verifica se h uma mensagem-pai */
    /* Se no houver ento no h mensagem seguinte.               */
    {
      if ($cod_msg_pai == "")
        $proximo = -1; # No h sucessor.
      else
      /* Se h uma mensagem pai ento deve-se procurar nela uma    */
      /* mensagem-irm.                                            */
        $proximo = RetornaMensagemSeguinteRecur($sock, $cod_msg_pai,
          $cod_forum, $status);
    }
  }
  return($proximo);
}


/* ******************************************************
  MensagemExiste - Verifica se a mensagem existe para
    que se possa respond-la.

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $cod_forum - cdigo do frum.

  Saida:    true se existir, do contrrio, false
*/
function MensagemExiste($sock, $cod_msg, $cod_forum)
{
  $query = "select cod_msg from Forum_mensagens where cod_msg = ".$cod_msg;
  $query .= " and cod_forum = ".$cod_forum;
  $res = Enviar($sock, $query);

  if (RetornaNumLinhas($res) > 0)
    return(true);
  else
    return(false);
}


/* ******************************************************
  MensagemTemRespostas - Verifica se a mensagem tm
    respostas para avaliar se pode ser excluda. Somente
    mensagens sem respostas podem ser excludas.

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $status - status da mensagem.

  Saida:    true se possuir respostas, do contrrio,
              false.

*/
function MensagemTemRespostas($sock, $cod_msg, $status)
{
  $query = "select cod_msg from Forum_mensagens where cod_msg_pai = ".$cod_msg;
  $query .= " and status = '".$status."'";

  $res = Enviar($sock, $query);

  if (RetornaNumLinhas($res) > 0)
    return(true);
  else
    return(false);
}

/* ******************************************************
  ApagaMensagem - Modifica o status da mensagem para X
    (excludo).

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $cod_forum - cdigo do frum.

  Saida:    true se bem-sucedido, do contrrio, false
*/
function ApagaMensagem($sock, $cod_msg, $cod_forum)
{
  $query = "update Forum_mensagens set status = 'X' where cod_forum = ".$cod_forum;
  $query .= " and cod_msg = ".$cod_msg." and cod_forum = ".$cod_forum;

  $res = Enviar($sock, $query);

  return($res);
}

/* ******************************************************
  SalvaMensagem - Salva a mensagem.

  Entradas: $sock - sock de conexao,
            $cod_msg - cdigo da mensagem,
            $cod_msg_pai - cdigo da mensagem que est
              sendo respondida (se houver),
            $cod_forum - cdigo do frum,
            $cod_usuario - cdigo do usurio,
            $titulo - titulo da mensagem,
            $mensagem - texto da mensagem.

  Saida:    true se bem-sucedido, do contrrio, false

*/
function SalvaMensagem($sock, $cod_msg_pai, $cod_forum, $cod_usuario, $titulo, $mensagem)
{
  /* Verifica se o frum  ativo.                 */
  $query = "select status from Forum where cod_forum = ".$cod_forum;

  $res = Enviar($sock, $query);
  $tupla = RetornaLinha($res);

  if ($tupla['status'] != 'A') return(false);

  $titulo = EliminaScript($titulo);
  $titulo = LimpaTitulo($titulo);
  $titulo = EliminaEspacos($titulo);

  $mensagem = EliminaScript($mensagem);
  $mensagem = LimpaConteudo($mensagem);

  $status = 'A';

  if ($cod_msg_pai == "") $cod_msg_pai = "NULL";

  $query = "insert into Forum_mensagens (cod_msg_pai, cod_forum, cod_usuario, ";
  $query .= "titulo, mensagem, status, data) values (".$cod_msg_pai.", ".$cod_forum;
  $query .= ", ".$cod_usuario.", '".$titulo."', '".$mensagem."', '".$status."', ".time().")";
  $res = Enviar($sock, $query);

  return($res);
}

?>