<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : cursos/aplic/material/material.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : cursos/aplic/material/material.inc
  ========================================================== */

/* *********************************************************************
   RetornaDiretorio - Retorna o Diretrio da tabela de diretorios
   Entrada: $sock - BASE EXTERNA
            $item - nome do item a ser buscado
   Saida: string com o diretrio
*/
function RetornaDiretorio($sock,$item)
{
  $query="select diretorio from Diretorio where item='".$item."'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return ($linha[0]);
}

/* *********************************************************************
   UltimaPosicaoLivreItem - Retorna a posicao do ultimo item livre
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - codigo do topico atual
   Saida: posicao
*/
function UltimaPosicaoLivreItem($sock, $tabela, $cod_topico)
{
  $consulta="select posicao_item from ".$tabela."_itens where cod_topico=$cod_topico order by posicao_item desc limit 1";
  $res=Enviar($sock, $consulta);
  $num=RetornaNumLinhas($res);
  if ($num>0)
  {
    $linha=RetornaLinha($res);
    $linha['posicao_item']++;
    return($linha['posicao_item']);
  }
  else
    return(1);
}

/* *********************************************************************
   UltimaPosicaoLivreTopico - Retorna a posicao do ultimo topico livre
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - codigo do topico atual
   Saida: posicao
*/
function UltimaPosicaoLivreTopico($sock, $tabela, $cod_topico)
{
  $consulta="select posicao_topico from ".$tabela."_topicos where cod_topico_pai=$cod_topico order by posicao_topico desc limit 1";
  $res=Enviar($sock, $consulta);
  $num=RetornaNumLinhas($res);
  if ($num>0)
  {
    $linha=RetornaLinha($res);
    $linha['posicao_topico']++;
    return($linha['posicao_topico']);
  }
  else
    return(1);
}

/* *********************************************************************
   OrganizaPosicaoTopico - Organizao a numeracao da posicao dos itens
                           na pgina, em ordem crescente
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - codigo do topico atual
   Saida: nenhuma
*/
function OrganizaPosicaoTopico($sock, $tabela, $cod_topico)
{
  $consulta="select cod_item, posicao_item from ".$tabela."_itens where cod_topico=$cod_topico and status<>'A' and status<>'X' and status<>'C' order by posicao_item";
  $res=Enviar($sock, $consulta);
  $lista_itens=RetornaArrayLinhas($res);
  if (count($lista_itens)>0)
  {
    $cont=1;
    foreach ($lista_itens as $cod => $linha)
    {
      if ($linha['posicao_item']!=$cont)
      {
        $consulta="update ".$tabela."_itens set posicao_item=".$cont." where cod_item=".$linha['cod_item'];
        $res=Enviar($sock, $consulta);
      }
      $cont++;
    }
  }
  $consulta="select cod_topico, posicao_topico from ".$tabela."_topicos where cod_topico_pai=$cod_topico order by posicao_topico";
  $res=Enviar($sock, $consulta);
  $lista_topicos=RetornaArrayLinhas($res);
  if (count($lista_topicos)>0)
  {
    $cont=1;
    foreach ($lista_topicos as $cod => $linha)
    {
      if ($linha['posicao_topico']!=$cont)
      {
        $consulta="update ".$tabela."_topicos set posicao_topico=".$cont." where cod_topico=".$linha['cod_topico'];
        $res=Enviar($sock, $consulta);
      }
      $cont++;
    }
  }

}

/* *********************************************************************
   ApagarItem - Apaga o item selecionado (envia para a lixeira)
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - codigo do item
            $cod_usuario - codigo do usuario que est removendo, para o histrico
   Saida: nenhuma
*/
function ApagarItem ($sock, $tabela, $cod_item, $cod_usuario)
{
  $linha=RetornaDadosDoItem($sock, $tabela, $cod_item);
  $consulta="update ".$tabela."_itens set cod_topico=2, data=".time()." where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $consulta="insert into ".$tabela."_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'A')";
  $res=Enviar($sock, $consulta);
  OrganizaPosicaoTopico($sock, $tabela, $linha['cod_topico']);
  AtualizaCompartilhamentoPastas ($sock, $tabela, $linha['cod_topico'], 'F');
}

/* *********************************************************************
   ExcluirItem - Apaga o item selecionado (definitivamente)
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - codigo do item
            $cod_usuario - codigo do usuario que est removendo, para o histrico
   Saida: nenhuma
*/
function ExcluirItem ($sock, $tabela, $cod_item, $cod_usuario)
{
  $linha=RetornaDadosDoItem($sock, $tabela, $cod_item);
  $consulta="update ".$tabela."_itens set cod_topico=0, data=".time()." where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $consulta="insert into ".$tabela."_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'X')";
  $res=Enviar($sock, $consulta);
  OrganizaPosicaoTopico($sock, $tabela, $linha['cod_topico']);
}


/* *********************************************************************
   ApagarTopico - Apaga o topico selecionado (envia para a lixeira todos os itens das subpastas)
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - codigo do topico
            $cod_usuario - codigo do usuario que est removendo, para o histrico
   Saida: nenhuma
*/
function ApagarTopico ($sock, $tabela, $cod_topico, $cod_usuario)
{
  /* Recursivamente, apaga os tpicos filhos */
  $query="select cod_topico from ".$tabela."_topicos where cod_topico_pai=".$cod_topico;
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  if (count($lista)>0)
    foreach($lista as $cod=>$linha)
      ApagarTopico($sock,$tabela,$linha['cod_topico'],$cod_usuario);

  /* Apaga os itens do topico */
  $query="select cod_item from ".$tabela."_itens where cod_topico=".$cod_topico;
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  if (count($lista)>0)
    foreach ($lista as $cod=>$linha)
    {
      $query="update ".$tabela."_itens set cod_topico=2,data=".time()." where cod_item=".$linha['cod_item'];
      Enviar($sock,$query);
      $query="insert into ".$tabela."_itens_historicos values (".$linha['cod_item'].", ".$cod_usuario.", ".time().", 'A')";
      Enviar($sock,$query);
    }

  /* Apagando o tpico e rearranjando ordem */
  $query="select cod_topico_pai from ".$tabela."_topicos where cod_topico=".$cod_topico;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $query="delete from ".$tabela."_topicos where cod_topico=".$cod_topico;
  Enviar($sock,$query);
  OrganizaPosicaoTopico($sock, $tabela, $linha['cod_topico_pai']);
}



/* *********************************************************************
   RecuperarItem - Recupera o item selecionado (da lixeira)
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - codigo do item
            $cod_usuario - codigo do usuario que est removendo, para o histrico
   Saida: nenhuma
*/
function RecuperarItem ($sock, $tabela, $cod_item, $cod_usuario)
{
  $linha=RetornaDadosDoItem($sock, $tabela, $cod_item);
  $consulta="update ".$tabela."_itens set cod_topico=1, data=".time().", posicao_item=".UltimaPosicaoLivreItem($sock, $tabela, 1).",tipo_compartilhamento='F' where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $consulta="insert into ".$tabela."_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'R')";
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   AtualizaCompartilhamentoPastas - Atualiza o compartilhamento das pastas (recursivamente)
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - codigo do topico
            $comp - Compartilhamento a ser setado (F ou T);
   Saida: nenhuma
*/
function AtualizaCompartilhamentoPastas ($sock, $tabela, $cod_topico, $comp)
{
  if ($comp=="F")
  {
    $consulta="select cod_item from ".$tabela."_itens where cod_topico=$cod_topico and tipo_compartilhamento='T' limit 1";
    $res=Enviar($sock, $consulta);
    $num1=RetornaNumLinhas($res);

    $consulta="select cod_topico from ".$tabela."_topicos where cod_topico_pai=$cod_topico and tipo_compartilhamento='T' limit 1";
    $res=Enviar($sock, $consulta);
    $num2=RetornaNumLinhas($res);

    if ($num1==0 && $num2==0)
    {
      $consulta="select cod_topico_pai from ".$tabela."_topicos where cod_topico=$cod_topico";
      $res=Enviar($sock, $consulta);
      $linha=RetornaLinha($res);

      if ($linha['cod_topico_pai']!="")
      {
        $consulta="update ".$tabela."_topicos set tipo_compartilhamento='F' where cod_topico=$cod_topico";
        $res=Enviar($sock, $consulta);

        AtualizaCompartilhamentoPastas($sock, $tabela, $linha['cod_topico_pai'], $comp);
      }
    }
  }
  else
  {
    $consulta="select cod_topico_pai from ".$tabela."_topicos where cod_topico=$cod_topico";
    $res=Enviar($sock, $consulta);
    $linha=RetornaLinha($res);

    if ($linha['cod_topico_pai']!="")
    {
      $consulta="update ".$tabela."_topicos set tipo_compartilhamento='T' where cod_topico=$cod_topico";
      $res=Enviar($sock, $consulta);

      AtualizaCompartilhamentoPastas($sock, $tabela, $linha['cod_topico_pai'], $comp);
    }
  }

}

/* *********************************************************************
   EPai - Retorna verdadeiro se $cod_topico for descendente de $cod_topico
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico_pai - codigo do topico pai
            $cod_topico - codigo do topico
   Saida: true, se For pai, false caso contrrio
*/
function EPai($sock, $tabela, $cod_topico_pai, $cod_topico)
{
  if ($cod_topico_pai==$cod_topico)
    return(true);
  else
  {
    if ($cod_topico=="")
      return(false);
    else
    {
      $consulta="select cod_topico_pai from ".$tabela."_topicos where cod_topico=$cod_topico";
      $res=Enviar($sock, $consulta);
      $linha=RetornaLinha($res);
      return(EPai($sock, $tabela, $cod_topico_pai, $linha['cod_topico_pai']));
    }
  }
}

/* *********************************************************************
   MoverItem - Move o item para outra pasta
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - item a ser movido
            $cod_usuario - usurio realizando ao
            $cod_topico - topico destino
   Saida: nenhuma
*/
function MoverItem ($sock, $tabela, $cod_item, $cod_usuario, $cod_topico)
{
  $data=time();
  $consulta="select cod_topico, tipo_compartilhamento from ".$tabela."_itens where cod_item=$cod_item";
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  $posicao_item=UltimaPosicaoLivreItem($sock, $tabela, $cod_topico);
  /* Movendo item */
  $consulta="update ".$tabela."_itens set cod_topico=$cod_topico, posicao_item=$posicao_item where cod_item=$cod_item";
  $res=Enviar($sock, $consulta);
  /* Inserindo dados no histrico */
  $consulta="insert into ".$tabela."_itens_historicos (cod_item, cod_usuario, data, acao) values ($cod_item, $cod_usuario, $data, 'M')";
  $res=Enviar($sock, $consulta);
  AtualizaCompartilhamentoPastas($sock, $tabela, $linha['cod_topico'], "F");
  AtualizaCompartilhamentoPastas($sock, $tabela, $cod_topico, $linha['tipo_compartilhamento']);
}

/* *********************************************************************
   MoverTopico - Move o topico para outra pasta
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - topico a ser movido
            $cod_usuario - usurio realizando ao
            $cod_topico_dest - topico destino
   Saida: true se nova posio for vlida
*/
function MoverTopico ($sock, $tabela, $cod_topico, $cod_usuario, $cod_topico_dest)
{
  if (EPai($sock, $tabela, $cod_topico, $cod_topico_dest))
  {
    /* Erro! */
    return false;
  }
  else
  {
    $consulta="select cod_topico_pai, tipo_compartilhamento from ".$tabela."_topicos where cod_topico=$cod_topico";
    $res=Enviar($sock, $consulta);
    $linha=RetornaLinha($res);
    $posicao_topico=UltimaPosicaoLivreTopico($sock, $tabela, $cod_topico_dest);
    /* Movendo topico */
    $consulta="update ".$tabela."_topicos set cod_topico_pai=$cod_topico_dest, posicao_topico=$posicao_topico where cod_topico=$cod_topico";
    $res=Enviar($sock, $consulta);

    AtualizaCompartilhamentoPastas($sock, $tabela, $linha['cod_topico_pai'], "F");
    AtualizaCompartilhamentoPastas($sock, $tabela, $cod_topico_dest, $linha['tipo_compartilhamento']);
    return true;
  }
}

/* *********************************************************************
   RetornaListaDeTopicos - retorna array com lista de topicos
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
   Saida: array []['cod_topico']
                []['cod_topico_pai']
                []['cod_usuario']
                []['topico']
                []['tipo_compartilhamento']
                []['data']
                []['posicao_topico']
                []['nivel'] - Nivel de recurso at atingir o tpico
                []['espacos'] - espacos que sero usados para exibio (&nbsp;)
*/
function RetornaListaDeTopicos ($sock, $tabela)
{
  $consulta="select * from ".$tabela."_topicos where cod_topico=1";
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  $retorno[0]=$linha;
  $retorno[0]['nivel']=0;
  $retorno[0]['espacos']="";
  $topicos=RetornaListaDeTopicosRecursao($sock, $tabela, $linha);
  $i=1;
  if (count($topicos)>0)
  {
    foreach ($topicos as $cod => $topico)
    {
      $retorno[$i]=$topico;
      $retorno[$i]['nivel']++;
      $retorno[$i]['espacos']=$retorno[$i]['espacos']."&nbsp;&nbsp;";
      $i++;
    }
  }
  return($retorno);
}

/* *********************************************************************
   RetornaListaDeTopicosRecursao - retorna array com lista de topicos a partir de um topico dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $topico - array com 1 elemento []['cod_topico'], contendo o cdigo do tpico
   Saida: array []['cod_topico']
                []['cod_topico_pai']
                []['cod_usuario']
                []['topico']
                []['tipo_compartilhamento']
                []['data']
                []['posicao_topico']
                []['nivel'] - Nivel de recurso at atingir o tpico
                []['espacos'] - espacos que sero usados para exibio (&nbsp;)
*/
function RetornaListaDeTopicosRecursao ($sock, $tabela, $topico)
{
  $consulta="select * from ".$tabela."_topicos where cod_topico_pai=".$topico['cod_topico']." order by posicao_topico";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  $i=0;
  unset($lista_retorno);
  if (count($lista)>0)
    foreach ($lista as $cod1 => $linha1)
    {
      $lista_retorno[$i]=$linha1;
      $lista_retorno[$i]['nivel']=0;
      $lista_retorno[$i]['espacos']="";

      $i++;
      $lista_filho=RetornaListaDeTopicosRecursao($sock, $tabela, $linha1);
      if (count($lista_filho)>0)
        foreach ($lista_filho as $cod2 => $linha2)
        {
          $lista_retorno[$i]=$linha2;
          $lista_retorno[$i]['nivel']++;
          $lista_retorno[$i]['espacos']=$lista_retorno[$i]['espacos']."&nbsp;&nbsp;";

          $i++;
        }
    }
  return($lista_retorno);
}

/* *********************************************************************
   RenomearTopico - Renomeia o tpico
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - topico a ser renomear
            $novo_nome - novo nome a ser usado
   Saida: nenhuma
*/
function RenomearTopico ($sock, $tabela, $cod_topico, $novo_nome)
{
  $consulta="update ".$tabela."_topicos set topico='".$novo_nome."' where cod_topico=".$cod_topico;
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   MudarCompartilhamento - Muda o compartilhamento do item dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - item a ser alterado compartilhamento
            $tipo_comp - Tipo do Compartilhamento (F ou T)
   Saida: nenhuma
*/
function MudarCompartilhamento ($sock, $tabela, $cod_item, $tipo_comp)
{
  $query="select tipo_compartilhamento from ".$tabela."_itens where cod_item=".$cod_item;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  if ($linha['tipo_compartilhamento']!=$tipo_comp)
  {
    $consulta="update ".$tabela."_itens set tipo_compartilhamento='".$tipo_comp."', data=".time()." where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);
    $consulta="select cod_topico from ".$tabela."_itens where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);
    $linha=RetornaLinha($res);
    AtualizaCompartilhamentoPastas($sock, $tabela, $linha['cod_topico'], $tipo_comp);
  }
}

/* *********************************************************************
   RetornaItensDoTopico - Retorna array com os itens do tpico dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - tpico
   Saida: array com []['cod_item']
                    []['cod_topico']
                    []['cod_usuario']
                    []['titulo']
                    []['texto']
                    []['tipo_compartilhamento']
                    []['data']
                    []['data_ativo']
                    []['data_inativo']
                    []['posicao_item']
                    []['status']
                    []['inicio_edicao']
*/
function RetornaItensDoTopico ($sock, $tabela, $cod_topico)
{
  $consulta="select * from ".$tabela."_itens where cod_topico=".$cod_topico." order by posicao_item";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* *********************************************************************
   RetornaTopicosDoTopico - Retorna array com os topicos filhos do tpico dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - tpico
   Saida: array com []['cod_topico']
                    []['cod_topico_pai']
                    []['cod_usuario']
                    []['topico']
                    []['tipo_compartilhamento']
                    []['data']
                    []['posicao_topico']
*/
function RetornaTopicosDoTopico ($sock, $tabela, $cod_topico)
{
  $consulta="select * from ".$tabela."_topicos where cod_topico_pai=".$cod_topico." order by posicao_topico";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* *********************************************************************
   ArrumaPosicoesItens - rearranja as posicoes dos itens em um topico qdo um item  movido
   entrada: $sock - sock de conexao
            $tabela - tabela da ferramenta na qual arrumar as posicoes (Atividades, Material, Leituras, Parada)
            $cod_topico - codigo do topico no qual arrumar as posicoes dos itens
   saida: nenhuma
*/
function ArrumaPosicoesItens($sock, $tabela, $cod_topico)
{
  // descobrindo quem eh o primeiro item no topico
  $query = "select cod_item from ".$tabela."_itens where cod_topico=".$cod_topico." order by posicao_item limit 1";
  $res = Enviar($sock, $query);
  $primeiro_item = RetornaLinha($res);

  // movemos o primeiro item para a primeira posicao. A funcao MudarPosicaoItem arruma as posicoes
  MudarPosicaoItem($sock, $tabela, $cod_topico, $primeiro_item['cod_item'], 1);
}

/* *********************************************************************
   MudarPosicaoItem - Muda a posio do item (utiliza semaforo)
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico_raiz - tpico a partir do qual sero rearranjados os itens
            $cod_item - Codigo do item a ter a posio mudada
            $posicao - valor da nova posio do item
   Saida: nenhuma
*/
function MudarPosicaoItem ($sock, $tabela, $cod_topico_raiz, $cod_item, $posicao)
{
  $consulta="select cod_item from ".$tabela."_itens where cod_topico=".$cod_topico_raiz." order by posicao_item";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  $cont=1;
  PegaSemaforo($sock, $tabela);
  if ($posicao==0)
    $posicao=1;
  if (count($lista)>0)
  {
    foreach ($lista as $cod => $linha)
    {
      if ($cod_item==$linha['cod_item'])
      {
        if ($posicao==$cont)
        {
          $consulta="update ".$tabela."_itens set posicao_item=".$cont." where cod_item=".$cod_item;
          $res=Enviar($sock, $consulta);
          $cont++;
          $posicao=-1;
        }
      }
      else
      {
        if ($posicao==$cont)
        {
          $consulta="update ".$tabela."_itens set posicao_item=".$cont." where cod_item=".$cod_item;
          $res=Enviar($sock, $consulta);
          $cont++;
          $posicao=-1;
        }
        $consulta="update ".$tabela."_itens set posicao_item=".$cont." where cod_item=".$linha['cod_item'];
        $res=Enviar($sock, $consulta);
        $cont++;
      }
    }
    if ($posicao>0)
    {
      $consulta="update ".$tabela."_itens set posicao_item=".$cont." where cod_item=".$cod_item;
      $res=Enviar($sock, $consulta);
      $cont++;
    }
  }
  LiberaSemaforo($sock, $tabela);
}

/* *********************************************************************
   ArrumaPosicoesTopicos - rearranja as posicoes dos topicos qdo um topico eh movido
   entrada: $sock - sock de conexao
            $tabela - tabela da ferramenta a mexer (Ativ, Material, Parada Obrig, Leituras)
            $cod_topico - codigo do topico no qual promover o rearranjo
   saida: nenhuma
*/
function ArrumaPosicoesTopicos($sock, $tabela, $cod_topico)
{
  // descobrindo quem eh o primeiro topico dentro do topico
  $query = "select cod_topico from ".$tabela."_topicos where cod_topico_pai=".$cod_topico." order by posicao_topico limit 1";
  $res = Enviar ($sock, $query);
  $primeiro_topico = RetornaLinha($res);

  // movemos o primeiro topico para a primeira posicao
  MudarPosicaoTopico ($sock, $tabela, $cod_topico, $primeiro_topico['cod_topico'], 1);
}

/* *********************************************************************
   MudarPosicaoTopico - Muda a posio do tpico (utiliza semaforo)
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico_raiz - tpico a partir do qual sero rearranjados os itens
            $cod_topico - Codigo do topico a ter a posio mudada
            $posicao - valor da nova posio do item
   Saida: nenhuma
*/
function MudarPosicaoTopico ($sock, $tabela, $cod_topico_raiz, $cod_topico, $posicao)
{
  $consulta="select * from ".$tabela."_topicos where cod_topico_pai=".$cod_topico_raiz." order by posicao_topico";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  $cont=1;
  PegaSemaforo($sock, $tabela);
  if ($posicao==0)
    $posicao=1;
  if (count($lista)>0)
  {
    foreach ($lista as $cod => $linha)
    {
      if ($cod_topico==$linha['cod_topico'])
      {
        if ($posicao==$cont)
        {
          $consulta="update ".$tabela."_topicos set posicao_topico=".$cont." where cod_topico=".$cod_topico;
          $res=Enviar($sock, $consulta);
          $cont++;
          $posicao=-1;
        }
      }
      else
      {
        if ($posicao==$cont)
        {
          $consulta="update ".$tabela."_topicos set posicao_topico=".$cont." where cod_topico=".$cod_topico;
          $res=Enviar($sock, $consulta);
          $cont++;
          $posicao=-1;
        }
        $consulta="update ".$tabela."_topicos set posicao_topico=".$cont." where cod_topico=".$linha['cod_topico'];
        $res=Enviar($sock, $consulta);
        $cont++;
      }
    }
    if ($posicao>0)
    {
      $consulta="update ".$tabela."_topicos set posicao_topico=".$cont." where cod_topico=".$cod_topico;
      $res=Enviar($sock, $consulta);
      $cont++;
      $posicao=-1;
    }
  }
  LiberaSemaforo($sock, $tabela);
}

/* *********************************************************************
   RetornaTopicosAncestrais - Retorna array com os tpicos ancestrais do tpico dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - Codigo do topico
   Saida: array [] - topicos (em ordem crescente de ancestralidade)
*/
function RetornaTopicosAncestrais ($sock, $tabela, $cod_topico)
{
  $cont=0;
  do
  {
    $consulta="select * from ".$tabela."_topicos where cod_topico=".$cod_topico;
    $res=Enviar($sock, $consulta);
    $linha=RetornaLinha($res);
    $cod_topico=$linha['cod_topico_pai'];
    $retorno[$cont]=$linha;
    $cont++;
  }
  while ($cod_topico!="");
  return($retorno);
}

/* *********************************************************************
   RetornaUltimaPosicaoHistorico - Retorna a ultima ocorrncia do historico de um item dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - item
   Saida: array ['cod_item']
                ['cod_usuario']
                ['data']
                ['acao']
*/
function RetornaUltimaPosicaoHistorico ($sock, $tabela, $cod_item)
{
  $consulta="select * from ".$tabela."_itens_historicos where cod_item=".$cod_item." order by data desc limit 1";
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  return($linha);
}

/* *********************************************************************
   CriarTopico - Cria um novo topico filho do topico dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico_raiz - topico pai
            $novo_nome - nome do novo topico
            $cod_usuario - codigo do usuario atual
   Saida: codigo do topico criado
*/
function CriarTopico ($sock, $tabela, $cod_topico_raiz, $novo_nome, $cod_usuario)
{
  $posicao=UltimaPosicaoLivreTopico($sock, $tabela, $cod_topico_raiz);
  $consulta="insert into ".$tabela."_topicos (cod_topico_pai, cod_usuario, topico, tipo_compartilhamento, data, posicao_topico) values (".$cod_topico_raiz.", ".$cod_usuario.", '".$novo_nome."', 'F', ".time().", ".$posicao.")";
  $res=Enviar($sock, $consulta);
  return($cod_topico);
}

/* *********************************************************************
   IniciaCriacao - Inicia a criao de um novo item
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - topico pai
            $cod_usuario - usuario atual
            $cod_curso - codigo do curso
            $dirname - Nome do diretrio onde os arquivos so arquivados
            $diretorio_temp - nome do diretrio temporario, usado durante a edio
   Saida: codigo do item criado
*/
function IniciaCriacao ($sock, $tabela, $cod_topico, $cod_usuario, $cod_curso, $dirname, $diretorio_temp)
{
  $cod_item=RetornaProximoCodigo($sock, $tabela."_itens");
  $posicao=UltimaPosicaoLivreItem($sock, $tabela, $cod_topico);
  $consulta="insert into ".$tabela."_itens (cod_item, cod_topico, cod_usuario, titulo, data, posicao_item, status, inicio_edicao) values (".$cod_item.", ".$cod_topico.", ".$cod_usuario.", ' ', ".time().", ".$posicao.", 'C', ".time().")";
  $res=Enviar($sock, $consulta);
  $consulta="insert into ".$tabela."_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'C')";
  $res=Enviar($sock, $consulta);

  if (!file_exists($diretorio_temp."/tmp/".$cod_curso."/"))
    CriaDiretorio($diretorio_temp."/tmp/".$cod_curso."/");
  if (!file_exists($diretorio_temp."/tmp/".$cod_curso."/".$dirname."/"))
    CriaDiretorio($diretorio_temp."/tmp/".$cod_curso."/".$dirname."/");

  $dir=$diretorio_temp."/tmp/".$cod_curso."/".$dirname."/".$cod_item."/";
  CriaDiretorio($dir);

  return($cod_item);
}

/* *********************************************************************
   RetornaDadosDoItem - Retorna um array com os dados do item
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_topico - tpico
   Saida: array com ['cod_item']
                    ['cod_topico']
                    ['cod_usuario']
                    ['titulo']
                    ['texto']
                    ['tipo_compartilhamento']
                    ['data']
                    ['data_ativo']
                    ['data_inativo']
                    ['posicao_item']
                    ['status']
                    ['inicio_edicao']
*/
function RetornaDadosDoItem ($sock, $tabela, $cod_item)
{
  $consulta="select * from ".$tabela."_itens where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  return($linha);
}

/* *********************************************************************
   RetornaResHistoricoDoItem - Retorna todas as ocorrncias do historico de um item dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - item
   Saida: array []['cod_item']
                []['cod_usuario']
                []['data']
                []['acao']
*/
function RetornaResHistoricoDoItem ($sock, $tabela, $cod_item)
{
  $consulta="select * from ".$tabela."_itens_historicos where cod_item=".$cod_item." order by data desc";
  $res=Enviar($sock, $consulta);
  return($res);
}

/* *********************************************************************
   CopiaArquivoParaTemporario - Copia os arquivos para temporario
   Entrada: $sock - BASE DO CURSO
            $cod_curso - cdigo do curso
            $diretorio_arquivos - diretrio dos arquivos do TelEduc
            $diretorio_temp - diretrio dos arquivos do TelEduc
            $dirname - nome do diretrio da ferramenta
            $cod_item - cdigo do item
   Saida: false - se houve algum erro.
*/
function CopiaArquivoParaTemporario($sock,$cod_curso,$diretorio_arquivos,$diretorio_temp,$dirname,$cod_item)
{
  $dir=$diretorio_arquivos."/".$cod_curso."/".$dirname."/".$cod_item."/";
  $dirtemp=$diretorio_temp."/tmp/".$cod_curso."/".$dirname."/".$cod_item."/";
  $dirtemp2=$diretorio_temp."/tmp/".$cod_curso."/".$dirname."/";

  if (!file_exists($diretorio_temp."/tmp/".$cod_curso."/"))
    CriaDiretorio($diretorio_temp."/tmp/".$cod_curso."/");
  if (!file_exists($diretorio_temp."/tmp/".$cod_curso."/".$dirname."/"))
    CriaDiretorio($diretorio_temp."/tmp/".$cod_curso."/".$dirname."/");

  if (!file_exists($dir))
  {
    if (!CriaDiretorio($dir))
      return false;
  }

  if (file_exists($dirtemp))
  {
    RemoveDiretorio($dirtemp);
  }
  if (!CopiaDiretorio($dir,$dirtemp2))
  {
    return false;
  }
  return true;
}

/* *********************************************************************
   RetornaArquivosMaterialTemp - Retorna lista de arquivos do Material no diretrio temporrio
   Entrada: $diretorio_temp - diretrio temporario de arquivos
            $dir - nome do diretrio da ferramenta
            $cod_item - cdigo do item
   Saida: Array multidimensional com:
          $lista[<num>]['Caminho'] - caminho completo.
          $lista[<num>]['Diretorio'] - Diretorio do arquivo
          $lista[<num>]['Arquivo'] - Nome do arquivo
          $lista[<num>]['Status'] - Condio especial (true ou false);
          $lista[<num>]['Tamanho'] - tamanho do arquivo
          $lista[<num>]['Data'] - data da ltima modificao
*/
function RetornaArquivosMaterialTemp ($cod_curso, $diretorio_temp, $dir, $cod_item)
{
  $dirtemp=$diretorio_temp."/tmp/".$cod_curso."/".$dir."/".$cod_item."/";
  return (RetornaArrayDiretorio($dirtemp));
}

/* *********************************************************************
   RetornaArquivosMaterialVer - Retorna lista de arquivos do Material
   Entrada: $diretorio_temp - diretrio temporario de arquivos
            $dir - nome do diretrio da ferramenta
            $cod_item - cdigo do item
   Saida: Array multidimensional com:
          $lista[<num>]['Caminho'] - caminho completo.
          $lista[<num>]['Diretorio'] - Diretorio do arquivo
          $lista[<num>]['Arquivo'] - Nome do arquivo
          $lista[<num>]['Status'] - Condio especial (true ou false);
          $lista[<num>]['Tamanho'] - tamanho do arquivo
          $lista[<num>]['Data'] - data da ltima modificao
*/
function RetornaArquivosMaterialVer ($cod_curso, $dirlink)
{
  return (RetornaArrayDiretorio($dirlink));
}

/* *********************************************************************
   RetornaEnderecosMaterial - Retorna um array com os enderecos associados ao item
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - item
   Saida: array com []['cod_endereco']
                    []['cod_item']
                    []['nome']
                    []['endereco']
                    []['status']
*/
function RetornaEnderecosMaterial ($sock, $tabela, $cod_item)
{
  $consulta="select * from ".$tabela."_itens_enderecos where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* *********************************************************************
   ApagaEndereco - apaga o endereco dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_endereco - codigo do endereco a ser apagada
   Saida: nenhuma
*/
function ApagaEndereco ($sock, $tabela, $cod_endereco)
{
  $consulta="select * from ".$tabela."_itens_enderecos where cod_endereco=".$cod_endereco;
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  if ($linha['status']=="F") /* Existia antes da edio */
  {
    $consulta="update ".$tabela."_itens_enderecos set status='A' where cod_endereco=".$cod_endereco;
  }
  else
  {
    /* S deve ter um caso: status="I", foi inserido nesta sesso */
    $consulta="delete from ".$tabela."_itens_enderecos where cod_endereco=".$cod_endereco;
  }
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   ApagaTodosEnderecos - apaga todos os enderecos do item dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - codigo do item a ter endereos apagados
   Saida: nenhuma
*/
function ApagaTodosEnderecos ($sock, $tabela, $cod_item)
{
  $consulta="select * from ".$tabela."_itens_enderecos where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);

  while($linha=RetornaLinha($res))
  {
    if ($linha['status']=="F") /* Existia antes da edio */
    {
      $consulta="update ".$tabela."_itens_enderecos set status='A' where cod_endereco=".$linha['cod_endereco'];
    }
    else
    {
      /* S deve ter um caso: status="I", foi inserido nesta sesso */
      $consulta="delete from ".$tabela."_itens_enderecos where cod_endereco=".$linha['cod_endereco'];
    }
    Enviar($sock, $consulta);
  }
}



/* *********************************************************************
   InsereEndereco - Insere (ou atualiza, se j existir) um endereco ao item dado
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $nome - nome do endereco
            $endereco - Endereco do item
            $cod_item - item ao qual o endereco estar associado
   Saida: nenhuma
*/
function InsereEndereco ($sock, $tabela, $nome, $endereco, $cod_item)
{
  $consulta="select * from ".$tabela."_itens_enderecos where endereco='".LimpaTitulo($endereco)."' and nome='".LimpaTitulo($nome)."' and cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $num=RetornaNumLinhas($res);
  if ($num>0)
  {
    $linha=RetornaLinha($res);
    if ($linha['status']=="A")
    {
      $consulta="update ".$tabela."_itens_enderecos set status='F' where cod_endereco=".$linha['cod_endereco'];
      $res=Enviar($sock, $consulta);
    }
  }
  else
  {
    $consulta="insert into ".$tabela."_itens_enderecos (cod_item, nome, endereco, status) values (".$cod_item.", '".$nome."', '".$endereco."', 'I')";
    $res=Enviar($sock, $consulta);
  }
}

/* *********************************************************************
   AtualizaDataEdicao - Atualiza a data de edio do item
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - item
   Saida: nenhuma
*/
function AtualizaDataEdicao ($sock, $tabela, $cod_item)
{
  $consulta="update ".$tabela."_itens set inicio_edicao=".time()." where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   AtualizaMaterial - Atualiza o Ttulo, o Texto e os arquivos
   Entrada: $sock - BASE DO CURSO
            $tabela - nome da tabela da ferramenta
            $cod_curso - cdigo do curso
            $cod_item - cdigo do item
            $titulo - ttulo do material
            $texto - texto a ser colocado
            $compartilhamento - tipo de compartilhamento
            $diretorio_arquivos - diretrio dos arquivos do TelEduc
            $diretorio_temp - diretrio dos arquivos do TelEduc
            $dirname - nome do diretrio da ferramenta
            $cod_usuario - codigo do usuario
   Saida: false - se houve algum erro.
*/
function AtualizaMaterial($sock,$tabela,$cod_curso,$cod_item,$titulo,$texto,$compartilhamento,$diretorio_arquivos,$diretorio_temp,$dirname,$cod_usuario)
{
  /* Copiar arquivos, quando necessrio... */
  $dir=$diretorio_arquivos."/".$cod_curso."/".$dirname."/";
  $dirtemp=$diretorio_temp."/tmp/".$cod_curso."/".$dirname."/".$cod_item."/";

  $ret=SobrepoeDiretorio($dirtemp,$dir);

  /* Checa se existem arquivos no diretrio */
  $array_temp=RetornaArrayDiretorio($dir."/".$cod_item);
  if ($ret && count($array_temp)==0)
  {
    RemoveDiretorio($dir."/".$cod_item);
  }

  $consulta="update ".$tabela."_itens set titulo='".$titulo."', texto='".$texto."', status='L' where cod_item=".$cod_item;
  Enviar($sock,$consulta);

  MudarCompartilhamento ($sock, $tabela, $cod_item, $compartilhamento);

  $consulta="delete from ".$tabela."_itens_enderecos where cod_item=".$cod_item." and status='A'";
  Enviar($sock,$consulta);
  $consulta="update ".$tabela."_itens_enderecos set status='F' where cod_item=".$cod_item;
  Enviar($sock,$consulta);
  $consulta="insert into ".$tabela."_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'F')";
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   MudaStatusEdicao - Muda p Estado do item para Em Edio
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $cod_item - item
            $cod_usuario - usuario realizando a edicao
   Saida: nenhuma
*/
function MudaStatusEdicao ($sock, $tabela, $cod_item, $cod_usuario)
{
  $consulta="update ".$tabela."_itens set status='E', cod_usuario=".$cod_usuario.", inicio_edicao=".time()." where cod_item=".$cod_item;
  $res=Enviar($sock,$consulta);
  $consulta="insert into ".$tabela."_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'E')";
  $res=Enviar($sock,$consulta);
}

/* *********************************************************************
   CancelaEdicao - Cancela a edicao de um item (termina os diretrios tb).
   Entrada: $sock - BASE DO CURSO
            $tabela - tabela a ser usada (Atividade,Apoio,Leitura,Obrigatoria)
            $dir - diretorio da ferramenta (atividade,apoio,leitura,obrigatoria)
            $cod_item - codigo do item
            $cod_usuario - usuario cancelando a edicao
            $cod_curso - codigo do curso
            $diretorio_arquivos - diretorio dos arquivos definitivos
            $diretorio_temp - diretorio temporario da edicao
   Saida: true se a edio foi cancelada corretamente
*/
function CancelaEdicao ($sock, $tabela, $dir, $cod_item, $cod_usuario, $cod_curso, $diretorio_arquivos, $diretorio_temp)
{
  $dirtemp=$diretorio_temp."/tmp/".$cod_curso."/".$dir."/".$cod_item."/";
  if (file_exists($dirtemp))
  {
    if (!RemoveDiretorio($dirtemp))
      return false;
  }
  $linha=RetornaDadosDoItem($sock, $tabela, $cod_item);
  if ($linha['status']=="C")
  {

    $consulta="delete from ".$tabela."_itens_enderecos where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    $consulta="delete from ".$tabela."_itens_historicos where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    $consulta="delete from ".$tabela."_itens where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    return true;
  }
  if ($linha['status']=="E")
  {
    $consulta="delete from ".$tabela."_itens_enderecos where cod_item=".$cod_item." and status='I'";
    $res=Enviar($sock, $consulta);
    $consulta="update ".$tabela."_itens_enderecos set status='F' where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    $consulta="insert into ".$tabela."_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'D')";
    $res=Enviar($sock, $consulta);

    $consulta="update ".$tabela."_itens set status='L' where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    return true;
  }
}

/* *********************************************************************
   CriaLinkVisualizar - Cria link simblico para dinamica e retorna o link
   Entrada: $sock - BASE DO CURSO
            $dirname - nome do diretorio da ferramenta
            $cod_curso - codigo do curso
            $cod_usuario - codigo do usuario
            $cod_item - cdigo do item
            $diretorio_arquivos - diretorio dos arquivos do TelEduc
            $diretorio_temp - diretorio dos arquivos do TelEduc
   Saida: caminho relativo
*/
function CriaLinkVisualizar($sock,$dirname,$cod_curso,$cod_usuario,$cod_item,$diretorio_arquivos,$diretorio_temp)
{
  /* Busca Arquivo a ser mostrado */
  unset ($caminho);
  $dir=$diretorio_arquivos."/".$cod_curso."/".$dirname."/".$cod_item."/";
/*
  $lista=RetornaArrayDiretorio($dir);
  foreach($lista as $cod => $linha)
    if ($linha['Status'] && $linha['Arquivo']!="")
      $arquivo=$linha['Diretorio']."/".$linha['Arquivo'];
*/

  /* Cria link simblico (apaga antigo, se houver)*/
  if ($cod_usuario<0)
    $cod_usuario=0;
  $dirlink=$diretorio_temp."/".$dirname."_".$cod_curso."_".$cod_usuario;
  $dirlinkpath="../../diretorio/".$dirname."_".$cod_curso."_".$cod_usuario;

  RemoveArquivo($dirlink);

  CriaLinkSimbolico($dir,$dirlink);

  $retorno['diretorio']=$dirlink."/";
  $retorno['link']=$dirlinkpath."/";

  return ($retorno);
}

/* *********************************************************************
   EncerrarExibicaoArquivo - Remove o link simblico criado para
                             visualizao dos itens
   Entrada: $sock - BASE DO CURSO
            $dirname - nome do diretorio da ferramenta
            $cod_curso - codigo do curso
            $cod_usuario - codigo do usuario
            $cod_item - cdigo do item
            $diretorio_arquivos - diretorio dos arquivos do TelEduc
   Saida: True se link removido corretamente
   Obs.: Alguns parametros no so mais usados... Entretanto, alterar a
         funo teria impacto em diversas pginas
*/
function EncerrarExibicaoArquivo($sock,$dirname,$cod_curso,$cod_usuario,$cod_item,$diretorio_arquivos)
{
  /* Cria link simblico (apaga antigo, se houver)*/
  if ($cod_usuario<0)
    $cod_usuario=0;
  $dirlink="../../diretorio/".$dirname."_".$cod_curso."_".$cod_usuario;
  return (RemoveArquivo($dirlink));
}

/* *********************************************************************
   RetornaArquivosVisiveis - Retorna array com os arquivos visiveis ao usuario
   Entrada: $lista_arq - **** Perguntar ao Davi a logica ******
   Saida: array com lista de arquivos
*/
function RetornaArquivosVisiveis($lista_arq)
{

  $cont=0;
  $pilha_index=-1;
  unset($pilha);
  if (count($lista_arq)>0)
  {
    foreach($lista_arq as $cod => $linha)
    {
      if ($linha['Diretorio']!="")
      {
        if ($linha['Arquivo']=="")
        {
          if ($pilha_index>=0)
          {

            $dir_array_p=explode("/", $pilha[$pilha_index]['Diretorio']);
            $nivel_p=count($dir_array_p)-1;
            $dir_name_p=$dir_array_p[$nivel_p];
            unset($dir_array_p[$nivel_p]);
            $dir_path_p=implode("/", $dir_array_p);

            $dir_array=explode("/", $linha['Diretorio']);
            $nivel=count($dir_array)-1;
            $dir_name=$dir_array[$nivel];
            unset($dir_array[$nivel]);
            $dir_path=implode("/", $dir_array);

            while ($nivel_p>=$nivel)
            {
              unset($pilha[$pilha_index]);
              $pilha_index--;
              $nivel_p--;
            }
            $pilha_index++;
            $pilha[$pilha_index]=$linha;
            $pilha[$pilha_index]['Posicao']=$cod;

          }
          else
          {
            $pilha_index++;
            $pilha[$pilha_index]=$linha;
            $pilha[$pilha_index]['Posicao']=$cod;
          }
        }
        else
        {
          if ($linha['Status'] && $pilha_index>=0)
          {

            foreach ($pilha as $cod_pilha => $linha_pilha)
            {
              $lista_arq[$linha_pilha['Posicao']]['Status']=true;
            }

          }
        }
      }
    }
  }
  return($lista_arq);
}

/* *********************************************************************
   RetornaMaiorData - Retorna a maior data dentro de um tpico ou subtpico
   Entrada: $sock - Conexo com a base interna
            $tabela - Tabela usada
            $cod_topico - codigo do topico a ser checado
            $tipo_comp - tipo do compartilhamento (F ou T)
            $data - Data do tpico
   Saida: maior data
*/
function RetornaMaiorData($sock,$tabela,$cod_topico,$tipo_comp,$data)
{
  $query="select cod_topico,data from ".$tabela."_topicos where cod_topico_pai=".$cod_topico;
  if ($tipo_comp=="T")
    $query.=" and tipo_compartilhamento='T'";
  $res=Enviar($sock,$query);
  $lista_topicos=RetornaArrayLinhas($res);

  /* Verifica se existem subtpicos */
  if (count($lista_topicos)>0)
  {
    foreach($lista_topicos as $cod=>$linha)
    {
      $data_tmp=RetornaMaiorData($sock,$tabela,$linha['cod_topico'],$tipo_comp,$linha['data']);
      if ($data_tmp>$data)
        $data=$data_tmp;
    }
  }

  $query="select max(data) from ".$tabela."_itens where cod_topico=".$cod_topico;
  if ($tipo_comp=="T")
    $query.=" and tipo_compartilhamento='T'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  if ($linha[0]>$data)
    $data=$linha[0];

  return $data;
}
?>