<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : cursos/aplic/portfolio/portfolio.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : cursos/aplic/portfolio/portfolio.inc
  ========================================================== */

/*
indice
RetornaDiretorio
UltimaPosicaoLivreItem
UltimaPosicaoLivreTopico
OrganizaPosicaoTopico
ApagarItem
ExcluirItem
ApagarTopico
RetornaPastaRaizUsuario
RecuperarItem
AtualizaCompartilhamentoPastas
EPai
MoverItem
MoverTopico
PertenceAoGrupo
RetornaListaDeTopicos
RetornaListaDeTopicosRecursao
RenomearTopico
MudarCompartilhamento
RetornaItensDoTopico
RetornaNumComentariosItem
RetornaTopicosDoTopico
NomeGrupo
StatusGrupo
RetornaTopicosBase
RetornaNumItensPortfolio
RetornaNumItensPortfolio
MudarPosicaoItem
MudarPosicaoTopico
RetornaTopicosAncestrais
RetornaUltimaPosicaoHistorico
CriarTopico
IniciaCriacao
RetornaDadosDoItem
RetornaResHistoricoDoItem
CopiaArquivoParaTemporario
RetornaArquivosMaterialTemp
RetornaArquivosMaterialVer
RetornaEnderecosMaterial
ApagaEndereco
ApagaTodosEnderecos
InsereEndereco
AtualizaDataEdicao
AtualizaMaterial
MudaStatusEdicao
CancelaEdicao
CriaLinkVisualizar
EncerraExibicaoArquivos
RetornaArquivosVisiveis
RetornaMaiorData
VerificaPortfolioGrupos
MontaMenu
RetornaListaIntegrantes
RetornaItensDaLixeixa
InsereComentario
RetornaComentariosDoItem
RetornaComentario
ApagaComentario
RetornaNumComentariosTopico
RetornaMaiorDataItemComentario
RetornaNumItensTopicoRec
RetornaStatusPortfolio
*/

/* *********************************************************************
   RetornaDiretorio - Retorna o Diretrio da tabela de diretorios
   Entrada: $sock - BASE EXTERNA
            $item - nome do item a ser buscado
   Saida: string com o diretrio
*/
function RetornaDiretorio($sock,$item)
{
  $query="select diretorio from Diretorio where item='".$item."'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return ($linha[0]);
}

/* *********************************************************************
   UltimaPosicaoLivreItem - Retorna a posicao do ultimo item livre
   Entrada: $sock - BASE DO CURSO
            $cod_topico - codigo do topico atual
   Saida: posicao
*/
function UltimaPosicaoLivreItem($sock, $cod_topico)
{
  $consulta="select posicao_item from Portfolio_itens where cod_topico=".$cod_topico." order by posicao_item desc limit 1";
  $res=Enviar($sock, $consulta);
  $num=RetornaNumLinhas($res);
  if ($num>0)
  {
    $linha=RetornaLinha($res);
    $linha['posicao_item']++;
    return($linha['posicao_item']);
  }
  else
    return(1);
}

/* *********************************************************************
   UltimaPosicaoLivreTopico - Retorna a posicao do ultimo topico livre
   Entrada: $sock - BASE DO CURSO
            $cod_topico - codigo do topico atual
   Saida: posicao
*/
function UltimaPosicaoLivreTopico($sock, $cod_topico)
{
  $consulta="select posicao_topico from Portfolio_topicos where cod_topico_pai=".$cod_topico." order by posicao_topico desc limit 1";
  $res=Enviar($sock, $consulta);
  $num=RetornaNumLinhas($res);
  if ($num>0)
  {
    $linha=RetornaLinha($res);
    $linha['posicao_topico']++;
    return($linha['posicao_topico']);
  }
  else
    return(1);
}

/* *********************************************************************
   OrganizaPosicaoTopico - Organizao a numeracao da posicao dos itens 
                           na pgina, em ordem crescente
   Entrada: $sock - BASE DO CURSO
            $cod_topico - codigo do topico atual
   Saida: nenhuma
*/
function OrganizaPosicaoTopico($sock, $cod_topico)
{
  $consulta="select cod_item, posicao_item from Portfolio_itens where cod_topico=".$cod_topico." and status<>'A' and status<>'X' and status<>'C' order by posicao_item";
  $res=Enviar($sock, $consulta);
  $lista_itens=RetornaArrayLinhas($res);
  if (count($lista_itens)>0)
  {
    $cont=1;
    foreach ($lista_itens as $cod => $linha)
    {
      if ($linha['posicao_item']!=$cont)
      {
        $consulta="update Portfolio_itens set posicao_item=".$cont." where cod_item=".$linha['cod_item'];
        $res=Enviar($sock, $consulta);
      }
      $cont++;
    }
  }
  $consulta="select cod_topico, posicao_topico from Portfolio_topicos where cod_topico_pai=".$cod_topico." order by posicao_topico";
  $res=Enviar($sock, $consulta);
  $lista_topicos=RetornaArrayLinhas($res);
  if (count($lista_topicos)>0)
  {
    $cont=1;
    foreach ($lista_topicos as $cod => $linha)
    {
      if ($linha['posicao_topico']!=$cont)
      {
        $consulta="update Portfolio_topicos set posicao_topico=".$cont." where cod_topico=".$linha['cod_topico'];
        $res=Enviar($sock, $consulta);
      }
      $cont++;
    }
  }

}

/* *********************************************************************
   ApagarItem - Apaga o item selecionado (envia para a lixeira)
   Entrada: $sock - BASE DO CURSO
            $cod_item - codigo do item
            $cod_usuario - codigo do usuario que est removendo, para o histrico
   Saida: nenhuma
*/
function ApagarItem ($sock, $cod_item, $cod_usuario)
{
  $linha=RetornaDadosDoItem($sock, $cod_item);
  $consulta="update Portfolio_itens set cod_topico=2 where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $consulta="insert into Portfolio_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'A')";
  $res=Enviar($sock, $consulta);
  OrganizaPosicaoTopico($sock, $linha['cod_topico']);
  AtualizaCompartilhamentoPastas ($sock, $linha['cod_topico'], 'P'); 
}

/* *********************************************************************
   ExcluirItem - Apaga o item selecionado (definitivamente)
   Entrada: $sock - BASE DO CURSO
            $cod_item - codigo do item
            $cod_usuario - codigo do usuario que est removendo, para o histrico
   Saida: nenhuma
*/
function ExcluirItem ($sock, $cod_item, $cod_usuario)
{
  $linha=RetornaDadosDoItem($sock, $cod_item);
  $consulta="update Portfolio_itens set cod_topico=0 where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $consulta="insert into Portfolio_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'X')";
  $res=Enviar($sock, $consulta);
  OrganizaPosicaoTopico($sock, $linha['cod_topico']);
}


/* *********************************************************************
   ApagarTopico - Apaga o topico selecionado (envia para a lixeira todos os itens das subpastas)
   Entrada: $sock - BASE DO CURSO
            $cod_topico - codigo do topico
            $cod_usuario - codigo do usuario que est removendo, para o histrico
   Saida: nenhuma
*/
function ApagarTopico ($sock, $cod_topico, $cod_usuario)
{
  /* Recursivamente, apaga os tpicos filhos */
  $query="select cod_topico from Portfolio_topicos where cod_topico_pai=".$cod_topico;
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  if (count($lista)>0)
    foreach($lista as $cod=>$linha)
      ApagarTopico($sock,$linha['cod_topico'],$cod_usuario);

  /* Apaga os itens do topico */
  $query="select cod_item from Portfolio_itens where cod_topico=".$cod_topico;
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  if (count($lista)>0)
    foreach ($lista as $cod=>$linha)
    {
      $query="update Portfolio_itens set cod_topico=2 where cod_item=".$linha['cod_item'];
      Enviar($sock,$query);
      $query="insert into Portfolio_itens_historicos values (".$linha['cod_item'].", ".$cod_usuario.", ".time().", 'A')";
      Enviar($sock,$query);
    }

  /* Apagando o tpico e rearranjando ordem */
  $query="select cod_topico_pai from Portfolio_topicos where cod_topico=".$cod_topico;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $query="delete from Portfolio_topicos where cod_topico=".$cod_topico;
  Enviar($sock,$query);
  OrganizaPosicaoTopico($sock, $linha['cod_topico_pai']);
  AtualizaCompartilhamentoPastas ($sock, $linha['cod_topico_pai'], 'P'); 
}

/* *********************************************************************
   RetornaPastaRaizUsuario - Retorna o cdigo da pasta raiz do usurio ou grupo
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - codigo do usuario que est removendo, para o histrico
            $cod_grupo - codigo do grupo (NULL ou "" se portfolio individual)
   Saida: nenhuma
*/
function RetornaPastaRaizUsuario($sock,$cod_usuario,$cod_grupo)
{
  if ($cod_usuario==-2)
    return 'NULL';
  /* definindo regra de escolha de pasta */
  if ($cod_grupo=="NULL" || $cod_grupo=="")
  {
    $cod_topico_pai=3;
    $regra="(cod_usuario=".$cod_usuario." and cod_grupo IS NULL)";
    $cod_grupo="NULL";
    $rep="#U".$cod_usuario;
  }
  else
  {
    $cod_topico_pai=4;
    $regra="(cod_grupo=".$cod_grupo.")";
    $rep="#G".$cod_grupo;
  }

  $query="select cod_topico from Portfolio_topicos where ".$regra." and cod_topico_pai=".$cod_topico_pai;
  $res=Enviar($sock,$query);
  if (RetornaNumLinhas($res)>0)
  {
    $linha=RetornaLinha($res);
    return $linha['cod_topico'];
  }
  else
  {
    $query="insert into Portfolio_topicos (cod_topico_pai,cod_usuario,cod_grupo,tipo_compartilhamento,data,posicao_topico,topico) values (".$cod_topico_pai.",".$cod_usuario.",".$cod_grupo.",'P',".time().",".UltimaPosicaoLivreTopico($sock, $cod_topico_pai).",'".$rep."')";
    Enviar($sock,$query);
    return RetornaPastaRaizUsuario($sock,$cod_usuario,$cod_grupo);
  }
}


/* *********************************************************************
   RecuperarItem - Recupera o item selecionado (da lixeira)
   Entrada: $sock - BASE DO CURSO
            $cod_item - codigo do item
            $cod_usuario - codigo do usuario que est removendo, para o histrico
            $cod_grupo - codigo do grupo (NULL ou "" se portfolio individual)
   Saida: nenhuma
*/
function RecuperarItem ($sock, $cod_item, $cod_usuario,$cod_grupo)
{
  $cod_raiz=RetornaPastaRaizUsuario($sock,$cod_usuario,$cod_grupo);
  $linha=RetornaDadosDoItem($sock, $cod_item);
  $consulta="update Portfolio_itens set cod_topico=".$cod_raiz.", posicao_item=".UltimaPosicaoLivreItem($sock, $cod_raiz).",tipo_compartilhamento='P' where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $consulta="insert into Portfolio_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'R')";
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   AtualizaCompartilhamentoPastas - Atualiza o compartilhamento das pastas (recursivamente)
   Entrada: $sock - BASE DO CURSO
            $cod_topico - codigo do topico
            $comp - Compartilhamento a ser setado (F ou T);
   Saida: nenhuma
*/
function AtualizaCompartilhamentoPastas ($sock, $cod_topico, $comp)
{
  if ($cod_topico>4)
  {
    if ($comp=="P")
    {
      // Verificamos se a pasta nao tem nenhum item ou filho compartilhado
      // Entao atualizamos o compartilhamento da pasta e dos pais

      $query  = "select tipo_compartilhamento from Portfolio_itens where cod_topico=".$cod_topico." and (tipo_compartilhamento='T' or tipo_compartilhamento='F') order by tipo_compartilhamento desc limit 1";
      $res    = Enviar($sock, $query);
      $linha1 = RetornaLinha($res);

      $query  = "select tipo_compartilhamento from Portfolio_topicos where cod_topico_pai=".$cod_topico." and (tipo_compartilhamento='T' or tipo_compartilhamento='F') order by tipo_compartilhamento desc limit 1";
      $res    = Enviar($sock, $query);
      $linha2 = RetornaLinha($res);

      unset ($compartilhamento);

      if (is_array($linha1))
      {
        // Existe um item compartilhado. O compartilhamento da pasta eh o mesmo deste item.
        $compartilhamento = $linha1['tipo_compartilhamento'];
      }
      if (is_array($linha2))
      {
        // Existe um filho compartilhado. O comp da pasta eh o de maior prioridade entre o filho e o item acima.
        if (!isset($compartilhamento) || $compartilhamento != 'T')
          $compartilhamento = $linha2['tipo_compartilhamento'];
      }
      if (!isset($compartilhamento))
        // No existem itens nem pastas comp. A pasta eh no comp.
        $compartilhamento = 'P';
    }
    else if ($comp=="F")
    {
      // Significa que um item ou filho desta pasta eh comp. com forms.
      // Entao verificamos se esta pasta ou um filho dela nao eh compartilhado com todos
      $consulta="select cod_item from Portfolio_itens where cod_topico=".$cod_topico." and tipo_compartilhamento='T' limit 1";
      $res=Enviar($sock, $consulta);
      $num1=RetornaNumLinhas($res);
      $consulta="select cod_topico from Portfolio_topicos where cod_topico_pai=".$cod_topico." and tipo_compartilhamento='T' limit 1";
      $res=Enviar($sock, $consulta);
      $num2=RetornaNumLinhas($res);

      if ($num1==0 && $num2==0)
      {
        // Nenhum item ou filho eh compartilhado com todos, 
        // Compartilhamos a pasta e seu pai com forms.
        $compartilhamento = 'F';
      }
      else
      {
        // Algum item ou filha eh compartilhado com todos,
        // Compartilhamos a pasta e seu pai com todos
        $compartilhamento = 'T';
      }
    }
    else
    {
      // aqui, $comp == 'T'
      // O que significa que um filho ou um item desta pasta eh compartilhado com todos
      // Entao esta pasta e seu pai devem ser compartilhados com todos
      $compartilhamento = 'T';
    }

    // Compartilhando a pasta
    $consulta="update Portfolio_topicos set tipo_compartilhamento='".$compartilhamento."' where cod_topico=".$cod_topico;
    $res=Enviar($sock, $consulta);

    // Encontrando o pai para atualizar.
    $consulta="select cod_topico_pai from Portfolio_topicos where cod_topico=".$cod_topico;
    $res=Enviar($sock, $consulta);
    $linha=RetornaLinha($res);

    AtualizaCompartilhamentoPastas($sock,  $linha['cod_topico_pai'], $compartilhamento);
  }
}

/* *********************************************************************
   EPai - Retorna verdadeiro se $cod_topico for descendente de $cod_topico
   Entrada: $sock - BASE DO CURSO
            $cod_topico_pai - codigo do topico pai
            $cod_topico - codigo do topico
   Saida: true, se For pai, false caso contrrio
*/
function EPai($sock, $cod_topico_pai, $cod_topico)
{
  if ($cod_topico_pai==$cod_topico)
    return(true);
  else
  {
    if ($cod_topico=="")
      return(false);
    else
    {
      $consulta="select cod_topico_pai from Portfolio_topicos where cod_topico=$cod_topico";
      $res=Enviar($sock, $consulta);
      $linha=RetornaLinha($res);
      return(EPai($sock, $cod_topico_pai, $linha['cod_topico_pai']));
    }
  }
}

/* *********************************************************************
   MoverItem - Move o item para outra pasta
   Entrada: $sock - BASE DO CURSO
            $cod_item - item a ser movido
            $cod_usuario - usurio realizando ao
            $cod_topico - topico destino
   Saida: nenhuma
*/
function MoverItem ($sock, $cod_item, $cod_usuario, $cod_topico)
{
  $data=time();
  // topico fonte do item
  $consulta="select cod_topico, tipo_compartilhamento from Portfolio_itens where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);

  // em que posicao o item aparece no destino
  $posicao_item=UltimaPosicaoLivreItem($sock, $cod_topico);

  /* Movendo item */
  $consulta="update Portfolio_itens set cod_topico=".$cod_topico.", posicao_item=".$posicao_item." where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);

  /* Inserindo dados no histrico */
  $consulta="insert into Portfolio_itens_historicos (cod_item, cod_usuario, data, acao) values (".$cod_item.", ".$cod_usuario.", ".$data.", 'M')";
  $res=Enviar($sock, $consulta);

  // atualizando modo de compartilhamento das pastas fonte e destino
  AtualizaCompartilhamentoPastas($sock, $linha['cod_topico'], "P");
  AtualizaCompartilhamentoPastas($sock, $cod_topico, $linha['tipo_compartilhamento']);
}

/* *********************************************************************
   MoverTopico - Move o topico para outra pasta
   Entrada: $sock - BASE DO CURSO
            $cod_topico - topico a ser movido
            $cod_usuario - usurio realizando ao
            $cod_topico_dest - topico destino
   Saida: true se nova posio for vlida
*/
function MoverTopico ($sock, $cod_topico, $cod_usuario, $cod_topico_dest)
{
  if (EPai($sock, $cod_topico, $cod_topico_dest))
  {
    /* Erro! */
    return false;
  }
  else
  {
    $consulta="select cod_topico_pai, tipo_compartilhamento from Portfolio_topicos where cod_topico=".$cod_topico;
    $res=Enviar($sock, $consulta);
    $linha=RetornaLinha($res);
    $posicao_topico=UltimaPosicaoLivreTopico($sock, $cod_topico_dest);
    /* Movendo topico */
    $consulta="update Portfolio_topicos set cod_topico_pai=".$cod_topico_dest.", posicao_topico=".$posicao_topico." where cod_topico=".$cod_topico;
    $res=Enviar($sock, $consulta);
    AtualizaCompartilhamentoPastas($sock, $linha['cod_topico_pai'], "P");
    AtualizaCompartilhamentoPastas($sock, $cod_topico_dest, $linha['tipo_compartilhamento']);
    return true;
  }
}

/* *********************************************************************
   PertenceAoGrupo - Retorna trua se o usuario pertence ao grupo e o grupo est ativo
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - codigo do usuario
            $cod_grupo_portfolio - codigo do grupo
   Saida: True se pertence, false caso nao pertenca ou o grupo nao exista
*/
function PertenceAoGrupo($sock, $cod_usuario, $cod_grupo_portfolio)
{
  if ($cod_grupo_portfolio=="" || $cod_grupo_portfolio=="NULL")
    return false;
  $query="select GU.cod_usuario 'cod_usuario' from Grupos_usuario GU, Grupos G where GU.cod_grupo=".$cod_grupo_portfolio." and G.cod_grupo=".$cod_grupo_portfolio." and GU.cod_usuario=".$cod_usuario." and G.status <> 'X'";
  $res=Enviar($sock,$query);
  if (RetornaNumLinhas($res)>0)
    return true;
  else
    return false;
}

/* *********************************************************************
   RetornaListaDeTopicos - retorna array com lista de topicos
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - codigo do usuario logado
            $eformador - true se o usuario logado for formador
            $cod_usuario_portfolio - codigo do usuario dono do portfolio
            $cod_grupo_portfolio - codigo do grupo dono do portfolio (NULL ou "" se individual
   Saida: array []['cod_topico']
                []['cod_topico_pai']
                []['cod_usuario']
                []['cod_grupo']
                []['topico']
                []['tipo_compartilhamento']
                []['data']
                []['posicao_topico']
                []['nivel'] - Nivel de recurso at atingir o tpico
                []['espacos'] - espacos que sero usados para exibio (&nbsp;)
*/
function RetornaListaDeTopicos ($sock,$cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio)
{
  global $lista_frases_geral;

  /* Pegando a estrutura do usurio sendo visualizado */
  $cod_raiz=RetornaPastaRaizUsuario($sock,$cod_usuario_portfolio,$cod_grupo_portfolio);

  $consulta="select * from Portfolio_topicos where cod_topico=".$cod_raiz;
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  /* 37 - Pasta Raiz */
  $linha['topico']=RetornaFraseDaLista($lista_frases_geral,37);
  $retorno[0]=$linha;
  $retorno[0]['nivel']=0;
  $retorno[0]['espacos']="";
  $topicos=RetornaListaDeTopicosRecursao($sock, $linha,$cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio);
  $i=1;
  if (count($topicos)>0)
  {
    foreach ($topicos as $cod => $topico)
    {
      $retorno[$i]=$topico;
      $retorno[$i]['nivel']++;
      $retorno[$i]['espacos']=$retorno[$i]['espacos']."&nbsp;&nbsp;";
      $i++;
    }
  }
  return($retorno);
}

/* *********************************************************************
   RetornaListaDeTopicosRecursao - retorna array com lista de topicos a partir de um topico dado
   Entrada: $sock - BASE DO CURSO
            $topico - array com 1 elemento []['cod_topico'], contendo o cdigo do tpico
            $cod_usuario - codigo do usuario logado
            $eformador - true se o usuario logado for formador
            $cod_usuario_portfolio - codigo do usuario dono do portfolio
            $cod_grupo_portfolio - codigo do grupo dono do portfolio (NULL ou "" se individual
   Saida: array []['cod_topico']
                []['cod_topico_pai']
                []['cod_usuario']
                []['cod_grupo']
                []['topico']
                []['tipo_compartilhamento']
                []['data']
                []['posicao_topico']
                []['nivel'] - Nivel de recurso at atingir o tpico
                []['espacos'] - espacos que sero usados para exibio (&nbsp;)
*/
function RetornaListaDeTopicosRecursao ($sock, $topico,$cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio)
{
  if ($cod_usuario==$cod_usuario_portfolio)
    $regra="";
  else if ($cod_grupo_portfolio=="NULL" || $cod_grupo_portfolio=="")
  {
    if ($eformador)
      $regra="and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";
    else
      $regra="and tipo_compartilhamento='T'";
  }   
  else
  {
    if (PertenceAoGrupo($sock, $cod_usuario, $cod_grupo_portfolio))
      $regra="";
    else if ($eformador)
      $regra="and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";
    else
      $regra="and tipo_compartilhamento='T'";
  }

  $consulta="select * from Portfolio_topicos where cod_topico_pai=".$topico['cod_topico']." ".$regra." order by posicao_topico";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  $i=0;
  unset($lista_retorno);
  if (count($lista)>0)
    foreach ($lista as $cod1 => $linha1)
    {
      $lista_retorno[$i]=$linha1;
      $lista_retorno[$i]['nivel']=0;
      $lista_retorno[$i]['espacos']="";

      $i++;
      $lista_filho=RetornaListaDeTopicosRecursao($sock, $linha1,$cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio);
      if (count($lista_filho)>0)
        foreach ($lista_filho as $cod2 => $linha2)
        {
          $lista_retorno[$i]=$linha2;
          $lista_retorno[$i]['nivel']++;
          $lista_retorno[$i]['espacos']=$lista_retorno[$i]['espacos']."&nbsp;&nbsp;";

          $i++;
        }
    }
  return($lista_retorno);
}

/* *********************************************************************
   RenomearTopico - Renomeia o tpico
   Entrada: $sock - BASE DO CURSO
            $cod_topico - topico a ser renomear
            $novo_nome - novo nome a ser usado
   Saida: nenhuma
*/
function RenomearTopico ($sock, $cod_topico, $novo_nome)
{
  $consulta="update Portfolio_topicos set topico='".$novo_nome."' where cod_topico=".$cod_topico;
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   MudarCompartilhamento - Muda o compartilhamento do item dado
   Entrada: $sock - BASE DO CURSO
            $cod_item - item a ser alterado compartilhamento
            $tipo_comp - Tipo do Compartilhamento (F ou T)
   Saida: nenhuma
*/
function MudarCompartilhamento ($sock, $cod_item, $tipo_comp)
{
  $query="select tipo_compartilhamento from Portfolio_itens where cod_item=".$cod_item;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  if ($linha['tipo_compartilhamento']!=$tipo_comp)
  {
    $consulta="update Portfolio_itens set tipo_compartilhamento='".$tipo_comp."', data=".time()." where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);
    $consulta="select cod_topico from Portfolio_itens where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);
    $linha=RetornaLinha($res);
    AtualizaCompartilhamentoPastas($sock, $linha['cod_topico'], $tipo_comp);
  }
}

/* *********************************************************************
   RetornaItensDoTopico - Retorna array com os itens do tpico dado
   Entrada: $sock - BASE DO CURSO
            $cod_curso - codigo do curso
            $cod_topico - tpico
            $cod_usuario - codigo do usuario logado
            $eformador - true se o usuario logado for formador
            $cod_usuario_portfolio - codigo do usuario dono do portfolio
            $cod_grupo_portfolio - codigo do grupo dono do portfolio (NULL ou "" se individual
   Saida: array com []['cod_item']
                    []['cod_topico']
                    []['cod_usuario']
                    []['cod_grupo']
                    []['titulo']
                    []['texto']
                    []['tipo_compartilhamento']
                    []['data']
                    []['data_ativo']
                    []['data_inativo']
                    []['posicao_item']
                    []['status']
                    []['inicio_edicao']
                    []['num_comentarios']
                    []['num_comentarios_alunos'] - numero de comentrios feitos por alunos que no o usuario
                    []['num_comentarios_formadores'] - numero de comentrios feitos por formadores que no o usuario
                    []['num_comentarios_usuario'] - numero de comentrios feitos pelo usuario
                    []['data_comentarios'] - Maior data de um comentrio

*/
function RetornaItensDoTopico ($sock, $cod_curso, $cod_topico, $cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio)
{
  if ($cod_usuario==$cod_usuario_portfolio)
    $regra="";
  else if ($cod_grupo_portfolio=="NULL" || $cod_grupo_portfolio=="")
  {
    if ($eformador)
      $regra="and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";
    else
      $regra="and tipo_compartilhamento='T'";
  }   
  else
  {
    if (PertenceAoGrupo($sock,$cod_usuario, $cod_grupo_portfolio))
      $regra="";
    else if ($eformador)
      $regra="and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";
    else
      $regra="and tipo_compartilhamento='T'";
  }

  if (EFormadorComVisaoDeAluno($sock, $cod_curso, $cod_usuario))
    $regra="and tipo_compartilhamento='T'";

  $consulta="select * from Portfolio_itens where cod_topico=".$cod_topico." ".$regra." order by posicao_item";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  if (count($lista)>0)
    foreach($lista as $cod => $linha)
    {
      $tmp=RetornaNumComentariosItem ($sock, $cod_usuario, $linha['cod_item']);
      $lista[$cod]['num_comentarios']=$tmp['num_comentarios'];
      $lista[$cod]['num_comentarios_alunos']=$tmp['num_comentarios_alunos'];
      $lista[$cod]['num_comentarios_formadores']=$tmp['num_comentarios_formadores'];
      $lista[$cod]['num_comentarios_usuario']=$tmp['num_comentarios_usuario'];
      $lista[$cod]['data_comentarios']=$tmp['data_comentarios'];
    }

  return($lista);
}

/* *********************************************************************
   RetornaNumComentariosItem - retorna o nmero de comentrios de um item
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - cod. usurio logado
            $cod_item - item
   Saida: array com ['num_comentarios']
                    ['num_comentarios_alunos'] - numero de comentrios feitos por alunos que no o usuario
                    ['num_comentarios_formadores'] - numero de comentrios feitos por formadores que no o usuario
                    ['num_comentarios_usuario'] - numero de comentrios feitos pelo usuario
                    ['data_comentarios'] - Maior data de um comentrio
*/
function RetornaNumComentariosItem ($sock, $cod_usuario, $cod_item)
{
  $query="select Pic.cod_comentarista 'cod', U.tipo_usuario 'tu' ,count(*) 'ct', max(Pic.data) 'dt' from Usuario U, Portfolio_itens_comentarios Pic where Pic.cod_item=".$cod_item." and Pic.cod_comentarista=U.cod_usuario and Pic.status='A' group by Pic.cod_comentarista order by Pic.cod_comentarista";
  $res=Enviar($sock,$query);
  $num_f=0;
  $num_a=0;
  $num_u=0;
  $data=0;
  while ($linha=RetornaLinha($res))
  {
    if ($linha['cod']==$cod_usuario)
      $num_u+=$linha['ct'];
    else if ($linha['tu']=="F")
      $num_f+=$linha['ct'];
    else
      $num_a+=$linha['ct'];
    if ($data<$linha['dt'])
      $data=$linha['dt'];
  }
  $saida['num_comentarios']=$num_f+$num_a+$num_u;
  $saida['num_comentarios_formadores']=$num_f;
  $saida['num_comentarios_alunos']=$num_a;
  $saida['num_comentarios_usuario']=$num_u;
  $saida['data_comentarios']=$data;
  return $saida;
}

/* *********************************************************************
   RetornaTopicosDoTopico - Retorna array com os topicos filhos do tpico dado
   Entrada: $sock - BASE DO CURSO
            $cod_curso - codigo do curso
            $cod_topico - tpico
            $cod_usuario - codigo do usuario logado
            $eformador - true se o usuario logado for formador
            $cod_usuario_portfolio - codigo do usuario dono do portfolio
            $cod_grupo_portfolio - codigo do grupo dono do portfolio (NULL ou "" se individual
   Saida: array com []['cod_topico']
                    []['cod_topico_pai']
                    []['cod_usuario']
                    []['cod_grupo']
                    []['topico']
                    []['tipo_compartilhamento']
                    []['data']
                    []['posicao_topico']
*/
function RetornaTopicosDoTopico ($sock, $cod_curso, $cod_topico, $cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio)
{
  if ($cod_usuario==$cod_usuario_portfolio)
    $regra="";
  else if ($cod_grupo_portfolio=="NULL" || $cod_grupo_portfolio=="")
  {
    if ($eformador)
      $regra="and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";
    else
      $regra="and tipo_compartilhamento='T'";
  }   
  else
  {
    if (PertenceAoGrupo($sock, $cod_usuario, $cod_grupo_portfolio))
      $regra="";
    else if ($eformador)
      $regra="and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";
    else
      $regra="and tipo_compartilhamento='T'";
  }

  if (EFormadorComVisaoDeAluno($sock, $cod_curso, $cod_usuario))
    $regra="and tipo_compartilhamento='T'";

  $consulta="select * from Portfolio_topicos where cod_topico_pai=".$cod_topico." ".$regra." order by posicao_topico";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* *********************************************************************
   NomeGrupo - Retorna o nome do grupo
   Entrada: $sock - BASE DO CURSO
            $cod_grupo - grupo
   Saida: nome do grupo
*/
function NomeGrupo($sock, $cod_grupo)
{
  $consulta="select nome from Grupos where cod_grupo=".$cod_grupo;
  $res=Enviar($sock, $consulta);
  $num=RetornaNumLinhas($res);
  $linha=RetornaLinha($res);
  return $linha['nome'];
}

/* *********************************************************************
   StatusGrupo - Retorna o estado de um grupo
   Entrada: $sock - BASE DO CURSO
            $cod_grupo - grupo
   Saida: Status - A - Ativo, X - Apagado
*/
function StatusGrupo($sock, $cod_grupo)
{
  $consulta="select status from Grupos where cod_grupo=".$cod_grupo;
  $res=Enviar($sock, $consulta);
  $num=RetornaNumLinhas($res);
  $linha=RetornaLinha($res);
  if ($linha['status']!="X")
    $linha['status']="A";
  return $linha['status'];
}

/* *********************************************************************
   RetornaTopicosBase - retorna topicos raizes (portfolios) de usuarios ou grupos
   Entrada: $sock                       - sock de conexao com a base
            $cod_usuario                - codigo do usuario logado
            $cod_usuario_portfolio      - codigo do usuario dono dos portfolios a exibir
            $eformador                  - booleano, se o cara eh formador
            $acao_portfolio_s           - indica se 
                                           'I' - portfolios individuais ou 
		                           'G' - de grupo

   Saida: array com [$cod_topico]['cod_topico_pai']
                    [$cod_topico]['cod_usuario']
                    [$cod_topico]['cod_grupo']
                    [$cod_topico]['topico']
                    [$cod_topico]['tipo_compartilhamento']
                    [$cod_topico]['data']                     
                    [$cod_topico]['posicao_topico']          
                    [$cod_topico]['num_itens']		
                    [$cod_topico]['num_itens_comentados']
                    [$cod_topico]['num_itens_nao_comentados']
                    [$cod_topico]['figura']                    - nome do arquivo da figura a exibir
*/
function RetornaTopicosBase ($sock, $cod_usuario, $cod_usuario_portfolio, $eformador, $acao_portfolio_s)
{
  global $lista_frases;
  unset ($lista_retorno);

  // lista de usuarios
  $query = "select cod_usuario, nome, tipo_usuario from Usuario";
  $res = Enviar ($sock, $query);
  $lista = RetornaArrayLinhas ($res);
  if (is_array ($lista))
    foreach ($lista as $c => $usuario)
    {
      $lista_usr[ $usuario['cod_usuario'] ]['nome']         = $usuario['nome'];
      $lista_usr[ $usuario['cod_usuario'] ]['tipo_usuario'] = $usuario['tipo_usuario'];
    }

  // lista de grupos
  $query = "select * from Grupos order by status";
  $res   = Enviar ($sock, $query);
  $lista = RetornaArrayLinhas ($res);
  unset ($lista_grupos);
  if (is_array ($lista))
    foreach ($lista as $c => $linha)
    {
      $lista_grupos [$cod_grupo = $linha['cod_grupo']]['nome'] = $linha['nome'];
      $lista_grupos [$cod_grupo]['status'] = $linha['status'];
    }

  //  echo ("<big><font color=red>Todos os grupos</font></big><br>");
  //  echo (print_array ($lista_grupos));

  // lista de grupos aos quais o usuario LOGADO pertence
  $query = "select * from Grupos_usuario where cod_usuario=".$cod_usuario;
  $res   = Enviar ($sock, $query);
  $lista = RetornaArrayLinhas ($res);
  unset ($grupos_usr);
  if (is_array ($lista))
    foreach ($lista as $c => $linha)
    {
      $grupos_usr[$linha['cod_grupo']] = true;
    }

  //  echo ("<big><font color=red>Grupos aos quais pertenco</font></big><br>");
  //  echo (print_array ($grupos_usr));


  if ($eformador)
  {
    // variavel para escolher compartilhamento dentro da query SQL
    $regra_comp = "(tipo_compartilhamento = 'F' or tipo_compartilhamento = 'T')";
    // variavel para escolher compartilhamento ao contar numero de itens dentro de um portfolio
    $comp = 'F';
  }
  else
  {
    $regra_comp = "tipo_compartilhamento = 'T'";
    $comp = 'T';
  }

  if ($acao_portfolio_s == 'I')
  {
    // primeiro pego portfolio do usuario
    $query = "select * from Portfolio_topicos where cod_topico_pai=3 and cod_usuario=".$cod_usuario;
    $res   = Enviar ($sock, $query);
    $portfolio_pessoal = RetornaLinha ($res);

    $lista_retorno [$cod_topico = $portfolio_pessoal['cod_topico']] = $portfolio_pessoal;
    // 76 - Portfolio de
    $lista_retorno [$cod_topico]['topico'] = RetornaFraseDaLista ($lista_frases, 76)." ".$lista_usr [ $cod_usuario ]['nome'];
    $lista_retorno [$cod_topico]['figura'] = "portfolio_i_p.gif";
    $lista_retorno [$cod_topico]['num_itens'] = $num_itens = RetornaNumItensPortfolio($sock, $cod_topico, 'P');
    $lista_retorno [$cod_topico]['num_itens_comentados'] = $num_itens_c = RetornaNumItensComentadosPortfolio($sock, $cod_topico, 'P');
    $lista_retorno [$cod_topico]['num_itens_nao_comentados'] = $num_itens - $num_itens_c;
    
    // segundo, pego outros portfolios individuais
    $query = "select * from Portfolio_topicos where cod_topico_pai=3 and cod_usuario <> ".$cod_usuario;
    $res   = Enviar ($sock, $query);
    $array_ind = RetornaArrayLinhas ($res);
    
    if (is_array ($array_ind))
    {
      unset ($port_ind);        // portfolios individuais
      unset ($port_rej);        // portfolios de alunos rejeitados

      foreach ($array_ind as $x => $linha_ind)
      {
        if ($lista_usr [ $cod_usr = $linha_ind ['cod_usuario'] ]['tipo_usuario'] != 'r')   // alguem do curso
        {
          $port_ind [ $cod_topico = $linha_ind ['cod_topico'] ] = $linha_ind;
          // 76 - Portfolio de
          $port_ind [ $cod_topico ]['topico'] = RetornaFraseDaLista ($lista_frases, 76)." ".$lista_usr [ $cod_usr ]['nome'];
          $port_ind [ $cod_topico ]['figura'] = "portfolio_i_n.gif";
        }
        else    // aluno rejeitado
        {
          $port_rej [ $cod_topico = $linha_ind ['cod_topico'] ] = $linha_ind;
          // 76 - Portfolio de
          $port_rej [ $cod_topico ]['topico'] = RetornaFraseDaLista ($lista_frases, 76)." ".$lista_usr [ $cod_usr ]['nome'];
          $port_rej [ $cod_topico ]['figura'] = "portfolio_i_x.gif";
        }
      }
      
      if (is_array ($port_ind))
      {
        uasort ($port_ind, CompareArrayTopicos);
        foreach ($port_ind as $cod_topico => $portfolio_individual)
        {
          $num_itens = RetornaNumItensPortfolio ($sock, $cod_topico, $comp);
          if ($num_itens > 0)
          {
            $lista_retorno [ $cod_topico ] = $portfolio_individual;
            $lista_retorno [ $cod_topico ]['num_itens'] = $num_itens;
            $lista_retorno [ $cod_topico ]['num_itens_comentados'] = $num_itens_c = RetornaNumItensComentadosPortfolio($sock, $cod_topico, $comp);
            $lista_retorno [ $cod_topico ]['num_itens_nao_comentados'] = $num_itens - $num_itens_c;
          }
        }
      }

      if (is_array ($port_rej))
      {
        uasort ($port_rej, CompareArrayTopicos);
        foreach ($port_rej as $cod_topico => $portfolio_rejeitado)
        {
          $num_itens = RetornaNumItensPortfolio ($sock, $cod_topico, $comp);
          if ($num_itens > 0)
          {
            $lista_retorno [ $cod_topico ] = $portfolio_rejeitado;
            $lista_retorno [ $cod_topico ]['num_itens'] = $num_itens;
            $lista_retorno [ $cod_topico ]['num_itens_comentados'] = $num_itens_c = RetornaNumItensComentadosPortfolio($sock, $cod_topico, $comp);
            $lista_retorno [ $cod_topico ]['num_itens_nao_comentados'] = $num_itens - $num_itens_c;
          }
        }
      }
    }
  }
  else if ($acao_portfolio_s == 'G')
  {
    $query = "select * from Portfolio_topicos where cod_topico_pai=4";
    $res   = Enviar ($sock, $query);
    $lista = RetornaArrayLinhas ($res);

    if (is_array ($lista))
    {
      unset ($port_meus_grp);           // portfolios de grupos aos quais pertenco
      unset ($port_outros_grp);         // portfolios de grupos aos quais NAO pertenco
      unset ($port_grupos_x);           // portfolios de grupos apagados
    
      foreach ($lista as $c => $linha_port)
      {
        // SE UM GRUPO FOI APAGADO, O SEU PORTFOLIO SERA EXIBIDO INDEPENDENTE DO TIPO DE COMPARTILHAMENTO QUE ELE TINHA QDO O GRUPO ERA ATIVO
        if ($lista_grupos[ $cod_grupo = $linha_port['cod_grupo'] ]['status'] == 'X') // grupo apagado
        {
          $port_grupos_x [ $cod_topico = $linha_port['cod_topico'] ] = $linha_port;
          // 77 - Portfolio do grupo
          $port_grupos_x [ $cod_topico ]['topico'] = RetornaFraseDaLista ($lista_frases, 77)." ".$lista_grupos[$cod_grupo]['nome'];
          $port_grupos_x [ $cod_topico ]['figura'] = "portfolio_g_x.gif";
        }
        else if ($grupos_usr[ $cod_grupo ])     // portfolio de um grupo ao qual o usuario pertence
        {
          $port_meus_grp [ $cod_topico = $linha_port['cod_topico'] ] = $linha_port;
          // 77 - Portfolio do grupo
          $port_meus_grp [ $cod_topico ]['topico'] = RetornaFraseDaLista ($lista_frases, 77)." ".$lista_grupos[$cod_grupo]['nome'];
          $port_meus_grp [ $cod_topico ]['figura'] = "portfolio_g_p.gif";
        }
        else if ( ($tipo = $linha_port ['tipo_compartilhamento']) == 'T' || $tipo == $comp)  // portfolio de um grupo ativo ao qual o usuario nao pertence, neste caso somente retornamos se o tipo de compartilhamento permitir
        {
          /*
            o tipo de compartilhamento pode ser
            P - no retornamos este portfolio
            T - retornamos sempre
            F - retornamos apenas se o usuario logado for formados, quando $comp tambem vale 'F' 
          */

          $port_outros_grp [ $cod_topico = $linha_port['cod_topico'] ] = $linha_port;
          // 77 - Portfolio do grupo
          $port_outros_grp [ $cod_topico ]['topico'] = RetornaFraseDaLista ($lista_frases, 77)." ".$lista_grupos[$cod_grupo]['nome'];
          $port_outros_grp [ $cod_topico ]['figura'] = "portfolio_g_n.gif";
        }
      }

      // copiando para o retorno os portfolios de grupos aos quais pertenco: copio todos aqueles aos quais pertenco
      if (is_array ($port_meus_grp))
      {
        uasort ($port_meus_grp, CompareArrayTopicos);
        foreach ($port_meus_grp as $cod_topico => $portfolio)
        {
          $lista_retorno [ $cod_topico ] = $portfolio;
          $lista_retorno [ $cod_topico ]['num_itens'] = $num_itens = RetornaNumItensPortfolio ($sock, $cod_topico, 'P');
          $lista_retorno [ $cod_topico ]['num_itens_comentados'] = $num_itens_c = RetornaNumItensComentadosPortfolio ($sock, $cod_topico, 'P');
          $lista_retorno [ $cod_topico ]['num_itens_nao_comentados'] = $num_itens - $num_itens_c;
        }
      }
      
      // copiando para o retorno os portfolios de grupos aos quais eu nao pertenco: copio apenas aqueles que tem algum item dentro
      if (is_array ($port_outros_grp))
      {
        uasort ($port_outros_grp, CompareArrayTopicos);
        foreach ($port_outros_grp as $cod_topico => $portfolio)
        {
          $num_itens = RetornaNumItensPortfolio ($sock, $cod_topico, $comp);
          if ($num_itens > 0)
          {
            $lista_retorno [$cod_topico] = $portfolio;
            $lista_retorno [$cod_topico]['num_itens'] = $num_itens;
            $lista_retorno [$cod_topico]['num_itens_comentados'] = $num_itens_c = RetornaNumItensComentadosPortfolio ($sock, $cod_topico, $comp);
            $lista_retorno [$cod_topico]['num_itens_nao_comentados'] = $num_itens - $num_itens_c;
          }
        }
      }

      // copiando para o retorno os portfolios de grupos apagados
      if (is_array ($port_grupos_x))
      {
        uasort ($port_grupos_x, CompareArrayTopicos);
        foreach ($port_grupos_x as $cod_topico => $portfolio)
        {
          $num_itens = RetornaNumItensPortfolio ($sock, $cod_topico, $comp);
          if ($num_itens > 0)
          {
            $lista_retorno [$cod_topico] = $portfolio;
            $lista_retorno [$cod_topico]['num_itens'] = $num_itens;
            $lista_retorno [$cod_topico]['num_itens_comentados'] = $num_itens_c = RetornaNumItensComentadosPortfolio ($sock, $cod_topico, $comp);
            $lista_retorno [$cod_topico]['num_itens_nao_comentados'] = $num_itens - $num_itens_c;
          }
        }
      }
    }
  }
  else
  {
    echo("<big><font color=red>Erro em RetornaTopicosBase: variavel acao_aportfolio_s</font></big>");
    exit();
  }

  /*
  // faltam outras infos em cada portfolio: num itens, num itens coments, etc.
  if (is_array ($lista_retorno))
  {
    foreach ($lista_retorno as $cod_topico => $portfolio)
    {
      // escolhendo compartilhamentos
      $comp = 'T';
      if ($eformador)
        $comp = 'F';
      if ($portfolio['cod_usuario'] == $cod_usuario || $grupos_usr[$portfolio['cod_grupo']] ) // se pertence ao grupo ou eh dono do portfolio
        $comp = 'P';
    
      $lista_retorno [$cod_topico]['num_itens'] = $num_itens = RetornaNumItensPortfolio($sock, $cod_topico, $comp);
      $lista_retorno [$cod_topico]['num_itens_comentados'] = $num_itens_c = RetornaNumItensComentadosPortfolio($sock, $cod_topico, $comp);
      $lista_retorno [$cod_topico]['num_itens_nao_comentados'] = $num_itens - $num_itens_c;
    }
  }
  */

  //  echo("<font color=red>Em RetornaTopicosBase: retorno da funcao = </font><br>");
  // echo(print_array ($lista_retorno));
  
  return $lista_retorno;
}

function CompareArrayTopicos($ar1, $ar2)
{
  if ($ar1['topico']<$ar2['topico'])
    return -1;
  else if ($ar1['topico']>$ar2['topico'])
    return 1;
  else
    return 0;
}

/* *********************************************************************
   RetornaNumItensPortfolio - Retorna o numero de itens em um portflio
   Entrada: $sock - BASE DO CURSO
            $cod_topico - codigo da pasta base
            $portfolios - 'P' - Todos os itens, 'F' - Itens tipo F e T, 'T' - S tipo T
   Saida: numero de itens
*/
function RetornaNumItensPortfolio($sock, $cod_topico,$portfolios)
{
  $total=0;
  if ($portfolios=='T')
    $topico="tipo_compartilhamento='T' and ";
  else if ($portfolios=='F')
    $topico="tipo_compartilhamento<>'P' and ";
  else 
    $topico="";

  $consulta="select cod_topico from Portfolio_topicos where ".$topico." cod_topico_pai=".$cod_topico;
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);

  if (count($lista)>0)
    foreach($lista as $cod => $linha)
      $total = $total + RetornaNumItensPortfolio($sock, $linha['cod_topico'],$portfolios);

  $consulta="select cod_item from Portfolio_itens where ".$topico." cod_topico=".$cod_topico;
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  $total = $total + count($lista);
  return $total;
}

/* *********************************************************************
   RetornaNumItensPortfolio - Retorna o numero de itens em um portflio
   Entrada: $sock - BASE DO CURSO
            $cod_topico - codigo da pasta base
            $portfolios - 'P' - Todos os itens, 'F' - Itens tipo F e T, 'T' - S tipo T
   Saida: numero de itens
*/
function RetornaNumItensComentadosPortfolio($sock, $cod_topico,$portfolios)
{
  $total=0;
  if ($portfolios=='T')
    $topico="Pi.tipo_compartilhamento='T' and ";
  else if ($portfolios=='F')
    $topico="Pi.tipo_compartilhamento<>'P' and ";
  else 
    $topico="";

  $consulta="select cod_topico from Portfolio_topicos Pi where ".$topico." Pi.cod_topico_pai=".$cod_topico;
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);

  if (count($lista)>0)
    foreach($lista as $cod => $linha)
      $total = $total + RetornaNumItensComentadosPortfolio($sock, $linha['cod_topico'],$portfolios);

  $consulta="select distinct Pi.cod_item from Portfolio_itens Pi, Portfolio_itens_comentarios Pic where ".$topico." Pi.cod_topico=".$cod_topico." and Pi.cod_item=Pic.cod_item and Pic.status<>'X'";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  $total = $total + count($lista);
  return $total;
}


/* *********************************************************************
   MudarPosicaoItem - Muda a posio do item (utiliza semaforo)
   Entrada: $sock - BASE DO CURSO
            $cod_topico_raiz - tpico a partir do qual sero rearranjados os itens
            $cod_item - Codigo do item a ter a posio mudada
            $posicao - valor da nova posio do item
   Saida: nenhuma
*/
function MudarPosicaoItem ($sock, $cod_topico_raiz, $cod_item, $posicao)
{
  $consulta="select cod_item from Portfolio_itens where cod_topico=".$cod_topico_raiz." order by posicao_item";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  $cont=1;
  PegaSemaforo($sock, "Portfolio");
  if ($posicao==0)
    $posicao=1;
  if (count($lista)>0)
  {
    foreach ($lista as $cod => $linha)
    {
      if ($cod_item==$linha['cod_item'])
      {
        if ($posicao==$cont)
        {
          $consulta="update Portfolio_itens set posicao_item=".$cont." where cod_item=".$cod_item;
          $res=Enviar($sock, $consulta);
          $cont++;
          $posicao=-1;
        }
      }
      else
      {
        if ($posicao==$cont)
        {
          $consulta="update Portfolio_itens set posicao_item=".$cont." where cod_item=".$cod_item;
          $res=Enviar($sock, $consulta);
          $cont++;
          $posicao=-1;
        }
        $consulta="update Portfolio_itens set posicao_item=".$cont." where cod_item=".$linha['cod_item'];
        $res=Enviar($sock, $consulta);
        $cont++;
      }
    }
    if ($posicao>0)
    {
      $consulta="update Portfolio_itens set posicao_item=".$cont." where cod_item=".$cod_item;
      $res=Enviar($sock, $consulta);
      $cont++;
    }
  }
  LiberaSemaforo($sock, "Portfolio");
}

/* *********************************************************************
   MudarPosicaoTopico - Muda a posio do tpico (utiliza semaforo)
   Entrada: $sock - BASE DO CURSO
            $cod_topico_raiz - tpico a partir do qual sero rearranjados os itens
            $cod_topico - Codigo do topico a ter a posio mudada
            $posicao - valor da nova posio do item
   Saida: nenhuma
*/
function MudarPosicaoTopico ($sock, $cod_topico_raiz, $cod_topico, $posicao)
{
  $consulta="select * from Portfolio_topicos where cod_topico_pai=".$cod_topico_raiz." order by posicao_topico";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  $cont=1;
  PegaSemaforo($sock, "Portfolio");
  if ($posicao==0)
    $posicao=1;
  if (count($lista)>0)
  {
    foreach ($lista as $cod => $linha)
    {
      if ($cod_topico==$linha['cod_topico'])
      {
        if ($posicao==$cont)
        {
          $consulta="update Portfolio_topicos set posicao_topico=".$cont." where cod_topico=".$cod_topico;
          $res=Enviar($sock, $consulta);
          $cont++;
          $posicao=-1;
        }
      }
      else
      {
        if ($posicao==$cont)
        {
          $consulta="update Portfolio_topicos set posicao_topico=".$cont." where cod_topico=".$cod_topico;
          $res=Enviar($sock, $consulta);
          $cont++;
          $posicao=-1;
        }
        $consulta="update Portfolio_topicos set posicao_topico=".$cont." where cod_topico=".$linha['cod_topico'];
        $res=Enviar($sock, $consulta);
        $cont++;
      }
    }
    if ($posicao>0)
    {
      $consulta="update Portfolio_topicos set posicao_topico=".$cont." where cod_topico=".$cod_topico;
      $res=Enviar($sock, $consulta);
      $cont++;
      $posicao=-1;
    }
  }
  LiberaSemaforo($sock, "Portfolio");
}

/* *********************************************************************
   RetornaTopicosAncestrais - Retorna array com os tpicos ancestrais do tpico dado
   Entrada: $sock - BASE DO CURSO
            $cod_topico - Codigo do topico
   Saida: array [] - topicos (em ordem crescente de ancestralidade)
*/
function RetornaTopicosAncestrais ($sock, $cod_topico)
{
  global $lista_frases;
  $cont=0;
  do
  {
    $consulta="select * from Portfolio_topicos where cod_topico=".$cod_topico;
    $res=Enviar($sock, $consulta);
    $linha=RetornaLinha($res);
    $cod_topico=$linha['cod_topico_pai'];
    $retorno[$cont]=$linha;
    $cont++;
  }
  while ($cod_topico>4); /* S desce at os portflios */
  // 124 - Raiz
  $retorno[$cont - 1]['topico']=RetornaFraseDaLista($lista_frases, 124);

  return($retorno);
}

/* *********************************************************************
   RetornaUltimaPosicaoHistorico - Retorna a ultima ocorrncia do historico de um item dado
   Entrada: $sock - BASE DO CURSO
            $cod_item - item
   Saida: array ['cod_item']
                ['cod_usuario']
                ['data']
                ['acao']
*/
function RetornaUltimaPosicaoHistorico ($sock, $cod_item)
{
  $consulta="select * from Portfolio_itens_historicos where cod_item=".$cod_item." order by data desc limit 1";
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  return($linha);
}

/* *********************************************************************
   CriarTopico - Cria um novo topico filho do topico dado
   Entrada: $sock - BASE DO CURSO
            $cod_topico_raiz - topico pai
            $novo_nome - nome do novo topico
            $cod_usuario - codigo do usuario atual
            $cod_grupo - codigo do grupo do portfolio (NULL ou "" se individual
   Saida: codigo do topico criado
*/
function CriarTopico ($sock, $cod_topico_raiz, $novo_nome, $cod_usuario, $cod_grupo)
{
  if ($cod_grupo=="")
    $cod_grupo="NULL";
  $posicao=UltimaPosicaoLivreTopico($sock, $cod_topico_raiz);
  $consulta="insert into Portfolio_topicos (cod_topico_pai, cod_usuario, cod_grupo, topico, tipo_compartilhamento, data, posicao_topico) values (".$cod_topico_raiz.", ".$cod_usuario.", ".$cod_grupo.", '".$novo_nome."', 'P', ".time().", ".$posicao.")";
  $res=Enviar($sock, $consulta);
  return($cod_topico);
}

/* *********************************************************************
   IniciaCriacao - Inicia a criao de um novo item 
   Entrada: $sock - BASE DO CURSO
            $cod_topico - topico pai
            $cod_usuario - usuario atual
            $cod_grupo - codigo do grupo (NULL ou "" se individual)
            $cod_curso - codigo do curso
            $diretorio_temp - nome do diretrio temporario, usado durante a edio
   Saida: codigo do item criado
*/
function IniciaCriacao ($sock, $cod_topico, $cod_usuario, $cod_grupo, $cod_curso, $diretorio_temp)
{
  // vamos mexer com datas, entao chamo a funcao time() uma vez soh
  $data = time();

  if ($cod_grupo=="")
    $cod_grupo="NULL";
  $cod_item=RetornaProximoCodigo($sock, "Portfolio_itens");
  $posicao=UltimaPosicaoLivreItem($sock, $cod_topico);
  $consulta="insert into Portfolio_itens (cod_item, cod_topico, cod_usuario, cod_grupo, titulo, data, posicao_item, status, inicio_edicao) values (".$cod_item.", ".$cod_topico.", ".$cod_usuario.", ".$cod_grupo.", ' ', ".$data.", ".$posicao.", 'C', ".$data.")";
  $res=Enviar($sock, $consulta);
  $consulta="insert into Portfolio_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".$data.", 'C')";
  $res=Enviar($sock, $consulta);

  if (!file_exists($diretorio_temp."/tmp/".$cod_curso."/"))
    CriaDiretorio($diretorio_temp."/tmp/".$cod_curso."/");
  if (!file_exists($diretorio_temp."/tmp/".$cod_curso."/portfolio/"))
    CriaDiretorio($diretorio_temp."/tmp/".$cod_curso."/portfolio/");

  $dir=$diretorio_temp."/tmp/".$cod_curso."/portfolio/".$cod_item."/";
  CriaDiretorio($dir);

  return($cod_item);
}

/* *********************************************************************
   RetornaDadosDoItem - Retorna um array com os dados do item
   Entrada: $sock - BASE DO CURSO
            $cod_topico - tpico
   Saida: array com ['cod_item']
                    ['cod_topico']
                    ['cod_usuario']
                    ['cod_grupo']
                    ['titulo']
                    ['texto']
                    ['tipo_compartilhamento']
                    ['data']
                    ['data_ativo']
                    ['data_inativo']
                    ['posicao_item']
                    ['status']
                    ['inicio_edicao']
*/
function RetornaDadosDoItem ($sock, $cod_item)
{
  $consulta="select * from Portfolio_itens where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  return($linha);
}

/* *********************************************************************
   RetornaResHistoricoDoItem - Retorna todas as ocorrncias do historico de um item dado
   Entrada: $sock - BASE DO CURSO
            $cod_item - item
   Saida: array []['cod_item']
                []['cod_usuario']
                []['data']
                []['acao']
*/
function RetornaResHistoricoDoItem ($sock, $cod_item)
{
  $consulta="select * from Portfolio_itens_historicos where cod_item=".$cod_item." order by data desc";
  $res=Enviar($sock, $consulta);
  return($res);
}

/* *********************************************************************
   CopiaArquivoParaTemporario - Copia os arquivos para temporario
   Entrada: $sock - BASE DO CURSO
            $cod_curso - cdigo do curso
            $diretorio_arquivos - diretrio dos arquivos do TelEduc
            $diretorio_temp - diretrio dos arquivos do TelEduc
            $cod_item - cdigo do item
   Saida: false - se houve algum erro.
*/
function CopiaArquivoParaTemporario($sock,$cod_curso,$diretorio_arquivos,$diretorio_temp,$cod_item)
{
  $dir=$diretorio_arquivos."/".$cod_curso."/portfolio/".$cod_item."/";
  $dirtemp=$diretorio_temp."/tmp/".$cod_curso."/portfolio/".$cod_item."/";
  $dirtemp2=$diretorio_temp."/tmp/".$cod_curso."/portfolio/";

  if (!file_exists($diretorio_temp."/tmp/".$cod_curso."/"))
    CriaDiretorio($diretorio_temp."/tmp/".$cod_curso."/");
  if (!file_exists($diretorio_temp."/tmp/".$cod_curso."/portfolio/"))
    CriaDiretorio($diretorio_temp."/tmp/".$cod_curso."/portfolio/");

  if (!file_exists($dir))
  {
    if (!CriaDiretorio($dir))
      return false;
  }

  if (file_exists($dirtemp))
  {
    RemoveDiretorio($dirtemp);
  }
  if (!CopiaDiretorio($dir,$dirtemp2))
  {
    return false;
  }
  return true;  
}

/* *********************************************************************
   RetornaArquivosMaterialTemp - Retorna lista de arquivos do Material no diretrio temporrio
   Entrada: $cod_curso - codigo do curso
            $diretorio_temp - diretrio temporario de arquivos
            $cod_item - cdigo do item
   Saida: Array multidimensional com:
          $lista[<num>]['Caminho'] - caminho completo.
          $lista[<num>]['Diretorio'] - Diretorio do arquivo
          $lista[<num>]['Arquivo'] - Nome do arquivo
          $lista[<num>]['Status'] - Condio especial (true ou false);
          $lista[<num>]['Tamanho'] - tamanho do arquivo
          $lista[<num>]['Data'] - data da ltima modificao
*/
function RetornaArquivosMaterialTemp ($cod_curso, $diretorio_temp, $cod_item)
{
  $dirtemp=$diretorio_temp."/tmp/".$cod_curso."/portfolio/".$cod_item."/";
  return (RetornaArrayDiretorio($dirtemp));
}

/* *********************************************************************
   RetornaArquivosMaterialVer - Retorna lista de arquivos do Material
   Entrada: $diretorio_temp - diretrio temporario de arquivos
            $dirlink - link
   Saida: Array multidimensional com:
          $lista[<num>]['Caminho'] - caminho completo.
          $lista[<num>]['Diretorio'] - Diretorio do arquivo
          $lista[<num>]['Arquivo'] - Nome do arquivo
          $lista[<num>]['Status'] - Condio especial (true ou false);
          $lista[<num>]['Tamanho'] - tamanho do arquivo
          $lista[<num>]['Data'] - data da ltima modificao
*/
function RetornaArquivosMaterialVer ($cod_curso, $dirlink)
{
  return (RetornaArrayDiretorio($dirlink));
}

/* *********************************************************************
   RetornaEnderecosMaterial - Retorna um array com os enderecos associados ao item
   Entrada: $sock - BASE DO CURSO
            $cod_item - item
   Saida: array com []['cod_endereco']
                    []['cod_item']
                    []['nome']
                    []['endereco']
                    []['status']
*/
function RetornaEnderecosMaterial ($sock, $cod_item)
{
  $consulta="select * from Portfolio_itens_enderecos where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* *********************************************************************
   ApagaEndereco - apaga o endereco dado
   Entrada: $sock - BASE DO CURSO
            $cod_endereco - codigo do endereco a ser apagada
   Saida: nenhuma
*/
function ApagaEndereco ($sock, $cod_endereco)
{
  $consulta="select * from Portfolio_itens_enderecos where cod_endereco=".$cod_endereco;
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  if ($linha['status']=="F") /* Existia antes da edio */
  {
    $consulta="update Portfolio_itens_enderecos set status='A' where cod_endereco=".$cod_endereco;
  }
  else
  {
    /* S deve ter um caso: status="I", foi inserido nesta sesso */
    $consulta="delete from Portfolio_itens_enderecos where cod_endereco=".$cod_endereco;
  }
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   ApagaTodosEnderecos - apaga todos os enderecos do item dado
   Entrada: $sock - BASE DO CURSO
            $cod_item - codigo do item a ter endereos apagados
   Saida: nenhuma
*/
function ApagaTodosEnderecos ($sock, $cod_item)
{
  $consulta="select * from Portfolio_itens_enderecos where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);

  while($linha=RetornaLinha($res))
  {
    if ($linha['status']=="F") /* Existia antes da edio */
    {
      $consulta="update Portfolio_itens_enderecos set status='A' where cod_endereco=".$linha['cod_endereco'];
    }
    else
    {
      /* S deve ter um caso: status="I", foi inserido nesta sesso */
      $consulta="delete from Portfolio_itens_enderecos where cod_endereco=".$linha['cod_endereco'];
    }
    Enviar($sock, $consulta);
  }
}



/* *********************************************************************
   InsereEndereco - Insere (ou atualiza, se j existir) um endereco ao item dado
   Entrada: $sock - BASE DO CURSO
            $nome - nome do endereco
            $endereco - Endereco do item
            $cod_item - item ao qual o endereco estar associado
   Saida: nenhuma
*/
function InsereEndereco ($sock, $nome, $endereco, $cod_item)
{
  $consulta="select * from Portfolio_itens_enderecos where endereco='".LimpaTitulo($endereco)."' and nome='".LimpaTitulo($nome)."' and cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
  $num=RetornaNumLinhas($res);
  if ($num>0)
  {
    $linha=RetornaLinha($res);
    if ($linha['status']=="A")
    {
      $consulta="update Portfolio_itens_enderecos set status='F' where cod_endereco=".$linha['cod_endereco'];
      $res=Enviar($sock, $consulta);
    }
  }
  else
  {
    $consulta="insert into Portfolio_itens_enderecos (cod_item, nome, endereco, status) values (".$cod_item.", '".$nome."', '".$endereco."', 'I')";
    $res=Enviar($sock, $consulta);
  }
}

/* *********************************************************************
   AtualizaDataEdicao - Atualiza a data de edio do item
   Entrada: $sock - BASE DO CURSO
            $cod_item - item 
   Saida: nenhuma
*/
function AtualizaDataEdicao ($sock, $cod_item)
{
  $consulta="update Portfolio_itens set inicio_edicao=".time()." where cod_item=".$cod_item;
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   AtualizaMaterial - Atualiza o Ttulo, o Texto e os arquivos
   Entrada: $sock - BASE DO CURSO
            $cod_curso - cdigo do curso
            $cod_item - cdigo do item
            $titulo - ttulo do material
            $texto - texto a ser colocado
            $compartilhamento - tipo de compartilhamento
            $diretorio_arquivos - diretrio dos arquivos do TelEduc
            $diretorio_temp - diretrio dos arquivos do TelEduc
            $cod_usuario - codigo do usuario
   Saida: false - se houve algum erro.
*/
function AtualizaMaterial($sock,$cod_curso,$cod_item,$titulo,$texto,$compartilhamento,$diretorio_arquivos,$diretorio_temp,$cod_usuario)
{
  /* Copiar arquivos, quando necessrio... */
  $dir=$diretorio_arquivos."/".$cod_curso."/portfolio/";
  $dirtemp=$diretorio_temp."/tmp/".$cod_curso."/portfolio/".$cod_item."/";

  $ret=SobrepoeDiretorio($dirtemp,$dir);

  /* Checa se existem arquivos no diretrio */
  $array_temp=RetornaArrayDiretorio($dir."/".$cod_item);
  if ($ret && count($array_temp)==0)
  {
    RemoveDiretorio($dir."/".$cod_item);
  }

  // como vou precisar atualizar campos de data, preciso saber a data em UnixTime
  $data = time();

  // atualizando item do portfolio
  $consulta="update Portfolio_itens set titulo='".$titulo."', texto='".$texto."', data=".$data.", status='L' where cod_item=".$cod_item;
  Enviar($sock,$consulta);

  MudarCompartilhamento ($sock, $cod_item, $compartilhamento);

  $consulta="delete from Portfolio_itens_enderecos where cod_item=".$cod_item." and status='A'";
  Enviar($sock,$consulta);
  $consulta="update Portfolio_itens_enderecos set status='F' where cod_item=".$cod_item;
  Enviar($sock,$consulta);
  $consulta="insert into Portfolio_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'F')";
  $res=Enviar($sock, $consulta);
}

/* *********************************************************************
   MudaStatusEdicao - Muda p Estado do item para Em Edio
   Entrada: $sock - BASE DO CURSO
            $cod_item - item 
            $cod_usuario - usuario realizando a edicao
   Saida: nenhuma
*/
function MudaStatusEdicao ($sock, $cod_item, $cod_usuario)
{
  $consulta="update Portfolio_itens set status='E', cod_usuario=".$cod_usuario.", inicio_edicao=".time()." where cod_item=".$cod_item;
  $res=Enviar($sock,$consulta);
  $consulta="insert into Portfolio_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'E')";
  $res=Enviar($sock,$consulta);
}

/* *********************************************************************
   CancelaEdicao - Cancela a edicao de um item (termina os diretrios tb).
   Entrada: $sock - BASE DO CURSO
            $cod_item - codigo do item
            $cod_usuario - usuario cancelando a edicao
            $cod_curso - codigo do curso
            $diretorio_arquivos - diretorio dos arquivos definitivos
            $diretorio_temp - diretorio temporario da edicao
   Saida: true se a edio foi cancelada corretamente
*/
function CancelaEdicao ($sock, $cod_item, $cod_usuario, $cod_curso, $diretorio_arquivos, $diretorio_temp)
{
  $dirtemp=$diretorio_temp."/tmp/".$cod_curso."/portfolio/".$cod_item."/";
  if (file_exists($dirtemp))
  {
    if (!RemoveDiretorio($dirtemp))
      return false;
  }
  $linha=RetornaDadosDoItem($sock, $cod_item);
  if ($linha['status']=="C")
  {
    $consulta="delete from Portfolio_itens_enderecos where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    $consulta="delete from Portfolio_itens_historicos where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    $consulta="delete from Portfolio_itens where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    return true;
  }
  if ($linha['status']=="E")
  {
    $consulta="delete from Portfolio_itens_enderecos where cod_item=".$cod_item." and status='I'";
    $res=Enviar($sock, $consulta);
    $consulta="update Portfolio_itens_enderecos set status='F' where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    $consulta="insert into Portfolio_itens_historicos values (".$cod_item.", ".$cod_usuario.", ".time().", 'D')";
    $res=Enviar($sock, $consulta);

    $consulta="update Portfolio_itens set status='L' where cod_item=".$cod_item;
    $res=Enviar($sock, $consulta);

    return true;
  }
}

/* *********************************************************************
   CriaLinkVisualizar - Cria link simblico para dinamica e retorna o link
   Entrada: $sock - BASE DO CURSO
            $cod_curso - codigo do curso
            $cod_usuario - codigo do usuario
            $cod_item - cdigo do item
            $diretorio_arquivos - diretorio dos arquivos do TelEduc
            $diretorio_temp - diretorio dos arquivos do TelEduc
   Saida: caminho relativo
*/
function CriaLinkVisualizar($sock,$cod_curso,$cod_usuario,$cod_item,$diretorio_arquivos,$diretorio_temp)
{
  /* Busca Arquivo a ser mostrado */
  unset ($caminho);
  $dir=$diretorio_arquivos."/".$cod_curso."/portfolio/".$cod_item."/";

/*
  $lista=RetornaArrayDiretorio($dir);
  foreach($lista as $cod => $linha)
    if ($linha['Status'] && $linha['Arquivo']!="")
      $arquivo=$linha['Diretorio']."/".$linha['Arquivo'];
*/

  /* Cria link simblico (apaga antigo, se houver)*/
  if ($cod_usuario<0) 
    $cod_usuario=0;
  $dirlink=$diretorio_temp."/portfolio_".$cod_curso."_".$cod_item."_".$cod_usuario;
  $dirlinkpath="../../diretorio/portfolio_".$cod_curso."_".$cod_item."_".$cod_usuario;

  RemoveArquivo($dirlink);

  CriaLinkSimbolico($dir,$dirlink);

  $retorno['diretorio']=$dirlink."/";
  $retorno['link']=$dirlinkpath."/";

  return ($retorno);
}

/* *********************************************************************
   EncerraExibicaoArquivos - Encerra os links criados
   Entrada: $sock - BASE DO CURSO
            $cod_curso - codigo do curso
            $cod_usuario - codigo do usuario
            $cod_item - cdigo do item
            $diretorio_arquivos - diretorio dos arquivos do TelEduc
   Saida: True se link removido corretamente
*/
function EncerrarExibicaoArquivo($sock,$cod_curso,$cod_usuario,$cod_item,$diretorio_arquivos)
{
  /* Cria link simblico (apaga antigo, se houver)*/
  if ($cod_usuario<0) 
    $cod_usuario=0;
  $dirlink="../../diretorio/portfolio_".$cod_curso."_".$cod_item."_".$cod_usuario;
  return (RemoveArquivo($dirlink));
}

/* *********************************************************************
   RetornaArquivosVisiveis - Retorna array com os arquivos visiveis ao usuario
   Entrada: $lista_arq - **** Perguntar ao Davi a logica ******
   Saida: array com lista de arquivos
*/
function RetornaArquivosVisiveis($lista_arq)
{

  $cont=0;
  $pilha_index=0;
  unset($pilha);
  if (count($lista_arq)>0)
  {
    foreach($lista_arq as $cod => $linha)
    {
      if ($linha['Diretorio']!="")
      {
        if ($linha['Arquivo']=="")
        {
          if ($pilha_index>=0)
          {

            $dir_array_p=explode("/", $pilha[$pilha_index]['Diretorio']);
            $nivel_p=count($dir_array_p)-1;
            $dir_name_p=$dir_array_p[$nivel_p];
            unset($dir_array_p[$nivel_p]);
            $dir_path_p=implode("/", $dir_array_p);

            $dir_array=explode("/", $linha['Diretorio']);
            $nivel=count($dir_array)-1;
            $dir_name=$dir_array[$nivel];
            unset($dir_array[$nivel]);
            $dir_path=implode("/", $dir_array);

            while ($nivel_p>=$nivel)
            {
              unset($pilha[$pilha_index]);
              $pilha_index--;
              $nivel_p--;
            }
            $pilha_index++;
            $pilha[$pilha_index]=$linha;
            $pilha[$pilha_index]['Posicao']=$cod;

          }
          else
          {
            $pilha_index++;
            $pilha[$pilha_index]=$linha;
            $pilha[$pilha_index]['Posicao']=$cod;
          }
        }
        else
        {
          if ($linha['Status'] && $pilha_index>=0)
          {

            foreach ($pilha as $cod_pilha => $linha_pilha)
            {
              $lista_arq[$linha_pilha['Posicao']]['Status']=true;
            }

          }
        }
      }
    }
  }
  return($lista_arq);
}

/* *********************************************************************
   RetornaMaiorData - Retorna a maior data dentro de um tpico ou subtpico
   Entrada: $sock - Conexo com a base interna
            $cod_topico - codigo do topico a ser checado
            $tipo_comp - tipo do compartilhamento (F ou T)
            $data - Data do tpico
   Saida: maior data 
*/
function RetornaMaiorData($sock,$cod_topico,$tipo_comp,$data)
{
  $query="select cod_topico,data from Portfolio_topicos where cod_topico_pai=".$cod_topico;
  if ($tipo_comp=="T")
    $query.=" and tipo_compartilhamento='T'";
  if ($tipo_comp=="F")
    $query.=" and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";

  $res=Enviar($sock,$query);
  $lista_topicos=RetornaArrayLinhas($res);

  /* Verifica se existem subtpicos */
  if (count($lista_topicos)>0)
  {
    foreach($lista_topicos as $cod=>$linha)
    {
      $data_tmp=RetornaMaiorData($sock,$linha['cod_topico'],$tipo_comp,$linha['data']);
      if ($data_tmp>$data)
        $data=$data_tmp;
    }
  }

  $query="select max(data) from Portfolio_itens where cod_topico=".$cod_topico;
  if ($tipo_comp=="T")
    $query.=" and tipo_compartilhamento='T'";
  if ($tipo_comp=="F")
    $query.=" and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  if ($linha[0]>$data)
    $data=$linha[0];
  return $data;
}

/* *********************************************************************
   VerificaPortfolioGrupos - Verifica se existem portfolios para todos os grupos aos quais
                             o usuario logado pertence
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - codigo do usuario logado
   Saida: nenhuma
*/
function VerificaPortfolioGrupos ($sock, $cod_usuario)
{
  // lista dos grupos do usuario (excluindo grupos apagados: grupos apagados somente aparecem se foi colocado algo neles qdo estavam ativos)
  $query = "select GU.cod_grupo from Grupos_usuario GU, Grupos G where GU.cod_grupo=G.cod_grupo and GU.cod_usuario=".$cod_usuario." and G.status <> 'X' order by cod_grupo";
  $res   = Enviar ($sock, $query);
  $lista = RetornaArrayLinhas ($res);

  if (is_array ($lista))
    foreach ($lista as $c => $linha)
    {
      $lista_grupos [ $linha['cod_grupo'] ] = true;
    }
  
  // lista dos portfolios de grupo
  $query = "select cod_topico, cod_grupo from Portfolio_topicos where cod_grupo IS NOT NULL order by cod_grupo";
  $res   = Enviar ($sock, $query);
  $lista2= RetornaArrayLinhas ($res);
  
  if (is_array ($lista2))
    foreach ($lista2 as $c => $linha)
    {
      $lista_portfolios_grupos [ $linha['cod_grupo'] ] = true;
    }

  //  echo ("<font color=red size=3>Em VerificaPortfolioGrupos:</font>Lista de grupos aos quais vc pertence= <br>\n");
  //  echo (print_array ($lista_grupos));
  //  echo ("<font color=red size=3>Em VerificaPortfolioGrupos:</font>Lista de todos portfolios de grupo= <br>\n");
  //  echo (print_array ($lista_portfolios_grupos));

  // fazendo o match: pegamos os grupos aos quais o usuario pertence e que no tem portfolio na lista
  if (is_array ($lista_grupos))
    foreach ($lista_grupos as $cod_grupo => $c)
    {
      if (!isset ($lista_portfolios_grupos [ $cod_grupo ]))
      {
        // Nao existe um portfolio para este grupo. Criamos
        $rep="#G".$cod_grupo;
        $query="insert into Portfolio_topicos (cod_topico_pai,cod_usuario,cod_grupo,tipo_compartilhamento,data,posicao_topico,topico) values (4,".$cod_usuario.",".$cod_grupo.",'P',".time().",".UltimaPosicaoLivreTopico($sock, 4).",'".$rep."')";
        Enviar($sock,$query);
      }
    }
}

/* *********************************************************************
   MontaMenu - Monta o menu superior do portfolio
   Entrada:
            $cod_curso        - codigo do curso
            $acao_portfolio_s - se usuario esta em port individuais, = 'I'
                                se esta em port de grupos, = 'G'
   Saida: Exibe na tela o menu
*/
function MontaMenu($cod_curso, $acao_portfolio_s)
{
  global $lista_frases;
  global $ferramenta_grupos_s;

  if ($ferramenta_grupos_s)     // se a ferramenta grupos estiver ativa, exibimos menus para portfolios individuais e de grupos
  {
    // ajustando cores dos links
    if ($acao_portfolio_s == 'I')
    {
      $css_ind = "menuativo";
      $css_grp = "menu";
    }
    else if ($acao_portfolio_s == 'G')
    {
      $css_ind = "menu";
      $css_grp = "menuativo";
    }
  
    echo("<table width=100% border=0 cellspacing=2 cellpadding=0><tr align=middle>\n");
    // 74 - Portfolios Individuais
    echo("<td class=menu><a class=".$css_ind." href=ver_portfolios.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&exibir=ind>".RetornaFraseDaLista($lista_frases,74)."</a></td>\n");
    // 75 - Portfolios de Grupos
    echo("<td class=menu><a class=".$css_grp." href=ver_portfolios.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&exibir=grp>".RetornaFraseDaLista($lista_frases,75)."</a></td>\n");
    echo("</tr></table>\n");
  }
  else    // se a ferramenta grupos no estiver ativa, nao existe distincao entre portfolios de grupos ou individuais
  {
    echo("<table width=100% border=0 cellspacing=2 cellpadding=0><tr align=middle>\n");
    // 127 - Outros portfolios
    echo("<td class=menu><a class=menu href=ver_portfolios.php?".RetornaSessionID()."&cod_curso=".$cod_curso.">".RetornaFraseDaLista($lista_frases,127)."</a></td>\n");
    echo("</tr></table>\n");
  }
}

/* *********************************************************************
   RetornaListaIntegrantes - Retorna a lista de integrantes de um grupo
   Entrada: $sock - BASE DO CURSO
            $cod_grupo- codigo do grupo
   Saida: array com [$cod_usuario]['nome']
                                  ['tipo_usuario']
*/
function RetornaListaIntegrantes($sock,$cod_grupo)
{
  $query="select GU.cod_usuario 'cod_usuario', U.nome 'nome', U.tipo_usuario 'tipo_usuario' from Grupos_usuario GU, Usuario U where GU.cod_grupo=".$cod_grupo." and GU.cod_usuario=U.cod_usuario and (binary U.tipo_usuario='A' or binary U.tipo_usuario='F') order by U.tipo_usuario desc, U.nome";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  if (count($lista)>0)
    foreach($lista as $cod => $linha)
    {
      $saida[$linha['cod_usuario']]['nome']=$linha['nome'];
      $saida[$linha['cod_usuario']]['tipo_usuario']=$linha['tipo_usuario'];
    }
  return $saida;
}

/* *********************************************************************
   RetornaItensDaLixeixa - Retorna array com os itens da lixeira
   Entrada: $sock - BASE DO CURSO
            $cod_usuario - codigo do usuario logado
            $cod_usuario_portfolio - codigo do usuario dono do portfolio
            $cod_grupo_portfolio - codigo do grupo dono do portfolio (NULL ou "" se individual
   Saida: array com []['cod_item']
                    []['cod_topico']
                    []['cod_usuario']
                    []['cod_grupo']
                    []['titulo']
                    []['texto']
                    []['tipo_compartilhamento']
                    []['data']
                    []['data_ativo']
                    []['data_inativo']
                    []['posicao_item']
                    []['status']
                    []['inicio_edicao']
*/
function RetornaItensDaLixeixa ($sock, $cod_usuario,$cod_usuario_portfolio,$cod_grupo_portfolio)
{
  $saida=0;
  if ($cod_usuario!=$cod_usuario_portfolio)
  {
    if (!PertenceAoGrupo($sock,$cod_usuario, $cod_grupo_portfolio))
      return $saida;
    else
      $regra="(cod_grupo=".$cod_grupo_portfolio.")";
  }
  else
  {
    if (PertenceAoGrupo($sock,$cod_usuario, $cod_grupo_portfolio))
      $regra="(cod_grupo=".$cod_grupo_portfolio.")";
    else
      $regra="(cod_grupo IS NULL and cod_usuario=".$cod_usuario_portfolio.")";
  }
  $consulta="select * from Portfolio_itens where cod_topico=2 and ".$regra." order by posicao_item";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* *********************************************************************
   InsereComentario - Insere o comentrio no item passado
   Entrada: $sock - BASE DO CURSO
            $cod_item - codigo do item
            $comentario - comentario a ser acrescido
            $cod_comentarista - Pessoa fazendo o comentario
   Saida: Nenhuma
*/
function InsereComentario ($sock, $cod_item, $comentario, $cod_comentarista)
{
  $comentario=LimpaConteudo($comentario);
  $query="insert into Portfolio_itens_comentarios (cod_item,comentario,cod_comentarista,data,status) values (".$cod_item.",'".$comentario."',".$cod_comentarista.",".time().",'A')";
  Enviar($sock,$query);
}

/* *********************************************************************
   RetornaComentariosDoItem - Retorna um array com os comentarios associados ao item
   Entrada: $sock - BASE DO CURSO
            $cod_item - item
   Saida: array com []['cod_comentario']
                    []['cod_item']
                    []['comentario']
                    []['cod_comentarista']
                    []['data']
                    []['status']
*/
function RetornaComentariosDoItem ($sock, $cod_item)
{
  $consulta="select * from Portfolio_itens_comentarios where cod_item=".$cod_item." and status='A' order by data desc";
  $res=Enviar($sock, $consulta);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* *********************************************************************
   RetornaComentario - Retorna um array com os comentarios associados ao item
   Entrada: $sock - BASE DO CURSO
            $cod_comentario - comentario
   Saida: array com ['cod_comentario']
                    ['cod_item']
                    ['comentario']
                    ['cod_comentarista']
                    ['data']
                    ['status']
*/
function RetornaComentario ($sock, $cod_comentario)
{
  $consulta="select * from Portfolio_itens_comentarios where cod_comentario=".$cod_comentario;
  $res=Enviar($sock, $consulta);
  $linha=RetornaLinha($res);
  return($linha);
}

/* *********************************************************************
   ApagaComentario - Apaga o comentario Dado
   Entrada: $sock - BASE DO CURSO
            $cod_comentario - comentario
   Saida: nenhuma
*/
function ApagaComentario ($sock, $cod_comentario)
{
  $consulta="update Portfolio_itens_comentarios set status='X' where cod_comentario=".$cod_comentario;
  Enviar($sock, $consulta);
}

/* *********************************************************************
   RetornaNumComentariosTopico - Retorna a maior data dentro de um tpico ou subtpico
   Entrada: $sock - Conexo com a base interna
            $cod_usuario - usuario
            $cod_topico - codigo do topico a ser checado
            $tipo_comp - tipo do compartilhamento (F ou T)
            $data - Data do tpico
   Saida: array com ['num_comentarios']
                    ['num_comentarios_alunos'] - numero de comentrios feitos por alunos que no o usuario
                    ['num_comentarios_formadores'] - numero de comentrios feitos por formadores que no o usuario
                    ['num_comentarios_usuario'] - numero de comentrios feitos pelo usuario
                    ['data_comentarios'] - Maior data de um comentrio
*/
function RetornaNumComentariosTopico($sock,$cod_usuario,$cod_topico,$tipo_comp,$data)
{
  $num_f=0;
  $num_a=0;
  $num_u=0;
  $data=0;

  $query="select cod_topico,data from Portfolio_topicos where cod_topico_pai=".$cod_topico;
  if ($tipo_comp=="T")
    $query.=" and tipo_compartilhamento='T'";
  if ($tipo_comp=="F")
    $query.=" and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";

  $res=Enviar($sock,$query);
  $lista_topicos=RetornaArrayLinhas($res);

  /* Verifica se existem subtpicos */
  if (count($lista_topicos)>0)
  {
    foreach($lista_topicos as $cod=>$linha)
    {
      $num_tmp=RetornaNumComentariosTopico($sock,$cod_usuario,$linha['cod_topico'],$tipo_comp,$linha['data']);
      $num_f += $num_tmp['num_comentarios_formadores'];
      $num_a += $num_tmp['num_comentarios_alunos'];
      $num_u += $num_tmp['num_comentarios_usuario'];
      if ($data < $num_tmp['data_comentarios'])
        $data = $num_tmp['data_comentarios'];
    }
  }
 
  /* checa o nivel atual */

  $query="select Pic.cod_comentarista 'cod', U.tipo_usuario 'tu', count(*) 'ct', max(Pic.data) 'dt' from Usuario U, Portfolio_itens_comentarios Pic, Portfolio_itens Pi where Pic.cod_comentarista=U.cod_usuario and Pic.cod_item=Pi.cod_item and Pi.cod_topico=".$cod_topico." and Pic.status='A'";
  if ($tipo_comp=="T")
    $query.=" and Pi.tipo_compartilhamento='T'";
  if ($tipo_comp=="F")
    $query.=" and (Pi.tipo_compartilhamento='T' or Pi.tipo_compartilhamento='F')";
  $query.=" group by Pic.cod_comentarista order by Pic.cod_comentarista";

  $res=Enviar($sock,$query);

  while ($linha=RetornaLinha($res))
  {
    if ($linha['cod']==$cod_usuario)
      $num_u+=$linha['ct'];
    else if ($linha['tu']=="F")
      $num_f+=$linha['ct'];
    else
      $num_a+=$linha['ct'];
    if ($data<$linha['dt'])
      $data=$linha['dt'];
  }
  $saida['num_comentarios']=$num_f+$num_a+$num_u;
  $saida['num_comentarios_formadores']=$num_f;
  $saida['num_comentarios_alunos']=$num_a;
  $saida['num_comentarios_usuario']=$num_u;
  $saida['data_comentarios']=$data;
  return $saida;
}

/* *********************************************************************
   RetornaMaiorDataItemComentario - Retorna a maior data de item ou comentrio
                                    dentro de um tpico ou subtpico
   Entrada: $sock - Conexo com a base interna
            $cod_topico - codigo do topico a ser checado
            $tipo_comp - tipo do compartilhamento (F ou T)
            $data - Data do tpico
            $cod_usuario - usuario logado
   Saida: maior data 
*/
function RetornaMaiorDataItemComentario($sock,$cod_topico,$tipo_comp,$data,$cod_usuario)
{
  $query="select cod_usuario,cod_grupo from Portfolio_topicos where cod_topico=".$cod_topico;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  $cod_usuario_portfolio=$linha['cod_usuario'];
  $cod_grupo_portfolio=$linha['cod_grupo'];

  if ($cod_grupo_portfolio=="" && $cod_usuario==$cod_usuario_portfolio)
    $tipo_comp="P";
  else 
    if (PertenceAoGrupo($sock,$cod_usuario,$cod_grupo_portfolio))
      $tipo_comp="P";

  $query="select cod_topico,data from Portfolio_topicos where cod_topico_pai=".$cod_topico;
  if ($tipo_comp=="T")
    $query.=" and tipo_compartilhamento='T'";
  if ($tipo_comp=="F")
    $query.=" and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";

  $res=Enviar($sock,$query);
  $lista_topicos=RetornaArrayLinhas($res);

  /* Verifica se existem subtpicos */
  if (count($lista_topicos)>0)
  {
    foreach($lista_topicos as $cod=>$linha)
    {
      $data_tmp=RetornaMaiorDataItemComentario($sock,$linha['cod_topico'],$tipo_comp,$linha['data'],$cod_usuario);
      if ($data_tmp>$data)
        $data=$data_tmp;
    }
  }

  $query="select max(Pi.data) 'PiData', max(Pic.data) 'PicData' from Portfolio_itens Pi, Portfolio_itens_comentarios Pic where Pi.cod_topico=".$cod_topico." and Pi.cod_item=Pic.cod_item";
  if ($tipo_comp=="T")
    $query.=" and Pi.tipo_compartilhamento='T'";
  if ($tipo_comp=="F")
    $query.=" and (Pi.tipo_compartilhamento='T' or Pi.tipo_compartilhamento='F')";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  if ($linha['PiData']>$data)
    $data=$linha['PiData'];
  if ($linha['PicData']>$data)
    $data=$linha['PicData'];


  $query="select max(Pi.data) 'PiData' from Portfolio_itens Pi where Pi.cod_topico=".$cod_topico;
  if ($tipo_comp=="T")
    $query.=" and Pi.tipo_compartilhamento='T'";
  if ($tipo_comp=="F")
    $query.=" and (Pi.tipo_compartilhamento='T' or Pi.tipo_compartilhamento='F')";
  $res=Enviar($sock,$query);

  $linha=RetornaLinha($res);
  if ($linha['PiData']>$data)
    $data=$linha['PiData'];

  return $data;
}

/* *********************************************************************
   ArrumaPosicoesItens - rearranja as posicoes dos itens em um topico qdo um item  movido
   entrada: $sock - sock de conexao
            $cod_topico - codigo do topico no qual arrumar as posicoes dos itens
   saida: nenhuma
*/
function ArrumaPosicoesItens($sock, $cod_topico)
{
  // descobrindo quem eh o primeiro item no topico
  $query = "select cod_item from Portfolio_itens where cod_topico=".$cod_topico." order by posicao_item limit 1";
  $res = Enviar($sock, $query);
  $primeiro_item = RetornaLinha($res);

  // movemos o primeiro item para a primeira posicao. A funcao MudarPosicaoItem arruma as posicoes
  MudarPosicaoItem($sock, $cod_topico, $primeiro_item['cod_item'], 1);
}

/* *********************************************************************
   ArrumaPosicoesTopicos - rearranja as posicoes dos topicos qdo um topico eh movido
   entrada: $sock - sock de conexao
            $cod_topico - codigo do topico no qual promover o rearranjo
   saida: nenhuma
*/
function ArrumaPosicoesTopicos($sock, $cod_topico)
{
  // descobrindo quem eh o primeiro topico dentro do topico
  $query = "select cod_topico from Portfolio_topicos where cod_topico_pai=".$cod_topico." order by posicao_topico limit 1";
  $res = Enviar ($sock, $query);
  $primeiro_topico = RetornaLinha($res);

  // movemos o primeiro topico para a primeira posicao
  MudarPosicaoTopico ($sock, $cod_topico, $primeiro_topico['cod_topico'], 1);
}

/* *********************************************************************
   TituloPagina - Retorna string com o subtitulo da pagina: portfolio individual ou de grupo0
   entrada:   $acao_portfolio_s - Indica se portfolio individual ou de grupo
   saida:     string com o subtitulo da pagina
*/
function TituloPagina ($acao_portfolio_s)
{
  global $lista_frases;

  if ($acao_portfolio_s == 'I')
    // 74 - Portfolios individuais
    return RetornaFraseDaLista ($lista_frases, 74);
  else if ($acao_portfolio_s == 'G')
    // 75 - Portfolios de grupos
    return RetornaFraseDaLista ($lista_frases, 75);
  else
   return "<big><font color=red>Funcao Titulo Pagina: Erro</font></big>";
}

/* *********************************************************************
   RetornaNumItensTopicoRec - Retorna numero de itens dentro de um topico e mergulhando
   entrada: $sock           - sock de conexao com a base
            $cod_topico     - codigo do topico a mergulhar contando itens
            $dono_portfolio - boolean, se o usuario logade eh dono do portfolio
            $eformador      - boolean, se o cara visitando eh formador
   saida:   numero de itens dentro do topico
   OBS:     A funcao calcula a regra de compartilhamento e chama sua auxiliar recursiva,
            para nao ter de calcular esta regra a cada chamada.
*/
function RetornaNumItensTopicoRec ($sock, $cod_topico, $dono_portfolio, $eformador)
{
  // Quando se fala de numero de itens, esta se falando de numero de itens visiveis ao usuario logado
  if (! $dono_portfolio)
  {
    if ($eformador)
      $regra_compartilhamento = " and (tipo_compartilhamento='T' or tipo_compartilhamento='F')";
    else
      $regra_compartilhamento = " and tipo_compartilhamento='T'";
  }
  else // - se for dono do portfolio, ignorar regras de compartilhamento, mostrar tudo
  {
    $regra_compartilhamento = "";
  }

  return RetornaNumItensTopicoRecAux ($sock, $cod_topico, $regra_compartilhamento);
}

/* *********************************************************************
   RetornaNumItensTopicoRecAux - auxiliar, retorna numero de itens
       dentro de um topico, e mergulhando nos niveis
   entrada: $sock           - conexao com a base de dados
            $cod_topico     - codigo do topico inicial
   saida:   numero de itens no topico pedido
*/
function RetornaNumItensTopicoRecAux($sock, $cod_topico, $regra_compartilhamento)
{
  // Numero de itens dentro de um topico eh o numero de itens dentro daquele topico mais o numero de itens em cada topico filho deste
  
  // Numero de itens dentro do topico pai
  $query = "select count(cod_item) 'num_itens' from Portfolio_itens where cod_topico = ".$cod_topico.$regra_compartilhamento;
  $res   = Enviar ($sock, $query);
  $linha = RetornaLinha ($res);
  $num_itens = $linha ['num_itens'];
  
  // Numero de itens dentro de cada topico filho
  $query = "select cod_topico from Portfolio_topicos where cod_topico_pai = ".$cod_topico;
  $res   = Enviar ($sock, $query);
  $lista = RetornaArrayLinhas ($res);
  if (is_array ($lista))
    foreach ($lista as $c => $linha)
    {
      $num_itens += RetornaNumItensTopicoRecAux ($sock, $linha ['cod_topico'], $regra_compartilhamento);
    }
    
  return $num_itens;
}

/* *********************************************************************
   RetornaStatusPortfolio - retorna informacoes sobre o portfolio e como
                            o usuario interage com ele
   entrada:   $sock                     - sock de conexao
              $cod_curso                - codigo do curso
              $cod_usuario              - codigo do usuario logado
              $cod_usuario_portfolio    - codigo do usuario dono do portfolio
              $cod_grupo                - codigo do grupo dono do portfolio

   saida:     array com 3 booleanos:
              ['portfolio_grupo']   - se o portfolio eh de grupo
              ['portfolio_apagado'] - se o portfolio estah apagado (grupo apagadoou aluno rejeitado)
              ['dono_portfolio']    - se o usuario tem privilegios de dono do portfolio
   obs:
   - se o portfolio eh apagado, ninguem tem os privilegios de dono
   - se for um formador com visao de aluno, ele tb nao tem estes priviliegios
   - em cursos terminados, ninguem tem privilegio de dono, apenas formadores para seus portfolio
*/
function RetornaStatusPortfolio ($sock, $cod_curso, $cod_usuario, $cod_usuario_portfolio, $cod_grupo)
{
  unset ($retorno);
  $portfolio_grupo = ($cod_grupo !="" && $cod_grupo != "NULL");

  if ($portfolio_grupo)
  {
    $portfolio_apagado = ( StatusGrupo ($sock, $cod_grupo) == 'X' );
    $dono_portfolio    = PertenceAoGrupo($sock, $cod_usuario, $cod_grupo);
  }
  else
  {
    $portfolio_apagado = ( RetornaStatusUsuario($sock, $cod_curso, $cod_usuario_portfolio) == 'r' );
    $dono_portfolio    = ( $cod_usuario == $cod_usuario_portfolio );
  }

  $dono_portfolio &= ( !$portfolio_apagado && !EFormadorComVisaoDeAluno($sock, $cod_curso, $cod_usuario) );
  
  /* Verifica o trmino do curso */
  $status_curso=RetornaStatusCurso($sock,$cod_curso);

  if ($status_curso=='E' && !EFormador($sock, $cod_curso, $cod_usuario) )
    $dono_portfolio=false;

  $retorno ['portfolio_grupo']   = $portfolio_grupo;
  $retorno ['portfolio_apagado'] = $portfolio_apagado;
  $retorno ['dono_portfolio']    = $dono_portfolio;

  /*  
    echo ("Em RetornaStatusPortfolio, entrada = <br>");
    echo ("sock = ".$sock."<br>");
    echo ("cod_curso = ".$cod_curso."<br>");
    echo ("cod_usuario = ".$cod_usuario."<br>");
    echo ("cod_usuario_portfolio = ".$cod_usuario_portfolio."<br>");
    echo ("cod_grupo = ".$cod_grupo."<br>");
    
    echo ("Em RetornaStatusPortfolio, array = <font color=red>".print_array ($retorno)."</font>");
  */
  
  return $retorno;
}

/* *********************************************************************
   TituloComDistincao - retorna subtitulo da pagina, fazendo distincao entre
                        portfolios individuais ou de grupos
   entrada:  $acao_portfolio_s    - indica se 'I' - portfolios individuais
                                              'G' - portfolios de grupos
             $ferramenta_grupos_s - bool, indica se ferramenta grupos esta ativada
                                    se nao estiver, nao faz a distincao
             $frase           - frase do subtitulo
   saida  :  frase para o subtitulo da pagina
*/
function TituloComDistincao ($acao_portfolio_s, $ferramenta_grupos_s, $frase)
{
  global $lista_frases;

  if (! $ferramenta_grupos_s)
  {
    $retorno = $frase;
  }
  else
  {
    if ($acao_portfolio_s == 'I')
    {
      // 2 - Portflios Individuais
      $retorno = RetornaFraseDaLista ($lista_frases, 2)." / ".$frase;
    }
    else
    {
      // 3 - Portfolios de grupo
      $retorno = RetornaFraseDaLista ($lista_frases, 3)." / ".$frase;
    }
  }
  //  echo ("Em TituloComDistincao: acao = ".$acao_portfolio_s.", ferr = ".$ferramenta_grupos_s.", frase = ".$frase."<br>");
  return $retorno;
}

/* *********************************************************************
   StatusFerramentaGrupos - retorna se a ferramenta Grupos esta ativada

   PROVISORIO !!! - O LUGAR DESTA FUNCAO NAO EH AQUI

   entrada: nenhuma
   saida  : true  - ferramenta grupos estah ativada
            false - ferramenta grupos nao estah ativa
*/
function StatusFerramentaGrupos ($sock)
{
  $query = "select status from Curso_ferramentas where cod_ferramenta=12";
  $res   = Enviar ($sock, $query);
  $linha = RetornaLinha ($res);
  return ( $linha ['status'] == 'A' );
}

/* *********************************************************************
   Alertar - funcao para debugar, faz um alert JavaScript 
   entrada: $string - string a alertar na tela
   saida:   nenhuma
*/
function Alertar ($string)
{
  echo ("<script language=JavaScript>\n");
  echo ("  alert (".$string.");");
  echo ("</script>\n");
}

/* *********************************************************************
   print_array - funcao para debugar, imprime o array
   entrada: $array - array do qual imprimir conteudo
            $level - nivel de aninhamento de array dentro de array. 
                     Primeira chamada sempre 0 (zero);
   saida:   nenhuma
*/
function print_array($array)
{
  print_array_aux($array,0);
}

function print_array_aux($array,$level)
{
  if (!is_array($array))
    return 0;

  reset($array);
  while ( list($key, $value) = each($array) ) 
  { 
    for ($i = 0; $i < $level; ++$i)
    {
      echo "&nbsp;&nbsp;&nbsp;";
    }
    echo "['".$key."'] ".$value."<br>";
    if (is_array($value))
      print_array_aux($value,$level+1);
  }
}

?>
