<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : cursos/aplic/portfolio/portfolio.php

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : cursos/aplic/portfolio/portfolio.php
  ========================================================== */

  $bibliotecas="../bibliotecas/";
  include($bibliotecas."geral.inc");
  include("portfolio.inc");

  /* Necessrio para a lixeira. */
  session_register("cod_topico_s");
  unset($cod_topico_s);

  $cod_usuario=VerificaAutenticacao($cod_curso);

  $sock=Conectar("");

  $lista_frases=RetornaListaDeFrases($sock,15);
  $lista_frases_geral=RetornaListaDeFrases($sock,-1);

  $diretorio_arquivos=RetornaDiretorio($sock,'Arquivos');
  $diretorio_temp=RetornaDiretorio($sock,'ArquivosWeb');

  Desconectar($sock);

  $sock=Conectar($cod_curso);

  VerificaAcessoAoCurso($sock,$cod_curso,$cod_usuario);

  MarcaAcesso($sock,$cod_usuario,15);

  $eformador=EFormador($sock,$cod_curso,$cod_usuario);

  echo("<html>\n");
  /* 1 - Portflio */

  echo("  <head><title>TelEduc - ".RetornaFraseDaLista($lista_frases,1)."</title></head>\n");
  echo("  <link rel=stylesheet TYPE=text/css href=../teleduc.css>\n");
  echo("  <link rel=stylesheet TYPE=text/css href=portfolio.css>\n");

  /* Apaga links simbolicos que por acaso tenham sobrado daquele usuario */
  system ("rm ../../diretorio/portfolio_".$cod_curso."_*_".$cod_usuario);

  $data_acesso=PenultimoAcesso($sock,$cod_usuario,"");

  $cod_topico_raiz_usuario=RetornaPastaRaizUsuario($sock,$cod_usuario,"");

  if (!isset($cod_topico_raiz))
  {
    if ($cod_grupo_portfolio!="" && $cod_grupo_portfolio!="NULL")
      $cod_topico_raiz=RetornaPastaRaizUsuario($sock,$cod_usuario,$cod_grupo_portfolio);
    else if ($cod_usuario_portfolio!="")
      $cod_topico_raiz=RetornaPastaRaizUsuario($sock,$cod_usuario_portfolio,"");
    else
    {
      $cod_topico_raiz=$cod_topico_raiz_usuario;
      $cod_usuario_portfolio=$cod_usuario;

      /* Checagem da existncia das pastas dos grupos a que o usurio pertence */
      VerificaPortfolioGrupos($sock,$cod_usuario);
    }
  }

  if (isset ($cod_ferramenta))  // primeira vez que o cara entra no portfolio
  {
    // esta variavel de sessao determina se examinamos portfolios individuais ou de grupo.
    // por default, na primeira vez que o cara entra, colocamos como individual
    session_register ("acao_portfolio_s");
    $acao_portfolio_s = 'I';

    // esta variavel determina se a ferramenta grupos esta ativada ou nao
    session_register ("ferramenta_grupos_s");
    $ferramenta_grupos_s = StatusFerramentaGrupos ($sock);

    // redirecionamos o cara para a pagina ver_portfolios.php
    echo("<script language=JavaScript>\n");
    echo("  document.location='ver_portfolios.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&exibir=ind';\n");
    echo("</script>\n");
  }

  if ($cod_topico_raiz=="NULL") /* Visitante */
  {
    echo("<script language=javascript>\n");
    echo("  document.location='ver_portfolios.php?".RetornaSessionID()."&cod_curso=".$cod_curso."';");
    echo("</script>\n");
    exit;
  }

  $status_portfolio = RetornaStatusPortfolio ($sock, $cod_curso, $cod_usuario, $cod_usuario_portfolio, $cod_grupo_portfolio);

  $dono_portfolio    = $status_portfolio ['dono_portfolio'];
  $portfolio_apagado = $status_portfolio ['portfolio_apagado'];
  $portfolio_grupo   = $status_portfolio ['portfolio_grupo'];

  /* Tem que arrumar daqui para a frente */

  if ($acao=="moveritem" && $dono_portfolio)
  {
    MoverItem($sock, $cod_item, $cod_usuario, $cod_topico_raiz);
    // adicionei esta funcao para corrigir o bug de posicao dos itens ao mover um item
    ArrumaPosicoesItens($sock, $cod_topico_ant);
    echo("<script language=javascript>\n");
    // adicionei cod_topico_ant como parametro
    echo("  document.location='portfolio.php?".RetornaSessionID()."&cod_topico_ant=".$cod_topico_raiz."&cod_curso=".$cod_curso."&cod_topico_raiz=".$cod_topico_raiz."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."';\n");
    echo("</script>\n");
  }

  if ($acao=="movertopico" && $dono_portfolio)
  {
    echo("<script language=javascript>\n");
    if (MoverTopico($sock, $cod_topico, $cod_usuario, $cod_topico_raiz))
    {
      // adicionei esta funcao para corrigir o bug de posicao dos itens ao mover um item
      ArrumaPosicoesTopicos($sock, $cod_topico_ant);
      echo("  document.location='portfolio.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico_raiz=".$cod_topico_raiz."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."';\n");
    }
    else
    {
      /* 28 - Voc no pode mover uma pasta para ela mesma ou para uma subpasta dela. */
      echo("  alert('".RetornaFraseDaLista($lista_frases,28)."');\n");
      echo("  history.go(-1);\n");
    }
    echo("</script>\n");
  }

  if ($acao=="novotopico" && $dono_portfolio)
  {
      $cod_topico=CriarTopico($sock, $cod_topico_raiz, $novo_nome, $cod_usuario,$cod_grupo_portfolio);
  }

  if ($acao=="renomeartop" && $dono_portfolio)
  {
      RenomearTopico($sock, $cod_topico, $novo_nome);
  }

  if ($acao=="mudarcomp" && $dono_portfolio)
  {
      MudarCompartilhamento($sock, $cod_item, $tipo_comp);
  }

  if ($acao=="mudarposicao" && $dono_portfolio)
  {
    if ($cod_item=="")
    {
      if ($cod_topico!="")
      {
        MudarPosicaoTopico($sock, $cod_topico_raiz, $cod_topico, $posicao);
      }
    }
    else
    {
      if ($cod_topico=="")
      {
        MudarPosicaoItem($sock, $cod_topico_raiz, $cod_item, $posicao);
      }
    }
  }

  if ($acao=="apagaritem" && $dono_portfolio)
  {
    ApagarItem($sock, $cod_item, $cod_usuario);
  }

  if ($acao=="apagartopico" && $dono_portfolio)
  {
    ApagarTopico($sock, $cod_topico, $cod_usuario);
  }

  /* Funes JavaScript */
  echo("<script language=JavaScript src=../bibliotecas/dhtmllib.js></script>\n");
  echo("<script language=JavaScript>\n");
  echo("var isNav = (navigator.appName.indexOf(\"Netscape\") !=-1);\n");
  echo("var isIE = (navigator.appName.indexOf(\"Microsoft\") !=-1);\n");
  echo("var Xpos, Ypos;\n");
  echo("var js_cod_item, js_cod_topico;\n");
  echo("var js_nome_topico;\n");
  echo("var js_tipo_item;\n");
  echo("var js_comp = new Array();\n");

  echo("if (isNav)\n");
  echo("{\n");

  echo("  document.captureEvents(Event.MOUSEMOVE);\n");
  echo("}\n");
  echo("document.onmousemove = TrataMouse;\n");

  echo("function TrataMouse(e)\n");
  echo("{\n");
  echo("  Ypos = (isMinNS4) ? e.pageY : event.clientY;\n");
  echo("  Xpos = (isMinNS4) ? e.pageX : event.clientX;\n");
  echo("}\n");

  echo("function getPageScrollY()\n");
  echo("{\n");
  echo("  if (isNav)\n");
  echo("    return(window.pageYOffset);\n");
  echo("  if (isIE)\n");
  echo("    return(document.body.scrollTop);\n");
  echo("}\n");

  echo("function AjustePosMenuIE()\n");
  echo("{\n");
  echo("  if (isIE)\n");
  echo("    return(getPageScrollY());\n");
  echo("  else\n");
  echo("    return(0);\n");
  echo("}\n");

  echo("function Iniciar()\n");
  echo("{\n");
  echo("  cod_menu = getLayer(\"menu\");\n");
  echo("  cod_comp = getLayer(\"comp\");\n");
  echo("  cod_menu_top = getLayer(\"menutop\");\n");
  echo("  cod_ren_top = getLayer(\"renomeartop\");\n");
  echo("  cod_novo_top = getLayer(\"novotop\");\n");
  echo("  cod_mover = getLayer(\"mover\");\n");
  echo("  cod_topicos = getLayer(\"topicos\");\n");
  echo("  cod_mudar_pos = getLayer(\"mudarpos\");\n");
  echo("}\n");
  echo("\n");

  echo("function EscondeLayers()\n");
  echo("{\n");
  echo("  hideLayer(cod_menu);\n");
  echo("  hideLayer(cod_comp);\n");
  echo("  hideLayer(cod_menu_top);\n");
  echo("  hideLayer(cod_ren_top);\n");
  echo("  hideLayer(cod_novo_top);\n");
  echo("  hideLayer(cod_mover);\n");
  echo("  hideLayer(cod_topicos);\n");
  echo("  hideLayer(cod_mudar_pos);\n");
  echo("}\n");

  echo("function MostraLayerTopico(cod_layer, ajuste)\n");
  echo("{\n");
  echo("  EscondeLayers();\n");
  echo("  if (isNav) {\n");
  echo("    document.renomeartop.document.form_renomear_top.novo_nome.value=js_nome_topico;\n");
  echo("    document.renomeartop.document.form_renomear_top.cod_topico.value=js_cod_topico;\n");
//  echo("    document.renomeartop.document.form_renomear_top.novo_nome.focus();\n");
  echo("  } else {\n");
  echo("    if (isIE) {\n");
  echo("      document.form_renomear_top.novo_nome.value=js_nome_topico;\n");
  echo("      document.form_renomear_top.cod_topico.value=js_cod_topico;\n");
//  echo("      document.form_renomear_top.novo_nome.select();\n");
  echo("    }\n");
  echo("  }\n");
  echo("  moveLayerTo(cod_layer,Xpos-ajuste,Ypos+AjustePosMenuIE());\n");
  echo("  showLayer(cod_layer);\n");
//  echo("  if (isIE) \n");
//  echo("    document.form_renomear_top.novo_nome.focus();\n");
  echo("}\n");

  echo("function testa_titulo_criar(form)\n");
  echo("{\n");
  echo("  return (PossoRenomear(form));\n");
  echo("}\n");

  echo("function PossoRenomear(form) {\n");
  echo("  nome=form.novo_nome.value;\n");
  echo("  if (nome==js_nome_topico) {\n");
  /* 29 - Nenhuma alteracao foi efetuada. */
  echo("    alert('".RetornaFraseDaLista($lista_frases,29)."');\n");
  echo("    hideLayer(cod_ren);\n");
  echo("    return(false);\n");
  echo("  } else {\n");
  echo("// se nome for vazio, nao pode\n");

  echo("      while (nome.search(\" \") != -1)\n");
  echo("      {\n");
  echo("        nome = nome.replace(/ /, \"\");\n");
  echo("      }\n");

  echo("    if (nome==\"\") {\n");
  /* 36 - O titulo nao pode ser vazio. */
  echo("      alert('".RetornaFraseDaLista($lista_frases,36)."');\n");
  echo("      return(false);\n");
  echo("    } else {\n");
  echo("// se nome tiver aspas, <, >, nao pode\n");
  echo("      if (nome.indexOf(\"\\\\\")>=0 || nome.indexOf(\"\\\"\")>=0 || nome.indexOf(\"'\")>=0 || nome.indexOf(\">\")>=0 || nome.indexOf(\"<\")>=0) {\n");
  /* 117 - O titulo do item a ser renomeado nao pode conter \\\", \\\', < ou >. */
  echo("        alert('".ConverteAspas2BarraAspas(ConverteHtml2Aspas(RetornaFraseDaLista($lista_frases,117)))."');\n");
  echo("        return(false);\n");
  echo("      } else {\n");
  echo("        return(true);\n");
  echo("      }\n");
  echo("    }\n");


  echo("  }\n");
  echo("}\n");

  echo("function AtualizaComp(js_tipo_comp)\n");
  echo("{\n");
  echo("  if (isNav) {\n");
  echo("    document.comp.document.form_comp.tipo_comp.value=js_tipo_comp;\n");
  echo("    document.comp.document.form_comp.cod_item.value=js_cod_item;\n");
  echo("    if (js_tipo_comp=='T') {\n");
  echo("      document.comp.document.form_comp.tipo_comp[0].checked=true;\n");
  echo("      document.comp.document.form_comp.tipo_comp[1].checked=false;\n");
  echo("      document.comp.document.form_comp.tipo_comp[2].checked=false;\n");
  echo("    } else if (js_tipo_comp=='F') {\n");
  echo("      document.comp.document.form_comp.tipo_comp[0].checked=false;\n");
  echo("      document.comp.document.form_comp.tipo_comp[1].checked=true;\n");
  echo("      document.comp.document.form_comp.tipo_comp[2].checked=false;\n");
  echo("    } else {\n");
  echo("      document.comp.document.form_comp.tipo_comp[0].checked=false;\n");
  echo("      document.comp.document.form_comp.tipo_comp[1].checked=false;\n");
  echo("      document.comp.document.form_comp.tipo_comp[2].checked=true;\n");
  echo("    }\n");
  echo("  } else {\n");
  echo("    if (isIE) {\n");
  echo("      document.form_comp.tipo_comp.value=js_tipo_comp;\n");
  echo("      document.form_comp.cod_item.value=js_cod_item;\n");
  echo("      if (js_tipo_comp=='T') {\n");
  echo("        document.form_comp.tipo_comp[0].checked=true;\n");
  echo("        document.form_comp.tipo_comp[1].checked=false;\n");
  echo("        document.form_comp.tipo_comp[2].checked=false;\n");
  echo("      } else if (js_tipo_comp=='F') {\n");
  echo("        document.form_comp.tipo_comp[0].checked=false;\n");
  echo("        document.form_comp.tipo_comp[1].checked=true;\n");
  echo("        document.form_comp.tipo_comp[2].checked=false;\n");
  echo("      } else {\n");
  echo("        document.form_comp.tipo_comp[0].checked=false;\n");
  echo("        document.form_comp.tipo_comp[1].checked=false;\n");
  echo("        document.form_comp.tipo_comp[2].checked=true;\n");
  echo("      }\n");
  echo("    }\n");
  echo("  }\n");
  echo("}\n");

  echo("function MostraLayer(cod_layer, ajuste)\n");
  echo("{\n");
  echo("  EscondeLayers();\n");
  echo("  moveLayerTo(cod_layer,Xpos-ajuste,Ypos+AjustePosMenuIE());\n");
  echo("  showLayer(cod_layer);\n");
  echo("}\n");

  echo("function EscondeLayer(cod_layer)\n");
  echo("{\n");
  echo("  hideLayer(cod_layer);\n");
  echo("}\n");

  echo("function AtualizaCamposPosicao(tipo)\n");
  echo("{\n");
  echo("  if (tipo=='item')\n");
  echo("  {\n");
  echo("    if (isNav) {\n");
  echo("      document.mudarpos.document.form_posicao.cod_item.value=js_cod_item;\n");
  echo("      document.mudarpos.document.form_posicao.cod_topico.value='';\n");
  echo("    } else {\n");
  echo("      if (isIE) {\n");
  echo("        document.form_posicao.cod_item.value=js_cod_item;\n");
  echo("        document.form_posicao.cod_topico.value='';\n");
  echo("      }\n");
  echo("    }\n");
  echo("  }\n");
  echo("  else\n");
  echo("  {\n");
  echo("    if (tipo=='topico')\n");
  echo("    {\n");
  echo("      if (isNav) {\n");
  echo("        document.mudarpos.document.form_posicao.cod_topico.value=js_cod_topico;\n");
  echo("        document.mudarpos.document.form_posicao.cod_item.value='';\n");
  echo("      } else {\n");
  echo("        if (isIE) {\n");
  echo("          document.form_posicao.cod_topico.value=js_cod_topico;\n");
  echo("          document.form_posicao.cod_item.value='';\n");
  echo("        }\n");
  echo("      }\n");
  echo("    }\n");
  echo("  }\n");
  echo("}\n");

  echo("function TemCertezaApagar()\n");
  echo("{\n");
  /* 18 - Voc tem certeza de que deseja apagar este item? */
  /* 19 - (O item ser movida para a lixeira) */
  echo("  return(confirm('".RetornaFraseDaLista($lista_frases,18)."\\n".RetornaFraseDaLista($lista_frases,19)."'));\n");
  echo("}\n");

  echo("function TemCertezaApagarTop(tmp_cod_topico)\n");
  echo("{\n");
  /* 20 - Voc tem certeza de que deseja apagar esta pasta? */
  /* 21 - (Todos os materiais contidos nessa pasta sero movidos para a lixeira) */
  echo("   if (confirm('".RetornaFraseDaLista($lista_frases,20)."\\n".RetornaFraseDaLista($lista_frases,21)."'))\n");
  echo("     document.location='portfolio.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&acao=apagartopico&cod_topico='+tmp_cod_topico+'&cod_topico_raiz=".$cod_topico_raiz."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."';\n");
  echo("   return false;\n");
  echo("}\n");

  echo("function MoverItem(link,cod_destino)\n");
  echo("{\n");
  echo("  if (js_tipo_item=='item')\n");
  echo("  {\n");
  // adicionei cod_topico_ant
  echo("    link.search='?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_item='+js_cod_item+'&cod_topico_raiz='+cod_destino+'&cod_topico_ant=".$cod_topico_raiz."&acao=moveritem&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."';\n");
  echo("    return true;\n");
  echo("  }\n");
  echo("  else\n");
  echo("  {\n");
  echo("    if (js_tipo_item=='topico')\n");
  echo("    {\n");
  // adicionei cod_topico_ant
  echo("      link.search='?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico='+js_cod_topico+'&cod_topico_raiz='+cod_destino+'&cod_topico_ant=".$cod_topico_raiz."&acao=movertopico&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."';\n");
  echo("      return true;\n");
  echo("    }\n");
  echo("    else\n");
  echo("    {\n");
  echo("      return false;\n");
  echo("    }\n");
  echo("  }\n");
  echo("}\n");

  echo("function nao_numerico(num)\n");
  echo("{\n");
  echo("  var erro=false;\n");
  echo("  var i=0;\n");
  echo("  var c='';\n");
  echo("  while (i<num.length && !erro) \n");
  echo("{\n");
  echo("    c=num.charAt(i);\n");
  echo("    if (c<'0' || c>'9') \n");
  echo("      { erro=true; } \n");
  echo("    i++;\n");
  echo("  }\n");
  echo("  return(erro);\n");
  echo("}\n");

  echo("function MudarPosicao(link) \n");
  echo("{\n");
  echo("  if (isNav)\n");
  echo("  {\n");
  echo("    posicao=document.mudarpos.document.form_posicao.posicao.value;\n");
  echo("  }\n");
  echo("  else \n");
  echo("  {\n");
  echo("    if (isIE) \n");
  echo("    {\n");
  echo("      posicao=document.form_posicao.posicao.value;\n");
  echo("    }\n");
  echo("  }\n");
  echo("  if (posicao=='') \n");
  echo("  {\n");
  /* 22 - Voc deve digitar um nmero! */
  echo("    alert('".RetornaFraseDaLista($lista_frases,22)."');\n");
  echo("    return(false);\n");
  echo("  }\n");
  echo("  else \n");
  echo("  {\n");
  echo("    if (nao_numerico(posicao)) \n");
  echo("    {\n");
  /* 23 - O valor deve ser um nmero! */
  echo("      alert('".RetornaFraseDaLista($lista_frases,23)."');\n");
  echo("      return(false);\n");
  echo("    }\n");
  echo("    else \n");
  echo("    {\n");
  echo("      return true;\n");
  echo("    }\n");
  echo("  }\n");

  echo("}\n");

  echo("function AbreJanelaComponentes(cod_grupo)\n");
  echo("{\n");
  echo("  window.open('integrantes.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_grupo='+cod_grupo,'Componentes','width=400,height=300,top=150,left=250,scrollbars=yes,status=yes,toolbar=no,menubar=no,resizable=yes');\n");
  echo("  return false;\n");
  echo("}\n");

  echo("function AbrePerfil(cod_usuario)\n");
  echo("{\n");
  echo("  window.open('../perfil/exibir_perfis.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_aluno[]='+cod_usuario,'PerfilDisplay','width=620,height=400,top=60,left=60,scrollbars=yes,status=yes,toolbar=no,menubar=no,resizable=no');\n");
  echo("  return(false);\n");
  echo("}\n");

  echo("function OpenWindowComentar(cod_item)\n");
  echo("{\n");
  echo("  EscondeLayers();\n");
  echo("  window.open('comentar.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_item='+cod_item+'&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."', 'Comentar', 'width=600,height=350,top=100,left=100,status=no,toolbar=no,menubar=no,resizable=yes');\n");
  echo("  return false;\n");
  echo("}\n");

  echo("</script>\n");

  echo("<body link=#0000ff vlink=#0000ff onLoad=\"Iniciar();\">\n");

  /* Pgina Principal */

  // 1 - Portflio
  $cabecalho = "<b class=titulo>".RetornaFraseDaLista ($lista_frases, 1)."</b>";

  if ($ferramenta_grupos_s && 'G' == $acao_portfolio_s)
    // 3 - Portfolios de grupos
    $cod_frase = 3;
  else
    // 2 - Portfolios individual
    $cod_frase = 2;

  $cabecalho .= "<b class=subtitulo> - ".RetornaFraseDaLista ($lista_frases, $cod_frase)."</b>";

  /* Cabecalho */
  echo(PreparaCabecalho($cod_curso,$cabecalho,15));

  $lista_topicos_ancestrais=RetornaTopicosAncestrais($sock, $cod_topico_raiz);
  unset($path);
  foreach ($lista_topicos_ancestrais as $cod => $linha)
  {
    if ($cod_topico_raiz!=$linha['cod_topico'])
    {
      $path="<a class=text href=\"portfolio.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico_raiz=".$linha['cod_topico']."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."\">".$linha['topico']."</a> &gt;&gt; ".$path;
    }
    else
    {
      $path="<b class=text>".$linha['topico']."</b><br>\n";
    }
  }

  if ($portfolio_grupo)
  {
    $nome=NomeGrupo($sock,$cod_grupo_portfolio);

    // Selecionando qual a figura a ser exibida ao lado do nome
    $fig_portfolio = "<img src=figuras/portfolio_g_".($dono_portfolio  ? "p" : ( $portfolio_apagado ? "x" : "n") ).".gif border=0>";

    if ( $grupo_apagado && $eformador)
      /* 84 - Grupo Excludo */
      $complemento=" <font class=textsmall>(".RetornaFraseDaLista($lista_frases,84).")</font>\n";

    echo("<a class=text href=# onClick=return(AbreJanelaComponentes(".$cod_grupo_portfolio."));>".$fig_portfolio." ".$nome."</a>".$complemento."<br>");
    echo("<a href=# onMouseDown=\"MostraLayer(cod_topicos,0);return(false);\"><img src=\"../figuras/estruturag.gif\" border=0></a>");
  }
  else
  {
    $nome=NomeUsuario($sock,$cod_usuario_portfolio);

    // Selecionando qual a figura a ser exibida ao lado do nome
    $fig_portfolio = "<img src=figuras/portfolio_i_".($dono_portfolio  ? "p" : ( $portfolio_apagado ? "x" : "n") ).".gif border=0>";
    if (RetornaStatusUsuario($sock,$cod_curso,$cod_usuario_portfolio)=="r" && $eformador)
      /* 85 - Aluno Rejeitado */
      $complemento=" <font class=textsmall>(".RetornaFraseDaLista($lista_frases,85).")</font>\n";
    echo("<a class=text href=# onClick=return(AbrePerfil(".$cod_usuario_portfolio.")); class=text>".$fig_portfolio." ".$nome."</a>".$complemento."<br>");
    echo("<a href=# onMouseDown=\"MostraLayer(cod_topicos,0);return(false);\"><img src=\"../figuras/estrutura.gif\" border=0></a>");
  }

  echo($path);
  echo("<p>\n");

  MontaMenu($cod_curso, $acao_portfolio_s);

  echo("<table border=0 width=100%>\n");
  echo("  <tr class=menu2>\n");

/*  
  // 69 - Atualizar
  echo("    <td align=center><a href=\"portfolio.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico_raiz=".$cod_topico_raiz."&time=".time()."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."\" class=menu2><b>".RetornaFraseDaLista($lista_frases,69)."</b></a></td>\n");
*/
  
  if ($dono_portfolio)
  {
    // 4 - Incluir Novo Item
    echo("    <td align=center><a href=\"criar_portfolio.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico=".$cod_topico_raiz."&origem=portfolio&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."\" class=menu2><b>".RetornaFraseDaLista($lista_frases,4)."</b></a></td>\n");
    // 5 - Nova Pasta
    echo("    <td align=center><a href=# onMouseDown=\"MostraLayer(cod_novo_top,150);return(false);\" class=menu2><b>".RetornaFraseDaLista($lista_frases,5)."</b></a></td>\n");
    // 6 - Estrutura de Pastas
    // echo("    <td align=center><a href=# onClick=\"MostraLayer(cod_topicos,0);return(false);\" class=menu2><b>".RetornaFraseDaLista($lista_frases,6)."</b></a></td>\n");
    // 7 - Lixeira
    echo("    <td align=center><a href=\"lixeira.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico=".$cod_topico_raiz."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."\" class=menu2><b>".RetornaFraseDaLista($lista_frases,7)."</b></a></td>\n");
  }
  echo("  </tr>\n");
  echo("</table>\n");

  echo("<br>\n");
  echo("<table border=0 width=100% cellspacing=0>\n");
  echo("  <tr>\n");
  echo("    <td width=1% class=colorfield>&nbsp;</td>\n");
  /* 82 - Itens */
  echo("    <td class=colorfield width=50%>".RetornaFraseDaLista($lista_frases,82)."</td>\n");
  /* 9 - Data */
  echo("    <td class=colorfield align=center width=15%>".RetornaFraseDaLista($lista_frases,9)."</td>\n");
  /* 119 - Compartilharmento */
  echo("    <td class=colorfield align=center width=24%>".RetornaFraseDaLista($lista_frases,119)."</td>\n");
  /* 112 - Comentrios */
  echo("    <td class=colorfield align=center width=10%>".RetornaFraseDaLista($lista_frases,112)."</td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("    <td colspan=5 height=5></td>\n");
  echo("  </tr>\n");

  $lista_topicos=RetornaTopicosDoTopico($sock, $cod_curso, $cod_topico_raiz,$cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio);
  $lista_itens=RetornaItensDoTopico($sock, $cod_curso, $cod_topico_raiz,$cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio);

  if (count($lista_topicos)<1 && count($lista_itens)<1)
  {
    echo("  <tr>\n");
    /* 11 - No h nenhum item neste portflio */
    echo("    <td colspan=5><font class=text>".RetornaFraseDaLista($lista_frases,11)."</font></td>\n");
    echo("  </tr>\n");
  }
  else
  {
    // definindo qual figura para representar pastas ou arquivos (itens)
    $pasta   = "pasta_";
    $arquivo = "arquivo_";
    
    // aqui, escolho entre a figura para grupo ou individual
    $gi      = ($portfolio_grupo ? "g_" : "i_");
    $pasta  .= $gi;
    $arquivo.= $gi;
    
    // aqui, escolho entre pessoal, nao-pessoal ou apagado
    $pnx = ($dono_portfolio  ? "p.gif" : ( $portfolio_apagado ? "x.gif" : "n.gif") );
    $pasta  .= $pnx;
    $arquivo.= $pnx;

    if (count($lista_topicos)>0)
    {
      foreach ($lista_topicos as $cod => $linha_topico)
      {
        $data="<font class=text>".UnixTime2Data($linha_topico['data'])."</font>";

        /*
        if ($linha_topico['tipo_compartilhamento']=="T")
        {
          // 12 - Totalmente Compartilhado 
          $compartilhamento="<font class=text>".RetornaFraseDaLista($lista_frases,12)."</font>";
        }
        else if ($linha_topico['tipo_compartilhamento']=="F")
        {
          // 13 - Compartilhado com Formadores 
          $compartilhamento="<font class=text>".RetornaFraseDaLista($lista_frases,13)."</font>";
        }
        else
        {
          if (!$portfolio_grupo)
            // 15 - No compartilhado 
            $compartilhamento="<font class=text>".RetornaFraseDaLista($lista_frases,15)."</font>";
          else
            // 14 - Compartilhado com o Grupo 
            $compartilhamento="<font class=text>".RetornaFraseDaLista($lista_frases,14)."</font>";
        }
        */

        if ($dono_portfolio)
          $max_data=RetornaMaiorData($sock,$linha_topico['cod_topico'],'P',$linha_topico['data']);
        else if ($eformador)
          $max_data=RetornaMaiorData($sock,$linha_topico['cod_topico'],'F',$linha_topico['data']);
        else
          $max_data=RetornaMaiorData($sock,$linha_topico['cod_topico'],'T',$linha_topico['data']);

        if ($dono_portfolio)
          $num_comentarios=RetornaNumComentariosTopico($sock,$cod_usuario,$linha_topico['cod_topico'],'P',$linha_topico['data']);
        else if ($eformador)
          $num_comentarios=RetornaNumComentariosTopico($sock,$cod_usuario,$linha_topico['cod_topico'],'F',$linha_topico['data']);
        else
          $num_comentarios=RetornaNumComentariosTopico($sock,$cod_usuario,$linha_topico['cod_topico'],'T',$linha_topico['data']);

        if ($data_acesso<$max_data)
        {
          $marcaib="<b>";
          $marcafb="</b>";
          $marcatr=" bgcolor=#F0F0F0";
        }
        else
        {
          $marcaib="";
          $marcafb="";
          $marcatr="";
        }
        echo("  <tr".$marcatr.">\n");
        echo("    <td width=1% align=center><a class=text href=\"portfolio.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico_raiz=".$linha_topico['cod_topico']."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."\"><img src=./figuras/".$pasta." border=0></a></td>\n");

        if ($dono_portfolio)
        {
          // echo("    <td>".$marcaib."<font class=text>".$linha_topico['posicao_topico']." - </font><a class=text href=# onMouseDown=\"js_cod_topico='".$linha_topico['cod_topico']."';js_nome_topico='".ConverteAspas2BarraAspas($linha_topico['topico'])."';MostraLayerTopico(cod_menu_top,0);return(false);\">".$linha_topico['topico']."</a>".$marcafb."</td>\n");
          $link_abre  = "<font class=text>".$linha_topico['posicao_topico']." - </font><a class=text href=# onMouseDown=\"js_cod_topico='".$linha_topico['cod_topico']."';js_nome_topico='".ConverteAspas2BarraAspas($linha_topico['topico'])."';MostraLayerTopico(cod_menu_top,0);return(false);\">";
          $link_fecha = "</a>";
        }
        else
        {
          // echo("    <td>".$marcaib."<a class=text href=\"portfolio.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico_raiz=".$linha_topico['cod_topico']."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."\">".$linha_topico['topico']."</a>".$marcafb."</td>\n");
          $link_abre  = "<a class=text href=\"portfolio.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico_raiz=".$linha_topico['cod_topico']."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."\">";
          $link_fecha = "</a>";
        }
        
        $num_itens = RetornaNumItensTopicoRec($sock, $linha_topico ['cod_topico'], $dono_portfolio, $eformador);
        $tag_abre  = "&nbsp;&nbsp;<i><font class=textsmall>(".$num_itens."&nbsp;";
        $tag_fecha = ")</font></i>";

        // 82 - Itens
        // 125 - Item
        // $itens     = ( $num_itens > 0 ? ( $num_itens == 1 ? $tag_abre.RetornaFraseDaLista ($lista_frases, 125).$tag_fecha : $tag_abre.RetornaFraseDaLista($lista_frases, 82).$tag_fecha ) : "");
        $frase = ($num_itens == 1 ? 125 : 82);
        $itens = ($num_itens > 0 ? $tag_abre.RetornaFraseDaLista ($lista_frases, $frase).$tag_fecha : "");
        
        echo("    <td>".$marcaib.$link_abre.$linha_topico['topico'].$link_fecha.$itens.$marcafb."</td>\n");
        echo("    <td align=center>".$marcaib.$data.$marcafb."</td>\n");
        echo("    <td align=center>".$marcaib."&nbsp;".$marcafb."</td>\n");
        echo("    <td align=center>");
          if ($num_comentarios['num_comentarios_alunos']>0)
            echo("<img src=../figuras/checked-a.gif border=0>");
          if ($num_comentarios['num_comentarios_formadores']>0)
            echo("<img src=../figuras/checked-f.gif border=0>");
          if ($num_comentarios['num_comentarios_usuario']>0)
            echo("<img src=../figuras/checked-d.gif border=0>");
          if ($num_comentarios['data_comentarios']>$data_acesso)
            echo("<img src=../figuras/asterisco.gif border=0>\n");
        echo("&nbsp;");
        echo("</td>\n");

        echo("  </tr>\n");
        echo("  <tr height=1><td colspan=5><hr size=1></td></tr>\n");
      }
    }
    if (count($lista_itens)>0)
    {
      foreach ($lista_itens as $cod => $linha_item)
      {
        $data="<font class=text>".UnixTime2Data($linha_item['data'])."</font>";
        if ($linha_item['tipo_compartilhamento']=="T")
        {
          /* 12 - Totalmente Compartilhado */
          $compartilhamento=RetornaFraseDaLista($lista_frases,12);
        }
        else if ($linha_item['tipo_compartilhamento']=="F")
        {
          /* 13 - Compartilhado com Formadores */
          $compartilhamento=RetornaFraseDaLista($lista_frases,13);
        }
        else
        {
          if (!$portfolio_grupo)
            /* 15 - No compartilhado */
            $compartilhamento="<font class=text>".RetornaFraseDaLista($lista_frases,15)."</font>";
          else
            /* 14 - Compartilhado com o Grupo */
            $compartilhamento="<font class=text>".RetornaFraseDaLista($lista_frases,14)."</font>";
        }
        if ($data_acesso<$linha_item['data'])
        {
          $marcaib="<b>";
          $marcafb="</b>";
          $marcatr=" bgcolor=#F0F0F0";
        }
        else
        {
          $marcaib="";
          $marcafb="";
          $marcatr="";
        }

        if ($linha_item['status']=="E")
        {
          $linha_historico=RetornaUltimaPosicaoHistorico($sock, $linha_item['cod_item']);
          if ($linha_item['inicio_edicao']<(time()-1800) || $cod_usuario==$linha_historico['cod_usuario'])
          {
            CancelaEdicao($sock, $linha_item['cod_item'], $cod_usuario, $cod_curso, $diretorio_arquivos, $diretorio_temp);
            if ($dono_portfolio)
            {
              $compartilhamento=$marcaib."<a class=text href=# onMouseDown=\"js_cod_item=".$linha_item['cod_item'].";AtualizaComp('".$linha_item['tipo_compartilhamento']."');MostraLayer(cod_comp,140);return(false);\">".$compartilhamento."</a>".$marcafb;
              $titulo=$marcaib."<font class=text>".$linha_item['posicao_item']." - </font><a class=text href=# onMouseDown=\"js_cod_item=".$linha_item['cod_item'].";MostraLayer(cod_menu,0);return(false);\">".$linha_item['titulo']."</a>".$marcafb;
            }
            else
            {
              $compartilhamento=$marcaib.$compartilhamento.$marcafb;
              $titulo=$marcaib."<a class=text href=# onMouseDown=\"js_cod_item=".$linha_item['cod_item'].";MostraLayer(cod_menu,0);return(false);\">".$linha_item['titulo']."</a>".$marcafb;
            }
            $icone="<a href=\"ver.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_item=".$linha_item['cod_item']."&cod_topico_raiz=".$cod_topico_raiz."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."\"><img src=./figuras/".$arquivo." border=0></a>";
          }
          else
          {
            /* 54 - Em Edio */
            $data="<a href=# class=text onClick=\"window.open('em_edicao.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_item=".$linha_item['cod_item']."&origem=portfolio&cod_topico_raiz=".$cod_topico_raiz."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."','EmEdicao','width=300,height=220,top=150,left=250,status=yes,toolbar=no,menubar=no,resizable=yes');\">".RetornaFraseDaLista($lista_frases_geral,54)."</a>";
            $compartilhamento="<font class=textgray>".$compartilhamento."</font>";
            $titulo="<font class=textgray>".$linha_item['titulo']."</font>";
            $icone="<img src=./figuras/".$arquivo." border=0>";
          }
        }
        else
        {
          if ($linha_item['status']!="C")
          {
            if ($dono_portfolio)
            {
              $compartilhamento=$marcaib."<a class=text href=# onMouseDown=\"js_cod_item=".$linha_item['cod_item'].";AtualizaComp('".$linha_item['tipo_compartilhamento']."');MostraLayer(cod_comp,140);return(false);\">".$compartilhamento."</a>".$marcafb;
              $titulo=$marcaib."<font class=text>".$linha_item['posicao_item']." - </font><a class=text href=# onMouseDown=\"js_cod_item=".$linha_item['cod_item'].";MostraLayer(cod_menu,0);return(false);\">".$linha_item['titulo']."</a>".$marcafb;              
            }
            else
            {
              $compartilhamento=$marcaib.$compartilhamento.$marcafb;
              $titulo=$marcaib."<a class=text href=# onMouseDown=\"js_cod_item=".$linha_item['cod_item'].";MostraLayer(cod_menu,0);return(false);\">".$linha_item['titulo']."</a>".$marcafb;
            }
            $icone="<a href=\"ver.php?".RetornaSessionID()."&cod_curso=$cod_curso&cod_item=".$linha_item['cod_item']."&cod_topico_raiz=".$cod_topico_raiz."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."\"><img src=./figuras/".$arquivo." border=0></a>";
          }
        }

        if ($linha_item['status']=="C")
        {
          if ($linha_item['inicio_edicao']<(time()-1800) || $cod_usuario==$linha_item['cod_usuario'])
          {
            CancelaEdicao($sock, $linha_item['cod_item'], $cod_usuario, $cod_curso, $diretorio_arquivos, $diretorio_temp);
          }
        }
        else
        {
          echo("  <tr".$marcatr.">\n");
          echo("    <td width=1% align=center>".$icone."</td>\n");
          echo("    <td><font class=text>".$titulo."</font></td>\n");
          echo("    <td align=center>".$marcaib.$data.$marcafb."</td>\n");
          echo("    <td align=center><font class=text>".$compartilhamento."</font></td>\n");

          echo("    <td align=center>");
          if ($linha_item['num_comentarios_alunos']>0)
            echo("<img src=../figuras/checked-a.gif border=0>");
          if ($linha_item['num_comentarios_formadores']>0)
            echo("<img src=../figuras/checked-f.gif border=0>");
          if ($linha_item['num_comentarios_usuario']>0)
            echo("<img src=../figuras/checked-d.gif border=0>");
          if ($linha_item['data_comentarios']>$data_acesso)
            echo("<img src=../figuras/asterisco.gif border=0>\n");
          echo("&nbsp;");
          echo("</td>\n");
          echo("  </tr>\n");
          echo("  <tr height=1><td colspan=5><hr size=1></td></tr>\n");
        }
      }
    }
  }
  echo("</table>\n");
  /* 113 - Comentrio de Aluno */
  /* 114 - Comentrio de Formador */
  /* 115 - Comentrio postados por mim */
  echo("<font class=text><img src=../figuras/checked-a.gif> ".RetornaFraseDaLista($lista_frases,113)."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n");
  echo("<img src=../figuras/checked-f.gif> ".RetornaFraseDaLista($lista_frases,114)."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n");
  if (!EVisitante($sock,$cod_curso,$cod_usuario))
    echo("<img src=../figuras/checked-d.gif> ".RetornaFraseDaLista($lista_frases,115)."\n");
  echo("</font>\n");

  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  echo("<br>&nbsp;\n");
  /* Layers */

  /* Menu */
  echo("<div id=menu class=block visibility=hidden onContextMenu=\"return(false);\">\n");
  echo("<table class=wtfield cellspacing=1 cellpadding=1 border=2>\n");
  echo("  <tr>\n");
  echo("    <td class=bgcolor align=right><a href=# onClick=\"EscondeLayer(cod_menu);return(false);\"><img src=../figuras/x.gif border=0 ></a></td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("      <td>\n");
  /* 21 - Ver (gen) */
  echo("        <a class=text href=ver.php onClick=\"this.search='?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico_raiz=".$cod_topico_raiz."&cod_item='+js_cod_item+'&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."'\">".RetornaFraseDaLista($lista_frases_geral,21)."</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>\n");

  if ($dono_portfolio)
  {
    /* 9 - Editar (gen) */
    echo("        <a class=text href=editar_portfolio.php onClick=\"this.search='?".RetornaSessionID()."&origem=portfolio&cod_curso=".$cod_curso."&cod_topico=".$cod_topico_raiz."&origem=portfolio&cod_item='+js_cod_item+'&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."'\">".RetornaFraseDaLista($lista_frases_geral,9)."</a><br>\n");
    /* 25 - Mover (gen) */
    echo("        <a class=text href=# onClick=\"js_tipo_item='item';MostraLayer(cod_mover,0);return(false);\">".RetornaFraseDaLista($lista_frases_geral,25)."</a><br>\n");
    /* 16 - Mudar Posio */
    echo("        <a class=text href=# onClick=\"AtualizaCamposPosicao('item');MostraLayer(cod_mudar_pos,0);return(false);\">".RetornaFraseDaLista($lista_frases,16)."</a><br>\n");
    /* 1 - Apagar (gen) */
    echo("        <a class=text href=portfolio.php onClick=\"this.search='?".RetornaSessionID()."&cod_curso=".$cod_curso."&acao=apagaritem&cod_item='+js_cod_item+'&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."';EscondeLayers();return(TemCertezaApagar());\">".RetornaFraseDaLista($lista_frases_geral,1)."</a><br>\n");
  }

  if (!EVisitante($sock,$cod_curso,$cod_usuario))
    if (!($status_curso=='E' && !$eformador))
      /* 3 - Comentar (gen) */
      echo("        <a class=text href=# OnClick=return(OpenWindowComentar(js_cod_item));>".RetornaFraseDaLista($lista_frases_geral,3)."</a><br>\n");

  echo("      </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("</div>\n");
  echo("\n");

  /* Menu Tpicos */
  echo("<div id=menutop class=block visibility=hidden onContextMenu=\"return(false);\">\n");
  echo("<table class=wtfield cellspacing=1 cellpadding=1 border=2>\n");
  echo("  <tr>\n");
  echo("    <td class=bgcolor align=right><a href=# onClick=EscondeLayer(cod_menu_top);return(false);><img src=../figuras/x.gif border=0 ></a></td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("    <td>\n");
  /* 34 - Abrir (gen) */
  echo("      <a class=text href=portfolio.php onClick=\"this.search='?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico_raiz='+js_cod_topico+'&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio."'\">".RetornaFraseDaLista($lista_frases_geral,34)."</a>&nbsp;&nbsp;&nbsp;&nbsp;<br>\n");
  if ($dono_portfolio)
  {
    /* 19 - Renomear (gen) */
    echo("      <a class=text href=# onClick=\"MostraLayerTopico(cod_ren_top,0,js_cod_topico,js_nome_topico);EscondeLayer(cod_menu_top);return(false);\">".RetornaFraseDaLista($lista_frases_geral,19)."</a><br>\n");
    /* 25 - Mover (gen) */
    echo("      <a class=text href=# onClick=\"js_tipo_item='topico';EscondeLayers();MostraLayer(cod_mover,0);return(false);\">".RetornaFraseDaLista($lista_frases_geral,25)."</a><br>\n");
    /* 16 - Mudar Posio */
    echo("        <a class=text href=# onClick=\"AtualizaCamposPosicao('topico');MostraLayer(cod_mudar_pos,0);return(false);\">".RetornaFraseDaLista($lista_frases,16)."</a><br>\n");
    /* 1 - Apagar (gen) */
    echo("      <a class=text href=# onClick=\"EscondeLayers();return(TemCertezaApagarTop(js_cod_topico));\">".RetornaFraseDaLista($lista_frases_geral,1)."</a><br>\n");
  }

  echo("    </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("</div>\n");

  /* Mover */
  echo("<div id=mover class=block visibility=hidden onContextMenu=\"return(false);\">\n");

  $lista_topicos=RetornaListaDeTopicos($sock,$cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio);

  if ($dono_portfolio)
  {
    echo("<table class=wtfield cellspacing=1 cellpadding=1 border=2>\n");
    echo("  <tr>\n");
    echo("    <td class=bgcolor align=right><a href=# onClick=\"EscondeLayer(cod_mover);return(false);\"><img src=../figuras/x.gif border=0></a></td>\n");
    echo("  </tr>\n");
    echo("  <tr>\n");
    echo("    <td>\n");
    echo("      <font class=text>\n");
    /* 17 - Escolha a pasta destino: */
    echo("".RetornaFraseDaLista($lista_frases,17)."<br>\n");
    echo("      </font>\n");
    /*
    $lista_topicos=RetornaListaDeTopicos($sock,$cod_usuario,$eformador,$cod_usuario_portfolio,$cod_grupo_portfolio);
    */
    if (count($lista_topicos)>0)
      foreach ($lista_topicos as $cod => $linha_topico)
      {
        if ($cod_topico_raiz==$linha_topico['cod_topico'])
          echo("      ".$linha_topico['espacos']."<b class=text><img src=\"../figuras/pasta.gif\" border=0>".$linha_topico['topico']."</b><br>\n");
        else
          echo("      ".$linha_topico['espacos']."<a class=text href=portfolio.php onClick=\"EscondeLayer(cod_mover);MoverItem(this,".$linha_topico['cod_topico'].");\"><img src=\"../figuras/pasta.gif\" border=0>".$linha_topico['topico']."</a><br>\n");
      }
    echo("    </td>\n");
    echo("  </tr>\n");
    echo("</table>\n");
  }
  echo("</div>\n");

  /* Novo Tpico */
  echo("<div id=novotop class=block visibility=hidden onContextMenu=\"return(false);\">\n");
  echo("<form name=form_novo_top method=post action=portfolio.php onSubmit='return(testa_titulo_criar(this));'>\n");
  echo(RetornaSessionIDInput());  

  echo("<table class=wtfield cellspacing=1 cellpadding=1 border=2>\n");
  echo("  <tr>\n");
  echo("    <td class=bgcolor align=right><a href=# onClick=EscondeLayer(cod_novo_top);return(false);><img src=../figuras/x.gif border=0></a></td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("    <td>\n");
  /* 24 - Digite o nome da pasta a ser criada aqui: */
  echo("      <font class=text>".RetornaFraseDaLista($lista_frases,24)."</font><BR>\n");
  echo("      <input type=text name=novo_nome value=\"\" maxlength=150><BR>\n");
  echo("      <input type=hidden name=cod_curso value=".$cod_curso.">\n");
  echo("      <input type=hidden name=acao value=novotopico>\n");
  echo("      <input type=hidden name=cod_usuario_portfolio value=".$cod_usuario_portfolio.">\n");
  echo("      <input type=hidden name=cod_grupo_portfolio value=".$cod_grupo_portfolio.">\n");
  echo("      <input type=hidden name=cod_topico_raiz value=".$cod_topico_raiz.">\n");
  /* 18 - Ok (gen) */
  echo("      <input type=submit value=".RetornaFraseDaLista($lista_frases_geral,18).">\n");
  /* 2 - Cancelar (gen) */
  echo("      &nbsp;&nbsp;<input type=button value=".RetornaFraseDaLista($lista_frases_geral,2)." onClick=\"EscondeLayer(cod_novo_top);\">\n");
  echo("    </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("</form>\n");
  echo("</div>\n");

  /* Renomear */
  echo("<div id=renomeartop class=block visibility=hidden onContextMenu=\"return(false);\">\n");
  echo("<form method=post name=form_renomear_top action=portfolio.php onSubmit=\"this.cod_topico.value=js_cod_topico;return(PossoRenomear(this));\">\n");
  echo(RetornaSessionIDInput());
  echo("<input type=hidden name=cod_curso value=".$cod_curso.">\n");

  echo("<table class=wtfield border=2 cellspacing=1 cellpadding=1>\n");
  echo("  <tr>\n");
  echo("    <td class=bgcolor align=right><a href=# onClick=EscondeLayer(cod_ren_top);return(false);><img src=../figuras/x.gif border=0 ></a></td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("    <td>\n");

  /* 25 - Digite o novo ttulo do item: */

  echo("      <font class=text>".RetornaFraseDaLista($lista_frases,25)."</font><BR>\n");
  echo("      <input type=text name=novo_nome value=\"\" maxlength=150><BR>\n");
  echo("      <input type=hidden name=cod_curso value=".$cod_curso.">\n");
  echo("      <input type=hidden name=cod_topico value=\"\">\n");
  echo("      <input type=hidden name=acao value=renomeartop>\n");
  echo("      <input type=hidden name=cod_topico_raiz value=".$cod_topico_raiz.">\n");
  echo("      <input type=hidden name=cod_usuario_portfolio value=".$cod_usuario_portfolio.">\n");
  echo("      <input type=hidden name=cod_grupo_portfolio value=".$cod_grupo_portfolio.">\n");

  /* 18 - Ok (gen) */
  echo("      <input type=submit value=".RetornaFraseDaLista($lista_frases_geral,18).">\n");
  /* 2 - Cancelar (gen) */
  echo("      &nbsp;&nbsp;<input type=button value=".RetornaFraseDaLista($lista_frases_geral,2)." onClick=\"EscondeLayer(cod_ren_top);\">\n");
  echo("    </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("</form>\n");
  echo("</div>\n");

  /* Mudar Compartilhamento */
  echo("<div id=comp class=block visibility=hidden onContextMenu=\"return(false);\">\n");
  echo("<script language=JavaScript>\n");
  if (count($lista_itens)>0)
    foreach ($lista_itens as $cod => $linha_item)
    {
      echo("  js_comp[".$linha_item['cod_item']."]=\"".$linha_item['tipo_compartilhamento']."\";\n");
    }
  echo("</script>\n");
  echo("<form method=post name=form_comp action=portfolio.php>\n");
  echo(RetornaSessionIDInput());
  echo("<input type=hidden name=cod_curso value=".$cod_curso.">\n");
  echo("  <input type=hidden name=cod_topico_raiz value=".$cod_topico_raiz.">\n");
  echo("  <input type=hidden name=cod_item value=\"\">\n");
  echo("  <input type=hidden name=acao value=mudarcomp>\n");
  echo("  <input type=hidden name=cod_usuario_portfolio value=".$cod_usuario_portfolio.">\n");
  echo("  <input type=hidden name=cod_grupo_portfolio value=".$cod_grupo_portfolio.">\n");
  echo("<table class=wtfield cellspacing=1 cellpadding=1 border=2>\n");
  echo("  <tr>\n");
  echo("    <td class=bgcolor align=right colspan=2><a href=# onClick=EscondeLayer(cod_comp);return(false);><img src=../figuras/x.gif border=0></a></td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("    <td>\n");
  echo("      <table class=wtfield border=0>\n");
  echo("        <tr>\n");
  echo("          <td>\n");
  echo("            <input type=radio name=tipo_comp value=\"T\" class=wtfield onClick=\"submit();\">\n");
  echo("          </td>\n");
  echo("          <td>\n");
  /* 12 - Totalmente compartilhado */
  echo("            <font class=text><nobr>".RetornaFraseDaLista($lista_frases,12)."</nobr></font>\n");
  echo("          </td>\n");
  echo("        </tr>\n");
  echo("        <tr>\n");
  echo("          <td>\n");
  echo("            <input type=radio name=tipo_comp value=\"F\" class=wtfield onClick=\"submit();\">\n");
  echo("          </td>\n");
  echo("          <td>\n");
  /* 13 - Compartilhado com formadores */
  echo("            <font class=text><nobr>".RetornaFraseDaLista($lista_frases,13)."</nobr></font>\n");
  echo("          </td>\n");
  echo("        </tr>\n");
  echo("        <tr>\n");
  echo("          <td>\n");
  echo("            <input type=radio name=tipo_comp value=\"P\" class=wtfield onClick=\"submit();\">\n");
  echo("          </td>\n");
  echo("          <td>\n");
  if (!$portfolio_grupo)
    /* 15 - No compartilhado */
    echo("            <font class=text><nobr>".RetornaFraseDaLista($lista_frases,15)."</nobr></font>\n");
  else
    /* 14 - Compartilhado com o Grupo */
    echo("            <font class=text><nobr>".RetornaFraseDaLista($lista_frases,14)."</nobr></font>\n");
  echo("          </td>\n");
  echo("        </tr>\n");

  echo("      </table>\n");
  echo("    </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("</form>\n");
  echo("</div>\n");

  /* Mudar Posio */
  echo("<div id=mudarpos class=block visibility=hidden onContextMenu=\"return(false);\">\n");
  echo("<form method=post name=form_posicao action=portfolio.php onSubmit=\"return(MudarPosicao(this));\">\n");
  echo(RetornaSessionIDInput());
  echo("<input type=hidden name=cod_curso value=".$cod_curso.">\n");

  echo("<table class=wtfield cellspacing=1 cellpadding=1 border=2>\n");
  echo("  <tr>\n");
  echo("    <td class=bgcolor align=right><a href=# onClick=\"EscondeLayer(cod_mudar_pos);return(false);\"><img src=../figuras/x.gif border=0></a></td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("    <td>\n");
  echo("      <font class=text>\n");
  /* 26 - Digite o nmero da posio em */
  echo("      ".RetornaFraseDaLista($lista_frases,26)."<br>\n");
  /* 27 - que a atividade deve aparecer: */
  echo("      ".RetornaFraseDaLista($lista_frases,27)."<br>\n");
  echo("      </font>\n");
  echo("      <input type=text name=posicao value=\"\" maxlength=4 size=4><br>\n");
  echo("      <input type=hidden name=cod_curso value=".$cod_curso.">\n");
  echo("      <input type=hidden name=cod_topico_raiz value=".$cod_topico_raiz.">\n");
  echo("      <input type=hidden name=cod_item value=\"\">\n");
  echo("      <input type=hidden name=acao value=\"mudarposicao\">\n");
  echo("      <input type=hidden name=cod_topico value=\"\">\n");
  echo("      <input type=hidden name=cod_usuario_portfolio value=".$cod_usuario_portfolio.">\n");
  echo("      <input type=hidden name=cod_grupo_portfolio value=".$cod_grupo_portfolio.">\n");

  /* 18 - Ok (gen) */
  echo("      <input type=submit value=".RetornaFraseDaLista($lista_frases_geral,18).">\n");
  /* 2 - Cancelar (gen) */
  echo("      <input type=button value=".RetornaFraseDaLista($lista_frases_geral,2)." onClick=\"EscondeLayer(cod_mudar_pos);return(false);\">\n");
  echo("    </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("</form>\n");
  echo("</div>\n");

  /* Estrutura de Tpicos */
  echo("<div id=topicos class=block visibility=hidden onContextMenu=\"return(false);\">\n");
  echo("<table class=wtfield cellspacing=1 cellpadding=1 border=2>\n");
  echo("  <tr>\n");
  echo("    <td class=bgcolor align=right><a href=# onClick=EscondeLayer(cod_topicos);return(false);><img src=../figuras/x.gif border=0></a></td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("    <td>\n");
  if (count($lista_topicos)>0)
    foreach ($lista_topicos as $cod => $linha_topico)
    {
      if ($cod_topico_raiz==$linha_topico['cod_topico'])
        echo("      ".$linha_topico['espacos']."<b class=text><img src=\"../figuras/pasta.gif\" border=0>".$linha_topico['topico']."</b><br>\n");
      else
        echo("      ".$linha_topico['espacos']."<a class=text href=portfolio.php?".RetornaSessionID()."&cod_curso=".$cod_curso."&cod_topico_raiz=".$linha_topico['cod_topico']."&cod_usuario_portfolio=".$cod_usuario_portfolio."&cod_grupo_portfolio=".$cod_grupo_portfolio." onClick=\"EscondeLayer(cod_topicos);\"><img src=\"../figuras/pasta.gif\" border=0>".$linha_topico['topico']."</a><br>\n");
    }
  echo("    </td>\n");
  echo("  </tr>\n");
  echo("</table>\n");
  echo("</div>\n");

  echo("</body>\n");
  echo("</html>\n");

  Desconectar($sock);
  exit;

?>
