<?
/*
<!--
-------------------------------------------------------------------------------

    Arquivo : pagina_inicial/inicial.inc

    TelEduc - Ambiente de Ensino-Aprendizagem a Distncia
    Copyright (C) 2001  NIED - Unicamp

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    You could contact us through the following addresses:

    Nied - Ncleo de Informtica Aplicada  Educao
    Unicamp - Universidade Estadual de Campinas
    Cidade Universitria "Zeferino Vaz"
    Bloco V da Reitoria - 2o. Piso
    CEP:13083-970 Campinas - SP - Brasil

    http://www.nied.unicamp.br
    nied@unicamp.br

------------------------------------------------------------------------------
-->
*/

/*==========================================================
  ARQUIVO : pagina_inicial/inicial.inc
  ========================================================== */
/* **********************************************************************
   RetornaCadastroUsuario - Retorna o dados cadastrais do usurio
                                 especificado.
   Entrada: $sock - sock do curso,
            $cod_usuario - cdigo do usurio.
   Saida: array contendo:
            ['nome'] - nome,
            ['email'] - email,
            ['telefone'] - telefone,
            ['endereco'] - endereco,
            ['cidade'] - cidade,
            ['estado'] - estado,
            ['pais'] - pais,
            ['data_nasc'] - data de nascimento,
            ['sexo'] - sexo,
            ['local_trab'] - local de trabalho,
            ['profissao'] - profissao,
            ['cod_escolaridade'] - cdigo de escolaridade,
            ['informacoes'] - informaes adicionais,
            ['login'] - login.
*/
function RetornaCadastroUsuario($sock, $cod_usuario)
{
  $query = "select nome, email, telefone, endereco, cidade, estado, pais, data_nasc,";
  $query .= " sexo, local_trab, profissao, cod_escolaridade, informacoes, login from";
  $query .= " Usuario where cod_usuario = ".$cod_usuario." order by";
  $query .= " ASCII(tipo_usuario) limit 1";

  $res = Enviar($sock,$query);
  $linha = RetornaArrayLinhas($res);
  return($linha[0]);
}

/* **********************************************************************
   RetornaConfiguracao - Retorna o contedo de um item da configurao
   Entrada: $sock - sock da base externa
            $item - item a ser buscado
   Saida: contedo
*/
function RetornaConfiguracao($sock,$item)
{
  $query="select valor from Config where item='".$item."'";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return ($linha['valor']);
}

/* **********************************************************************
   RetornaInstituicao - Retorna o contedo de um item da configurao
   Entrada: $sock - sock da base externa
   Saida: array ['nome'] - nome da instituicao
                ['informacoes'] - informaes adicionais
                ['link'] - endereo da pgina da instituio
*/
function RetornaInstituicao($sock)
{
  $query="select * from Instituicao";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return ($linha);
}

/* **********************************************************************
   RetornaCodigoTextosFerramentas - Retorna o contedo de um item da configurao
   Entrada: $sock - sock da base externa
   Saida: array [0] - Cdigo do texto do nome da ferramenta
                [1] - Cdigo do texto da descrio da ferramneta
                [2] - Cdigo da ferramenta
                [3] - Posio da ferramenta no Menu.
*/
function RetornaCodigoTextosFerramentas($sock)
{
  $query="select F.cod_texto_nome,F.cod_texto_descricao,F.cod_ferramenta, M.posicao from Ferramentas F,Menu M where F.cod_ferramenta=M.cod_ferramenta order by M.posicao";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  return ($lista);
}

/* **********************************************************************
   RetornaListaDeCursosUsuario - Retorna os cursos do qual um usurio
     participa/participou baseado em seu e-mail ou login.

   Entrada: $email - e-mail do usurio,
            $login - login do usurio.
   Saida: array []['cod_curso']['nome_curso']
                []['inscricao_inicio']
                []['inscricao_fim']
                []['acesso_visitante'] - 'A' se aceita, 'N' se no
*/

function RetornaListaDeCursosUsuario($email, $login)
{
  $sock = Conectar("");

  $query = "select cod_curso, nome_curso from Cursos";
  $res = Enviar($sock,$query);
  $total_cursos = RetornaNumLinhas($res);
  $lista = RetornaArrayLinhas($res);

  Desconectar($sock);

  if (!($email == '') || ($login == ''))
    $whclause = "email = '".$email."' or login = '".$login;
  else if ($email != '')
    $whclause = "email = '".$email;
  else if ($login != '')
    $whclause = "login = '".$login;

  $query = "select cod_usuario from Usuario where ".$whclause."' order by";
  $query .= " ASCII(tipo_usuario) limit 1";

  for ($i = 0; $i < $total_cursos; $i++)
  {
    $sock = Conectar($lista[$i]['cod_curso']);

    $res = Enviar($sock,$query);
    $dados = RetornaArrayLinhas($res);

    if (count($dados) > 0)
    {
      $resultado[$lista[$i]['cod_curso']]['nome_curso'] = $lista[$i]['nome_curso'];
      $resultado[$lista[$i]['cod_curso']]['cod_usuario'] = $dados[0]['cod_usuario'];
    }
    Desconectar($sock);
  }

  return($resultado);
}

/* **********************************************************************
   RetornaListaDeCursos - Retorna a lista de cursos dado o tipo
   Entrada: $sock - sock da base externa
            $tipo_curso - tipo do curso
                          'A' - Em andamento
                          'I' - com inscries aberta
                          'E' - Encerrados
            $cod_pasta - codigo da pasta a qual pertence os cursos a serem retornados
   Saida: array []['cod_curso']
                []['nome_curso']
                []['inscricao_inicio']
                []['inscricao_fim']
                []['acesso_visitante'] - 'A' se aceita, 'N' se no
*/
function RetornaListaDeCursos($sock,$tipo_curso,$cod_pasta)
{
  $hoje=time();
  $ontem=$hoje - 86400;

  if ($tipo_curso=='A')
    $where="where curso_inicio<=".$hoje." and curso_fim>=".$ontem;
  else if ($tipo_curso=='I')
    $where="where inscricao_inicio<=".$hoje." and inscricao_fim>=".$ontem;
  else
    $where="where curso_fim<".$ontem;

  if ($cod_pasta=="NULL" || $cod_pasta=="")
    $pasta="cod_pasta IS NULL";
  else
    $pasta="cod_pasta=".$cod_pasta;

  $query="select cod_curso,nome_curso,inscricao_inicio,inscricao_fim,acesso_visitante from Cursos ".$where." and ".$pasta." order by nome_curso";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);

  if (count($lista)>0)
  {
    $c=0;
    foreach($lista as $cod => $linha)
      $lista_saida[$c++]=$linha;
  }
  else
    $lista_saida=$lista;

  return ($lista_saida);
}

/* **********************************************************************
   RetornaDadosInstituicao - Retorna os dados da instituio
   Entrada: $sock= Base externa
   Saida: array com ['nome'],['informacoes'],['link']
*/
function RetornaDadosIntituicao($sock)
{
  $query="select * from Instituicao";
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return ($linha);
}

/* **********************************************************************
   RetornaContatos - Retorna os dados dos contatos para criacao de curso
   Entrada: nenhuma
   Saida: array com []['nome'],[]['email'],[]['status']
*/
function RetornaContatos($sock)
{
  $query="select * from Contatos where status='C' order by nome";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  return ($lista);
}

/* **********************************************************************
   RetornaDadosCurso - Retorna os dados do curso dado
   Entrada: $sock - base externo
   Saida: array com []['cod_curso']
                    []['nome_curso']
                    []['inscricao_inicio']
                    []['inscricao_fim']
                    []['curso_inicio']
                    []['curso_fim']
                    []['informacoes']
                    []['publico_alvo']
                    []['tipo_inscricao']
                    []['num_alunos']
                    []['cod_coordenador']
                    []['acesso_visitante']
*/
function RetornaDadosCurso($sock,$cod_curso)
{
  $query="select * from Cursos where cod_curso=".$cod_curso;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);
  return ($linha);
}

/* *****************************************************************************
  RetornaListaEscolaridade - Verifica se existe a orientacao na tabela Perfil_Orientacao
  Entrada: $sock - sock de conexao EXTERNA
  Saida:   array com
            []['cod_escolaridade']
            []['cod_texto_escolaridade']
*/
function RetornaListaEscolaridade($sock)
{
  $query="select * from Escolaridade order by cod_escolaridade";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);
  return($lista);
}

/* *****************************************************************************
  CadastraUsuario - Cadastra o usurio na tabela
  Entrada: $sock - sock da base do Curso
           $nome_usuario, $email, $telefone, $endereco,
           $cidade, $estado, $pais, $data,
           $sexo, $local, $profissao, $cod_escolaridade,
           $informacoes,$login,$opcao
  Saida: true - se tudo ok, false se j houver um usurio com aquele login
*/
function CadastraUsuario($sock,$nome_usuario,$email,$telefone,$endereco,$cidade,$estado,$pais,$data,$sexo,$local,$profissao,$cod_escolaridade,$informacoes,$login,$opcao)
{
  global $cod_lingua_s;
  $query="select login from Usuario where login='".$login."'";
  $res=Enviar($sock,$query);
  if (RetornaNumLinhas($res)==0)
  {
    $query="insert into Usuario (cod_usuario,nome,email,telefone,endereco,cidade,estado,pais,data_nasc,sexo,local_trab,profissao,cod_escolaridade,informacoes,login,senha,tipo_usuario,opcoes,data_inscricao,cod_lingua) values (".RetornaProximoCodigo($sock,"Usuario").",'".$nome_usuario."','".$email."','".$telefone."','".$endereco."','".$cidade."','".$estado."','".$pais."',".$data.",'".$sexo."','".$local."','".$profissao."',".$cod_escolaridade.",'".$informacoes."','".$login."','','a','".$opcao."',".time().",".$cod_lingua_s.")";
    Enviar($sock,$query);
    return true;
  }
  else
    return false;
}

/* ****************************************************************************************
  RetornaPastasDeCursos - Retorna uma array com as pastas em que os cursos esto divididos
                          (somente as pastas que contem algum curso)
  Entrada: $sock - sock Base Externa
           $tipo_curso - tipo do curso
                         'A' - Em andamento
                         'I' - com inscries aberta
                         'E' - Encerrados
  Saida: array com []['cod_pasta']
                   []['pasta']
                   []['num_cursos']
*/
function RetornaPastasDeCursos($sock,$tipo_curso)
{
  global $lista_frases;

  $hoje=time();
  $ontem=$hoje - 86400;

  if ($tipo_curso=='A')
    $where="C.curso_inicio<=".$hoje." and C.curso_fim>=".$ontem;
  else if ($tipo_curso=='I')
    $where="C.inscricao_inicio<=".$hoje." and C.inscricao_fim>=".$ontem;
  else
    $where="C.curso_fim<".$ontem;

  $query="select CP.cod_pasta,CP.pasta,count(*) 'num_cursos' from Cursos_pastas as CP, Cursos as C where CP.cod_pasta=C.cod_pasta and ".$where." group by CP.cod_pasta order by CP.pasta";
  $res=Enviar($sock,$query);
  $lista=RetornaArrayLinhas($res);

  $query="select count(*) from Cursos C where C.cod_pasta IS NULL and ".$where;
  $res=Enviar($sock,$query);
  $linha=RetornaLinha($res);

  if ($linha[0]>0)
  {
    $cont=count($lista);
    $lista[$cont]['cod_pasta']="NULL";
    /* 115 - Cursos gerais */
    $lista[$cont]['pasta']=RetornaFraseDaLista($lista_frases,115);
    $lista[$cont]['num_cursos']=$linha[0];
  }
  return ($lista);
}

?>